(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var RoutePolicy = Package.routepolicy.RoutePolicy;
var WebApp = Package.webapp.WebApp;
var main = Package.webapp.main;
var WebAppInternals = Package.webapp.WebAppInternals;
var _ = Package.underscore._;
var ServiceConfiguration = Package['service-configuration'].ServiceConfiguration;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Accounts = Package['accounts-base'].Accounts;
var Random = Package.random.Random;
var ECMAScript = Package.ecmascript.ECMAScript;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var middleware, _saml, SAML, profile;

var require = meteorInstall({"node_modules":{"meteor":{"accounts-saml":{"saml_server.js":function(require,exports,module){

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                  //
// packages/accounts-saml/saml_server.js                                                                            //
//                                                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                    //
if (!Accounts.saml) {                                                                                               // 1
  Accounts.saml = {};                                                                                               // 2
}                                                                                                                   // 3
                                                                                                                    //
var Url = Npm.require("url");                                                                                       // 5
var Fiber = Npm.require("fibers");                                                                                  // 6
                                                                                                                    //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                   //
// uses. Fortunately, they let us extract it.                                                                       //
var connect = WebAppInternals.NpmModules.connect.module;                                                            // 10
                                                                                                                    //
RoutePolicy.declare("/_saml/", "network");                                                                          // 12
                                                                                                                    //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                            // 14
                                                                                                                    //
Accounts.registerLoginHandler(function (loginRequest) {                                                             // 16
  if (!loginRequest.saml || !loginRequest.credentialToken) {                                                        // 17
    return undefined;                                                                                               // 18
  }                                                                                                                 // 19
                                                                                                                    //
  if (!Accounts.identityServices.saml.isEnabled()) {                                                                // 21
    throw new Meteor.Error(403, "SAML service is disabled.");                                                       // 22
  }                                                                                                                 // 23
                                                                                                                    //
  var loginResult = Accounts.saml.retrieveCredential(loginRequest.credentialToken);                                 // 25
  if (!loginResult) {                                                                                               // 26
    throw new Meteor.Error(500, "SAML login did not complete.");                                                    // 27
  } else if (loginResult.profile && loginResult.profile.email) {                                                    // 28
    var user = _.pick(loginResult.profile, "displayName", "email");                                                 // 29
    user.id = loginResult.profile.nameID;                                                                           // 30
    return Accounts.updateOrCreateUserFromExternalService("saml", user, {});                                        // 31
  } else {                                                                                                          // 32
    throw new Meteor.Error(500, "SAML profile did not contain an email address");                                   // 33
  }                                                                                                                 // 34
});                                                                                                                 // 35
                                                                                                                    //
// TODO(soon): This may need to be a Mongo collection in order to work when the frontend is                         //
//   replicated (but currently Sandstorm for Work is not replicated).                                               //
Accounts.saml._loginResultForCredentialToken = {};                                                                  // 39
                                                                                                                    //
Accounts.saml.hasCredential = function (credentialToken) {                                                          // 41
  return _.has(Accounts.saml._loginResultForCredentialToken, credentialToken);                                      // 42
};                                                                                                                  // 43
                                                                                                                    //
Accounts.saml.retrieveCredential = function (credentialToken) {                                                     // 45
  var result = Accounts.saml._loginResultForCredentialToken[credentialToken];                                       // 46
  delete Accounts.saml._loginResultForCredentialToken[credentialToken];                                             // 47
  return result;                                                                                                    // 48
};                                                                                                                  // 49
                                                                                                                    //
// Listen to incoming OAuth http requests                                                                           //
WebApp.connectHandlers.use(connect.urlencoded()).use(function (req, res, next) {                                    // 52
  // Need to create a Fiber since we're using synchronous http calls and nothing                                    //
  // else is wrapping this in a fiber automatically                                                                 //
  Fiber(function () {                                                                                               // 55
    middleware(req, res, next);                                                                                     // 56
  }).run();                                                                                                         // 57
});                                                                                                                 // 58
                                                                                                                    //
function generateService() {                                                                                        // 60
  var entityId = SandstormDb.prototype.getSamlEntityId();                                                           // 61
  var service = {                                                                                                   // 62
    "provider": "default",                                                                                          // 63
    "entryPoint": SandstormDb.prototype.getSamlEntryPoint(),                                                        // 64
    // TODO(someday): find a better way to inject the DB                                                            //
    "issuer": entityId || HOSTNAME,                                                                                 // 66
    "cert": SandstormDb.prototype.getSamlPublicCert()                                                               // 67
  };                                                                                                                // 62
  return service;                                                                                                   // 69
}                                                                                                                   // 70
                                                                                                                    //
middleware = function middleware(req, res, next) {                                                                  // 72
  // Make sure to catch any exceptions because otherwise we'd crash                                                 //
  // the runner                                                                                                     //
  try {                                                                                                             // 75
    var samlObject = samlUrlToObject(req.url);                                                                      // 76
    if (!samlObject || !samlObject.serviceName) {                                                                   // 77
      next();                                                                                                       // 78
      return;                                                                                                       // 79
    }                                                                                                               // 80
                                                                                                                    //
    if (samlObject.actionName === "config") {                                                                       // 82
      _saml = new SAML(generateService());                                                                          // 83
      res.writeHead(200, { "Content-Type": "text/xml" });                                                           // 84
      res.end(_saml.generateServiceProviderMetadata());                                                             // 85
      return;                                                                                                       // 86
    }                                                                                                               // 87
                                                                                                                    //
    if (!Accounts.identityServices.saml.isEnabled()) {                                                              // 89
      next();                                                                                                       // 90
      return;                                                                                                       // 91
    }                                                                                                               // 92
                                                                                                                    //
    if (!samlObject.actionName) throw new Error("Missing SAML action");                                             // 94
                                                                                                                    //
    var service = generateService();                                                                                // 97
                                                                                                                    //
    // Skip everything if there's no service set by the saml middleware                                             //
    if (!service || samlObject.serviceName !== service.provider) throw new Error("Unexpected SAML service " + samlObject.serviceName);
                                                                                                                    //
    if (samlObject.actionName === "authorize") {                                                                    // 103
      service.callbackUrl = Meteor.absoluteUrl("_saml/validate/" + service.provider);                               // 104
      service.id = samlObject.credentialToken;                                                                      // 105
      _saml = new SAML(service);                                                                                    // 106
      _saml.getAuthorizeUrl(req, function (err, url) {                                                              // 107
        if (err) throw new Error("Unable to generate authorize url");                                               // 108
        res.writeHead(302, { "Location": url });                                                                    // 110
        res.end();                                                                                                  // 111
      });                                                                                                           // 112
    } else if (samlObject.actionName === "validate") {                                                              // 113
      _saml = new SAML(service);                                                                                    // 114
      _saml.validateResponse(req.body.SAMLResponse, function (err, profile, loggedOut) {                            // 115
        if (err) {                                                                                                  // 116
          console.error("Error validating SAML response", err.toString());                                          // 117
          throw new Error("Unable to validate response url");                                                       // 118
        }                                                                                                           // 119
                                                                                                                    //
        // Do NOT use samlObject.credentialToken; it isn't signed!                                                  //
        var credentialToken = profile.inResponseToId || profile.InResponseTo;                                       // 122
        if (!credentialToken) {                                                                                     // 123
          throw new Error("SAML response missing InResponseTo attribute. Sandstorm does not support " + "IdP-initiated authentication; authentication requests must start " + "from the user choosing SAML login in the Sandstorm UI.");
        }                                                                                                           // 128
                                                                                                                    //
        Accounts.saml._loginResultForCredentialToken[credentialToken] = {                                           // 130
          profile: profile                                                                                          // 131
        };                                                                                                          // 130
                                                                                                                    //
        closePopup(res);                                                                                            // 134
      });                                                                                                           // 135
    } else {                                                                                                        // 136
      throw new Error("Unexpected SAML action " + samlObject.actionName);                                           // 137
    }                                                                                                               // 138
  } catch (err) {                                                                                                   // 139
    closePopup(res, err);                                                                                           // 140
  }                                                                                                                 // 141
};                                                                                                                  // 142
                                                                                                                    //
var samlUrlToObject = function samlUrlToObject(url) {                                                               // 144
  // req.url will be "/_saml/<action>/<service name>/<credentialToken>"                                             //
  if (!url) return null;                                                                                            // 146
                                                                                                                    //
  var splitPath = url.split("/");                                                                                   // 149
                                                                                                                    //
  // Any non-saml request will continue down the default                                                            //
  // middlewares.                                                                                                   //
  if (splitPath[1] !== "_saml") return null;                                                                        // 153
                                                                                                                    //
  return {                                                                                                          // 156
    actionName: splitPath[2],                                                                                       // 157
    serviceName: splitPath[3],                                                                                      // 158
    credentialToken: splitPath[4]                                                                                   // 159
  };                                                                                                                // 156
};                                                                                                                  // 161
                                                                                                                    //
var closePopup = function closePopup(res, err) {                                                                    // 163
  res.writeHead(200, { "Content-Type": "text/html" });                                                              // 164
  var content = "<html><head><script>window.close()</script></head></html>";                                        // 165
  if (err) content = "<html><body><h2>Sorry, an error occured</h2><div>" + err + '</div><a onclick="window.close();">Close Window</a></body></html>';
  res.end(content, "utf-8");                                                                                        // 169
};                                                                                                                  // 170
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"saml_utils.js":function(require){

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                  //
// packages/accounts-saml/saml_utils.js                                                                             //
//                                                                                                                  //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                    //
var zlib = Npm.require("zlib");                                                                                     // 1
var xml2js = Npm.require("xml2js");                                                                                 // 2
var xmlCrypto = Npm.require("xml-crypto");                                                                          // 3
var crypto = Npm.require("crypto");                                                                                 // 4
var xmldom = Npm.require("xmldom");                                                                                 // 5
var querystring = Npm.require("querystring");                                                                       // 6
var xmlbuilder = Npm.require("xmlbuilder");                                                                         // 7
var Url = Npm.require("url");                                                                                       // 8
                                                                                                                    //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                            // 10
                                                                                                                    //
SAML = function SAML(options) {                                                                                     // 12
  this.options = this.initialize(options);                                                                          // 13
};                                                                                                                  // 14
                                                                                                                    //
SAML.prototype.initialize = function (options) {                                                                    // 16
  if (!options) {                                                                                                   // 17
    options = {};                                                                                                   // 18
  }                                                                                                                 // 19
                                                                                                                    //
  if (!options.protocol) {                                                                                          // 21
    options.protocol = "https://";                                                                                  // 22
  }                                                                                                                 // 23
                                                                                                                    //
  if (!options.path) {                                                                                              // 25
    options.path = "/saml/consume";                                                                                 // 26
  }                                                                                                                 // 27
                                                                                                                    //
  if (!options.issuer) {                                                                                            // 29
    options.issuer = "onelogin_saml";                                                                               // 30
  }                                                                                                                 // 31
                                                                                                                    //
  if (options.identifierFormat === undefined) {                                                                     // 33
    options.identifierFormat = "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent";                              // 34
  }                                                                                                                 // 35
                                                                                                                    //
  return options;                                                                                                   // 37
};                                                                                                                  // 38
                                                                                                                    //
SAML.prototype.generateUniqueID = function () {                                                                     // 40
  var chars = "abcdef0123456789";                                                                                   // 41
  var uniqueID = "";                                                                                                // 42
  for (var i = 0; i < 20; i++) {                                                                                    // 43
    uniqueID += chars.substr(Math.floor(Math.random() * 15), 1);                                                    // 44
  }                                                                                                                 // 45
                                                                                                                    //
  return uniqueID;                                                                                                  // 47
};                                                                                                                  // 48
                                                                                                                    //
SAML.prototype.generateInstant = function () {                                                                      // 50
  var date = new Date();                                                                                            // 51
  return date.getUTCFullYear() + "-" + ("0" + (date.getUTCMonth() + 1)).slice(-2) + "-" + ("0" + date.getUTCDate()).slice(-2) + "T" + ("0" + date.getUTCHours()).slice(-2) + ":" + ("0" + date.getUTCMinutes()).slice(-2) + ":" + ("0" + date.getUTCSeconds()).slice(-2) + "Z";
};                                                                                                                  // 53
                                                                                                                    //
SAML.prototype.signRequest = function (xml) {                                                                       // 55
  var signer = crypto.createSign("RSA-SHA1");                                                                       // 56
  signer.update(xml);                                                                                               // 57
  return signer.sign(this.options.privateCert, "base64");                                                           // 58
};                                                                                                                  // 59
                                                                                                                    //
SAML.prototype.generateAuthorizeRequest = function (req) {                                                          // 61
  var id = "_" + this.generateUniqueID();                                                                           // 62
  var instant = this.generateInstant();                                                                             // 63
                                                                                                                    //
  var callbackUrl = void 0;                                                                                         // 65
  // Post-auth destination                                                                                          //
  if (this.options.callbackUrl) {                                                                                   // 67
    callbackUrl = this.options.callbackUrl;                                                                         // 68
  } else {                                                                                                          // 69
    callbackUrl = this.options.protocol + req.headers.host + this.options.path;                                     // 70
  }                                                                                                                 // 71
                                                                                                                    //
  if (this.options.id) id = this.options.id;                                                                        // 73
                                                                                                                    //
  var request = "<samlp:AuthnRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" ProtocolBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST\" AssertionConsumerServiceURL=\"" + callbackUrl + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>\n";
                                                                                                                    //
  if (this.options.identifierFormat) {                                                                              // 82
    request += "<samlp:NameIDPolicy xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Format=\"" + this.options.identifierFormat + "\" AllowCreate=\"true\"></samlp:NameIDPolicy>\n";
  }                                                                                                                 // 85
                                                                                                                    //
  request += "<samlp:RequestedAuthnContext xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Comparison=\"exact\">" + "<saml:AuthnContextClassRef xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" + "</saml:AuthnContextClassRef>" + "</samlp:RequestedAuthnContext>\n" + "</samlp:AuthnRequest>";
                                                                                                                    //
  return request;                                                                                                   // 95
};                                                                                                                  // 96
                                                                                                                    //
SAML.prototype.generateLogoutRequest = function (req) {                                                             // 98
  var id = "_" + this.generateUniqueID();                                                                           // 99
  var instant = this.generateInstant();                                                                             // 100
                                                                                                                    //
  //samlp:LogoutRequest xmlns:samlp="urn:oasis:names:tc:SAML:2.0:protocol" xmlns:saml="urn:oasis:names:tc:SAML:2.0:assertion"
  // ID="_135ad2fd-b275-4428-b5d6-3ac3361c3a7f" Version="2.0" Destination="https://idphost/adfs/ls/"                //
  //IssueInstant="2008-06-03T12:59:57Z"><saml:Issuer>myhost</saml:Issuer><NameID Format="urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress"
  //NameQualifier="https://idphost/adfs/ls/">myemail@mydomain.com</NameID<samlp:SessionIndex>_0628125f-7f95-42cc-ad8e-fde86ae90bbe
  //</samlp:SessionIndex></samlp:LogoutRequest>                                                                     //
                                                                                                                    //
  var request = "<samlp:LogoutRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" " + "xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>" + "<saml:NameID Format=\"" + req.user.nameIDFormat + "\">" + req.user.nameID + "</saml:NameID>" + "</samlp:LogoutRequest>";
  return request;                                                                                                   // 114
};                                                                                                                  // 115
                                                                                                                    //
SAML.prototype.requestToUrl = function (request, operation, callback) {                                             // 117
  var _this = this;                                                                                                 // 118
  zlib.deflateRaw(request, function (err, buffer) {                                                                 // 119
    if (err) {                                                                                                      // 120
      return callback(err);                                                                                         // 121
    }                                                                                                               // 122
                                                                                                                    //
    var base64 = buffer.toString("base64");                                                                         // 124
    var target = _this.options.entryPoint;                                                                          // 125
                                                                                                                    //
    if (operation === "logout") {                                                                                   // 127
      if (_this.options.logoutUrl) {                                                                                // 128
        target = _this.options.logoutUrl;                                                                           // 129
      }                                                                                                             // 130
    }                                                                                                               // 131
                                                                                                                    //
    if (target.indexOf("?") > 0) target += "&";else target += "?";                                                  // 133
                                                                                                                    //
    var samlRequest = {                                                                                             // 138
      SAMLRequest: base64                                                                                           // 139
    };                                                                                                              // 138
                                                                                                                    //
    if (_this.options.privateCert) {                                                                                // 142
      samlRequest.SigAlg = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";                                            // 143
      samlRequest.Signature = _this.signRequest(querystring.stringify(samlRequest));                                // 144
    }                                                                                                               // 145
                                                                                                                    //
    target += querystring.stringify(samlRequest);                                                                   // 147
                                                                                                                    //
    callback(null, target);                                                                                         // 149
  });                                                                                                               // 150
};                                                                                                                  // 151
                                                                                                                    //
SAML.prototype.getAuthorizeUrl = function (req, callback) {                                                         // 153
  var request = this.generateAuthorizeRequest(req);                                                                 // 154
                                                                                                                    //
  this.requestToUrl(request, "authorize", callback);                                                                // 156
};                                                                                                                  // 157
                                                                                                                    //
SAML.prototype.getLogoutUrl = function (req, callback) {                                                            // 159
  var request = this.generateLogoutRequest(req);                                                                    // 160
                                                                                                                    //
  this.requestToUrl(request, "logout", callback);                                                                   // 162
};                                                                                                                  // 163
                                                                                                                    //
SAML.prototype.certToPEM = function (cert) {                                                                        // 165
  cert = cert.match(/.{1,64}/g).join("\n");                                                                         // 166
  cert = "-----BEGIN CERTIFICATE-----\n" + cert;                                                                    // 167
  cert = cert + "\n-----END CERTIFICATE-----\n";                                                                    // 168
  return cert;                                                                                                      // 169
};                                                                                                                  // 170
                                                                                                                    //
SAML.prototype.validateSignature = function (xml, cert) {                                                           // 172
  var _this = this;                                                                                                 // 173
  var doc = new xmldom.DOMParser().parseFromString(xml);                                                            // 174
  var signature = xmlCrypto.xpath(doc, "//*[local-name(.)='Signature' and namespace-uri(.)='http://www.w3.org/2000/09/xmldsig#']")[0];
  var sig = new xmlCrypto.SignedXml();                                                                              // 176
  sig.keyInfoProvider = {                                                                                           // 177
    getKeyInfo: function getKeyInfo(key) {                                                                          // 178
      return "<X509Data></X509Data>";                                                                               // 179
    },                                                                                                              // 180
                                                                                                                    //
    getKey: function getKey(keyInfo) {                                                                              // 182
      return _this.certToPEM(cert);                                                                                 // 183
    }                                                                                                               // 184
  };                                                                                                                // 177
  sig.loadSignature(signature.toString());                                                                          // 186
  return sig.checkSignature(xml);                                                                                   // 187
};                                                                                                                  // 188
                                                                                                                    //
SAML.prototype.getElement = function (parentElement, elementName) {                                                 // 190
  if (parentElement["saml:" + elementName]) {                                                                       // 191
    return parentElement["saml:" + elementName];                                                                    // 192
  } else if (parentElement["samlp:" + elementName]) {                                                               // 193
    return parentElement["samlp:" + elementName];                                                                   // 194
  } else if (parentElement["saml2p:" + elementName]) {                                                              // 195
    return parentElement["saml2p:" + elementName];                                                                  // 196
  } else if (parentElement["saml2:" + elementName]) {                                                               // 197
    return parentElement["saml2:" + elementName];                                                                   // 198
  }                                                                                                                 // 199
                                                                                                                    //
  return parentElement[elementName];                                                                                // 201
};                                                                                                                  // 202
                                                                                                                    //
SAML.prototype.validateResponse = function (samlResponse, callback) {                                               // 204
  var _this = this;                                                                                                 // 205
  var xml = new Buffer(samlResponse, "base64").toString("utf8");                                                    // 206
  var parser = new xml2js.Parser({ explicitRoot: true });                                                           // 207
  parser.parseString(xml, function (err, doc) {                                                                     // 208
    // Verify signature                                                                                             //
    if (_this.options.cert && !_this.validateSignature(xml, _this.options.cert)) {                                  // 210
      return callback(new Error("Invalid signature"), null, false);                                                 // 211
    }                                                                                                               // 212
                                                                                                                    //
    var response = _this.getElement(doc, "Response");                                                               // 214
    if (response) {                                                                                                 // 215
      var assertion = _this.getElement(response, "Assertion");                                                      // 216
      if (!assertion) {                                                                                             // 217
        return callback(new Error("Missing SAML assertion"), null, false);                                          // 218
      }                                                                                                             // 219
                                                                                                                    //
      profile = {};                                                                                                 // 221
                                                                                                                    //
      if (response.$ && response.$.InResponseTo) {                                                                  // 223
        profile.inResponseToId = response.$.InResponseTo;                                                           // 224
      }                                                                                                             // 225
                                                                                                                    //
      if (response.$ && response.$.Destination) {                                                                   // 227
        if (!response.$.Destination.startsWith(process.env.ROOT_URL)) {                                             // 228
          return callback(new Error("SAML Response received with invalid Destination: " + response.$.Destination));
        }                                                                                                           // 231
      }                                                                                                             // 232
                                                                                                                    //
      var issuer = _this.getElement(assertion[0], "Issuer");                                                        // 234
      if (issuer) {                                                                                                 // 235
        profile.issuer = issuer[0];                                                                                 // 236
      }                                                                                                             // 237
                                                                                                                    //
      var subject = _this.getElement(assertion[0], "Subject");                                                      // 239
      if (subject) {                                                                                                // 240
        var nameID = _this.getElement(subject[0], "NameID");                                                        // 241
        if (nameID) {                                                                                               // 242
          profile.nameID = nameID[0]._;                                                                             // 243
                                                                                                                    //
          if (nameID[0].$.Format) {                                                                                 // 245
            profile.nameIDFormat = nameID[0].$.Format;                                                              // 246
            if (profile.nameIDFormat.toLowerCase().indexOf("transient") !== -1) {                                   // 247
              return callback(new Error("SAML returned a transient NameID. Sandstorm requires a persistent NameID. " + "Please check your IdP config."));
            }                                                                                                       // 251
          }                                                                                                         // 252
        }                                                                                                           // 253
                                                                                                                    //
        var subjectConfirmation = _this.getElement(subject[0], "SubjectConfirmation");                              // 255
        if (subjectConfirmation) {                                                                                  // 256
          var subjectConfirmationData = _this.getElement(subjectConfirmation[0], "SubjectConfirmationData")[0];     // 257
          if (subjectConfirmationData) {                                                                            // 259
            var recipient = subjectConfirmationData.$.Recipient;                                                    // 260
            if (recipient && !recipient.startsWith(process.env.ROOT_URL)) {                                         // 261
              return callback(new Error("SAML sent to wrong recipient"));                                           // 262
            }                                                                                                       // 263
                                                                                                                    //
            var nowMs = Date.now();                                                                                 // 265
            var notBefore = subjectConfirmationData.$.NotBefore;                                                    // 266
            if (notBefore && nowMs < Date.parse(notBefore)) {                                                       // 267
              return callback(new Error("SAML assertion was signed for the future."));                              // 268
            }                                                                                                       // 269
                                                                                                                    //
            var notOnOrAfter = subjectConfirmationData.$.NotOnOrAfter;                                              // 271
            if (notOnOrAfter && nowMs >= Date.parse(notOnOrAfter)) {                                                // 272
              return callback(new Error("SAML assertion was signed for the past."));                                // 273
            }                                                                                                       // 274
          }                                                                                                         // 275
        }                                                                                                           // 276
      }                                                                                                             // 277
                                                                                                                    //
      var conditions = _this.getElement(assertion[0], "Conditions")[0];                                             // 279
      if (conditions) {                                                                                             // 280
        for (var key in conditions) {                                                                               // 281
          if (conditions.hasOwnProperty(key)) {                                                                     // 282
            var value = conditions[key];                                                                            // 283
            if (key === "$") {                                                                                      // 284
              var _nowMs = Date.now();                                                                              // 285
              var _notBefore = value.NotBefore;                                                                     // 286
              if (_notBefore && _nowMs < Date.parse(_notBefore)) {                                                  // 287
                return callback(new Error("SAML condition NotBefore is in the future."));                           // 288
              }                                                                                                     // 289
                                                                                                                    //
              var _notOnOrAfter = value.NotOnOrAfter;                                                               // 291
              if (_notOnOrAfter && _nowMs >= Date.parse(_notOnOrAfter)) {                                           // 292
                return callback(new Error("SAML condition notOnOrAfter is in the past."));                          // 293
              }                                                                                                     // 294
            } else if (key.endsWith("AudienceRestriction") || key.endsWith("OneTimeUse") || key.endsWith("ProxyRestriction")) {
              continue;                                                                                             // 298
              // Do nothing.                                                                                        //
              // We already check both Destination and SubjectConfirmation.Recipient, so                            //
              // the Audience constraint isn't as important, and is tricky to handle                                //
              // correctly.                                                                                         //
              // OneTimeUse is actually very tricky to get right, and requires a cache of                           //
              // previously seen assertions (or at least their hashes). In Sandstorm's case,                        //
              // we would probably need to stuff it in Mongo to make it robust across multiple                      //
              // front-ends. It is a very rarely used constraint anyways.                                           //
              // ProxyRestriction constraints only govern the future use of the assertion by the                    //
              // SP. We don't fall under this constraint so it's meaningless to us. As per the                      //
              // spec, it is always considered valid.                                                               //
            } else {                                                                                                // 310
                return callback(new Error("Unrecognized SAML constraint: " + key));                                 // 311
              }                                                                                                     // 312
          }                                                                                                         // 313
        }                                                                                                           // 314
      }                                                                                                             // 315
                                                                                                                    //
      var attributeStatement = _this.getElement(assertion[0], "AttributeStatement");                                // 317
      if (attributeStatement) {                                                                                     // 318
        var attributes = _this.getElement(attributeStatement[0], "Attribute");                                      // 319
                                                                                                                    //
        if (attributes) {                                                                                           // 321
          attributes.forEach(function (attribute) {                                                                 // 322
            var value = _this.getElement(attribute, "AttributeValue");                                              // 323
            if (typeof value[0] === "string") {                                                                     // 324
              profile[attribute.$.Name] = value[0];                                                                 // 325
            } else {                                                                                                // 326
              profile[attribute.$.Name] = value[0]._;                                                               // 327
            }                                                                                                       // 328
          });                                                                                                       // 329
        }                                                                                                           // 330
                                                                                                                    //
        if (!profile.mail && profile["urn:oid:0.9.2342.19200300.100.1.3"]) {                                        // 332
          // See http://www.incommonfederation.org/attributesummary.html for definition of attribute OIDs           //
          profile.mail = profile["urn:oid:0.9.2342.19200300.100.1.3"];                                              // 334
        }                                                                                                           // 335
                                                                                                                    //
        if (!profile.email && profile.mail) {                                                                       // 337
          profile.email = profile.mail;                                                                             // 338
        }                                                                                                           // 339
                                                                                                                    //
        var microsoftEmail = profile["http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress"];         // 341
        if (!profile.email && microsoftEmail) {                                                                     // 342
          profile.email = microsoftEmail;                                                                           // 343
        }                                                                                                           // 344
                                                                                                                    //
        var microsoftDisplayName = profile["http://schemas.microsoft.com/identity/claims/displayname"];             // 346
        if (!profile.displayName && microsoftDisplayName) {                                                         // 347
          profile.displayName = microsoftDisplayName;                                                               // 348
        }                                                                                                           // 349
      }                                                                                                             // 350
                                                                                                                    //
      if (!profile.email && profile.nameID && profile.nameIDFormat && profile.nameIDFormat.indexOf("emailAddress") >= 0) {
        profile.email = profile.nameID;                                                                             // 353
      }                                                                                                             // 354
                                                                                                                    //
      callback(null, profile, false);                                                                               // 356
    } else {                                                                                                        // 357
      var logoutResponse = _this.getElement(doc, "LogoutResponse");                                                 // 358
                                                                                                                    //
      if (logoutResponse) {                                                                                         // 360
        callback(null, null, true);                                                                                 // 361
      } else {                                                                                                      // 362
        return callback(new Error("Unknown SAML response message"), null, false);                                   // 363
      }                                                                                                             // 364
    }                                                                                                               // 366
  });                                                                                                               // 368
};                                                                                                                  // 369
                                                                                                                    //
SAML.prototype.generateServiceProviderMetadata = function () {                                                      // 371
  var entityId = this.options.issuer;                                                                               // 372
  var metadata = {                                                                                                  // 373
    "EntityDescriptor": {                                                                                           // 374
      "@xmlns": "urn:oasis:names:tc:SAML:2.0:metadata",                                                             // 375
      "@xmlns:ds": "http://www.w3.org/2000/09/xmldsig#",                                                            // 376
      "@entityID": entityId,                                                                                        // 377
      "@ID": entityId.replace(/\W/g, "_"),                                                                          // 378
      "SPSSODescriptor": {                                                                                          // 379
        "@protocolSupportEnumeration": "urn:oasis:names:tc:SAML:2.0:protocol"                                       // 380
      }                                                                                                             // 379
    }                                                                                                               // 374
  };                                                                                                                // 373
                                                                                                                    //
  var decryptionCert = this.options.localCertPublic; // TODO(someday); support local certs                          // 385
  if (decryptionCert) {                                                                                             // 386
    decryptionCert = decryptionCert.replace(/-+BEGIN CERTIFICATE-+\r?\n?/, "");                                     // 387
    decryptionCert = decryptionCert.replace(/-+END CERTIFICATE-+\r?\n?/, "");                                       // 388
    decryptionCert = decryptionCert.replace(/\r\n/g, "\n");                                                         // 389
                                                                                                                    //
    metadata.EntityDescriptor.SPSSODescriptor.KeyDescriptor = {                                                     // 391
      "ds:KeyInfo": {                                                                                               // 392
        "ds:X509Data": {                                                                                            // 393
          "ds:X509Certificate": {                                                                                   // 394
            "#text": decryptionCert                                                                                 // 395
          }                                                                                                         // 394
        }                                                                                                           // 393
      },                                                                                                            // 392
      "EncryptionMethod": [                                                                                         // 399
      // this should be the set that the xmlenc library supports                                                    //
      { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes256-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes128-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#tripledes-cbc" }]
    };                                                                                                              // 391
  }                                                                                                                 // 406
                                                                                                                    //
  if (this.options.logoutCallbackUrl) {                                                                             // 408
    metadata.EntityDescriptor.SPSSODescriptor.SingleLogoutService = {                                               // 409
      "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                 // 410
      "@Location": this.options.logoutCallbackUrl                                                                   // 411
    };                                                                                                              // 409
  }                                                                                                                 // 413
                                                                                                                    //
  metadata.EntityDescriptor.SPSSODescriptor.NameIDFormat = this.options.identifierFormat;                           // 415
  metadata.EntityDescriptor.SPSSODescriptor.AssertionConsumerService = {                                            // 416
    "@index": "1",                                                                                                  // 417
    "@isDefault": "true",                                                                                           // 418
    "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                   // 419
    "@Location": Meteor.absoluteUrl("_saml/validate/default")                                                       // 420
  };                                                                                                                // 416
                                                                                                                    //
  return xmlbuilder.create(metadata).end({ pretty: true, indent: "  ", newline: "\n" });                            // 423
};                                                                                                                  // 424
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/accounts-saml/saml_server.js");
require("./node_modules/meteor/accounts-saml/saml_utils.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['accounts-saml'] = {};

})();

//# sourceMappingURL=accounts-saml.js.map
