var require = meteorInstall({"server":{"lib":{"constants.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/lib/constants.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// A collection of some global variables used in multiple places.                                                      //
SANDSTORM_ALTHOME = Meteor.settings && Meteor.settings.home;                                                           // 18
SANDSTORM_LOGDIR = (SANDSTORM_ALTHOME || "") + "/var/log";                                                             // 19
SANDSTORM_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandstorm";                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"accounts":{"accounts-ui-methods.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-methods.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file contains method definitions which are available on both client and server (on the                         //
// client for prediction purposes, on the server for actual execution).                                                //
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 20
  check(handle, String);                                                                                               // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  updateProfile: function updateProfile(identityId, profile) {                                                         // 26
    // TODO(cleanup): This check also appears in sandstorm-db/users.js.                                                //
    check(identityId, String);                                                                                         // 28
                                                                                                                       //
    check(profile, {                                                                                                   // 30
      name: String,                                                                                                    // 31
      handle: ValidHandle,                                                                                             // 32
      pronoun: Match.OneOf("male", "female", "neutral", "robot"),                                                      // 33
      unverifiedEmail: Match.Optional(String)                                                                          // 34
    });                                                                                                                // 30
                                                                                                                       //
    if (!this.userId) {                                                                                                // 37
      throw new Meteor.Error(403, "not logged in");                                                                    // 38
    }                                                                                                                  // 39
                                                                                                                       //
    var userToUpdate = Meteor.users.findOne({ _id: identityId });                                                      // 41
                                                                                                                       //
    if (!this.isSimulation && !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                 // 43
      throw new Meteor.Error(403, "identity is not linked to current user: " + identityId);                            // 45
    }                                                                                                                  // 46
                                                                                                                       //
    var newValues = {                                                                                                  // 48
      "profile.name": profile.name,                                                                                    // 49
      "profile.handle": profile.handle,                                                                                // 50
      "profile.pronoun": profile.pronoun                                                                               // 51
    };                                                                                                                 // 48
                                                                                                                       //
    Meteor.users.update({ _id: userToUpdate._id }, { $set: newValues });                                               // 54
                                                                                                                       //
    if (!Meteor.user().hasCompletedSignup) {                                                                           // 56
      Meteor.users.update({ _id: this.userId }, { $set: { hasCompletedSignup: true } });                               // 57
    }                                                                                                                  // 58
  },                                                                                                                   // 59
                                                                                                                       //
  testFirstSignup: function testFirstSignup(profile) {                                                                 // 61
    if (!this.userId) {                                                                                                // 62
      throw new Meteor.Error(403, "not logged in");                                                                    // 63
    }                                                                                                                  // 64
                                                                                                                       //
    Meteor.users.update(this.userId, { $unset: { hasCompletedSignup: "" } });                                          // 66
  },                                                                                                                   // 67
                                                                                                                       //
  uploadProfilePicture: function uploadProfilePicture(identityId) {                                                    // 69
    check(identityId, String);                                                                                         // 70
    if (!this.userId || !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                       // 71
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 72
    }                                                                                                                  // 73
                                                                                                                       //
    return this.connection.sandstormDb.newAssetUpload({                                                                // 75
      profilePicture: { userId: this.userId, identityId: identityId }                                                  // 76
    });                                                                                                                // 75
  },                                                                                                                   // 78
                                                                                                                       //
  cancelUploadProfilePicture: function cancelUploadProfilePicture(id) {                                                // 80
    check(id, String);                                                                                                 // 81
    this.connection.sandstormDb.fulfillAssetUpload(id);                                                                // 82
  },                                                                                                                   // 83
                                                                                                                       //
  setPrimaryEmail: function setPrimaryEmail(email) {                                                                   // 85
    check(email, String);                                                                                              // 86
    if (!this.userId) {                                                                                                // 87
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 88
    }                                                                                                                  // 89
                                                                                                                       //
    var emails = SandstormDb.getUserEmails(Meteor.user());                                                             // 91
    if (!_.findWhere(emails, { email: email, verified: true })) {                                                      // 92
      throw new Meteor.Error(403, "Not a verified email of the current user: " + email);                               // 93
    }                                                                                                                  // 94
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { primaryEmail: email } });                                      // 96
  }                                                                                                                    // 97
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"accounts-ui-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-server.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Meteor permits users to modify their own profile by default, for some reason.                                       //
Meteor.users.deny({                                                                                                    // 18
  insert: function insert() {                                                                                          // 19
    return true;                                                                                                       // 19
  },                                                                                                                   // 19
                                                                                                                       //
  update: function update() {                                                                                          // 21
    return true;                                                                                                       // 21
  },                                                                                                                   // 21
                                                                                                                       //
  remove: function remove() {                                                                                          // 23
    return true;                                                                                                       // 23
  },                                                                                                                   // 23
                                                                                                                       //
  fetch: []                                                                                                            // 25
});                                                                                                                    // 18
                                                                                                                       //
Meteor.publish("getMyUsage", function () {                                                                             // 28
  var db = this.connection.sandstormDb;                                                                                // 29
  if (this.userId) {                                                                                                   // 30
    // TODO(someday): Make this reactive.                                                                              //
    var user = Meteor.users.findOne(this.userId);                                                                      // 32
    var usage = db.getMyUsage(user);                                                                                   // 33
    this.added("users", this.userId, {                                                                                 // 34
      pseudoUsage: usage                                                                                               // 35
    });                                                                                                                // 34
  }                                                                                                                    // 37
                                                                                                                       //
  this.ready();                                                                                                        // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"admin":{"admin-alert-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-alert-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var maintenanceMessageShape = {                                                                                        // 5
  text: String,                                                                                                        // 6
  time: Match.OneOf(Date, undefined, null),                                                                            // 7
  url: Match.Optional(String)                                                                                          // 8
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 11
  setMaintenanceMessage: function setMaintenanceMessage(params) {                                                      // 12
    checkAuth(undefined);                                                                                              // 13
    check(params, maintenanceMessageShape);                                                                            // 14
    var db = this.connection.sandstormDb;                                                                              // 15
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "adminAlertTime" }, { value: params.time });                                 // 17
    db.collections.settings.upsert({ _id: "adminAlertUrl" }, { value: params.url });                                   // 18
    db.collections.settings.upsert({ _id: "adminAlert" }, { value: params.text });                                     // 19
  }                                                                                                                    // 20
});                                                                                                                    // 11
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-user-invite.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-user-invite.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.publish("allInviteTokens", function () {                                                                        // 1
  var db = this.connection.sandstormDb;                                                                                // 2
  if (!db.isAdminById(this.userId)) {                                                                                  // 3
    throw new Meteor.Error(403, "User must be admin to list invite tokens.");                                          // 4
  }                                                                                                                    // 5
                                                                                                                       //
  return db.collections.signupKeys.find({});                                                                           // 7
});                                                                                                                    // 8
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"network-capabilities-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/network-capabilities-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
Meteor.publish("adminGrains", function (grainIds) {                                                                    // 5
  // If the caller is an admin, publishes the Grains referred to by the provided list of grain IDs.                    //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 8
  check(grainIds, [String]);                                                                                           // 9
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 11
  return db.collections.grains.find({                                                                                  // 12
    _id: {                                                                                                             // 13
      $in: grainIds                                                                                                    // 14
    }                                                                                                                  // 13
  }, {                                                                                                                 // 12
    fields: {                                                                                                          // 17
      identityId: 1,                                                                                                   // 18
      title: 1,                                                                                                        // 19
      packageId: 1                                                                                                     // 20
    }                                                                                                                  // 17
  });                                                                                                                  // 16
});                                                                                                                    // 23
                                                                                                                       //
Meteor.publish("adminPackages", function (packageIds) {                                                                // 25
  // If the caller is an admin, publishes the Packages referred to by the provided list of package                     //
  // IDs.  Otherwise, does nothing.                                                                                    //
  if (!isAdminById(this.userId)) return [];                                                                            // 28
  check(packageIds, [String]);                                                                                         // 29
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 31
  return db.collections.packages.find({                                                                                // 32
    _id: {                                                                                                             // 33
      $in: packageIds                                                                                                  // 34
    }                                                                                                                  // 33
  }, {                                                                                                                 // 32
    fields: {                                                                                                          // 37
      manifest: 1                                                                                                      // 38
    }                                                                                                                  // 37
  });                                                                                                                  // 36
});                                                                                                                    // 41
                                                                                                                       //
Meteor.publish("adminIdentities", function (identityIds) {                                                             // 43
  // If the caller is an admin, publishes the identity Users listed by ID in identityIds.                              //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 46
  check(identityIds, [String]);                                                                                        // 47
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 49
  return db.collections.users.find({                                                                                   // 50
    _id: {                                                                                                             // 51
      $in: identityIds                                                                                                 // 52
    }                                                                                                                  // 51
  });                                                                                                                  // 50
});                                                                                                                    // 55
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"personalization-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/personalization-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var personalizationMessageShape = {                                                                                    // 5
  serverTitle: String,                                                                                                 // 6
  splashUrl: String,                                                                                                   // 7
  signupDialog: String,                                                                                                // 8
  termsOfServiceUrl: String,                                                                                           // 9
  privacyPolicyUrl: String,                                                                                            // 10
                                                                                                                       //
  whitelabelCustomLoginProviderName: String,                                                                           // 12
  whitelabelHideSendFeedback: Boolean,                                                                                 // 13
  whitelabelHideTroubleshooting: Boolean,                                                                              // 14
  whitelabelUseServerTitleForHomeText: Boolean                                                                         // 15
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 18
  setPersonalizationSettings: function setPersonalizationSettings(params) {                                            // 19
    checkAuth(undefined);                                                                                              // 20
    check(params, personalizationMessageShape);                                                                        // 21
    var db = this.connection.sandstormDb;                                                                              // 22
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "serverTitle" }, { value: params.serverTitle });                             // 24
    db.collections.settings.upsert({ _id: "splashUrl" }, { value: params.splashUrl });                                 // 25
    db.collections.settings.upsert({ _id: "signupDialog" }, { value: params.signupDialog });                           // 26
    db.collections.settings.upsert({ _id: "termsUrl" }, { value: params.termsOfServiceUrl });                          // 27
    db.collections.settings.upsert({ _id: "privacyUrl" }, { value: params.privacyPolicyUrl });                         // 28
                                                                                                                       //
    db.collections.settings.upsert({ _id: "whitelabelCustomLoginProviderName" }, { value: params.whitelabelCustomLoginProviderName });
    db.collections.settings.upsert({ _id: "whitelabelHideSendFeedback" }, { value: params.whitelabelHideSendFeedback });
    db.collections.settings.upsert({ _id: "whitelabelHideTroubleshooting" }, { value: params.whitelabelHideTroubleshooting });
    db.collections.settings.upsert({ _id: "whitelabelUseServerTitleForHomeText" }, { value: params.whitelabelUseServerTitleForHomeText });
  },                                                                                                                   // 38
  getWhitelabelLogoUploadToken: function getWhitelabelLogoUploadToken() {                                              // 40
    checkAuth(undefined);                                                                                              // 41
    var db = this.connection.sandstormDb;                                                                              // 42
    return db.newAssetUpload({ loginLogo: {} });                                                                       // 43
  },                                                                                                                   // 44
  resetWhitelabelLogo: function resetWhitelabelLogo() {                                                                // 46
    checkAuth(undefined);                                                                                              // 47
    var db = this.connection.sandstormDb;                                                                              // 48
    var old = globalDb.collections.settings.findAndModify({                                                            // 49
      query: { _id: "whitelabelCustomLogoAssetId" },                                                                   // 50
      remove: true,                                                                                                    // 51
      fields: { value: 1 }                                                                                             // 52
    });                                                                                                                // 49
                                                                                                                       //
    if (old) {                                                                                                         // 55
      db.unrefStaticAsset(old.value);                                                                                  // 56
    }                                                                                                                  // 57
  }                                                                                                                    // 58
});                                                                                                                    // 18
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"system-status-server.js":["meteor/meteor","meteor/iron:router","meteor/random","crypto","fs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/system-status-server.js                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Router;module.import("meteor/iron:router",{"Router":function(v){Router=v}});var Random;module.import("meteor/random",{"Random":function(v){Random=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       //
var hashSessionId = function hashSessionId(sessionId) {                                                                // 7
  return Crypto.createHash("sha256").update(sessionId).digest("base64");                                               // 8
};                                                                                                                     // 9
                                                                                                                       //
// An in-memory map of random id -> timestamp, used to authorize requests to download the system                       //
// log.                                                                                                                //
var SYSTEM_LOG_DOWNLOAD_TOKENS = {};                                                                                   // 13
var SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION = 60000; // 60 seconds                                                 // 14
                                                                                                                       //
Meteor.methods({                                                                                                       // 16
  adminGetServerLogDownloadToken: function adminGetServerLogDownloadToken() {                                          // 17
    var db = this.connection.sandstormDb;                                                                              // 18
    if (!db.isAdminById(this.userId)) {                                                                                // 19
      throw new Meteor.Error(403, "User must be admin to download system log.");                                       // 20
    }                                                                                                                  // 21
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 23
    SYSTEM_LOG_DOWNLOAD_TOKENS[token] = Date.now();                                                                    // 24
    setTimeout(function () {                                                                                           // 25
      if (SYSTEM_LOG_DOWNLOAD_TOKENS[token]) {                                                                         // 26
        delete SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                                      // 27
      }                                                                                                                // 28
    }, SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION * 2);                                                               // 29
    return token;                                                                                                      // 30
  }                                                                                                                    // 31
});                                                                                                                    // 16
                                                                                                                       //
Router.map(function () {                                                                                               // 34
  this.route("adminDownloadServerLog", {                                                                               // 35
    where: "server",                                                                                                   // 36
    path: "/admin/status/server-log/:tokenId",                                                                         // 37
    action: function action() {                                                                                        // 38
      var token = this.params.tokenId;                                                                                 // 39
      var response = this.response;                                                                                    // 40
      var issueDate = SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                               // 41
      delete SYSTEM_LOG_DOWNLOAD_TOKENS[token]; // Clear the token from the in-memory map.                             // 42
      if (issueDate === undefined || issueDate + SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION < Date.now()) {           // 43
        // Require download to start within 60 seconds of the adminGetServerLogDownloadToken                           //
        // method being called.                                                                                        //
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 47
        return response.end("Invalid server log download token.");                                                     // 48
      }                                                                                                                // 49
                                                                                                                       //
      var logFilePath = SANDSTORM_LOGDIR + "/sandstorm.log";                                                           // 51
      var fd = Fs.openSync(logFilePath, "r");                                                                          // 52
      var stats = Fs.fstatSync(fd);                                                                                    // 53
      var initialSize = stats.size;                                                                                    // 54
      var readStream = Fs.createReadStream(undefined, {                                                                // 55
        fd: fd,                                                                                                        // 56
        start: 0,                                                                                                      // 57
        end: initialSize                                                                                               // 58
      });                                                                                                              // 55
                                                                                                                       //
      response.writeHead(200, {                                                                                        // 61
        "Content-Length": initialSize,                                                                                 // 62
        "Content-Type": "text/plain",                                                                                  // 63
        "content-Disposition": "attachment;filename=\"sandstorm.log\""                                                 // 64
      });                                                                                                              // 61
      readStream.pipe(response);                                                                                       // 66
    }                                                                                                                  // 67
  });                                                                                                                  // 35
});                                                                                                                    // 69
                                                                                                                       //
Meteor.publish("systemStatus", function () {                                                                           // 71
  // A pseudocollection containing the number of active grain sessions and unique                                      //
  // userIds associated with these sessions                                                                            //
  var db = this.connection.sandstormDb;                                                                                // 74
  if (!db.isAdminById(this.userId)) {                                                                                  // 75
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 76
  }                                                                                                                    // 77
                                                                                                                       //
  var _this = this;                                                                                                    // 79
  var userIdToSessionHashes = {}; // Maps userId => list of (sha256(sessionId))                                        // 80
  var grainIdToSessionHashes = {}; // Maps grainId => list of (sha256(sessionId))                                      // 81
                                                                                                                       //
  var userIdCount = 0;                                                                                                 // 83
  var grainIdCount = 0;                                                                                                // 84
                                                                                                                       //
  this.added("systemStatus", "globalStatus", {                                                                         // 86
    activeUsers: userIdCount,                                                                                          // 87
    activeGrains: grainIdCount                                                                                         // 88
  });                                                                                                                  // 86
                                                                                                                       //
  var query = db.collections.sessions.find();                                                                          // 91
  var handle = query.observe({                                                                                         // 92
    added: function added(session) {                                                                                   // 93
      var hashedSessionId = hashSessionId(session._id);                                                                // 94
      var changed = {};                                                                                                // 95
                                                                                                                       //
      // Update userId cache.                                                                                          //
      if (session.userId) {                                                                                            // 98
        if (userIdToSessionHashes[session.userId] === undefined) {                                                     // 99
          userIdToSessionHashes[session.userId] = [];                                                                  // 100
          userIdCount = userIdCount + 1;                                                                               // 101
          changed.activeUsers = userIdCount;                                                                           // 102
        }                                                                                                              // 103
                                                                                                                       //
        userIdToSessionHashes[session.userId] = _.union(userIdToSessionHashes[session.userId], [hashedSessionId]);     // 105
      }                                                                                                                // 107
                                                                                                                       //
      // Update grainId cache.                                                                                         //
      if (grainIdToSessionHashes[session.grainId] === undefined) {                                                     // 110
        grainIdToSessionHashes[session.grainId] = [];                                                                  // 111
        grainIdCount = grainIdCount + 1;                                                                               // 112
        changed.activeGrains = grainIdCount;                                                                           // 113
      }                                                                                                                // 114
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.union(grainIdToSessionHashes[session.grainId], [hashedSessionId]);   // 116
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 119
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 120
      }                                                                                                                // 121
    },                                                                                                                 // 122
    removed: function removed(session) {                                                                               // 124
      var hashedSessionId = hashSessionId(session._id);                                                                // 125
      var changed = {};                                                                                                // 126
                                                                                                                       //
      if (session.userId) {                                                                                            // 128
        userIdToSessionHashes[session.userId] = _.without(userIdToSessionHashes[session.userId], hashedSessionId);     // 129
                                                                                                                       //
        if (userIdToSessionHashes[session.userId].length === 0) {                                                      // 132
          delete userIdToSessionHashes[session.userId];                                                                // 133
          userIdCount = userIdCount - 1;                                                                               // 134
          changed.activeUsers = userIdCount;                                                                           // 135
        }                                                                                                              // 136
      }                                                                                                                // 137
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.without(grainIdToSessionHashes[session.grainId], hashedSessionId);   // 139
                                                                                                                       //
      if (grainIdToSessionHashes[session.grainId].length === 0) {                                                      // 142
        delete grainIdToSessionHashes[session.grainId];                                                                // 143
        grainIdCount = grainIdCount - 1;                                                                               // 144
        changed.activeGrains = grainIdCount;                                                                           // 145
      }                                                                                                                // 146
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 148
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 149
      }                                                                                                                // 150
    }                                                                                                                  // 151
  });                                                                                                                  // 92
                                                                                                                       //
  this.onStop(function () {                                                                                            // 154
    handle.stop();                                                                                                     // 155
  });                                                                                                                  // 156
  this.ready();                                                                                                        // 157
});                                                                                                                    // 158
                                                                                                                       //
Meteor.publish("adminDemoUsers", function () {                                                                         // 160
  // Publishes expiry information about demo accounts to admins, so demo users can be counted                          //
  // clientside and reactively updated.                                                                                //
  var db = this.connection.sandstormDb;                                                                                // 163
  if (!db.isAdminById(this.userId)) {                                                                                  // 164
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 165
  }                                                                                                                    // 166
                                                                                                                       //
  return db.collections.users.find({                                                                                   // 168
    expires: {                                                                                                         // 169
      $gt: new Date()                                                                                                  // 170
    },                                                                                                                 // 169
    loginIdentities: {                                                                                                 // 172
      $exists: true                                                                                                    // 173
    }                                                                                                                  // 172
  }, {                                                                                                                 // 168
    expires: 1,                                                                                                        // 176
    loginIdentities: 1                                                                                                 // 177
  });                                                                                                                  // 175
});                                                                                                                    // 179
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"drivers":{"external-ui-view.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/external-ui-view.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Promise = Npm.require("es6-promise").Promise;                                                                      // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var Url = Npm.require("url");                                                                                          // 20
var Http = Npm.require("http");                                                                                        // 21
var Https = Npm.require("https");                                                                                      // 22
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 23
                                                                                                                       //
WrappedUiView = function () {                                                                                          // 25
  function WrappedUiView(token, proxy) {                                                                               // 26
    _classCallCheck(this, WrappedUiView);                                                                              // 26
                                                                                                                       //
    // TODO(someday): handle the fact that these proxies will be garbage collected every 2 minutes,                    //
    // even if it's in use.                                                                                            //
    this.token = token;                                                                                                // 29
    this.proxy = proxy;                                                                                                // 30
  }                                                                                                                    // 31
                                                                                                                       //
  WrappedUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams, retryCount) {
    if (sessionType !== ApiSession.typeId) {                                                                           // 34
      throw new Error("SessionType must be ApiSession.");                                                              // 35
    }                                                                                                                  // 36
                                                                                                                       //
    retryCount = retryCount || 0;                                                                                      // 38
    var _this = this;                                                                                                  // 39
                                                                                                                       //
    return this.proxy.keepAlive().then(function () {                                                                   // 41
      // ignore the passed userInfo and instead use the one associated with this                                       //
      // token TODO(someday): Merge / intersect the two userInfo objects                                               //
      // (especially permissions) rather than only taking the token's user info.                                       //
      // This will allow the caller to request only a subset of the permissions                                        //
      // granted by the token, which is useful to protect against bugs.                                                //
      var session = _this.proxy.uiView.newSession(_this.proxy.userInfo, context, sessionType, sessionParams).session;  // 47
      return { session: session };                                                                                     // 49
    })["catch"](function (error) {                                                                                     // 50
      return _this.proxy.maybeRetryAfterError(error, retryCount).then(function () {                                    // 51
        return _this.newSession(userInfo, context, sessionType, sessionParams, retryCount + 1);                        // 52
      });                                                                                                              // 53
    });                                                                                                                // 54
  };                                                                                                                   // 55
                                                                                                                       //
  return WrappedUiView;                                                                                                // 25
}();                                                                                                                   // 25
                                                                                                                       //
getWrappedUiViewForToken = function getWrappedUiViewForToken(token) {                                                  // 58
  var proxyPromise = getProxyForApiToken(token);                                                                       // 59
                                                                                                                       //
  return proxyPromise.then(function (proxy) {                                                                          // 61
    return { view: new WrappedUiView(token, proxy) };                                                                  // 62
  });                                                                                                                  // 63
};                                                                                                                     // 64
                                                                                                                       //
ExternalUiView = function () {                                                                                         // 66
  function ExternalUiView(url, grainId, token) {                                                                       // 67
    _classCallCheck(this, ExternalUiView);                                                                             // 67
                                                                                                                       //
    this.url = url;                                                                                                    // 68
    this.grainId = grainId;                                                                                            // 69
    this.token = token;                                                                                                // 70
  }                                                                                                                    // 71
                                                                                                                       //
  ExternalUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams) {           // 66
    if (sessionType !== ApiSession.typeId) {                                                                           // 74
      throw new Error("SessionType must be ApiSession.");                                                              // 75
    }                                                                                                                  // 76
                                                                                                                       //
    var options = {};                                                                                                  // 78
                                                                                                                       //
    if (this.token) {                                                                                                  // 80
      options.headers = {                                                                                              // 81
        authorization: "Bearer " + this.token                                                                          // 82
      };                                                                                                               // 81
    }                                                                                                                  // 84
                                                                                                                       //
    return { session: new Capnp.Capability(new ExternalWebSession(this.url, this.grainId, options), ApiSession) };     // 86
  };                                                                                                                   // 87
                                                                                                                       //
  return ExternalUiView;                                                                                               // 66
}();                                                                                                                   // 66
                                                                                                                       //
var responseCodes = {                                                                                                  // 90
  200: { type: "content", code: "ok" },                                                                                // 91
  201: { type: "content", code: "created" },                                                                           // 92
  202: { type: "content", code: "accepted" },                                                                          // 93
  204: { type: "noContent", shouldResetForm: false },                                                                  // 94
  205: { type: "noContent", shouldResetForm: true },                                                                   // 95
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 206: {type: 'noContent'},                                                                                         //
  // 300: {type: 'redirect'},                                                                                          //
  301: { type: "redirect", switchToGet: true, isPermanent: true },                                                     // 100
  302: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 101
  303: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 102
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 304: {type: 'redirect'},                                                                                          //
  // 305: {type: 'redirect'},                                                                                          //
  307: { type: "redirect", switchToGet: false, isPermanent: false },                                                   // 107
  308: { type: "redirect", switchToGet: false, isPermanent: true },                                                    // 108
  400: { type: "clientError", clientErrorCode: "badRequest", descriptionHtml: "Bad Request" },                         // 109
  403: { type: "clientError", clientErrorCode: "forbidden", descriptionHtml: "Forbidden" },                            // 110
  404: { type: "clientError", clientErrorCode: "notFound", descriptionHtml: "Not Found" },                             // 111
  405: { type: "clientError", clientErrorCode: "methodNotAllowed", descriptionHtml: "Method Not Allowed" },            // 112
  406: { type: "clientError", clientErrorCode: "notAcceptable", descriptionHtml: "Not Acceptable" },                   // 113
  409: { type: "clientError", clientErrorCode: "conflict", descriptionHtml: "Conflict" },                              // 114
  410: { type: "clientError", clientErrorCode: "gone", descriptionHtml: "Gone" },                                      // 115
  413: { type: "clientError", clientErrorCode: "requestEntityTooLarge", descriptionHtml: "Request Entity Too Large" },
  414: { type: "clientError", clientErrorCode: "requestUriTooLong", descriptionHtml: "Request-URI Too Long" },         // 117
  415: { type: "clientError", clientErrorCode: "unsupportedMediaType", descriptionHtml: "Unsupported Media Type" },    // 118
  418: { type: "clientError", clientErrorCode: "imATeapot", descriptionHtml: "I'm a teapot" },                         // 119
  500: { type: "serverError" },                                                                                        // 120
  501: { type: "serverError" },                                                                                        // 121
  502: { type: "serverError" },                                                                                        // 122
  503: { type: "serverError" },                                                                                        // 123
  504: { type: "serverError" },                                                                                        // 124
  505: { type: "serverError" }                                                                                         // 125
};                                                                                                                     // 90
                                                                                                                       //
ExternalWebSession = function () {                                                                                     // 128
  function ExternalWebSession(url, grainId, options) {                                                                 // 129
    _classCallCheck(this, ExternalWebSession);                                                                         // 129
                                                                                                                       //
    var parsedUrl = Url.parse(url);                                                                                    // 130
    this.host = parsedUrl.hostname;                                                                                    // 131
    this.port = parsedUrl.port;                                                                                        // 132
    this.protocol = parsedUrl.protocol;                                                                                // 133
    this.grainId = grainId;                                                                                            // 134
    this.options = options || {};                                                                                      // 135
  }                                                                                                                    // 136
                                                                                                                       //
  ExternalWebSession.prototype.get = function get(path, context) {                                                     // 128
    return this._requestHelper("GET", path, context);                                                                  // 139
  };                                                                                                                   // 140
                                                                                                                       //
  ExternalWebSession.prototype.post = function post(path, content, context) {                                          // 128
    return this._requestHelper("POST", path, context, content.content, content.mimeType);                              // 143
  };                                                                                                                   // 144
                                                                                                                       //
  ExternalWebSession.prototype.put = function put(path, content, context) {                                            // 128
    return this._requestHelper("PUT", path, context, content.content, content.mimeType);                               // 147
  };                                                                                                                   // 148
                                                                                                                       //
  ExternalWebSession.prototype["delete"] = function _delete(path, context) {                                           // 128
    return this._requestHelper("DELETE", path, context);                                                               // 151
  };                                                                                                                   // 152
                                                                                                                       //
  // TODO(someday): implement streaming and websockets for ExternalWebSession                                          //
  //postStreaming(path, mimeType, context) {                                                                           //
  //}                                                                                                                  //
                                                                                                                       //
  //putStreaming(path, mimeType, context) {                                                                            //
  //}                                                                                                                  //
                                                                                                                       //
  //openWebSocket(path, context, protocol, clientStream) {                                                             //
  //}                                                                                                                  //
                                                                                                                       //
  ExternalWebSession.prototype._requestHelper = function _requestHelper(method, path, context, content, contentType) {
    var _this = this;                                                                                                  // 165
    var session = _this;                                                                                               // 166
    return new Promise(function (resolve, reject) {                                                                    // 167
      var options = _.clone(session.options);                                                                          // 168
      options.headers = options.headers || {};                                                                         // 169
      options.path = path;                                                                                             // 170
      options.method = method;                                                                                         // 171
      if (contentType) {                                                                                               // 172
        options.headers["content-type"] = contentType;                                                                 // 173
      }                                                                                                                // 174
                                                                                                                       //
      // set accept header                                                                                             //
      if ("accept" in context) {                                                                                       // 177
        options.headers.accept = context.accept.map(function (acceptedType) {                                          // 178
          return acceptedType.mimeType + "; " + acceptedType.qValue;                                                   // 179
        }).join(", ");                                                                                                 // 180
      } else if (!("accept" in options.headers)) {                                                                     // 181
        options.headers.accept = "*/*";                                                                                // 182
      }                                                                                                                // 183
                                                                                                                       //
      // set cookies                                                                                                   //
      if (context.cookies && context.cookies.length > 0) {                                                             // 186
        options.headers.cookies = options.headers.cookies || "";                                                       // 187
        context.cookies.forEach(function (keyVal) {                                                                    // 188
          options.headers.cookies += keyVal.key + "=" + keyVal.val + ",";                                              // 189
        });                                                                                                            // 190
        options.headers.cookies = options.headers.cookies.slice(0, -1);                                                // 191
      }                                                                                                                // 192
                                                                                                                       //
      options.host = session.host;                                                                                     // 194
      options.port = session.port;                                                                                     // 195
                                                                                                                       //
      var requestMethod = Http.request;                                                                                // 197
      if (session.protocol === "https:") {                                                                             // 198
        requestMethod = Https.request;                                                                                 // 199
      }                                                                                                                // 200
                                                                                                                       //
      req = requestMethod(options, function (resp) {                                                                   // 202
        var buffers = [];                                                                                              // 203
        var statusInfo = responseCodes[resp.statusCode];                                                               // 204
                                                                                                                       //
        var rpcResponse = {};                                                                                          // 206
                                                                                                                       //
        switch (statusInfo.type) {                                                                                     // 208
          case "content":                                                                                              // 209
            resp.on("data", function (buf) {                                                                           // 210
              buffers.push(buf);                                                                                       // 211
            });                                                                                                        // 212
                                                                                                                       //
            resp.on("end", function () {                                                                               // 214
              var content = {};                                                                                        // 215
              rpcResponse.content = content;                                                                           // 216
                                                                                                                       //
              content.statusCode = statusInfo.code;                                                                    // 218
              if ("content-encoding" in resp.headers) content.encoding = resp.headers["content-encoding"];             // 219
              if ("content-language" in resp.headers) content.language = resp.headers["content-language"];             // 220
              if ("content-type" in resp.headers) content.language = resp.headers["content-type"];                     // 221
              if ("content-disposition" in resp.headers) {                                                             // 222
                var disposition = resp.headers["content-disposition"];                                                 // 223
                var parts = disposition.split(";");                                                                    // 224
                if (parts[0].toLowerCase().trim() === "attachment") {                                                  // 225
                  parts.forEach(function (part) {                                                                      // 226
                    var splitPart = part.split("=");                                                                   // 227
                    if (splitPart[0].toLowerCase().trim() === "filename") {                                            // 228
                      content.disposition = { download: splitPart[1].trim() };                                         // 229
                    }                                                                                                  // 230
                  });                                                                                                  // 231
                }                                                                                                      // 232
              }                                                                                                        // 233
                                                                                                                       //
              content.body = {};                                                                                       // 235
              content.body.bytes = Buffer.concat(buffers);                                                             // 236
                                                                                                                       //
              resolve(rpcResponse);                                                                                    // 238
            });                                                                                                        // 239
            break;                                                                                                     // 240
          case "noContent":                                                                                            // 241
            var noContent = {};                                                                                        // 242
            rpcResponse.noContent = noContent;                                                                         // 243
            noContent.setShouldResetForm = statusInfo.shouldResetForm;                                                 // 244
            resolve(rpcResponse);                                                                                      // 245
            break;                                                                                                     // 246
          case "redirect":                                                                                             // 247
            var redirect = {};                                                                                         // 248
            rpcResponse.redirect = redirect;                                                                           // 249
            redirect.isPermanent = statusInfo.isPermanent;                                                             // 250
            redirect.switchToGet = statusInfo.switchToGet;                                                             // 251
            if ("location" in resp.headers) redirect.location = resp.headers.location;                                 // 252
            resolve(rpcResponse);                                                                                      // 253
            break;                                                                                                     // 254
          case "clientError":                                                                                          // 255
            var clientError = {};                                                                                      // 256
            rpcResponse.clientError = clientError;                                                                     // 257
            clientError.statusCode = statusInfo.clientErrorCode;                                                       // 258
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 259
            resolve(rpcResponse);                                                                                      // 260
            break;                                                                                                     // 261
          case "serverError":                                                                                          // 262
            var serverError = {};                                                                                      // 263
            rpcResponse.serverError = serverError;                                                                     // 264
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 265
            resolve(rpcResponse);                                                                                      // 266
            break;                                                                                                     // 267
          default:                                                                                                     // 268
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 269
            reject(err);                                                                                               // 270
            break;                                                                                                     // 271
        }                                                                                                              // 208
      });                                                                                                              // 273
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 275
        reject(e);                                                                                                     // 276
      });                                                                                                              // 277
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 279
        req.abort();                                                                                                   // 280
        err = new Error("Request timed out.");                                                                         // 281
        err.kjType = "overloaded";                                                                                     // 282
        reject(err);                                                                                                   // 283
      });                                                                                                              // 284
                                                                                                                       //
      if (content) {                                                                                                   // 286
        req.end(content);                                                                                              // 287
      } else {                                                                                                         // 288
        req.end();                                                                                                     // 289
      }                                                                                                                // 290
    });                                                                                                                // 291
  };                                                                                                                   // 292
                                                                                                                       //
  return ExternalWebSession;                                                                                           // 128
}();                                                                                                                   // 128
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"ip.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","bignum","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/ip.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Future = Npm.require("fibers/future");                                                                             // 19
var Net = Npm.require("net");                                                                                          // 20
var Dgram = Npm.require("dgram");                                                                                      // 21
var Promise = Npm.require("es6-promise").Promise;                                                                      // 22
var Capnp = Npm.require("capnp");                                                                                      // 23
                                                                                                                       //
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 25
                                                                                                                       //
ByteStreamConnection = function () {                                                                                   // 27
  function ByteStreamConnection(connection) {                                                                          // 28
    _classCallCheck(this, ByteStreamConnection);                                                                       // 28
                                                                                                                       //
    this.connection = connection;                                                                                      // 29
  }                                                                                                                    // 30
                                                                                                                       //
  ByteStreamConnection.prototype.done = function done() {                                                              // 27
    this.connection.end();                                                                                             // 33
  };                                                                                                                   // 34
                                                                                                                       //
  ByteStreamConnection.prototype.write = function write(data) {                                                        // 27
    this.connection.write(data);                                                                                       // 37
  };                                                                                                                   // 38
                                                                                                                       //
  // expectSize not implemented                                                                                        //
  // expectSize(size) { }                                                                                              //
                                                                                                                       //
                                                                                                                       //
  return ByteStreamConnection;                                                                                         // 27
}();                                                                                                                   // 27
                                                                                                                       //
var IpInterfaceImpl = function (_PersistentImpl) {                                                                     //
  _inherits(IpInterfaceImpl, _PersistentImpl);                                                                         //
                                                                                                                       //
  function IpInterfaceImpl(db, saveTemplate) {                                                                         // 45
    _classCallCheck(this, IpInterfaceImpl);                                                                            // 45
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                             // 45
  }                                                                                                                    // 47
                                                                                                                       //
  IpInterfaceImpl.prototype.listenTcp = function listenTcp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 50
      var resolved = false;                                                                                            // 51
      var server = Net.createServer(function (connection) {                                                            // 52
        var wrappedConnection = new ByteStreamConnection(connection);                                                  // 53
        var upstream = port.connect(wrappedConnection).upstream;                                                       // 54
                                                                                                                       //
        connection.on("data", function (data) {                                                                        // 56
          upstream.write(data);                                                                                        // 57
        });                                                                                                            // 58
                                                                                                                       //
        connection.on("close", function (hadError) {                                                                   // 60
          upstream.done();                                                                                             // 61
        });                                                                                                            // 62
                                                                                                                       //
        connection.on("error", function (err) {                                                                        // 64
          if (resolved) {                                                                                              // 65
            connection.write = errorWrite;                                                                             // 66
          } else {                                                                                                     // 67
            // upstream hasn't been resolved yet, so it's safe to reject                                               //
            reject(err);                                                                                               // 69
          }                                                                                                            // 70
        });                                                                                                            // 71
      });                                                                                                              // 72
                                                                                                                       //
      server.listen(portNum, function () {                                                                             // 74
        resolved = true;                                                                                               // 75
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 76
      });                                                                                                              // 77
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 79
        if (!resolved) {                                                                                               // 80
          reject(err);                                                                                                 // 81
        }                                                                                                              // 82
      });                                                                                                              // 83
    });                                                                                                                // 84
  };                                                                                                                   // 85
                                                                                                                       //
  IpInterfaceImpl.prototype.listenUdp = function listenUdp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 88
      var portMap = {};                                                                                                // 89
      var resolved = false;                                                                                            // 90
      var server = Dgram.createSocket("udp4"); // TODO(someday): handle ipv6 sockets too                               // 91
      server.bind(portNum);                                                                                            // 92
                                                                                                                       //
      server.on("listening", function () {                                                                             // 94
        // Although UDP is connectionless, we don't resolve until here so that we can handle bind                      //
        // errors such as invalid host                                                                                 //
        resolved = true;                                                                                               // 97
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 98
      });                                                                                                              // 99
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 101
        // TODO(someday): do something about errors after the promise is resolved                                      //
        if (!resolved) {                                                                                               // 103
          reject(err);                                                                                                 // 104
        } else {                                                                                                       // 105
          console.error("error in listenUdp: " + err);                                                                 // 106
        }                                                                                                              // 107
      });                                                                                                              // 108
                                                                                                                       //
      var returnMap = {};                                                                                              // 110
      server.on("message", function (msg, rinfo) {                                                                     // 111
        var address = rinfo.address + "]:" + rinfo.port;                                                               // 112
        var returnPort = returnMap[address];                                                                           // 113
                                                                                                                       //
        if (!returnPort) {                                                                                             // 115
          returnMap[address] = returnPort = new BoundUdpPortImpl(server, rinfo.address, rinfo.port);                   // 116
        }                                                                                                              // 117
                                                                                                                       //
        port.send(msg, returnPort);                                                                                    // 119
      });                                                                                                              // 120
    });                                                                                                                // 121
  };                                                                                                                   // 122
                                                                                                                       //
  return IpInterfaceImpl;                                                                                              //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 123
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 127
  globalFrontendRefRegistry.register({                                                                                 // 128
    frontendRefField: "ipInterface",                                                                                   // 129
    typeId: IpRpc.IpInterface.typeId,                                                                                  // 130
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 132
      return new Capnp.Capability(new IpInterfaceImpl(db, saveTemplate), IpRpc.PersistentIpInterface);                 // 133
    },                                                                                                                 // 135
    validate: function validate(db, session, value) {                                                                  // 137
      check(value, true);                                                                                              // 138
                                                                                                                       //
      if (!session.userId) {                                                                                           // 140
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 141
      }                                                                                                                // 142
                                                                                                                       //
      return {                                                                                                         // 144
        descriptor: { tags: [{ id: IpRpc.IpInterface.typeId }] },                                                      // 145
        requirements: [{ userIsAdmin: session.userId }]                                                                // 146
      };                                                                                                               // 144
    },                                                                                                                 // 148
    query: function query(db, userId, value) {                                                                         // 150
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 151
        return [{                                                                                                      // 152
          _id: "frontendref-ipinterface",                                                                              // 154
          frontendRef: { ipInterface: true },                                                                          // 155
          cardTemplate: "ipInterfacePowerboxCard"                                                                      // 156
        }];                                                                                                            // 153
      } else {                                                                                                         // 159
        return [];                                                                                                     // 160
      }                                                                                                                // 161
    }                                                                                                                  // 162
  });                                                                                                                  // 128
});                                                                                                                    // 164
                                                                                                                       //
BoundUdpPortImpl = function () {                                                                                       // 166
  function BoundUdpPortImpl(server, address, port) {                                                                   // 167
    _classCallCheck(this, BoundUdpPortImpl);                                                                           // 167
                                                                                                                       //
    this.server = server;                                                                                              // 168
    this.address = address;                                                                                            // 169
    this.port = port;                                                                                                  // 170
  }                                                                                                                    // 171
                                                                                                                       //
  BoundUdpPortImpl.prototype.send = function send(message, returnPort) {                                               // 166
    // TODO(someday): this whole class is a hack to deal with the fact that we can't compare                           //
    // capabilities or build a map with them. What we should be doing is mapping all ports to                          //
    // their raw physical address/port, and using that here                                                            //
    this.server.send(message, 0, message.length, this.port, this.address);                                             // 177
  };                                                                                                                   // 178
                                                                                                                       //
  return BoundUdpPortImpl;                                                                                             // 166
}();                                                                                                                   // 166
                                                                                                                       //
var bits16 = Bignum(1).shiftLeft(16).sub(1);                                                                           // 181
var bits32 = Bignum(1).shiftLeft(32).sub(1);                                                                           // 182
                                                                                                                       //
var intToIpv4 = function intToIpv4(num) {                                                                              // 184
  var part1 = num & 255;                                                                                               // 185
  var part2 = num >> 8 & 255;                                                                                          // 186
  var part3 = num >> 16 & 255;                                                                                         // 187
  var part4 = num >> 24 & 255;                                                                                         // 188
                                                                                                                       //
  return part4 + "." + part3 + "." + part2 + "." + part1;                                                              // 190
};                                                                                                                     // 191
                                                                                                                       //
var addressToString = function addressToString(address) {                                                              // 193
  var ipv6num = Bignum(address.upper64).shiftLeft(64).add(Bignum(address.lower64));                                    // 194
                                                                                                                       //
  if (ipv6num.shiftRight(32).eq(bits16)) {                                                                             // 196
    // this is an ipv4 address, we should return it as such                                                            //
    var ipv4num = ipv6num.and(bits32).toNumber();                                                                      // 198
    return intToIpv4(ipv4num);                                                                                         // 199
  }                                                                                                                    // 200
                                                                                                                       //
  var hex = ipv6num.toString(16);                                                                                      // 202
  var numColons = 0;                                                                                                   // 203
  var out = "";                                                                                                        // 204
                                                                                                                       //
  for (var i = 0; i < hex.length; ++i) {                                                                               // 206
    // start with lower bits of address and build the output in reverse                                                //
    // this ensures that we can place a colon every 4 characters                                                       //
    out += hex[hex.length - 1 - i];                                                                                    // 209
    if ((i + 1) % 4 === 0) {                                                                                           // 210
      out += ":";                                                                                                      // 211
      ++numColons;                                                                                                     // 212
    }                                                                                                                  // 213
  }                                                                                                                    // 214
                                                                                                                       //
  // Double colon represents all bits being 0                                                                          //
  if (numColons < 7) {                                                                                                 // 217
    out += "::";                                                                                                       // 218
  }                                                                                                                    // 219
                                                                                                                       //
  return out.split("").reverse().join("");                                                                             // 221
};                                                                                                                     // 222
                                                                                                                       //
var addressType = function addressType(address) {                                                                      // 224
  var type = "udp4";                                                                                                   // 225
                                                                                                                       //
  // Check if it's an ipv6 address                                                                                     //
  // TODO(someday): make this less hacky and change address to explicitly pass this information                        //
  if (address.indexOf(":") != -1) {                                                                                    // 229
    type = "udp6";                                                                                                     // 230
  }                                                                                                                    // 231
                                                                                                                       //
  return type;                                                                                                         // 233
};                                                                                                                     // 234
                                                                                                                       //
var IpNetworkImpl = function (_PersistentImpl2) {                                                                      //
  _inherits(IpNetworkImpl, _PersistentImpl2);                                                                          //
                                                                                                                       //
  function IpNetworkImpl(db, saveTemplate) {                                                                           // 237
    _classCallCheck(this, IpNetworkImpl);                                                                              // 237
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 237
  }                                                                                                                    // 239
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHost = function getRemoteHost(address) {                                            //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 242
  };                                                                                                                   // 243
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHostByName = function getRemoteHostByName(address) {                                //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 246
  };                                                                                                                   // 247
                                                                                                                       //
  return IpNetworkImpl;                                                                                                //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 248
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 252
  globalFrontendRefRegistry.register({                                                                                 // 253
    frontendRefField: "ipNetwork",                                                                                     // 254
    typeId: IpRpc.IpNetwork.typeId,                                                                                    // 255
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 257
      return new Capnp.Capability(new IpNetworkImpl(db, saveTemplate), IpRpc.PersistentIpNetwork);                     // 258
    },                                                                                                                 // 260
    validate: function validate(db, session, value) {                                                                  // 262
      check(value, true);                                                                                              // 263
                                                                                                                       //
      if (!session.userId) {                                                                                           // 265
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 266
      }                                                                                                                // 267
                                                                                                                       //
      return {                                                                                                         // 269
        descriptor: { tags: [{ id: IpRpc.IpNetwork.typeId }] },                                                        // 270
        requirements: [{ userIsAdmin: session.userId }]                                                                // 271
      };                                                                                                               // 269
    },                                                                                                                 // 273
    query: function query(db, userId, value) {                                                                         // 275
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 276
        return [{                                                                                                      // 277
          _id: "frontendref-ipnetwork",                                                                                // 279
          frontendRef: { ipNetwork: true },                                                                            // 280
          cardTemplate: "ipNetworkPowerboxCard"                                                                        // 281
        }];                                                                                                            // 278
      } else {                                                                                                         // 284
        return [];                                                                                                     // 285
      }                                                                                                                // 286
    }                                                                                                                  // 287
  });                                                                                                                  // 253
});                                                                                                                    // 289
                                                                                                                       //
IpRemoteHostImpl = function () {                                                                                       // 291
  function IpRemoteHostImpl(address) {                                                                                 // 292
    _classCallCheck(this, IpRemoteHostImpl);                                                                           // 292
                                                                                                                       //
    if (address.upper64 || address.upper64 === 0) {                                                                    // 293
      // address is an ip.capnp:IpAddress, we need to convert it                                                       //
      this.address = addressToString(address);                                                                         // 295
    } else {                                                                                                           // 296
      this.address = address;                                                                                          // 297
    }                                                                                                                  // 298
  }                                                                                                                    // 299
                                                                                                                       //
  IpRemoteHostImpl.prototype.getTcpPort = function getTcpPort(portNum) {                                               // 291
    return { port: new TcpPortImpl(this.address, portNum) };                                                           // 302
  };                                                                                                                   // 303
                                                                                                                       //
  IpRemoteHostImpl.prototype.getUdpPort = function getUdpPort(portNum) {                                               // 291
    return { port: new UdpPortImpl(this.address, portNum) };                                                           // 306
  };                                                                                                                   // 307
                                                                                                                       //
  return IpRemoteHostImpl;                                                                                             // 291
}();                                                                                                                   // 291
                                                                                                                       //
TcpPortImpl = function () {                                                                                            // 310
  function TcpPortImpl(address, portNum) {                                                                             // 311
    _classCallCheck(this, TcpPortImpl);                                                                                // 311
                                                                                                                       //
    this.address = address;                                                                                            // 312
    this.port = portNum;                                                                                               // 313
  }                                                                                                                    // 314
                                                                                                                       //
  TcpPortImpl.prototype.connect = function connect(downstream) {                                                       // 310
    var _this = this;                                                                                                  // 317
    var resolved = false;                                                                                              // 318
    return new Promise(function (resolve, reject) {                                                                    // 319
      var client = Net.connect({ host: _this.address, port: _this.port }, function () {                                // 320
        resolved = true;                                                                                               // 321
        resolve({ upstream: new ByteStreamConnection(client) });                                                       // 322
      });                                                                                                              // 323
                                                                                                                       //
      client.on("data", function (data) {                                                                              // 325
        downstream.write(data);                                                                                        // 326
      });                                                                                                              // 327
                                                                                                                       //
      client.on("close", function (hadError) {                                                                         // 329
        downstream.done();                                                                                             // 330
      });                                                                                                              // 331
                                                                                                                       //
      client.on("error", function (err) {                                                                              // 333
        if (resolved) {                                                                                                // 334
          client.write = errorWrite;                                                                                   // 335
        } else {                                                                                                       // 336
          // upstream hasn't been resolved yet, so it's safe to reject                                                 //
          reject(err);                                                                                                 // 338
        }                                                                                                              // 339
      });                                                                                                              // 340
    });                                                                                                                // 341
  };                                                                                                                   // 342
                                                                                                                       //
  return TcpPortImpl;                                                                                                  // 310
}();                                                                                                                   // 310
                                                                                                                       //
var errorWrite = function errorWrite(data) {                                                                           // 345
  throw new Error("error occurred in connection");                                                                     // 346
};                                                                                                                     // 347
                                                                                                                       //
UdpPortImpl = function () {                                                                                            // 349
  function UdpPortImpl(address, portNum) {                                                                             // 350
    _classCallCheck(this, UdpPortImpl);                                                                                // 350
                                                                                                                       //
    this.address = address;                                                                                            // 351
    this.port = portNum;                                                                                               // 352
                                                                                                                       //
    var type = addressType(address);                                                                                   // 354
    this.socket = Dgram.createSocket(type);                                                                            // 355
                                                                                                                       //
    // TODO(someday): close socket after a certain time of inactivity?                                                 //
    // This may be pointless since grains are killed frequently when not in use anyways                                //
                                                                                                                       //
    // Temporary hack. We only expect clients to pass in a single return port, so we'll store it                       //
    // and only send replies here.                                                                                     //
    // This will be changed to be correct when equality comparisons are added to capabilities.                         //
    this.returnPort = null;                                                                                            // 363
                                                                                                                       //
    var _this = this;                                                                                                  // 365
    this.socket.on("message", function (msg, rinfo) {                                                                  // 366
      if (_this.returnPort) {                                                                                          // 367
        _this.returnPort.send(msg, _this);                                                                             // 368
      }                                                                                                                // 369
    });                                                                                                                // 370
  }                                                                                                                    // 371
                                                                                                                       //
  UdpPortImpl.prototype.send = function send(message, returnPort) {                                                    // 349
    this.returnPort = returnPort;                                                                                      // 374
    this.socket.send(message, 0, message.length, this.port, this.address);                                             // 375
                                                                                                                       //
    // TODO(someday): use callback to catch errors and do something with them                                          //
  };                                                                                                                   // 378
                                                                                                                       //
  return UdpPortImpl;                                                                                                  // 349
}();                                                                                                                   // 349
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"mail.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/mail.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Promise = Npm.require("es6-promise").Promise;                                                                      // 21
var Capnp = Npm.require("capnp");                                                                                      // 22
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 24
var EmailImpl = Capnp.importSystem("sandstorm/email-impl.capnp");                                                      // 25
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 26
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 27
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 28
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 30
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 32
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 33
                                                                                                                       //
var RECIPIENT_LIMIT = 20;                                                                                              // 35
                                                                                                                       //
var CLIENT_TIMEOUT = 15000; // 15s                                                                                     // 37
                                                                                                                       //
// Every day, reset all per-user sent counts to zero.                                                                  //
// TODO(cleanup): Consider a more granular approach. For example, each user could have a timer                         //
//   after which their count will reset. We'd only check the timer when that user is trying to                         //
//   send a new message. This avoids a global query.                                                                   //
if (!Meteor.settings.replicaNumber) {                                                                                  // 43
  // only first replica                                                                                                //
  SandstormDb.periodicCleanup(86400000, function () {                                                                  // 44
    Meteor.users.update({ dailySentMailCount: { $exists: true } }, { $unset: { dailySentMailCount: "" } }, { multi: true });
  });                                                                                                                  // 48
}                                                                                                                      // 49
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 51
  var server = simplesmtp.createSimpleServer({ SMTPBanner: "Sandstorm Mail Server" }, function (req) {                 // 52
    var mailparser = new MailParser();                                                                                 // 53
    req.pipe(mailparser);                                                                                              // 54
                                                                                                                       //
    mailparser.on("end", function (mail) {                                                                             // 56
      // Wrap in outer promise for easier error handling.                                                              //
      Promise.resolve().then(function () {                                                                             // 58
        // Extract the 'from' address.                                                                                 //
        var from = void 0;                                                                                             // 60
        if (mail.from && mail.from.length > 0) {                                                                       // 61
          // It's theoretically possible for the message to have multiple 'from' headers, but this                     //
          // never really happens in legitimate practice so we'll just take the first one.                             //
          from = mail.from[0];                                                                                         // 64
        } else {                                                                                                       // 65
          // The mail body is missing a 'From:' header. We'll use req.from instead. Note that                          //
          // req.from is actually the bounce address, which is sometimes *not* the original sender                     //
          // but rather some intermediate agent (e.g. a mailing list daemon). See:                                     //
          //   http://en.wikipedia.org/wiki/Bounce_address                                                             //
          // TODO(someday): Is this really right, or should we report a blank address instead?                         //
          from = { address: req.from, name: false };                                                                   // 71
        }                                                                                                              // 72
                                                                                                                       //
        var attachments = [];                                                                                          // 74
        if (mail.attachments) {                                                                                        // 75
          attachments = mail.attachments.map(function (attachment) {                                                   // 76
            var disposition = attachment.contentDisposition || "attachment";                                           // 77
            disposition += ';\n\tfilename="' + (attachment.fileName || attachment.generatedFileName) + '"';            // 78
            return {                                                                                                   // 79
              contentType: attachment.contentType,                                                                     // 80
              contentDisposition: disposition,                                                                         // 81
              contentId: attachment.contentId,                                                                         // 82
              content: attachment.content                                                                              // 83
            };                                                                                                         // 79
          });                                                                                                          // 85
        }                                                                                                              // 86
                                                                                                                       //
        if (mail.replyTo && mail.replyTo.length > 1) {                                                                 // 88
          console.error("More than one reply-to address address was received in an email.");                           // 89
        }                                                                                                              // 90
                                                                                                                       //
        var mailMessage = {                                                                                            // 92
          // Note that converting the date to nanoseconds actually goes outside the range of                           //
          // integers that Javascript can represent precisely. But this is OK because dates aren't                     //
          // precise anyway.                                                                                           //
          date: (mail.date || new Date()).getTime() * 1000000,                                                         // 96
          from: from,                                                                                                  // 97
          to: mail.to,                                                                                                 // 98
          cc: mail.cc || [],                                                                                           // 99
          bcc: mail.bcc || [],                                                                                         // 100
          replyTo: mail.replyTo && mail.replyTo[0] || {},                                                              // 101
          messageId: mail.headers["message-id"] || Meteor.uuid() + "@" + HOSTNAME,                                     // 102
          references: mail.references || [],                                                                           // 103
          inReplyTo: mail.inReplyTo || [],                                                                             // 104
          subject: mail.subject || "",                                                                                 // 105
          text: mail.text || null,                                                                                     // 106
          html: mail.html || null,                                                                                     // 107
          attachments: attachments                                                                                     // 108
        };                                                                                                             // 92
                                                                                                                       //
        // Get list of grain IDs.                                                                                      //
        var grainPublicIds = _.uniq(req.to.map(function (deliverTo) {                                                  // 112
          // simplesmtp already validates that the address contains an @.                                              //
          // To simplify things, we ignore the hostname part of the address and assume that the                        //
          // message would not have been sent here if it weren't intended for our host. Usually                        //
          // there will be an nginx frontend verifying hostnames anyway. Grain public IDs are                          //
          // globally unique anyway, so an e-mail meant for another server presumably won't match                      //
          // any ID at this one anyway.                                                                                //
          return deliverTo.slice(0, deliverTo.indexOf("@"));                                                           // 119
        }));                                                                                                           // 120
                                                                                                                       //
        // Deliver to each grain in parallel.                                                                          //
        return Promise.all(grainPublicIds.map(function (publicId) {                                                    // 123
          // Wrap in a function so that we can call it recursively to retry.                                           //
          var tryDeliver = function tryDeliver(retryCount) {                                                           // 125
            var grainId = void 0;                                                                                      // 126
            return inMeteor(function () {                                                                              // 127
              var grain = Grains.findOne({ publicId: publicId }, { fields: {} });                                      // 128
              if (grain) {                                                                                             // 129
                grainId = grain._id;                                                                                   // 130
                return globalBackend.continueGrain(grainId, retryCount > 0);                                           // 131
              } else {                                                                                                 // 132
                // TODO(someday): We really ought to rig things up so that the 'RCPT TO' SMTP command                  //
                //   fails in this case, but simplesmtp doesn't appear to support that.                                //
                throw new Error("No such grain: " + publicId);                                                         // 135
              }                                                                                                        // 136
            }).then(function (grainInfo) {                                                                             // 137
              var supervisor = grainInfo.supervisor;                                                                   // 138
              var uiView = supervisor.getMainView().view;                                                              // 139
                                                                                                                       //
              // Create an arbitrary struct to use as the session params. E-mail sessions actually                     //
              // require no params, but node-capnp won't let us pass null and we don't have an                         //
              // EmptyStruct type available, so we just use EmailAddress, but any struct type would                    //
              // work.                                                                                                 //
              // TODO(cleanup): Fix node-capnp to accept null.                                                         //
              var emptyParams = Capnp.serialize(EmailRpc.EmailAddress, {});                                            // 146
                                                                                                                       //
              // Create a new session of type HackEmailSession. This is a short-term hack until                        //
              // persistent capabilities and the Powerbox are implemented. We need to pass along a                     //
              // HackSessionContext because old versions of sandstorm-http-bridge always use                           //
              // the context of the most recent session; if an old RoundCube grain has a                               //
              // WebSession open, receives an email, and then tries to send an email, the request                      //
              // will go out on the SessionContext associated with the HackEmailSession that                           //
              // delivered the email.                                                                                  //
              var session = uiView.newSession({}, makeHackSessionContext(grainId), "0xc3b5ced7344b04a6", emptyParams).session.castAs(EmailSendPort);
              return session.send(mailMessage);                                                                        // 159
            })["catch"](function (err) {                                                                               // 160
              if (SandstormBackend.shouldRestartGrain(err, retryCount)) {                                              // 161
                return tryDeliver(retryCount + 1);                                                                     // 162
              } else {                                                                                                 // 163
                throw err;                                                                                             // 164
              }                                                                                                        // 165
            });                                                                                                        // 166
          };                                                                                                           // 167
                                                                                                                       //
          return tryDeliver(0);                                                                                        // 169
        }));                                                                                                           // 170
      }).then(function () {                                                                                            // 171
        req.accept();                                                                                                  // 172
      }, function (err) {                                                                                              // 173
        console.error("E-mail delivery failure:", err.stack);                                                          // 174
        req.reject(err.message);                                                                                       // 175
      });                                                                                                              // 176
    });                                                                                                                // 177
  });                                                                                                                  // 178
                                                                                                                       //
  if (global.SANDSTORM_SMTP_LISTEN_HANDLE) {                                                                           // 180
    server.listen(global.SANDSTORM_SMTP_LISTEN_HANDLE);                                                                // 181
  } else {                                                                                                             // 182
    // We must be running `run-dev.sh`.                                                                                //
    var BIND_IP = process.env.BIND_IP || "127.0.0.1";                                                                  // 184
    var SMTP_LISTEN_PORT = Meteor.settings["public"].smtpListenPort || 30025;                                          // 185
    server.listen(SMTP_LISTEN_PORT, BIND_IP);                                                                          // 186
  }                                                                                                                    // 187
});                                                                                                                    // 188
                                                                                                                       //
function formatAddress(field) {                                                                                        // 190
  if (!field) {                                                                                                        // 191
    return null;                                                                                                       // 192
  }                                                                                                                    // 193
                                                                                                                       //
  if (Array.isArray(field)) {                                                                                          // 195
    return field.map(formatAddress);                                                                                   // 196
  }                                                                                                                    // 197
                                                                                                                       //
  if (field.name) {                                                                                                    // 199
    return field.name + " <" + field.address + ">";                                                                    // 200
  }                                                                                                                    // 201
                                                                                                                       //
  return field.address;                                                                                                // 203
}                                                                                                                      // 204
                                                                                                                       //
hackSendEmail = function hackSendEmail(session, email) {                                                               // 206
  return inMeteor(function () {                                                                                        // 207
    var recipientCount = 0;                                                                                            // 208
    recipientCount += email.to ? email.to.length : 0;                                                                  // 209
    recipientCount += email.cc ? email.cc.length : 0;                                                                  // 210
    recipientCount += email.bcc ? email.bcc.length : 0;                                                                // 211
    if (recipientCount > RECIPIENT_LIMIT) {                                                                            // 212
      throw new Error("Sorry, Sandstorm currently only allows you to send an e-mail to " + RECIPIENT_LIMIT + " recipients at a time, for spam control. Consider setting up a mailing list. " + "Please feel free to contact us if this is a problem for you.");
    }                                                                                                                  // 217
                                                                                                                       //
    var grainAddress = session._getAddress();                                                                          // 219
    var userAddress = session._getUserAddress();                                                                       // 220
                                                                                                                       //
    // Overwrite the 'from' address with the grain's address.                                                          //
    if (!email.from) {                                                                                                 // 223
      email.from = {                                                                                                   // 224
        address: grainAddress                                                                                          // 225
      };                                                                                                               // 224
    }                                                                                                                  // 227
                                                                                                                       //
    if (email.from.address !== grainAddress && email.from.address !== userAddress.address) {                           // 229
      throw new Error("FROM header in outgoing emails need to equal either " + grainAddress + " or " + userAddress.address + ". Yours was: " + email.from.address);
    }                                                                                                                  // 233
                                                                                                                       //
    var mc = new MailComposer();                                                                                       // 235
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 237
      from: formatAddress(email.from),                                                                                 // 238
      to: formatAddress(email.to),                                                                                     // 239
      cc: formatAddress(email.cc),                                                                                     // 240
      bcc: formatAddress(email.bcc),                                                                                   // 241
      replyTo: formatAddress(email.replyTo),                                                                           // 242
      subject: email.subject,                                                                                          // 243
      text: email.text,                                                                                                // 244
      html: email.html                                                                                                 // 245
    });                                                                                                                // 237
                                                                                                                       //
    var envelope = mc.getEnvelope();                                                                                   // 248
    envelope.from = grainAddress;                                                                                      // 249
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 251
      envelope: envelope                                                                                               // 252
    });                                                                                                                // 251
                                                                                                                       //
    var headers = {};                                                                                                  // 255
    if (email.messageId) {                                                                                             // 256
      mc.addHeader("message-id", email.messageId);                                                                     // 257
    }                                                                                                                  // 258
                                                                                                                       //
    if (email.references) {                                                                                            // 260
      mc.addHeader("references", email.references);                                                                    // 261
    }                                                                                                                  // 262
                                                                                                                       //
    if (email.inReplyTo) {                                                                                             // 264
      mc.addHeader("in-reply-to", email.inReplyTo);                                                                    // 265
    }                                                                                                                  // 266
                                                                                                                       //
    if (email.date) {                                                                                                  // 268
      var date = new Date(email.date / 1000000);                                                                       // 269
      if (!isNaN(date.getTime())) {                                                                                    // 270
        // Check to make sure date is valid                                                                            //
        mc.addHeader("date", date.toUTCString());                                                                      // 271
      }                                                                                                                // 272
    }                                                                                                                  // 273
                                                                                                                       //
    if (email.attachments) {                                                                                           // 275
      email.attachments.forEach(function (attachment) {                                                                // 276
        mc.addAttachment({                                                                                             // 277
          cid: attachment.contentId,                                                                                   // 278
          contentType: attachment.contentType,                                                                         // 279
          contentDisposition: attachment.contentDisposition,                                                           // 280
          contents: attachment.content                                                                                 // 281
        });                                                                                                            // 277
      });                                                                                                              // 283
    }                                                                                                                  // 284
                                                                                                                       //
    var grain = Grains.findOne(session.grainId);                                                                       // 286
    if (!grain) throw new Error("Grain does not exist.");                                                              // 287
    globalDb.incrementDailySentMailCount(grain.userId);                                                                // 288
                                                                                                                       //
    SandstormEmail.rawSend(mc);                                                                                        // 290
  }.bind(_this))["catch"](function (err) {                                                                             // 291
    console.error("Error sending e-mail:", err.stack);                                                                 // 292
    throw err;                                                                                                         // 293
  });                                                                                                                  // 294
};                                                                                                                     // 295
                                                                                                                       //
var EmailVerifierImpl = function (_PersistentImpl) {                                                                   //
  _inherits(EmailVerifierImpl, _PersistentImpl);                                                                       //
                                                                                                                       //
  function EmailVerifierImpl(db, saveTemplate, params) {                                                               // 298
    _classCallCheck(this, EmailVerifierImpl);                                                                          // 298
                                                                                                                       //
    var _this2 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 298
                                                                                                                       //
    _this2._id = params.id;                                                                                            // 300
    _this2._services = params.services;                                                                                // 301
    return _this2;                                                                                                     // 298
  }                                                                                                                    // 302
                                                                                                                       //
  EmailVerifierImpl.prototype.getId = function getId() {                                                               //
    return { id: new Buffer(this._id, "base64") };                                                                     // 305
  };                                                                                                                   // 306
                                                                                                                       //
  EmailVerifierImpl.prototype.verifyEmail = function verifyEmail(tabId, verification) {                                //
    var _this3 = this;                                                                                                 // 308
                                                                                                                       //
    return unwrapFrontendCap(verification, "verifiedEmail", function (verification) {                                  // 309
      if (verification.tabId !== tabId.toString("hex")) {                                                              // 310
        throw new Error("VerifiedEmail is from a different tab");                                                      // 311
      }                                                                                                                // 312
                                                                                                                       //
      if (_this3._services) {                                                                                          // 314
        // Since this verifier is restricted to specific services, only indicate a match if the                        //
        // VerifiedEmail was for the correct verifier ID. (If our _services is null, then we                           //
        // match all services, and therefore all VerifiedEmails.)                                                      //
        if (verification.verifierId !== _this3._id) {                                                                  // 318
          throw new Error("VerifierEmail is for a different EmailVerifier.");                                          // 319
        }                                                                                                              // 320
      }                                                                                                                // 321
                                                                                                                       //
      return verification.address;                                                                                     // 323
    });                                                                                                                // 324
  };                                                                                                                   // 325
                                                                                                                       //
  return EmailVerifierImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 326
                                                                                                                       //
var VerifiedEmailImpl = function (_PersistentImpl2) {                                                                  //
  _inherits(VerifiedEmailImpl, _PersistentImpl2);                                                                      //
                                                                                                                       //
  function VerifiedEmailImpl(db, saveTemplate) {                                                                       // 329
    _classCallCheck(this, VerifiedEmailImpl);                                                                          // 329
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 329
  }                                                                                                                    // 331
                                                                                                                       //
  return VerifiedEmailImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
function getVerifiedEmails(db, userId, verifierId) {                                                                   // 334
  // Get all of the email addresses verified as belonging to the given user using the given                            //
  // verifier.                                                                                                         //
                                                                                                                       //
  var services = null;                                                                                                 // 338
                                                                                                                       //
  if (verifierId) {                                                                                                    // 340
    var verifier = db.collections.apiTokens.findOne({ "frontendRef.emailVerifier.id": verifierId });                   // 341
    if (!verifier) return []; // invalid verifier                                                                      // 343
    var verifierInfo = verifier.frontendRef.emailVerifier;                                                             // 344
                                                                                                                       //
    if (verifierInfo.services) {                                                                                       // 346
      // Limit to the listed services.                                                                                 //
      services = {};                                                                                                   // 348
      verifierInfo.services.forEach(function (service) {                                                               // 349
        return services[service] = true;                                                                               // 349
      });                                                                                                              // 349
    }                                                                                                                  // 350
  }                                                                                                                    // 351
                                                                                                                       //
  var user = Meteor.users.findOne(userId);                                                                             // 353
  var emails = {}; // map address -> true, for uniquification                                                          // 354
  Meteor.users.find({ _id: { $in: SandstormDb.getUserIdentityIds(user) } }).forEach(function (identity) {              // 355
    if (!services || services[identity.profile.service]) {                                                             // 356
      SandstormDb.getVerifiedEmails(identity).forEach(function (email) {                                               // 357
        emails[email.email] = true;                                                                                    // 357
      });                                                                                                              // 357
    }                                                                                                                  // 358
  });                                                                                                                  // 359
                                                                                                                       //
  return Object.keys(emails);                                                                                          // 361
}                                                                                                                      // 362
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 366
  globalFrontendRefRegistry.register({                                                                                 // 367
    frontendRefField: "emailVerifier",                                                                                 // 368
    typeId: EmailRpc.EmailVerifier.typeId,                                                                             // 369
                                                                                                                       //
    restore: function restore(db, saveTemplate, params) {                                                              // 371
      return new Capnp.Capability(new EmailVerifierImpl(db, saveTemplate, params), EmailImpl.PersistentEmailVerifier);
    },                                                                                                                 // 374
    validate: function validate(db, session, value) {                                                                  // 376
      check(value, { services: Match.Optional([String]) });                                                            // 377
                                                                                                                       //
      var services = value.services;                                                                                   // 379
      if (services) {                                                                                                  // 380
        services.forEach(function (service) {                                                                          // 381
          if (!Accounts.identityServices[service]) {                                                                   // 382
            throw new Error("No such identity service: " + service);                                                   // 383
          }                                                                                                            // 384
        });                                                                                                            // 385
      }                                                                                                                // 386
                                                                                                                       //
      value.id = Crypto.randomBytes(16).toString("base64");                                                            // 388
                                                                                                                       //
      return {                                                                                                         // 390
        descriptor: { tags: [{ id: EmailRpc.EmailVerifier.typeId }] },                                                 // 391
        requirements: []                                                                                               // 392
      };                                                                                                               // 390
    },                                                                                                                 // 394
    query: function query(db, userId, value) {                                                                         // 396
      var results = [];                                                                                                // 397
                                                                                                                       //
      results.push({                                                                                                   // 399
        _id: "emailverifier-all",                                                                                      // 400
        frontendRef: { emailVerifier: {} },                                                                            // 401
        cardTemplate: "emailVerifierPowerboxCard"                                                                      // 402
      });                                                                                                              // 399
                                                                                                                       //
      for (var name in Accounts.identityServices) {                                                                    // 405
        if (Accounts.identityServices[name].isEnabled()) {                                                             // 406
          results.push({                                                                                               // 407
            _id: "emailverifier-" + name,                                                                              // 408
            frontendRef: { emailVerifier: { services: [name] } },                                                      // 409
            cardTemplate: "emailVerifierPowerboxCard"                                                                  // 410
          });                                                                                                          // 407
        }                                                                                                              // 412
      };                                                                                                               // 413
                                                                                                                       //
      return results;                                                                                                  // 415
    }                                                                                                                  // 416
  });                                                                                                                  // 367
                                                                                                                       //
  globalFrontendRefRegistry.register({                                                                                 // 419
    frontendRefField: "verifiedEmail",                                                                                 // 420
    typeId: EmailRpc.VerifiedEmail.typeId,                                                                             // 421
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 423
      return new Capnp.Capability(new VerifiedEmailImpl(db, saveTemplate), EmailImpl.PersistentVerifiedEmail);         // 424
    },                                                                                                                 // 426
    validate: function validate(db, session, value) {                                                                  // 428
      check(value, { verifierId: Match.Optional(String), address: String });                                           // 429
                                                                                                                       //
      if (!session.userId) {                                                                                           // 431
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 432
      }                                                                                                                // 433
                                                                                                                       //
      // Verify that the address actually belongs to the user.                                                         //
                                                                                                                       //
      if (!_.contains(getVerifiedEmails(db, session.userId, value.verifierId), value.address)) {                       // 437
        throw new Meteor.Error(403, "User has no such verified address");                                              // 438
      }                                                                                                                // 439
                                                                                                                       //
      // Add the session's tabId.                                                                                      //
      value.tabId = session.tabId;                                                                                     // 442
                                                                                                                       //
      // Build the descriptor, which contains the verifier ID.                                                         //
      var tagValue = value.verifierId && Capnp.serialize(EmailRpc.VerifiedEmail.PowerboxTag, { verifierId: new Buffer(value.verifierId, "hex") });
                                                                                                                       //
      return {                                                                                                         // 449
        descriptor: { tags: [{ id: EmailRpc.VerifiedEmail.typeId, value: tagValue }] },                                // 450
        requirements: []                                                                                               // 451
      };                                                                                                               // 449
    },                                                                                                                 // 453
    query: function query(db, userId, value) {                                                                         // 455
      var verifierId = value && Capnp.parse(EmailRpc.VerifiedEmail.PowerboxTag, value).verifierId.toString("base64");  // 456
      return getVerifiedEmails(db, userId, verifierId).map(function (address) {                                        // 458
        return {                                                                                                       // 458
          _id: "email-" + address,                                                                                     // 459
          frontendRef: { verifiedEmail: { verifierId: verifierId, address: address } },                                // 460
          cardTemplate: "verifiedEmailPowerboxCard"                                                                    // 461
        };                                                                                                             // 458
      });                                                                                                              // 458
    }                                                                                                                  // 463
  });                                                                                                                  // 419
});                                                                                                                    // 465
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"00-startup.js":["/imports/db-deprecated.js","/imports/server/frontend-ref.js","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/00-startup.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.import("/imports/db-deprecated.js");var FrontendRefRegistry;module.import("/imports/server/frontend-ref.js",{"FrontendRefRegistry":function(v){FrontendRefRegistry=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       //
globalFrontendRefRegistry = new FrontendRefRegistry();                                                                 // 21
                                                                                                                       //
SandstormPowerbox.registerUiViewQueryHandler(globalFrontendRefRegistry);                                               // 23
                                                                                                                       //
if (global.BlackrockPayments && BlackrockPayments.registerPaymentsApi) {                                               // 25
  // TODO(cleanup): Meteor.startup() needed because unwrapFrontendCap is not defined yet when this                     //
  //   first runs. Move it into an import.                                                                             //
  Meteor.startup(function () {                                                                                         // 28
    BlackrockPayments.registerPaymentsApi(globalFrontendRefRegistry, PersistentImpl, unwrapFrontendCap);               // 29
  });                                                                                                                  // 31
}                                                                                                                      // 32
                                                                                                                       //
getWildcardOrigin = globalDb.getWildcardOrigin.bind(globalDb);                                                         // 34
                                                                                                                       //
Meteor.onConnection(function (connection) {                                                                            // 36
  // TODO(cleanup): This is the best way I've thought of so far to allow methods declared in                           //
  //   packages to actually use the DB, but it's pretty sad.                                                           //
  connection.sandstormDb = globalDb;                                                                                   // 39
  connection.frontendRefRegistry = globalFrontendRefRegistry;                                                          // 40
});                                                                                                                    // 41
SandstormDb.periodicCleanup(5 * 60 * 1000, SandstormPermissions.cleanupSelfDestructing(globalDb));                     // 42
SandstormDb.periodicCleanup(10 * 60 * 1000, SandstormPermissions.cleanupClientPowerboxRequests(globalDb));             // 43
SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                         // 45
  SandstormAutoupdateApps.updateAppIndex(globalDb);                                                                    // 46
});                                                                                                                    // 47
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 49
  globalDb.migrateToLatest();                                                                                          // 49
});                                                                                                                    // 49
LDAP_DEFAULTS.url = globalDb.getLdapUrl();                                                                             // 50
LDAP_DEFAULTS.base = globalDb.getLdapBase();                                                                           // 51
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-server.js":["babel-runtime/helpers/objectWithoutProperties","meteor/meteor","fs","crypto","/imports/server/auth.js","heapdump",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _objectWithoutProperties;module.import("babel-runtime/helpers/objectWithoutProperties",{"default":function(v){_objectWithoutProperties=v}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var clearAdminToken,checkAuth,tokenIsValid,tokenIsSetupSession;module.import("/imports/server/auth.js",{"clearAdminToken":function(v){clearAdminToken=v},"checkAuth":function(v){checkAuth=v},"tokenIsValid":function(v){tokenIsValid=v},"tokenIsSetupSession":function(v){tokenIsSetupSession=v}});var Heapdump;module.import("heapdump",{"default":function(v){Heapdump=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       //
var publicAdminSettings = ["google", "github", "ldap", "saml", "emailToken", "splashUrl", "signupDialog", "adminAlert", "adminAlertTime", "adminAlertUrl", "termsUrl", "privacyUrl", "appMarketUrl", "appIndexUrl", "appUpdatesEnabled", "serverTitle", "returnAddress", "ldapNameField", "organizationMembership", "organizationSettings", "whitelabelCustomLoginProviderName", "whitelabelCustomLogoAssetId", "whitelabelHideSendFeedback", "whitelabelHideTroubleshooting", "whitelabelUseServerTitleForHomeText"];
                                                                                                                       //
var FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS = ["customer", "expires", "features", "isElasticBilling", "isTrial", "issued", "userLimit"];
                                                                                                                       //
var PUBLIC_FEATURE_KEY_FIELDS = ["expires", "features"];                                                               // 40
                                                                                                                       //
var smtpConfigShape = {                                                                                                // 44
  hostname: String,                                                                                                    // 45
  port: Number,                                                                                                        // 46
  auth: {                                                                                                              // 47
    user: String,                                                                                                      // 48
    pass: String                                                                                                       // 49
  },                                                                                                                   // 47
  returnAddress: String                                                                                                // 51
};                                                                                                                     // 44
                                                                                                                       //
Meteor.methods({                                                                                                       // 54
  setAccountSetting: function setAccountSetting(token, serviceName, value) {                                           // 55
    checkAuth(token);                                                                                                  // 56
    check(serviceName, String);                                                                                        // 57
    check(value, Boolean);                                                                                             // 58
                                                                                                                       //
    // TODO(someday): currently this relies on the fact that an account is tied to a single                            //
    // identity, and thus has only that entry in "services". This will need to be looked at when                       //
    // multiple login methods/identities are allowed for a single account.                                             //
    if (!value && !tokenIsValid(token) && !tokenIsSetupSession(token) && serviceName in Meteor.user().services) {      // 63
      throw new Meteor.Error(403, "You can not disable the login service that your account uses.");                    // 64
    }                                                                                                                  // 66
                                                                                                                       //
    // Only check configurations for OAuth services.                                                                   //
    var oauthServices = ["google", "github"];                                                                          // 69
    if (value && oauthServices.indexOf(serviceName) != -1) {                                                           // 70
      var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                // 71
      var config = ServiceConfiguration.configurations.findOne({ service: serviceName });                              // 72
      if (!config) {                                                                                                   // 73
        throw new Meteor.Error(403, "You must configure the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 76
                                                                                                                       //
      if (!config.clientId || !config.secret) {                                                                        // 78
        throw new Meteor.Error(403, "You must provide a non-empty clientId and secret for the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 81
    }                                                                                                                  // 82
                                                                                                                       //
    Settings.upsert({ _id: serviceName }, { $set: { value: value } });                                                 // 84
    if (value) {                                                                                                       // 85
      Settings.update({ _id: serviceName }, { $unset: { automaticallyReset: 1 } });                                    // 86
    }                                                                                                                  // 87
  },                                                                                                                   // 88
                                                                                                                       //
  setSmtpConfig: function setSmtpConfig(token, config) {                                                               // 90
    checkAuth(token);                                                                                                  // 91
    check(config, smtpConfigShape);                                                                                    // 92
                                                                                                                       //
    Settings.upsert({ _id: "smtpConfig" }, { $set: { value: config } });                                               // 94
  },                                                                                                                   // 95
                                                                                                                       //
  setSetting: function setSetting(token, name, value) {                                                                // 97
    checkAuth(token);                                                                                                  // 98
    check(name, String);                                                                                               // 99
    check(value, Match.OneOf(null, String, Date, Boolean));                                                            // 100
                                                                                                                       //
    Settings.upsert({ _id: name }, { $set: { value: value } });                                                        // 102
  },                                                                                                                   // 103
                                                                                                                       //
  submitFeatureKey: function submitFeatureKey(token, textBlock) {                                                      // 105
    checkAuth(token);                                                                                                  // 106
    check(textBlock, Match.OneOf(null, String));                                                                       // 107
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 109
                                                                                                                       //
    if (!textBlock) {                                                                                                  // 111
      // Delete the feature key.                                                                                       //
      db.collections.featureKey.remove("currentFeatureKey");                                                           // 113
      return;                                                                                                          // 114
    }                                                                                                                  // 115
                                                                                                                       //
    // textBlock is a base64'd string, possibly with newlines and comment lines starting with "-"                      //
    var featureKeyBase64 = _.chain(textBlock.split("\n")).filter(function (line) {                                     // 118
      return line.length > 0 && line[0] !== "-";                                                                       // 119
    }).value().join("");                                                                                               // 119
                                                                                                                       //
    var buf = new Buffer(featureKeyBase64, "base64");                                                                  // 123
    if (buf.length < 64) {                                                                                             // 124
      throw new Meteor.Error(401, "Invalid feature key");                                                              // 125
    }                                                                                                                  // 126
                                                                                                                       //
    // loadSignedFeatureKey is provided in feature-key.js                                                              //
    var featureKey = loadSignedFeatureKey(buf);                                                                        // 129
    if (!featureKey) {                                                                                                 // 130
      throw new Meteor.Error(401, "Invalid feature key");                                                              // 131
    }                                                                                                                  // 132
                                                                                                                       //
    // Persist the feature key in the database.                                                                        //
    db.collections.featureKey.upsert("currentFeatureKey", {                                                            // 135
      _id: "currentFeatureKey",                                                                                        // 138
      value: buf                                                                                                       // 139
    });                                                                                                                // 137
  },                                                                                                                   // 142
                                                                                                                       //
  saveOrganizationSettings: function saveOrganizationSettings(token, params) {                                         // 144
    checkAuth(token);                                                                                                  // 145
    check(params, {                                                                                                    // 146
      membership: {                                                                                                    // 147
        emailToken: {                                                                                                  // 148
          enabled: Boolean,                                                                                            // 149
          domain: String                                                                                               // 150
        },                                                                                                             // 148
        google: {                                                                                                      // 152
          enabled: Boolean,                                                                                            // 153
          domain: String                                                                                               // 154
        },                                                                                                             // 152
        ldap: {                                                                                                        // 156
          enabled: Boolean                                                                                             // 157
        },                                                                                                             // 156
        saml: {                                                                                                        // 159
          enabled: Boolean                                                                                             // 160
        }                                                                                                              // 159
      },                                                                                                               // 147
      settings: {                                                                                                      // 163
        disallowGuests: Boolean,                                                                                       // 164
        shareContacts: Boolean                                                                                         // 165
      }                                                                                                                // 163
    });                                                                                                                // 146
                                                                                                                       //
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationMembership" }, { value: params.membership });
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationSettings" }, { value: params.settings });
  },                                                                                                                   // 171
                                                                                                                       //
                                                                                                                       //
  adminConfigureLoginService: function adminConfigureLoginService(token, options) {                                    // 173
    checkAuth(token);                                                                                                  // 174
    check(options, Match.ObjectIncluding({ service: String }));                                                        // 175
                                                                                                                       //
    var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                  // 177
                                                                                                                       //
    ServiceConfiguration.configurations.upsert({ service: options.service }, options);                                 // 179
  },                                                                                                                   // 180
                                                                                                                       //
  clearResumeTokensForService: function clearResumeTokensForService(token, serviceName) {                              // 182
    checkAuth(token);                                                                                                  // 183
    check(serviceName, String);                                                                                        // 184
                                                                                                                       //
    var query = {};                                                                                                    // 186
    query["services." + serviceName] = { $exists: true };                                                              // 187
    Meteor.users.find(query).forEach(function (identity) {                                                             // 188
      if (identity.services.resume && identity.services.resume.loginTokens && identity.services.resume.loginTokens.length > 0) {
        Meteor.users.update({ _id: identity._id }, { $set: { "services.resume.loginTokens": [] } });                   // 191
      }                                                                                                                // 192
                                                                                                                       //
      Meteor.users.update({ "loginIdentities.id": identity._id }, { $set: { "services.resume.loginTokens": [] } });    // 194
    });                                                                                                                // 196
  },                                                                                                                   // 197
                                                                                                                       //
  adminUpdateUser: function adminUpdateUser(token, userInfo) {                                                         // 199
    checkAuth(token);                                                                                                  // 200
    check(userInfo, {                                                                                                  // 201
      userId: String,                                                                                                  // 202
      signupKey: Boolean,                                                                                              // 203
      isAdmin: Boolean                                                                                                 // 204
    });                                                                                                                // 201
                                                                                                                       //
    var userId = userInfo.userId;                                                                                      // 207
    if (userId === Meteor.userId() && !userInfo.isAdmin) {                                                             // 208
      throw new Meteor.Error(403, "User cannot remove admin permissions from itself.");                                // 209
    }                                                                                                                  // 210
                                                                                                                       //
    Meteor.users.update({ _id: userId }, { $set: _.omit(userInfo, ["_id", "userId"]) });                               // 212
  },                                                                                                                   // 213
                                                                                                                       //
  testSend: function testSend(token, smtpConfig, to) {                                                                 // 215
    checkAuth(token);                                                                                                  // 216
    check(smtpConfig, smtpConfigShape);                                                                                // 217
    check(to, String);                                                                                                 // 218
    var returnAddress = smtpConfig.returnAddress;                                                                      // 215
                                                                                                                       //
    var restConfig = _objectWithoutProperties(smtpConfig, ["returnAddress"]);                                          // 215
                                                                                                                       //
    try {                                                                                                              // 221
      SandstormEmail.send({                                                                                            // 222
        to: to,                                                                                                        // 223
        from: globalDb.getServerTitle() + " <" + returnAddress + ">",                                                  // 224
        subject: "Testing your Sandstorm's SMTP setting",                                                              // 225
        text: "Success! Your outgoing SMTP is working.",                                                               // 226
        smtpConfig: restConfig                                                                                         // 227
      });                                                                                                              // 222
    } catch (e) {                                                                                                      // 229
      // Attempt to give more accurate error messages for a variety of known failure modes,                            //
      // and the actual exception data in the event a user hits a new failure mode.                                    //
      if (e.syscall === "getaddrinfo") {                                                                               // 232
        if (e.code === "EIO" || e.code === "ENOTFOUND") {                                                              // 233
          throw new Meteor.Error("getaddrinfo " + e.code, "Couldn't resolve \"" + smtpConfig.hostname + "\" - check for typos or broken DNS.");
        }                                                                                                              // 235
      } else if (e.syscall === "connect") {                                                                            // 236
        if (e.code === "ECONNREFUSED") {                                                                               // 237
          throw new Meteor.Error("connect ECONNREFUSED", "Server at " + smtpConfig.hostname + ":" + smtpConfig.port + " refused connection.  Check your settings, firewall rules, and that your mail server is up.");
        }                                                                                                              // 239
      } else if (e.name === "AuthError") {                                                                             // 240
        throw new Meteor.Error("auth error", "Authentication failed.  Check your credentials.  Message from " + smtpConfig.hostname + ": " + e.data);
      }                                                                                                                // 243
                                                                                                                       //
      throw new Meteor.Error("other-email-sending-error", "Error while trying to send test email: " + JSON.stringify(e));
    }                                                                                                                  // 246
  },                                                                                                                   // 247
                                                                                                                       //
  createSignupKey: function createSignupKey(token, note, quota) {                                                      // 249
    checkAuth(token);                                                                                                  // 250
    check(note, String);                                                                                               // 251
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 252
                                                                                                                       //
    var key = Random.id();                                                                                             // 254
    var content = { _id: key, used: false, note: note };                                                               // 255
    if (typeof quota === "number") content.quota = quota;                                                              // 256
    SignupKeys.insert(content);                                                                                        // 257
    return key;                                                                                                        // 258
  },                                                                                                                   // 259
                                                                                                                       //
  sendInvites: function sendInvites(token, origin, from, list, subject, message, quota) {                              // 261
    checkAuth(token);                                                                                                  // 262
    check([origin, from, list, subject, message], [String]);                                                           // 263
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 264
                                                                                                                       //
    if (!from.trim()) {                                                                                                // 266
      throw new Meteor.Error(403, "Must enter 'from' address.");                                                       // 267
    }                                                                                                                  // 268
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 270
      throw new Meteor.Error(403, "Must enter 'to' addresses.");                                                       // 271
    }                                                                                                                  // 272
                                                                                                                       //
    this.unblock();                                                                                                    // 274
                                                                                                                       //
    list = list.split("\n");                                                                                           // 276
    for (var i in list) {                                                                                              // 277
      var email = list[i].trim();                                                                                      // 278
                                                                                                                       //
      if (email) {                                                                                                     // 280
        var key = Random.id();                                                                                         // 281
                                                                                                                       //
        var content = {                                                                                                // 283
          _id: key,                                                                                                    // 284
          used: false,                                                                                                 // 285
          note: "E-mail invite to " + email,                                                                           // 286
          email: email,                                                                                                // 287
          definitelySent: false                                                                                        // 288
        };                                                                                                             // 283
        if (typeof quota === "number") content.quota = quota;                                                          // 290
        SignupKeys.insert(content);                                                                                    // 291
        SandstormEmail.send({                                                                                          // 292
          to: email,                                                                                                   // 293
          from: from,                                                                                                  // 294
          envelopeFrom: globalDb.getReturnAddress(),                                                                   // 295
          subject: subject,                                                                                            // 296
          text: message.replace(/\$KEY/g, origin + "/signup/" + key)                                                   // 297
        });                                                                                                            // 292
        SignupKeys.update(key, { $set: { definitelySent: true } });                                                    // 299
      }                                                                                                                // 300
    }                                                                                                                  // 301
                                                                                                                       //
    return { sent: true };                                                                                             // 303
  },                                                                                                                   // 304
                                                                                                                       //
  adminToggleDisableCap: function adminToggleDisableCap(token, capId, value) {                                         // 306
    checkAuth(token);                                                                                                  // 307
    check(capId, String);                                                                                              // 308
    check(value, Boolean);                                                                                             // 309
                                                                                                                       //
    if (value) {                                                                                                       // 311
      ApiTokens.update({ _id: capId }, { $set: { revoked: true } });                                                   // 312
    } else {                                                                                                           // 313
      ApiTokens.update({ _id: capId }, { $set: { revoked: false } });                                                  // 314
    }                                                                                                                  // 315
  },                                                                                                                   // 316
                                                                                                                       //
  updateQuotas: function updateQuotas(token, list, quota) {                                                            // 318
    checkAuth(token);                                                                                                  // 319
    check(list, String);                                                                                               // 320
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 321
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 323
      throw new Meteor.Error(400, "Must enter addresses.");                                                            // 324
    }                                                                                                                  // 325
                                                                                                                       //
    var items = list.split("\n");                                                                                      // 327
    var invalid = [];                                                                                                  // 328
    for (var i in items) {                                                                                             // 329
      var modifier = typeof quota === "number" ? { $set: { quota: quota } } : { $unset: { quota: "" } };               // 330
      var n = SignupKeys.update({ email: items[i] }, modifier, { multi: true });                                       // 332
      n += Meteor.users.update({ signupEmail: items[i] }, modifier, { multi: true });                                  // 333
                                                                                                                       //
      if (n < 1) invalid.push(items[i]);                                                                               // 335
    }                                                                                                                  // 336
                                                                                                                       //
    if (invalid.length > 0) {                                                                                          // 338
      throw new Meteor.Error(404, "These addresses did not map to any user nor invite: " + invalid.join(", "));        // 339
    }                                                                                                                  // 341
  },                                                                                                                   // 342
                                                                                                                       //
  dismissAdminStatsNotifications: function dismissAdminStatsNotifications(token) {                                     // 344
    checkAuth(token);                                                                                                  // 345
    globalDb.collections.notifications.remove({ "admin.type": "reportStats" });                                        // 346
  },                                                                                                                   // 347
                                                                                                                       //
  signUpAsAdmin: function signUpAsAdmin(token) {                                                                       // 349
    check(token, String);                                                                                              // 350
    checkAuth(token);                                                                                                  // 351
    if (!this.userId) {                                                                                                // 352
      throw new Meteor.Error(403, "Must be logged in to sign up as admin.");                                           // 353
    }                                                                                                                  // 354
                                                                                                                       //
    if (!Meteor.user().loginIdentities) {                                                                              // 356
      throw new Meteor.Error(403, "Must be logged into an account to sign up as admin.");                              // 357
    }                                                                                                                  // 358
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { isAdmin: true, signupKey: "admin" } });                        // 360
    clearAdminToken(token);                                                                                            // 361
  },                                                                                                                   // 362
                                                                                                                       //
  redeemSetupToken: function redeemSetupToken(token) {                                                                 // 364
    // Redeem an admin token into a setup session.                                                                     //
    check(token, String);                                                                                              // 366
    if (tokenIsValid(token)) {                                                                                         // 367
      var sessId = Random.secret();                                                                                    // 368
      var creationDate = new Date();                                                                                   // 369
      var hashedSessionId = Crypto.createHash("sha256").update(sessId).digest("base64");                               // 370
      this.connection.sandstormDb.collections.setupSession.upsert({                                                    // 371
        _id: "current-session"                                                                                         // 372
      }, {                                                                                                             // 371
        creationDate: creationDate,                                                                                    // 374
        hashedSessionId: hashedSessionId                                                                               // 375
      });                                                                                                              // 373
      // Then, invalidate the token, so one one else can use it.                                                       //
      clearAdminToken(token);                                                                                          // 378
      return sessId;                                                                                                   // 379
    } else {                                                                                                           // 380
      throw new Meteor.Error(401, "Invalid setup token");                                                              // 381
    }                                                                                                                  // 382
  },                                                                                                                   // 383
  heapdump: function heapdump() {                                                                                      // 385
    // Requests a heap dump. Intended for use by Sandstorm developers. Requires admin.                                 //
    //                                                                                                                 //
    // Call this from the JS console like:                                                                             //
    //   Meteor.call("heapdump");                                                                                      //
                                                                                                                       //
    checkAuth();                                                                                                       // 391
                                                                                                                       //
    // We use /var/log because it's a location in the container to which the front-end is allowed                      //
    // to write.                                                                                                       //
    var name = "/var/log/" + Date.now() + ".heapsnapshot";                                                             // 395
    Heapdump.writeSnapshot(name);                                                                                      // 396
    console.log("Wrote heapdump: /opt/sandstorm" + name);                                                              // 397
    return name;                                                                                                       // 398
  }                                                                                                                    // 399
});                                                                                                                    // 54
                                                                                                                       //
var authorizedAsAdmin = function authorizedAsAdmin(token, userId) {                                                    // 402
  return Match.test(token, Match.OneOf(undefined, null, String)) && (userId && isAdminById(userId) || tokenIsValid(token) || tokenIsSetupSession(token));
};                                                                                                                     // 405
                                                                                                                       //
Meteor.publish("admin", function (token) {                                                                             // 407
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 408
  return Settings.find();                                                                                              // 409
});                                                                                                                    // 410
                                                                                                                       //
Meteor.publish("adminServiceConfiguration", function (token) {                                                         // 412
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 413
  return Package["service-configuration"].ServiceConfiguration.configurations.find();                                  // 414
});                                                                                                                    // 415
                                                                                                                       //
Meteor.publish("publicAdminSettings", function () {                                                                    // 417
  return Settings.find({ _id: { $in: publicAdminSettings } });                                                         // 418
});                                                                                                                    // 419
                                                                                                                       //
Meteor.publish("adminToken", function (token) {                                                                        // 421
  check(token, String);                                                                                                // 422
  this.added("adminToken", "adminToken", { tokenIsValid: tokenIsValid(token) || tokenIsSetupSession(token) });         // 423
  this.ready();                                                                                                        // 424
});                                                                                                                    // 425
                                                                                                                       //
Meteor.publish("allUsers", function (token) {                                                                          // 427
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 428
  return Meteor.users.find();                                                                                          // 429
});                                                                                                                    // 430
                                                                                                                       //
Meteor.publish("adminUserDetails", function (userId) {                                                                 // 432
  var _this2 = this;                                                                                                   // 432
                                                                                                                       //
  if (!authorizedAsAdmin(undefined, this.userId)) return [];                                                           // 433
                                                                                                                       //
  // Reactive publish of any identities owned by the account with id userId,                                           //
  // as well as that user object itself.                                                                               //
  var identitySubs = {};                                                                                               // 437
  var accountId = userId;                                                                                              // 438
                                                                                                                       //
  var unrefIdentity = function unrefIdentity(identityId) {                                                             // 440
    if (!identitySubs[identityId]) {                                                                                   // 441
      // should never happen, but if somehow you attempt to unref an identity that we don't have a                     //
      // subscription to, then don't crash                                                                             //
      console.error("attempted to unref untracked identity id:", identityId);                                          // 444
      return;                                                                                                          // 445
    }                                                                                                                  // 446
                                                                                                                       //
    var observeHandle = identitySubs[identityId];                                                                      // 448
    delete identitySubs[identityId];                                                                                   // 449
    observeHandle.stop();                                                                                              // 450
    _this2.removed("users", identityId);                                                                               // 451
  };                                                                                                                   // 452
                                                                                                                       //
  var refIdentity = function refIdentity(identityId) {                                                                 // 454
    if (identitySubs[identityId]) {                                                                                    // 455
      // should never happen, but if somehow an account wound up with a duplicate identity ID,                         //
      // avoid leaking a subscription                                                                                  //
      console.error("duplicate identity id:", identityId);                                                             // 458
      return;                                                                                                          // 459
    }                                                                                                                  // 460
                                                                                                                       //
    var cursor = Meteor.users.find({ _id: identityId });                                                               // 462
    var observeHandle = cursor.observe({                                                                               // 463
      added: function added(doc) {                                                                                     // 464
        _this2.added("users", doc._id, doc);                                                                           // 465
      },                                                                                                               // 466
                                                                                                                       //
      changed: function changed(newDoc, oldDoc) {                                                                      // 468
        _this2.changed("users", newDoc._id, newDoc);                                                                   // 469
      },                                                                                                               // 470
                                                                                                                       //
      removed: function removed(oldDoc) {                                                                              // 472
        _this2.removed("users", oldDoc._id);                                                                           // 473
      }                                                                                                                // 474
    });                                                                                                                // 463
                                                                                                                       //
    identitySubs[identityId] = observeHandle;                                                                          // 477
  };                                                                                                                   // 478
                                                                                                                       //
  var accountCursor = Meteor.users.find({ _id: accountId });                                                           // 480
  var accountSubHandle = accountCursor.observe({                                                                       // 481
    added: function added(newDoc) {                                                                                    // 482
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 483
      newIdentities.forEach(function (identityId) {                                                                    // 484
        refIdentity(identityId);                                                                                       // 485
      });                                                                                                              // 486
                                                                                                                       //
      _this2.added("users", newDoc._id, newDoc);                                                                       // 488
    },                                                                                                                 // 489
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 491
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 492
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 493
                                                                                                                       //
      // Those in newDoc - oldDoc, ref.                                                                                //
      var identitiesAdded = _.difference(newIdentities, oldIdentities);                                                // 496
      identitiesAdded.forEach(function (identityId) {                                                                  // 497
        refIdentity(identityId);                                                                                       // 498
      });                                                                                                              // 499
                                                                                                                       //
      // Those in oldDoc - newDoc, unref.                                                                              //
      var identitiesRemoved = _.difference(oldIdentities, newIdentities);                                              // 502
      identitiesRemoved.forEach(function (identityId) {                                                                // 503
        unrefIdentity(identityId);                                                                                     // 504
      });                                                                                                              // 505
                                                                                                                       //
      _this2.changed("users", newDoc._id, newDoc);                                                                     // 507
    },                                                                                                                 // 508
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 510
      _this2.removed("users", oldDoc._id);                                                                             // 511
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 512
      oldIdentities.forEach(function (identityId) {                                                                    // 513
        unrefIdentity(identityId);                                                                                     // 514
      });                                                                                                              // 515
    }                                                                                                                  // 516
  });                                                                                                                  // 481
                                                                                                                       //
  this.onStop(function () {                                                                                            // 519
    accountSubHandle.stop();                                                                                           // 520
    // Also stop all the identity subscriptions.                                                                       //
    var subs = _.values(identitySubs);                                                                                 // 522
    subs.forEach(function (sub) {                                                                                      // 523
      sub.stop();                                                                                                      // 524
    });                                                                                                                // 525
  });                                                                                                                  // 526
                                                                                                                       //
  // Meteor's cursor.observe() will synchronously call all of the added() callbacks from the initial                   //
  // query, so by the time we get here we can report readiness.                                                        //
  this.ready();                                                                                                        // 530
});                                                                                                                    // 531
                                                                                                                       //
Meteor.publish("activityStats", function (token) {                                                                     // 533
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 534
  return ActivityStats.find();                                                                                         // 535
});                                                                                                                    // 536
                                                                                                                       //
Meteor.publish("statsTokens", function (token) {                                                                       // 538
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 539
  return StatsTokens.find();                                                                                           // 540
});                                                                                                                    // 541
                                                                                                                       //
Meteor.publish("allPackages", function (token) {                                                                       // 543
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 544
  return Packages.find({ manifest: { $exists: true } }, { fields: { appId: 1, "manifest.appVersion": 1,                // 545
      "manifest.actions": 1, "manifest.appTitle": 1 } });                                                              // 547
});                                                                                                                    // 548
                                                                                                                       //
Meteor.publish("realTimeStats", function (token) {                                                                     // 550
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 551
                                                                                                                       //
  // Last five minutes.                                                                                                //
  this.added("realTimeStats", "now", computeStats(new Date(Date.now() - 5 * 60 * 1000)));                              // 554
                                                                                                                       //
  // Since last sample.                                                                                                //
  var lastSample = ActivityStats.findOne({}, { sort: { timestamp: -1 } });                                             // 557
  var lastSampleTime = lastSample ? lastSample.timestamp : new Date(0);                                                // 558
  this.added("realTimeStats", "today", computeStats(lastSampleTime));                                                  // 559
                                                                                                                       //
  // TODO(someday): Update every few minutes?                                                                          //
                                                                                                                       //
  this.ready();                                                                                                        // 563
});                                                                                                                    // 564
                                                                                                                       //
Meteor.publish("adminLog", function (token) {                                                                          // 566
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 567
                                                                                                                       //
  var logfile = SANDSTORM_LOGDIR + "/sandstorm.log";                                                                   // 569
                                                                                                                       //
  var fd = Fs.openSync(logfile, "r");                                                                                  // 571
  var startSize = Fs.fstatSync(fd).size;                                                                               // 572
                                                                                                                       //
  // Start tailing at EOF - 8k.                                                                                        //
  var offset = Math.max(0, startSize - 8192);                                                                          // 575
                                                                                                                       //
  var _this = this;                                                                                                    // 577
  function doTail() {                                                                                                  // 578
    for (;;) {                                                                                                         // 579
      var buf = new Buffer(Math.max(1024, startSize - offset));                                                        // 580
      var n = Fs.readSync(fd, buf, 0, buf.length, offset);                                                             // 581
      if (n <= 0) break;                                                                                               // 582
      _this.added("adminLog", offset, { text: buf.toString("utf8", 0, n) });                                           // 583
      offset += n;                                                                                                     // 584
    }                                                                                                                  // 585
  }                                                                                                                    // 586
                                                                                                                       //
  // Watch the file for changes.                                                                                       //
  var watcher = Fs.watch(logfile, { persistent: false }, Meteor.bindEnvironment(doTail));                              // 589
                                                                                                                       //
  // When the subscription stops, stop watching the file.                                                              //
  this.onStop(function () {                                                                                            // 592
    watcher.close();                                                                                                   // 593
    Fs.closeSync(fd);                                                                                                  // 594
  });                                                                                                                  // 595
                                                                                                                       //
  // Read initial 8k tail data immediately.                                                                            //
  doTail();                                                                                                            // 598
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 601
});                                                                                                                    // 602
                                                                                                                       //
Meteor.publish("adminApiTokens", function (token) {                                                                    // 604
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 605
  return ApiTokens.find({                                                                                              // 606
    $or: [{ "frontendRef.ipNetwork": { $exists: true } }, { "frontendRef.ipInterface": { $exists: true } }]            // 607
  }, {                                                                                                                 // 606
    fields: {                                                                                                          // 612
      frontendRef: 1,                                                                                                  // 613
      created: 1,                                                                                                      // 614
      requirements: 1,                                                                                                 // 615
      revoked: 1,                                                                                                      // 616
      owner: 1                                                                                                         // 617
    }                                                                                                                  // 612
  });                                                                                                                  // 611
});                                                                                                                    // 620
                                                                                                                       //
Meteor.publish("featureKey", function (forAdmin, token) {                                                              // 622
  var _this3 = this;                                                                                                   // 622
                                                                                                                       //
  if (forAdmin && !authorizedAsAdmin(token, this.userId)) return [];                                                   // 623
                                                                                                                       //
  var fields = forAdmin ? FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS : PUBLIC_FEATURE_KEY_FIELDS;                          // 625
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 628
  var featureKeyQuery = db.collections.featureKey.find({ _id: "currentFeatureKey" });                                  // 629
  var observeHandle = featureKeyQuery.observe({                                                                        // 630
    added: function added(doc) {                                                                                       // 631
      // Load and verify the signed feature key.                                                                       //
      var buf = new Buffer(doc.value);                                                                                 // 633
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 634
                                                                                                                       //
      if (featureKey) {                                                                                                // 636
        var _ref;                                                                                                      // 636
                                                                                                                       //
        // If the signature is valid, publish the feature key information.                                             //
        var filteredFeatureKey = (_ref = _).pick.apply(_ref, [featureKey].concat(fields));                             // 638
        _this3.added("featureKey", doc._id, filteredFeatureKey);                                                       // 639
      }                                                                                                                // 640
    },                                                                                                                 // 641
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 643
      // Load and reverify the new signed feature key.                                                                 //
      var buf = new Buffer(newDoc.value);                                                                              // 645
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 646
                                                                                                                       //
      if (featureKey) {                                                                                                // 648
        var _ref2;                                                                                                     // 648
                                                                                                                       //
        // If the signature is valid, call this.changed() with the interesting fields.                                 //
        var filteredFeatureKey = (_ref2 = _).pick.apply(_ref2, [featureKey].concat(fields));                           // 650
        _this3.changed("featureKey", newDoc._id, filteredFeatureKey);                                                  // 651
      } else {                                                                                                         // 652
        // Otherwise, call this.removed(), since the new feature key is invalid.                                       //
        _this3.removed("featureKey", oldDoc._id);                                                                      // 654
      }                                                                                                                // 655
    },                                                                                                                 // 656
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 658
      _this3.removed("featureKey", oldDoc._id);                                                                        // 659
    }                                                                                                                  // 660
  });                                                                                                                  // 630
                                                                                                                       //
  this.onStop(function () {                                                                                            // 663
    observeHandle.stop();                                                                                              // 664
  });                                                                                                                  // 665
                                                                                                                       //
  this.ready();                                                                                                        // 667
});                                                                                                                    // 668
                                                                                                                       //
Meteor.publish("hasAdmin", function (token) {                                                                          // 670
  var _this4 = this;                                                                                                   // 670
                                                                                                                       //
  // Like hasUsers, but for admins, and with token auth required.                                                      //
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 672
                                                                                                                       //
  // Query if there are any admin users.                                                                               //
  var cursor = Meteor.users.find({ isAdmin: true });                                                                   // 675
  if (cursor.count() > 0) {                                                                                            // 676
    this.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                            // 677
  } else {                                                                                                             // 678
    (function () {                                                                                                     // 678
      var handle = cursor.observeChanges({                                                                             // 679
        added: function added(id) {                                                                                    // 680
          _this4.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                    // 681
          handle.stop();                                                                                               // 682
          handle = null;                                                                                               // 683
        }                                                                                                              // 684
      });                                                                                                              // 679
      _this4.onStop(function () {                                                                                      // 686
        if (handle) handle.stop();                                                                                     // 687
      });                                                                                                              // 688
    })();                                                                                                              // 678
  }                                                                                                                    // 689
                                                                                                                       //
  this.ready();                                                                                                        // 691
});                                                                                                                    // 692
                                                                                                                       //
function observeOauthService(name) {                                                                                   // 694
  Settings.find({ _id: name, value: true }).observe({                                                                  // 695
    added: function added() {                                                                                          // 696
      // Tell the oauth library it should accept login attempts from this service.                                     //
      Accounts.oauth.registerService(name);                                                                            // 698
    },                                                                                                                 // 699
                                                                                                                       //
    removed: function removed() {                                                                                      // 701
      // Tell the oauth library it should deny login attempts from this service.                                       //
      Accounts.oauth.unregisterService(name);                                                                          // 703
    }                                                                                                                  // 704
  });                                                                                                                  // 695
}                                                                                                                      // 706
                                                                                                                       //
observeOauthService("github");                                                                                         // 708
observeOauthService("google");                                                                                         // 709
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backup.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/backup.js                                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var ChildProcess = Npm.require("child_process");                                                                       // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Promise = Npm.require("es6-promise").Promise;                                                                      // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
                                                                                                                       //
var GrainInfo = Capnp.importSystem("sandstorm/grain.capnp").GrainInfo;                                                 // 22
                                                                                                                       //
var TOKEN_CLEANUP_MINUTES = 15;                                                                                        // 24
var TOKEN_CLEANUP_TIMER = TOKEN_CLEANUP_MINUTES * 60 * 1000;                                                           // 25
                                                                                                                       //
function cleanupToken(tokenId) {                                                                                       // 27
  check(tokenId, String);                                                                                              // 28
  FileTokens.remove({ _id: tokenId });                                                                                 // 29
  waitPromise(globalBackend.cap().deleteBackup(tokenId));                                                              // 30
}                                                                                                                      // 31
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 33
  // Cleanup tokens every TOKEN_CLEANUP_MINUTES                                                                        //
  SandstormDb.periodicCleanup(TOKEN_CLEANUP_TIMER, function () {                                                       // 35
    var queryDate = new Date(Date.now() - TOKEN_CLEANUP_TIMER);                                                        // 36
                                                                                                                       //
    FileTokens.find({ timestamp: { $lt: queryDate } }).forEach(function (token) {                                      // 38
      cleanupToken(token._id);                                                                                         // 39
    });                                                                                                                // 40
  });                                                                                                                  // 41
});                                                                                                                    // 42
                                                                                                                       //
Meteor.methods({                                                                                                       // 44
  backupGrain: function backupGrain(grainId) {                                                                         // 45
    check(grainId, String);                                                                                            // 46
    var grain = Grains.findOne(grainId);                                                                               // 47
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 48
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 49
    }                                                                                                                  // 50
                                                                                                                       //
    this.unblock();                                                                                                    // 52
                                                                                                                       //
    var token = {                                                                                                      // 54
      _id: Random.id(),                                                                                                // 55
      timestamp: new Date(),                                                                                           // 56
      name: grain.title                                                                                                // 57
    };                                                                                                                 // 54
                                                                                                                       //
    // TODO(soon): does the grain need to be offline?                                                                  //
                                                                                                                       //
    var grainInfo = _.pick(grain, "appId", "appVersion", "title");                                                     // 62
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 64
    waitPromise(globalBackend.cap().backupGrain(token._id, this.userId, grainId, grainInfo));                          // 65
                                                                                                                       //
    return token._id;                                                                                                  // 67
  },                                                                                                                   // 68
  newRestoreToken: function newRestoreToken() {                                                                        // 70
    if (!isSignedUpOrDemo()) {                                                                                         // 71
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can restore backups.");                          // 72
    }                                                                                                                  // 73
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 75
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 76
    }                                                                                                                  // 78
                                                                                                                       //
    var token = {                                                                                                      // 80
      _id: Random.id(),                                                                                                // 81
      timestamp: new Date()                                                                                            // 82
    };                                                                                                                 // 80
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 85
                                                                                                                       //
    return token._id;                                                                                                  // 87
  },                                                                                                                   // 88
  restoreGrain: function restoreGrain(tokenId, identityId) {                                                           // 90
    check(tokenId, String);                                                                                            // 91
    check(identityId, String);                                                                                         // 92
    var token = FileTokens.findOne(tokenId);                                                                           // 93
    if (!token || !isSignedUpOrDemo()) {                                                                               // 94
      throw new Meteor.Error(403, "Unauthorized", "Token was not found, or user cannot create grains");                // 95
    }                                                                                                                  // 97
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 99
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 100
    }                                                                                                                  // 102
                                                                                                                       //
    this.unblock();                                                                                                    // 104
                                                                                                                       //
    var grainId = Random.id(22);                                                                                       // 106
                                                                                                                       //
    try {                                                                                                              // 108
      var grainInfo = waitPromise(globalBackend.cap().restoreGrain(tokenId, this.userId, grainId)["catch"](function (err) {
        console.error("Unzip failure:", err.message);                                                                  // 111
        throw new Meteor.Error(500, "Invalid backup file.");                                                           // 112
      })).info;                                                                                                        // 113
      if (!grainInfo.appId) {                                                                                          // 114
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 115
        throw new Meteor.Error(500, "Metadata object for uploaded grain has no AppId");                                // 116
      }                                                                                                                // 117
                                                                                                                       //
      var action = UserActions.findOne({ appId: grainInfo.appId, userId: this.userId });                               // 119
                                                                                                                       //
      // Create variables we'll use for later Mongo query.                                                             //
      var packageId = void 0;                                                                                          // 122
      var appVersion = void 0;                                                                                         // 123
                                                                                                                       //
      // DevPackages are system-wide, so we do not check the user ID.                                                  //
      var devPackage = DevPackages.findOne({ appId: grainInfo.appId });                                                // 126
      if (devPackage) {                                                                                                // 127
        // If the dev app package exists, it should override the user action.                                          //
        packageId = devPackage.packageId;                                                                              // 129
        appVersion = devPackage.manifest.appVersion;                                                                   // 130
      } else if (action) {                                                                                             // 131
        // The app is installed, so we can continue restoring this                                                     //
        // grain.                                                                                                      //
        packageId = action.packageId;                                                                                  // 134
        appVersion = action.appVersion;                                                                                // 135
      } else {                                                                                                         // 136
        // If the package isn't installed at all, bail out.                                                            //
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 138
        throw new Meteor.Error(500, "App id for uploaded grain not installed", "App Id: " + grainInfo.appId);          // 139
      }                                                                                                                // 142
                                                                                                                       //
      if (appVersion < grainInfo.appVersion) {                                                                         // 144
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 145
        throw new Meteor.Error(500, "App version for uploaded grain is newer than any " + "installed version. You need to upgrade your app first", "New version: " + grainInfo.appVersion + ", Old version: " + appVersion);
      }                                                                                                                // 151
                                                                                                                       //
      Grains.insert({                                                                                                  // 153
        _id: grainId,                                                                                                  // 154
        packageId: packageId,                                                                                          // 155
        appId: grainInfo.appId,                                                                                        // 156
        appVersion: appVersion,                                                                                        // 157
        userId: this.userId,                                                                                           // 158
        identityId: identityId,                                                                                        // 159
        title: grainInfo.title,                                                                                        // 160
        "private": true                                                                                                // 161
      });                                                                                                              // 153
    } finally {                                                                                                        // 163
      cleanupToken(tokenId);                                                                                           // 164
    }                                                                                                                  // 165
                                                                                                                       //
    return grainId;                                                                                                    // 167
  }                                                                                                                    // 168
});                                                                                                                    // 44
                                                                                                                       //
Router.map(function () {                                                                                               // 171
  this.route("downloadBackup", {                                                                                       // 172
    where: "server",                                                                                                   // 173
    path: "/downloadBackup/:tokenId",                                                                                  // 174
    action: function action() {                                                                                        // 175
      var token = FileTokens.findOne(this.params.tokenId);                                                             // 176
      var response = this.response;                                                                                    // 177
      if (!token) {                                                                                                    // 178
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 179
        return response.end("File does not exist");                                                                    // 180
      }                                                                                                                // 181
                                                                                                                       //
      var started = false;                                                                                             // 183
      var filename = (token.name.replace(/["\n]/g, "") || "backup") + ".zip";                                          // 184
      var sawEnd = false;                                                                                              // 185
                                                                                                                       //
      var stream = {                                                                                                   // 187
        expectSize: function expectSize(size) {                                                                        // 188
          if (!started) {                                                                                              // 189
            started = true;                                                                                            // 190
            response.writeHead(200, {                                                                                  // 191
              "Content-Length": size,                                                                                  // 192
              "Content-Type": "application/zip",                                                                       // 193
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 194
            });                                                                                                        // 191
          }                                                                                                            // 196
        },                                                                                                             // 197
        write: function write(data) {                                                                                  // 199
          if (!started) {                                                                                              // 200
            started = true;                                                                                            // 201
            response.writeHead(200, {                                                                                  // 202
              "Content-Type": "application/zip",                                                                       // 203
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 204
            });                                                                                                        // 202
          }                                                                                                            // 206
                                                                                                                       //
          response.write(data);                                                                                        // 208
        },                                                                                                             // 209
        done: function done(data) {                                                                                    // 211
          if (!started) {                                                                                              // 212
            started = true;                                                                                            // 213
            response.writeHead(200, {                                                                                  // 214
              "Content-Length": 0,                                                                                     // 215
              "Content-Type": "application/zip",                                                                       // 216
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 217
            });                                                                                                        // 214
          }                                                                                                            // 219
                                                                                                                       //
          sawEnd = true;                                                                                               // 221
          response.end();                                                                                              // 222
        }                                                                                                              // 223
      };                                                                                                               // 187
                                                                                                                       //
      waitPromise(globalBackend.cap().downloadBackup(this.params.tokenId, stream));                                    // 226
                                                                                                                       //
      if (!sawEnd) {                                                                                                   // 228
        console.error("backend failed to call done() when downloading backup");                                        // 229
        if (!started) {                                                                                                // 230
          throw new Meteor.Error(500, "backend failed to produce data");                                               // 231
        }                                                                                                              // 232
                                                                                                                       //
        response.end();                                                                                                // 234
      }                                                                                                                // 235
                                                                                                                       //
      cleanupToken(this.params.tokenId);                                                                               // 237
    }                                                                                                                  // 238
  });                                                                                                                  // 172
                                                                                                                       //
  this.route("uploadBackup", {                                                                                         // 241
    where: "server",                                                                                                   // 242
    path: "/uploadBackup/:token",                                                                                      // 243
    action: function action() {                                                                                        // 244
      var _this = this;                                                                                                // 244
                                                                                                                       //
      if (this.request.method === "POST") {                                                                            // 245
        var _ret = function () {                                                                                       // 245
          var token = FileTokens.findOne(_this.params.token);                                                          // 246
          if (!_this.params.token || !token) {                                                                         // 247
            _this.response.writeHead(403, {                                                                            // 248
              "Content-Type": "text/plain"                                                                             // 249
            });                                                                                                        // 248
            _this.response.write("Invalid upload token.");                                                             // 251
            _this.response.end();                                                                                      // 252
            return {                                                                                                   // 253
              v: void 0                                                                                                // 253
            };                                                                                                         // 253
          }                                                                                                            // 254
                                                                                                                       //
          var request = _this.request;                                                                                 // 256
          try {                                                                                                        // 257
            (function () {                                                                                             // 257
              var stream = globalBackend.cap().uploadBackup(_this.params.token).stream;                                // 258
                                                                                                                       //
              waitPromise(new Promise(function (resolve, reject) {                                                     // 260
                request.on("data", function (data) {                                                                   // 261
                  stream.write(data);                                                                                  // 262
                });                                                                                                    // 263
                request.on("end", function () {                                                                        // 264
                  resolve(stream.done());                                                                              // 265
                });                                                                                                    // 266
                request.on("error", function (err) {                                                                   // 267
                  stream.close();                                                                                      // 268
                });                                                                                                    // 269
              }));                                                                                                     // 270
                                                                                                                       //
              _this.response.writeHead(204);                                                                           // 272
              _this.response.end();                                                                                    // 273
            })();                                                                                                      // 257
          } catch (error) {                                                                                            // 274
            console.error(error.stack);                                                                                // 275
            _this.response.writeHead(500, {                                                                            // 276
              "Content-Type": "text/plain"                                                                             // 277
            });                                                                                                        // 276
            _this.response.write(error.stack);                                                                         // 279
            _this.response.end();                                                                                      // 280
          }                                                                                                            // 281
        }();                                                                                                           // 245
                                                                                                                       //
        if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                   // 245
      } else {                                                                                                         // 282
        this.response.writeHead(405, {                                                                                 // 283
          "Content-Type": "text/plain"                                                                                 // 284
        });                                                                                                            // 283
        this.response.write("You can only POST here.");                                                                // 286
        this.response.end();                                                                                           // 287
      }                                                                                                                // 288
    }                                                                                                                  // 289
  });                                                                                                                  // 241
});                                                                                                                    // 291
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"core.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/core.js                                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var PersistentImpl,hashSturdyRef,generateSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v},"hashSturdyRef":function(v){hashSturdyRef=v},"generateSturdyRef":function(v){generateSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var Url = Npm.require("url");                                                                                          // 18
                                                                                                                       // 19
                                                                                                                       //
var PersistentHandle = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentHandle;                              // 22
var SandstormCore = Capnp.importSystem("sandstorm/supervisor.capnp").SandstormCore;                                    // 23
var SandstormCoreFactory = Capnp.importSystem("sandstorm/backend.capnp").SandstormCoreFactory;                         // 24
var PersistentOngoingNotification = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentOngoingNotification;    // 25
var PersistentUiView = Capnp.importSystem("sandstorm/persistentuiview.capnp").PersistentUiView;                        // 26
var StaticAsset = Capnp.importSystem("sandstorm/grain.capnp").StaticAsset;                                             // 27
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 28
                                                                                                                       //
var SandstormCoreImpl = function () {                                                                                  //
  function SandstormCoreImpl(grainId) {                                                                                // 31
    _classCallCheck(this, SandstormCoreImpl);                                                                          // 31
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 32
  }                                                                                                                    // 33
                                                                                                                       //
  SandstormCoreImpl.prototype.restore = function restore(sturdyRef) {                                                  //
    var _this2 = this;                                                                                                 // 35
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 36
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 37
      var token = ApiTokens.findOne({                                                                                  // 38
        _id: hashedSturdyRef,                                                                                          // 39
        "owner.grain.grainId": _this2.grainId                                                                          // 40
      });                                                                                                              // 38
                                                                                                                       //
      if (!token) {                                                                                                    // 43
        throw new Error("no such token");                                                                              // 44
      }                                                                                                                // 45
                                                                                                                       //
      if (token.owner.grain.introducerIdentity) {                                                                      // 47
        throw new Error("Cannot restore grain-owned sturdyref that contains the obsolete " + "introducerIdentity field. Please request a new capability.");
      }                                                                                                                // 50
                                                                                                                       //
      return restoreInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this2.grainId }) }, [], token);     // 52
    });                                                                                                                // 55
  };                                                                                                                   // 56
                                                                                                                       //
  SandstormCoreImpl.prototype.drop = function drop(sturdyRef) {                                                        //
    var _this3 = this;                                                                                                 // 58
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 59
      return dropInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this3.grainId }) });                   // 60
    });                                                                                                                // 61
  };                                                                                                                   // 62
                                                                                                                       //
  SandstormCoreImpl.prototype.makeToken = function makeToken(ref, owner, requirements) {                               //
    var _this = this;                                                                                                  // 65
    return inMeteor(function () {                                                                                      // 66
      var sturdyRef = new Buffer(generateSturdyRef());                                                                 // 67
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 68
      ApiTokens.insert({                                                                                               // 69
        _id: hashedSturdyRef,                                                                                          // 70
        grainId: _this.grainId,                                                                                        // 71
        objectId: ref,                                                                                                 // 72
        owner: owner,                                                                                                  // 73
        created: new Date(),                                                                                           // 74
        requirements: requirements                                                                                     // 75
      });                                                                                                              // 69
                                                                                                                       //
      return {                                                                                                         // 78
        token: sturdyRef                                                                                               // 79
      };                                                                                                               // 78
    });                                                                                                                // 81
  };                                                                                                                   // 82
                                                                                                                       //
  SandstormCoreImpl.prototype.makeChildToken = function makeChildToken(parent, owner, requirements) {                  //
    return inMeteor(function () {                                                                                      // 85
      // Compute the save ApiToken template.                                                                           //
      return makeSaveTemplateForChild(parent.toString(), requirements);                                                // 87
    }).then(function (saveTemplate) {                                                                                  // 88
      // Create a dummy PersistentImpl and invoke its own save() method.                                               //
      return new PersistentImpl(globalDb, saveTemplate).save({ sealFor: owner });                                      // 90
    }).then(function (saveResult) {                                                                                    // 91
      // Transform to expected result structure.                                                                       //
      return { token: saveResult.sturdyRef };                                                                          // 93
    });                                                                                                                // 94
  };                                                                                                                   // 95
                                                                                                                       //
  SandstormCoreImpl.prototype.getOwnerNotificationTarget = function getOwnerNotificationTarget() {                     //
    var grainId = this.grainId;                                                                                        // 98
    return {                                                                                                           // 99
      owner: {                                                                                                         // 100
        addOngoing: function addOngoing(displayInfo, notification) {                                                   // 101
          return inMeteor(function () {                                                                                // 102
            var grain = Grains.findOne({ _id: grainId });                                                              // 103
            if (!grain) {                                                                                              // 104
              throw new Error("Grain not found.");                                                                     // 105
            }                                                                                                          // 106
                                                                                                                       //
            var castedNotification = notification.castAs(PersistentOngoingNotification);                               // 108
            var wakelockToken = waitPromise(castedNotification.save()).sturdyRef;                                      // 109
                                                                                                                       //
            // We have to close both the casted cap and the original. Perhaps this should be fixed in                  //
            // node-capnp?                                                                                             //
            castedNotification.close();                                                                                // 113
            notification.close();                                                                                      // 114
            var notificationId = Notifications.insert({                                                                // 115
              ongoing: wakelockToken,                                                                                  // 116
              grainId: grainId,                                                                                        // 117
              userId: grain.userId,                                                                                    // 118
              text: displayInfo.caption,                                                                               // 119
              timestamp: new Date(),                                                                                   // 120
              isUnread: true                                                                                           // 121
            });                                                                                                        // 115
                                                                                                                       //
            return {                                                                                                   // 124
              handle: globalFrontendRefRegistry.create(globalDb, { notificationHandle: notificationId })               // 125
            };                                                                                                         // 124
          });                                                                                                          // 128
        }                                                                                                              // 129
      }                                                                                                                // 100
    };                                                                                                                 // 99
  };                                                                                                                   // 132
                                                                                                                       //
  SandstormCoreImpl.prototype.backgroundActivity = function backgroundActivity(event) {                                //
    var _this4 = this;                                                                                                 // 134
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 135
      logActivity(_this4.grainId, null, event);                                                                        // 136
    });                                                                                                                // 137
  };                                                                                                                   // 138
                                                                                                                       //
  return SandstormCoreImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var makeSandstormCore = function makeSandstormCore(grainId) {                                                          // 141
  return new Capnp.Capability(new SandstormCoreImpl(grainId), SandstormCore);                                          // 142
};                                                                                                                     // 143
                                                                                                                       //
var NotificationHandle = function (_PersistentImpl) {                                                                  //
  _inherits(NotificationHandle, _PersistentImpl);                                                                      //
                                                                                                                       //
  // TODO(cleanup): Move to a different file.                                                                          //
                                                                                                                       //
  function NotificationHandle(db, saveTemplate, notificationId) {                                                      // 148
    _classCallCheck(this, NotificationHandle);                                                                         // 148
                                                                                                                       //
    var _this5 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 148
                                                                                                                       //
    _this5.notificationId = notificationId;                                                                            // 150
    return _this5;                                                                                                     // 148
  }                                                                                                                    // 151
                                                                                                                       //
  NotificationHandle.prototype.close = function close() {                                                              //
    var _this6 = this;                                                                                                 // 153
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 154
      if (!_this6.isSaved()) {                                                                                         // 155
        _dismissNotification(_this6.notificationId);                                                                   // 156
      }                                                                                                                // 157
    });                                                                                                                // 158
  };                                                                                                                   // 159
                                                                                                                       //
  return NotificationHandle;                                                                                           //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 162
                                                                                                                       //
var StaticAssetImpl = function () {                                                                                    //
  function StaticAssetImpl(assetId) {                                                                                  // 165
    _classCallCheck(this, StaticAssetImpl);                                                                            // 165
                                                                                                                       //
    check(assetId, String);                                                                                            // 166
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 167
    this._hostPath = makeWildcardHost("static") + "/" + assetId;                                                       // 168
  }                                                                                                                    // 169
                                                                                                                       //
  StaticAssetImpl.prototype.getUrl = function getUrl() {                                                               //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 172
  };                                                                                                                   // 173
                                                                                                                       //
  return StaticAssetImpl;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
var IdenticonStaticAssetImpl = function () {                                                                           //
  function IdenticonStaticAssetImpl(hash, size) {                                                                      // 177
    _classCallCheck(this, IdenticonStaticAssetImpl);                                                                   // 177
                                                                                                                       //
    check(hash, String);                                                                                               // 178
    check(size, Match.Integer);                                                                                        // 179
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 180
    this._hostPath = makeWildcardHost("static") + "/identicon/" + hash + "?s=" + size;                                 // 181
  }                                                                                                                    // 182
                                                                                                                       //
  IdenticonStaticAssetImpl.prototype.getUrl = function getUrl() {                                                      //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 185
  };                                                                                                                   // 186
                                                                                                                       //
  return IdenticonStaticAssetImpl;                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
var PersistentUiViewImpl = function (_PersistentImpl2) {                                                               //
  _inherits(PersistentUiViewImpl, _PersistentImpl2);                                                                   //
                                                                                                                       //
  // TODO(cleanup): Move out of core.js.                                                                               //
                                                                                                                       //
  function PersistentUiViewImpl(db, saveTemplate, grainId) {                                                           // 192
    _classCallCheck(this, PersistentUiViewImpl);                                                                       // 192
                                                                                                                       //
    var _this7 = _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                      // 192
                                                                                                                       //
    check(grainId, String);                                                                                            // 194
    _this7._db = db;                                                                                                   // 195
    _this7._grainId = grainId;                                                                                         // 196
    return _this7;                                                                                                     // 192
  }                                                                                                                    // 197
                                                                                                                       //
  PersistentUiViewImpl.prototype.getViewInfo = function getViewInfo() {                                                //
    var _this8 = this;                                                                                                 // 199
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 200
      var grain = _this8._db.getGrain(_this8._grainId);                                                                // 201
      if (!grain || grain.trashed) {                                                                                   // 202
        throw new Error("grain no longer exists");                                                                     // 203
      }                                                                                                                // 204
                                                                                                                       //
      var pkg = _this8._db.getPackage(grain.packageId) || DevPackages.findOne({ appId: grain.appId }) || {};           // 206
                                                                                                                       //
      var manifest = pkg.manifest || {};                                                                               // 210
                                                                                                                       //
      var viewInfo = grain.cachedViewInfo || {};                                                                       // 212
                                                                                                                       //
      if (!viewInfo.appTitle) {                                                                                        // 214
        viewInfo.appTitle = manifest.appTitle || {};                                                                   // 215
      }                                                                                                                // 216
                                                                                                                       //
      if (!viewInfo.grainIcon) {                                                                                       // 218
        var grainIcon = ((manifest.metadata || {}).icons || {}).grain;                                                 // 219
        if (grainIcon) {                                                                                               // 220
          viewInfo.grainIcon = new Capnp.Capability(new StaticAssetImpl(grainIcon.assetId), StaticAsset);              // 221
        } else {                                                                                                       // 223
          var hash = Identicon.hashAppIdForIdenticon(pkg.appId);                                                       // 224
          viewInfo.grainIcon = new Capnp.Capability(new IdenticonStaticAssetImpl(hash, 24), StaticAsset);              // 225
        }                                                                                                              // 227
      }                                                                                                                // 228
                                                                                                                       //
      return viewInfo;                                                                                                 // 230
    });                                                                                                                // 231
  };                                                                                                                   // 232
                                                                                                                       //
  // All other UiView methods are currently unimplemented, which, while not strictly correct,                          //
  // results in the same overall behavior, since users can't call restore() on a PersistentUiView,                     //
  // and grains can't call methods on UiViews because they lack the "is human" pseudopermission.                       //
                                                                                                                       //
                                                                                                                       //
  return PersistentUiViewImpl;                                                                                         //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var makePersistentUiView = function makePersistentUiView(db, saveTemplate, grainId) {                                  // 239
  check(grainId, String);                                                                                              // 240
                                                                                                                       //
  // Verify that the grain exists and hasn't been trashed.                                                             //
  var grain = db.getGrain(grainId);                                                                                    // 243
  if (!grain || grain.trashed) {                                                                                       // 244
    throw new Meteor.Error(404, "grain not found");                                                                    // 245
  }                                                                                                                    // 246
                                                                                                                       //
  return new Capnp.Capability(new PersistentUiViewImpl(db, saveTemplate, grainId), PersistentUiView);                  // 248
};                                                                                                                     // 250
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 252
  frontendRefField: "notificationHandle",                                                                              // 253
                                                                                                                       //
  restore: function restore(db, saveTemplate, notificationId) {                                                        // 255
    return new Capnp.Capability(new NotificationHandle(db, saveTemplate, notificationId), PersistentHandle);           // 256
  }                                                                                                                    // 258
});                                                                                                                    // 252
                                                                                                                       //
function _dismissNotification(notificationId, callCancel) {                                                            // 261
  var notification = Notifications.findOne({ _id: notificationId });                                                   // 262
  if (notification) {                                                                                                  // 263
    Notifications.remove({ _id: notificationId });                                                                     // 264
    if (notification.ongoing) {                                                                                        // 265
      // For some reason, Mongo returns an object that looks buffer-like, but isn't a buffer.                          //
      // Only way to fix seems to be to copy it.                                                                       //
      var id = new Buffer(notification.ongoing);                                                                       // 268
                                                                                                                       //
      if (!callCancel) {                                                                                               // 270
        dropInternal(id, { frontend: null });                                                                          // 271
      } else {                                                                                                         // 272
        var notificationCap = restoreInternal(id, { frontend: null }, []).cap;                                         // 273
        var castedNotification = notificationCap.castAs(PersistentOngoingNotification);                                // 274
        dropInternal(id, { frontend: null });                                                                          // 275
        try {                                                                                                          // 276
          waitPromise(castedNotification.cancel());                                                                    // 277
          castedNotification.close();                                                                                  // 278
          notificationCap.close();                                                                                     // 279
        } catch (err) {                                                                                                // 280
          if (err.kjType !== "disconnected") {                                                                         // 281
            // ignore disconnected errors, since cancel may shutdown the grain before the supervisor                   //
            // responds.                                                                                               //
            throw err;                                                                                                 // 284
          }                                                                                                            // 285
        }                                                                                                              // 286
      }                                                                                                                // 287
    } else if (notification.appUpdates) {                                                                              // 288
      _.forEach(notification.appUpdates, function (app, appId) {                                                       // 289
        globalDb.deleteUnusedPackages(appId);                                                                          // 290
      });                                                                                                              // 291
    }                                                                                                                  // 292
  }                                                                                                                    // 293
}                                                                                                                      // 294
                                                                                                                       //
Meteor.methods({                                                                                                       // 296
  dismissNotification: function dismissNotification(notificationId) {                                                  // 297
    // This will remove notifications from the database and from view of the user.                                     //
    // For ongoing notifications, it will begin the process of cancelling and dropping them from                       //
    // the app.                                                                                                        //
                                                                                                                       //
    check(notificationId, String);                                                                                     // 302
                                                                                                                       //
    var notification = Notifications.findOne({ _id: notificationId });                                                 // 304
    if (!notification) {                                                                                               // 305
      throw new Meteor.Error(404, "Notification id not found.");                                                       // 306
    } else if (notification.userId !== Meteor.userId()) {                                                              // 307
      throw new Meteor.Error(403, "Notification does not belong to current user.");                                    // 308
    } else {                                                                                                           // 309
      _dismissNotification(notificationId, true);                                                                      // 310
    }                                                                                                                  // 311
  },                                                                                                                   // 312
  readAllNotifications: function readAllNotifications() {                                                              // 314
    // Marks all notifications as read for the current user.                                                           //
    if (!Meteor.userId()) {                                                                                            // 316
      throw new Meteor.Error(403, "User not logged in.");                                                              // 317
    }                                                                                                                  // 318
                                                                                                                       //
    Notifications.update({ userId: Meteor.userId() }, { $set: { isUnread: false } }, { multi: true });                 // 320
  }                                                                                                                    // 321
});                                                                                                                    // 296
                                                                                                                       //
var makeSaveTemplateForChild = function makeSaveTemplateForChild(parentToken, requirements, parentTokenInfo) {         // 324
  // Constructs (part of) an ApiToken record appropriate to be used when save()ing a capability                        //
  // that was originally created by restore()ing `parentToken`. This fills in everything that is                       //
  // appropriate to fill in based only on the parent. Some fields -- especially `owner`, `created`,                    //
  // and `_id` -- obviously cannot be filled in until `save()` is called.                                              //
  //                                                                                                                   //
  // `parentToken` is the raw SturdyRef of the parent.                                                                 //
  //                                                                                                                   //
  // `requirements` is a list of MembraneRequirements that should be added to any children.                            //
  //                                                                                                                   //
  // `parentTokenInfo` is the ApiToken record for `parentToken`. Provide this only if you have                         //
  // it handy; if omitted it will be looked up.                                                                        //
                                                                                                                       //
  parentTokenInfo = parentTokenInfo || ApiTokens.findOne(hashSturdyRef(parentToken));                                  // 337
  if (!parentTokenInfo) {                                                                                              // 338
    throw new Error("no such token");                                                                                  // 339
  }                                                                                                                    // 340
                                                                                                                       //
  var saveTemplate = void 0;                                                                                           // 342
  if ((parentTokenInfo.owner || {}).clientPowerboxRequest) {                                                           // 343
    // Saving this token should make a copy of the restored token, rather than make a child                            //
    // token.                                                                                                          //
                                                                                                                       //
    saveTemplate = _.clone(parentTokenInfo);                                                                           // 347
                                                                                                                       //
    // Don't copy over fields that should be determined at save() time.                                                //
    delete saveTemplate._id;                                                                                           // 350
    delete saveTemplate.owner;                                                                                         // 351
    delete saveTemplate.created;                                                                                       // 352
  } else {                                                                                                             // 353
    if (parentTokenInfo.identityId) {                                                                                  // 354
      // A UiView token. Need to denormalize some fields from the parent.                                              //
      saveTemplate = _.pick(parentTokenInfo, "grainId", "identityId", "accountId");                                    // 356
                                                                                                                       //
      // By default, a save()d copy should have the same permissions, so set an allAccess role                         //
      // assignment.                                                                                                   //
      saveTemplate.roleAssignment = { allAccess: null };                                                               // 360
    } else {                                                                                                           // 361
      // A non-UiView child token.                                                                                     //
      saveTemplate = {};                                                                                               // 363
    }                                                                                                                  // 364
                                                                                                                       //
    // Saved token should be a child of the restored token.                                                            //
    saveTemplate.parentToken = parentTokenInfo._id;                                                                    // 367
  }                                                                                                                    // 368
                                                                                                                       //
  if (requirements) {                                                                                                  // 370
    // Append additional requirements requested by caller.                                                             //
    saveTemplate.requirements = (saveTemplate.requirements || []).concat(requirements);                                // 372
  }                                                                                                                    // 373
                                                                                                                       //
  return saveTemplate;                                                                                                 // 375
};                                                                                                                     // 376
                                                                                                                       //
restoreInternal = function (_restoreInternal) {                                                                        // 378
  function restoreInternal(_x, _x2, _x3, _x4, _x5) {                                                                   // 378
    return _restoreInternal.apply(this, arguments);                                                                    // 378
  }                                                                                                                    // 378
                                                                                                                       //
  restoreInternal.toString = function () {                                                                             // 378
    return _restoreInternal.toString();                                                                                // 378
  };                                                                                                                   // 378
                                                                                                                       //
  return restoreInternal;                                                                                              // 378
}(function (originalToken, ownerPattern, requirements, originalTokenInfo, currentTokenId) {                            // 378
  // Restores the token `originalToken`, which is a Buffer.                                                            //
  //                                                                                                                   //
  // `ownerPattern` is a match pattern (i.e. used with check()) that the token's owner must match.                     //
  // This is used to enforce than an entity can't use tokens owned by some other entity.                               //
  //                                                                                                                   //
  // `requirements` is a list of additional MembraneRequirements to add to the returned capability,                    //
  // beyond what's already stored in ApiTokens. This is often an empty list.                                           //
  //                                                                                                                   //
  // `originalTokenInfo` is optional. If specified, it should be the ApiToken record associated                        //
  // with `originalToken`. Provide this if you happen to have looked it up already.                                    //
  //                                                                                                                   //
  // `currentTokenId` is only provided when this function calls itself recursively. It is the                          //
  // _id (hashed token) of an ancestor of originalToken. The function recurses until it gets to                        //
  // the top-level token.                                                                                              //
                                                                                                                       //
  requirements = requirements || [];                                                                                   // 395
                                                                                                                       //
  if (!originalTokenInfo) {                                                                                            // 397
    originalTokenInfo = ApiTokens.findOne(hashSturdyRef(originalToken));                                               // 398
    if (!originalTokenInfo) {                                                                                          // 399
      throw new Meteor.Error(403, "No token found to restore");                                                        // 400
    }                                                                                                                  // 401
  }                                                                                                                    // 402
                                                                                                                       //
  var token = currentTokenId ? ApiTokens.findOne(currentTokenId) : originalTokenInfo;                                  // 404
  if (!token) {                                                                                                        // 406
    if (!originalTokenInfo) {                                                                                          // 407
      throw new Meteor.Error(403, "Couldn't restore token because parent token has been deleted");                     // 408
    }                                                                                                                  // 409
  }                                                                                                                    // 410
                                                                                                                       //
  if (token.revoked) {                                                                                                 // 412
    throw new Meteor.Error(403, "Token has been revoked");                                                             // 413
  }                                                                                                                    // 414
                                                                                                                       //
  // The ownerPattern should specify the appropriate user or grain involved, if appropriate.                           //
  check(token.owner, ownerPattern);                                                                                    // 417
                                                                                                                       //
  // Check requirements on the token.                                                                                  //
  checkRequirements(globalDb, token.requirements);                                                                     // 420
                                                                                                                       //
  // Check expiration.                                                                                                 //
  if (token.expires && token.expires.getTime() <= Date.now()) {                                                        // 423
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 424
  }                                                                                                                    // 425
                                                                                                                       //
  if (token.expiresIfUnused) {                                                                                         // 427
    if (token.expiresIfUnused.getTime() <= Date.now()) {                                                               // 428
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 429
    } else {                                                                                                           // 430
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(token._id, { $unset: { expiresIfUnused: "" } });                                                // 432
    }                                                                                                                  // 433
  }                                                                                                                    // 434
                                                                                                                       //
  // If this token has a parent, go ahead and recurse to it now.                                                       //
  if (token.parentToken) {                                                                                             // 437
    // A token which chains to some parent token.  Restore the parent token (possibly recursively),                    //
    // checking requirements on the way up.                                                                            //
    return restoreInternal(originalToken, Match.Any, requirements, originalTokenInfo, token.parentToken);              // 440
  }                                                                                                                    // 442
                                                                                                                       //
  // Check the passed-in `requirements`.                                                                               //
  checkRequirements(globalDb, requirements);                                                                           // 445
                                                                                                                       //
  if (token.objectId) {                                                                                                // 447
    // A token which represents a specific capability exported by a grain.                                             //
                                                                                                                       //
    // Fix Mongo converting Buffers to Uint8Arrays.                                                                    //
    if (token.objectId.appRef) {                                                                                       // 451
      token.objectId.appRef = new Buffer(token.objectId.appRef);                                                       // 452
    }                                                                                                                  // 453
                                                                                                                       //
    // Ensure the grain is running, then restore the capability.                                                       //
    return waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                   // 456
      // Note that in this case it is the supervisor's job to implement SystemPersistent, so we                        //
      // don't generate a saveTemplate here.                                                                           //
      return supervisor.restore(token.objectId, requirements, originalToken);                                          // 459
    }));                                                                                                               // 460
  } else {                                                                                                             // 461
    // Construct a template ApiToken for use if the restored capability is save()d later.                              //
    var saveTemplate = makeSaveTemplateForChild(originalToken, requirements, originalTokenInfo);                       // 463
                                                                                                                       //
    if (token.frontendRef) {                                                                                           // 465
      // A token which represents a capability implemented by a pseudo-driver.                                         //
                                                                                                                       //
      var cap = globalFrontendRefRegistry.restore(globalDb, saveTemplate, token.frontendRef);                          // 468
      return { cap: cap };                                                                                             // 469
    } else if (token.grainId) {                                                                                        // 470
      // It's a UiView.                                                                                                //
                                                                                                                       //
      // If a grain is attempting to restore a UiView, it gets a UiView which filters out all                          //
      // the method calls.  In the future, we may allow grains to restore UiViews that pass along the                  //
      // "is human" pseudopermission (say, to allow an app to proxy all requests to some grain and                     //
      // do some transformation), which will return a different capability.                                            //
      return { cap: makePersistentUiView(globalDb, saveTemplate, token.grainId) };                                     // 477
    } else {                                                                                                           // 478
      throw new Meteor.Error(500, "Unknown token type. ID: " + token._id);                                             // 479
    }                                                                                                                  // 480
  }                                                                                                                    // 481
});                                                                                                                    // 482
                                                                                                                       //
function dropInternal(sturdyRef, ownerPattern) {                                                                       // 484
  // Drops `sturdyRef`, checking first that its owner matches `ownerPattern`.                                          //
                                                                                                                       //
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 487
  var token = ApiTokens.findOne({ _id: hashedSturdyRef });                                                             // 488
  if (!token) {                                                                                                        // 489
    return;                                                                                                            // 490
  }                                                                                                                    // 491
                                                                                                                       //
  check(token.owner, ownerPattern);                                                                                    // 493
                                                                                                                       //
  if (token.frontendRef && token.frontendRef.notificationHandle) {                                                     // 495
    var notificationId = token.frontendRef.notificationHandle;                                                         // 496
    globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                                // 497
    var anyToken = ApiTokens.findOne({ "frontendRef.notificationHandle": notificationId });                            // 498
    if (!anyToken) {                                                                                                   // 499
      // No other tokens referencing this notification exist, so dismiss the notification                              //
      _dismissNotification(notificationId);                                                                            // 501
    }                                                                                                                  // 502
  } else if (token.objectId) {                                                                                         // 503
    waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                          // 504
      return supervisor.drop(token.objectId);                                                                          // 505
    }));                                                                                                               // 506
                                                                                                                       //
    globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                                // 508
  } else {                                                                                                             // 509
    globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                                // 510
  }                                                                                                                    // 511
}                                                                                                                      // 512
                                                                                                                       //
function SandstormCoreFactoryImpl() {}                                                                                 // 514
                                                                                                                       //
SandstormCoreFactoryImpl.prototype.getSandstormCore = function (grainId) {                                             // 517
  return { core: makeSandstormCore(grainId) };                                                                         // 518
};                                                                                                                     // 519
                                                                                                                       //
makeSandstormCoreFactory = function makeSandstormCoreFactory() {                                                       // 521
  return new Capnp.Capability(new SandstormCoreFactoryImpl(), SandstormCoreFactory);                                   // 522
};                                                                                                                     // 523
                                                                                                                       //
unwrapFrontendCap = function unwrapFrontendCap(cap, type, callback) {                                                  // 525
  // Expect that `cap` is a Cap'n Proto capability implemented by the frontend as a frontendRef                        //
  // with the given type (the name of one of the fields of frontendRef). Unwraps the capability                        //
  // and then calls callback() with the `frontendRef[type]` descriptor object as                                       //
  // the paramater. The callback runs in a Meteor fiber, but this function can be called from                          //
  // anywhere. The function returns a Promise for the result of the callback.                                          //
  //                                                                                                                   //
  // (The reason for the callback, rather than just returning a Promise for the descriptor, is                         //
  // so that you don't have to do your own inMeteor() dance.)                                                          //
                                                                                                                       //
  // For now, we save() the capability and then dig through ApiTokens to find where it leads.                          //
  // TODO(cleanup): In theory we should be using something like CapabilityServerSet, but it is                         //
  //   not available in Javascript yet and even if it were, it wouldn't work in the case where                         //
  //   there are multiple front-end replicas, since the capability could be on a different                             //
  //   replica.                                                                                                        //
                                                                                                                       //
  return cap.castAs(SystemPersistent).save({ frontend: null }).then(function (saveResult) {                            // 541
    return inMeteor(function () {                                                                                      // 542
      var tokenId = hashSturdyRef(saveResult.sturdyRef);                                                               // 543
      var tokenInfo = ApiTokens.findOne(tokenId);                                                                      // 544
                                                                                                                       //
      // Delete the token now since it's not needed.                                                                   //
      ApiTokens.remove(tokenId);                                                                                       // 547
                                                                                                                       //
      for (;;) {                                                                                                       // 549
        if (!tokenInfo) throw new Error("missing token?");                                                             // 550
        if (!tokenInfo.parentToken) break;                                                                             // 551
        tokenInfo = ApiTokens.findOne(tokenInfo.parentToken);                                                          // 552
      }                                                                                                                // 553
                                                                                                                       //
      if (!tokenInfo.frontendRef || !tokenInfo.frontendRef[type]) {                                                    // 555
        throw new Error("not a " + type + " capability");                                                              // 556
      }                                                                                                                // 557
                                                                                                                       //
      return callback(tokenInfo.frontendRef[type]);                                                                    // 559
    });                                                                                                                // 560
  });                                                                                                                  // 561
};                                                                                                                     // 562
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/demo-server.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var DEMO_EXPIRATION_MS = 60 * 60 * 1000;                                                                               // 19
var DEMO_GRACE_MS = 10 * 60 * 1000; // time between expiration and deletion                                            // 20
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 22
  // Enforce expiration times for demo accounts.                                                                       //
                                                                                                                       //
  if (attempt.user && attempt.user.expires) {                                                                          // 25
    (function () {                                                                                                     // 25
      var expireIn = attempt.user.expires.getTime() - Date.now() + DEMO_GRACE_MS;                                      // 26
      if (expireIn < 0) {                                                                                              // 27
        throw new Meteor.Error(403, "This demo account has expired.");                                                 // 28
      }                                                                                                                // 29
                                                                                                                       //
      if (!allowDemo) {                                                                                                // 31
        // An expiration time implies that this is a demo account, but those have been disabled.                       //
        // Perhaps the config was just changed.                                                                        //
        throw new Meteor.Error(403, "Demo accounts have been disabled.");                                              // 34
      }                                                                                                                // 35
                                                                                                                       //
      // Force connection close when account expires, so that the client reconnects and                                //
      // re-authenticates, which fails.                                                                                //
      var connection = attempt.connection;                                                                             // 39
      var handle = Meteor.setTimeout(function () {                                                                     // 40
        connection.close();                                                                                            // 40
      }, expireIn);                                                                                                    // 40
                                                                                                                       //
      connection.onClose(function () {                                                                                 // 42
        Meteor.clearTimeout(handle);                                                                                   // 42
      });                                                                                                              // 42
    })();                                                                                                              // 25
  }                                                                                                                    // 43
                                                                                                                       //
  return true;                                                                                                         // 45
});                                                                                                                    // 46
                                                                                                                       //
function cleanupExpiredUsers() {                                                                                       // 48
  // Delete expired demo accounts and all their grains.                                                                //
                                                                                                                       //
  var now = new Date(Date.now() - DEMO_GRACE_MS);                                                                      // 51
  Meteor.users.find({ expires: { $lt: now } }, { fields: { _id: 1, loginIdentities: 1, lastActive: 1, appDemoId: 1 } }).forEach(function (user) {
                                                                                                                       //
    globalDb.deleteGrains({ userId: user._id }, globalBackend, "demoGrain");                                           // 56
                                                                                                                       //
    console.log("delete user: " + user._id);                                                                           // 58
    // We intentionally do not do `ApiTokens.remove({accountId: user._id})`, because some such                         //
    // tokens might still play an active role in the sharing graph.                                                    //
    Contacts.remove({ ownerId: user._id });                                                                            // 61
    UserActions.remove({ userId: user._id });                                                                          // 62
    Notifications.remove({ userId: user._id });                                                                        // 63
    Meteor.users.remove(user._id);                                                                                     // 64
    waitPromise(globalBackend.cap().deleteUser(user._id));                                                             // 65
    if (user.loginIdentities && user.lastActive) {                                                                     // 66
      // When deleting a user, we can specify it as a "normal" user                                                    //
      // (type: user) or as a user who started out by using the app                                                    //
      // demo feature (type: appDemoUser).                                                                             //
      var deleteStatsType = "demoUser";                                                                                // 70
      var isAppDemoUser = !!user.appDemoId;                                                                            // 71
      if (isAppDemoUser) {                                                                                             // 72
        deleteStatsType = "appDemoUser";                                                                               // 73
      }                                                                                                                // 74
                                                                                                                       //
      // Intentionally record deleted users at time of deletion to avoid miscounting users that                        //
      // were demoing just before the day rolled over.                                                                 //
      DeleteStats.insert({ type: deleteStatsType, lastActive: new Date(), appId: user.appDemoId });                    // 78
    }                                                                                                                  // 79
  });                                                                                                                  // 80
}                                                                                                                      // 81
                                                                                                                       //
if (allowDemo) {                                                                                                       // 83
  Meteor.methods({                                                                                                     // 84
    createDemoUser: function createDemoUser(displayName, appDemoId) {                                                  // 85
      // This is a login method that creates a new temporary user                                                      //
      // every time it is used.                                                                                        //
      //                                                                                                               //
      // appDemoId is important for stats; see cleanupExpiredUsers().                                                  //
      check(displayName, String);                                                                                      // 90
      check(appDemoId, Match.OneOf(undefined, null, String));                                                          // 91
                                                                                                                       //
      // Create the new user.                                                                                          //
      var newUser = { expires: new Date(Date.now() + DEMO_EXPIRATION_MS) };                                            // 94
      if (appDemoId) {                                                                                                 // 95
        newUser.appDemoId = appDemoId;                                                                                 // 96
      }                                                                                                                // 97
                                                                                                                       //
      var userId = Accounts.insertUserDoc({ profile: { name: displayName } }, newUser);                                // 99
                                                                                                                       //
      // Log them in on this connection.                                                                               //
      return Accounts._loginMethod(this, "createDemoUser", arguments, "demo", function () {                            // 102
        return { userId: userId };                                                                                     // 103
      });                                                                                                              // 103
    },                                                                                                                 // 104
                                                                                                                       //
    testExpireDemo: function testExpireDemo() {                                                                        // 106
      if (!isDemoUser()) throw new Meteor.Error(403, "not a demo user");                                               // 107
                                                                                                                       //
      var newExpires = new Date(Date.now() + 15000);                                                                   // 109
      if (Meteor.user().expires.getTime() < newExpires.getTime()) {                                                    // 110
        throw new Meteor.Error(403, "can't exend demo");                                                               // 111
      }                                                                                                                // 112
                                                                                                                       //
      Meteor.users.update(this.userId, { $set: { expires: newExpires } });                                             // 114
    }                                                                                                                  // 115
  });                                                                                                                  // 84
                                                                                                                       //
  // If demo mode is enabled, we permit the client to subscribe to                                                     //
  // information about an app by appId. If this were available in                                                      //
  // non-demo mode, then anonymous users could effectively ask the                                                     //
  // server which apps are installed.                                                                                  //
  Meteor.publish("appInfo", function (appId) {                                                                         // 122
    // This publishes info about an app, including the latest                                                          //
    // version of it. Once you log in, it also publishes your                                                          //
    // list of UserActions.                                                                                            //
    check(appId, String);                                                                                              // 126
                                                                                                                       //
    var packageCursor = Packages.find({ appId: appId }, { sort: { "manifest.appVersion": -1 } });                      // 128
                                                                                                                       //
    var pkg = packageCursor.fetch()[0];                                                                                // 132
                                                                                                                       //
    // This allows us to avoid creating duplicate UserActions.                                                         //
    if (this.userId) {                                                                                                 // 135
      return [packageCursor, UserActions.find({ userId: this.userId, appId: appId })];                                 // 136
    }                                                                                                                  // 140
                                                                                                                       //
    return packageCursor;                                                                                              // 142
  });                                                                                                                  // 143
                                                                                                                       //
  SandstormDb.periodicCleanup(DEMO_EXPIRATION_MS, cleanupExpiredUsers);                                                // 145
} else {                                                                                                               // 146
  // Just run once, in case the config just changed from allowing demos to prohibiting them.                           //
  Meteor.setTimeout(cleanupExpiredUsers, DEMO_EXPIRATION_MS + DEMO_GRACE_MS);                                          // 148
}                                                                                                                      // 149
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications-server.js":["meteor/meteor",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/desktop-notifications-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});// Sandstorm - Personal Cloud Sandbox       //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
SandstormDb.periodicCleanup(120000, function () {                                                                      // 19
  // Remove old desktop notfications regularly.                                                                        //
  // periodicCleanup doesn't like runs more frequent than once every two minutes                                       //
  var now = Date.now();                                                                                                // 22
  var then = new Date(now - 30000); // Clear tokens older than 30 seconds.                                             // 23
  globalDb.collections.desktopNotifications.find({                                                                     // 24
    creationDate: { $lt: then }                                                                                        // 25
  }).forEach(function (doc) {                                                                                          // 24
    globalDb.collections.desktopNotifications.remove({                                                                 // 27
      _id: doc._id                                                                                                     // 28
    });                                                                                                                // 27
  });                                                                                                                  // 30
});                                                                                                                    // 31
                                                                                                                       //
Meteor.publish("desktopNotifications", function () {                                                                   // 33
  var _this = this;                                                                                                    // 33
                                                                                                                       //
  var subscribeTime = new Date();                                                                                      // 34
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 36
    // No desktop notifications for anonymous users.                                                                   //
    return [];                                                                                                         // 38
  }                                                                                                                    // 39
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 41
  var callbacks = {                                                                                                    // 42
    added: function added(doc) {                                                                                       // 43
      _this.added("desktopNotifications", doc._id, doc);                                                               // 44
    },                                                                                                                 // 45
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 47
      _this.changed("desktopNotifications", newDoc._id, newDoc);                                                       // 48
    },                                                                                                                 // 49
                                                                                                                       //
    removed: function removed(doc) {                                                                                   // 51
      _this.removed("desktopNotifications", doc._id);                                                                  // 52
    }                                                                                                                  // 53
  };                                                                                                                   // 42
                                                                                                                       //
  var sub = db.collections.desktopNotifications.find({                                                                 // 56
    userId: this.userId,                                                                                               // 57
    creationDate: { $gt: subscribeTime }                                                                               // 58
  }).observe(callbacks);                                                                                               // 56
                                                                                                                       //
  this.onStop(function () {                                                                                            // 61
    if (sub) {                                                                                                         // 62
      sub.stop();                                                                                                      // 63
    }                                                                                                                  // 64
  });                                                                                                                  // 65
                                                                                                                       //
  this.ready();                                                                                                        // 67
});                                                                                                                    // 68
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"dev-accounts-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/dev-accounts-server.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  createDevAccount: function createDevAccount(displayName, isAdmin, profile, unverifiedEmail) {                        // 20
    // This is a login method that creates or logs in a dev account with the given displayName                         //
                                                                                                                       //
    check(displayName, String);                                                                                        // 23
    check(isAdmin, Match.OneOf(undefined, null, Boolean));                                                             // 24
    check(profile, Match.OneOf(undefined, null, Object));                                                              // 25
    check(unverifiedEmail, Match.OneOf(undefined, null, String));                                                      // 26
                                                                                                                       //
    if (!this.connection.sandstormDb.allowDevAccounts()) {                                                             // 28
      throw new Meteor.Error(404, "Dev accounts are not enabled on this server");                                      // 29
    }                                                                                                                  // 30
                                                                                                                       //
    isAdmin = isAdmin || false;                                                                                        // 32
                                                                                                                       //
    profile = profile || {};                                                                                           // 34
    profile.name = profile.name || displayName;                                                                        // 35
    var hasCompletedSignup = !!unverifiedEmail && !!profile.pronoun && !!profile.handle;                               // 36
                                                                                                                       //
    var user = Meteor.users.findOne({ "services.dev.name": displayName });                                             // 38
    var userId = void 0;                                                                                               // 39
                                                                                                                       //
    if (user) {                                                                                                        // 41
      userId = user._id;                                                                                               // 42
    } else {                                                                                                           // 43
      userId = Accounts.insertUserDoc({                                                                                // 44
        profile: profile,                                                                                              // 45
        unverifiedEmail: unverifiedEmail                                                                               // 46
      }, {                                                                                                             // 44
        services: {                                                                                                    // 48
          dev: {                                                                                                       // 49
            name: displayName,                                                                                         // 50
            isAdmin: isAdmin,                                                                                          // 51
            hasCompletedSignup: hasCompletedSignup                                                                     // 52
          }                                                                                                            // 49
        }                                                                                                              // 48
      });                                                                                                              // 47
    }                                                                                                                  // 56
    // Log them in on this connection.                                                                                 //
    return Accounts._loginMethod(this, "createDevAccount", arguments, "dev", function () {                             // 58
      return { userId: userId };                                                                                       // 59
    });                                                                                                                // 59
  }                                                                                                                    // 60
});                                                                                                                    // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"feature-key.js":["bignum","ed25519",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/feature-key.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var ed25519;module.import("ed25519",{"default":function(v){ed25519=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var FeatureKey = Capnp.importSystem("sandstorm/feature-key.capnp").FeatureKey;                                         // 20
                                                                                                                       //
// We don't currently have a way of reading the raw bytes of a capnp struct in Javascript the                          //
// way we do in C++. Awkwardly, what we end up with is four 64-bit ints that have been stringified                     //
// since JS can't actually deal with 64-bit ints. We have to laboriously reconstruct the underlying                    //
// bytes using Bignum. Don't forget that everything is little-endian, as DJBeesus intended.                            //
var bits0 = Bignum(FeatureKey.signingKey.key0);                                                                        // 26
var bits1 = Bignum(FeatureKey.signingKey.key1);                                                                        // 27
var bits2 = Bignum(FeatureKey.signingKey.key2);                                                                        // 28
var bits3 = Bignum(FeatureKey.signingKey.key3);                                                                        // 29
var signingKey = bits0.add(bits1.shiftLeft(64 * 1)).add(bits2.shiftLeft(64 * 2)).add(bits3.shiftLeft(64 * 3)).toBuffer({ endian: "little", size: 32 });
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 36
                                                                                                                       //
function verifyFeatureKeySignature(buf) {                                                                              // 39
  // buf is a Buffer containing an feature key with attached signature.                                                //
  // This function returns the signed data if the signature is valid,                                                  //
  // or undefined if the signature is invalid.                                                                         //
                                                                                                                       //
  // Per crypto_sign, the first 64 bytes are the ed25519 signature                                                     //
  // and the rest of the blob is the signed data.                                                                      //
  var signature = buf.slice(0, 64);                                                                                    // 46
  var signedData = buf.slice(64);                                                                                      // 47
                                                                                                                       //
  if (!ed25519.Verify(signedData, signature, signingKey)) {                                                            // 49
    console.error("feature key failed signature check", bits0, bits1, bits2, bits3);                                   // 50
    return undefined;                                                                                                  // 51
  } else {                                                                                                             // 52
    return signedData;                                                                                                 // 53
  }                                                                                                                    // 54
};                                                                                                                     // 55
                                                                                                                       //
// Export for use in db.js and server/admin.js                                                                         //
loadSignedFeatureKey = function loadSignedFeatureKey(buf) {                                                            // 58
  // Given a Buffer containing a signed feature key, verifies and parses the feature key.                              //
  // Returns the parsed FeatureKey if it was signed by a trusted key, or                                               //
  // undefined if the signature did not pass verification.                                                             //
  var verifiedFeatureKeyBlob = verifyFeatureKeySignature(buf);                                                         // 62
  if (verifiedFeatureKeyBlob) {                                                                                        // 63
    var featureKey = Capnp.parse(FeatureKey, verifiedFeatureKeyBlob, { packed: true });                                // 64
    if (featureKey.isForTesting && !isTesting) {                                                                       // 65
      // This key is for testing only, but the server is not running in testing mode. Note that                        //
      // enabling testing mode forfeits up all security.                                                               //
      return undefined;                                                                                                // 68
    }                                                                                                                  // 69
                                                                                                                       //
    return featureKey;                                                                                                 // 71
  } else {                                                                                                             // 72
    return undefined;                                                                                                  // 73
  }                                                                                                                    // 74
};                                                                                                                     // 75
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"grain-server.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/grain-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
var emailLinkWithInlineStyle = function emailLinkWithInlineStyle(url, text) {                                          // 19
  return "<a href='" + url + "' style='display:inline-block;text-decoration:none;" + "font-family:sans-serif;width:200px;min-height:30px;line-height:30px;" + "border-radius:4px;text-align:center;background:#762F87;color:white'>" + text + "</a>";
};                                                                                                                     // 24
                                                                                                                       //
Meteor.publish("grainTopBar", function (grainId) {                                                                     // 26
  check(grainId, String);                                                                                              // 27
                                                                                                                       //
  var result = [Grains.find({                                                                                          // 29
    _id: grainId,                                                                                                      // 31
    $or: [{ userId: this.userId }, { "private": { $ne: true } }]                                                       // 32
  }, {                                                                                                                 // 30
    fields: {                                                                                                          // 37
      title: 1,                                                                                                        // 38
      userId: 1,                                                                                                       // 39
      identityId: 1,                                                                                                   // 40
      "private": 1                                                                                                     // 41
    }                                                                                                                  // 37
  })];                                                                                                                 // 36
  if (this.userId) {                                                                                                   // 45
    var myIdentityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                 // 46
    result.push(ApiTokens.find({                                                                                       // 47
      grainId: grainId,                                                                                                // 48
      $or: [{ "owner.user.identityId": { $in: myIdentityIds } }, { identityId: { $in: myIdentityIds } }]               // 49
    }));                                                                                                               // 47
  }                                                                                                                    // 54
                                                                                                                       //
  return result;                                                                                                       // 56
});                                                                                                                    // 57
                                                                                                                       //
// We allow users to learn package information about a grain they own.                                                 //
// This is used for obtaining icon and app title information for grains                                                //
// you own, which is used in the sidebar. It is not a security/privacy                                                 //
// risk since it only exposes this information for grains the user owns.                                               //
Meteor.publish("packageByGrainId", function (grainId) {                                                                // 63
  check(grainId, String);                                                                                              // 64
  var publishThis = [];                                                                                                // 65
  // We need to publish the packageId so that client-side code can                                                     //
  // find the right package.                                                                                           //
  var thisGrainCursor = Grains.find({                                                                                  // 68
    _id: grainId,                                                                                                      // 69
    userId: this.userId                                                                                                // 70
  }, {                                                                                                                 // 68
    fields: { packageId: 1 }                                                                                           // 72
  });                                                                                                                  // 71
  publishThis.push(thisGrainCursor);                                                                                   // 74
                                                                                                                       //
  if (thisGrainCursor.count()) {                                                                                       // 76
    var thisGrain = thisGrainCursor.fetch()[0];                                                                        // 77
    var thisPackageCursor = Packages.find({ _id: thisGrain.packageId });                                               // 78
    publishThis.push(thisPackageCursor);                                                                               // 79
  }                                                                                                                    // 80
                                                                                                                       //
  return publishThis;                                                                                                  // 82
});                                                                                                                    // 83
                                                                                                                       //
Meteor.publish("tokenInfo", function (token) {                                                                         // 85
  // Allows the client side to map a raw token to its entry in ApiTokens, and the additional                           //
  // metadata that it will need to display the app icon and title.  We do not care about making                        //
  // the metadata reactive.                                                                                            //
  check(token, String);                                                                                                // 89
                                                                                                                       //
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 91
  var apiToken = ApiTokens.findOne({                                                                                   // 92
    _id: hashedToken                                                                                                   // 93
  }, {                                                                                                                 // 92
    fields: {                                                                                                          // 95
      grainId: 1,                                                                                                      // 96
      identityId: 1,                                                                                                   // 97
      owner: 1,                                                                                                        // 98
      revoked: 1                                                                                                       // 99
    }                                                                                                                  // 95
  });                                                                                                                  // 94
  if (!apiToken) {                                                                                                     // 102
    this.added("tokenInfo", token, { invalidToken: true });                                                            // 103
  } else if (apiToken.revoked) {                                                                                       // 104
    this.added("tokenInfo", token, { revoked: true });                                                                 // 105
  } else {                                                                                                             // 106
    var grainId = apiToken.grainId;                                                                                    // 107
    var grain = Grains.findOne({                                                                                       // 108
      _id: grainId                                                                                                     // 109
    }, {                                                                                                               // 108
      fields: {                                                                                                        // 111
        packageId: 1,                                                                                                  // 112
        appId: 1,                                                                                                      // 113
        userId: 1                                                                                                      // 114
      }                                                                                                                // 111
    });                                                                                                                // 110
    if (!grain) {                                                                                                      // 117
      this.added("tokenInfo", token, { invalidToken: true });                                                          // 118
    } else {                                                                                                           // 119
      if (apiToken.owner && apiToken.owner.user) {                                                                     // 120
        var identity = globalDb.getIdentity(apiToken.owner.user.identityId);                                           // 121
        var metadata = apiToken.owner.user.denormalizedGrainMetadata;                                                  // 122
        if (identity && metadata) {                                                                                    // 123
          SandstormDb.fillInLoginId(identity);                                                                         // 124
          this.added("tokenInfo", token, {                                                                             // 125
            identityOwner: _.pick(identity, "_id", "profile", "loginId"),                                              // 126
            grainId: grainId,                                                                                          // 127
            grainMetadata: metadata                                                                                    // 128
          });                                                                                                          // 125
        } else {                                                                                                       // 130
          this.added("tokenInfo", token, { invalidToken: true });                                                      // 131
        }                                                                                                              // 132
      } else if (!apiToken.owner || "webkey" in apiToken.owner) {                                                      // 133
        if (this.userId) {                                                                                             // 134
          var user = Meteor.users.findOne({ _id: this.userId });                                                       // 135
          var identityIds = SandstormDb.getUserIdentityIds(user);                                                      // 136
          var childToken = ApiTokens.findOne({                                                                         // 137
            "owner.user.identityId": { $in: identityIds },                                                             // 138
            parentToken: apiToken._id                                                                                  // 139
          });                                                                                                          // 137
          if (childToken || this.userId === grain.userId || identityIds.indexOf(apiToken.identityId) >= 0) {           // 141
            this.added("tokenInfo", token, { alreadyRedeemed: true, grainId: apiToken.grainId });                      // 143
            this.ready();                                                                                              // 144
            return;                                                                                                    // 145
          }                                                                                                            // 146
        }                                                                                                              // 147
                                                                                                                       //
        var pkg = Packages.findOne({ _id: grain.packageId }, { fields: { manifest: 1 } });                             // 149
        var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                            // 150
        var appIcon = undefined;                                                                                       // 151
        if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                             // 152
          var icons = pkg.manifest.metadata.icons;                                                                     // 153
          appIcon = icons.grain || icons.appGrid;                                                                      // 154
        }                                                                                                              // 155
                                                                                                                       //
        var denormalizedGrainMetadata = {                                                                              // 157
          appTitle: appTitle,                                                                                          // 158
          icon: appIcon,                                                                                               // 159
          appId: appIcon ? undefined : grain.appId                                                                     // 160
        };                                                                                                             // 157
        this.added("tokenInfo", token, {                                                                               // 162
          webkey: true,                                                                                                // 163
          grainId: grainId,                                                                                            // 164
          grainMetadata: denormalizedGrainMetadata                                                                     // 165
        });                                                                                                            // 162
      } else {                                                                                                         // 167
        this.added("tokenInfo", token, { invalidToken: true });                                                        // 168
      }                                                                                                                // 169
    }                                                                                                                  // 170
  }                                                                                                                    // 171
                                                                                                                       //
  this.ready();                                                                                                        // 173
  return;                                                                                                              // 174
});                                                                                                                    // 175
                                                                                                                       //
Meteor.publish("requestingAccess", function (grainId) {                                                                // 177
  check(grainId, String);                                                                                              // 178
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 180
    throw new Meteor.Error(403, "Must be logged in to request access.");                                               // 181
  }                                                                                                                    // 182
                                                                                                                       //
  var grain = globalDb.getGrain(grainId);                                                                              // 184
  if (!grain) {                                                                                                        // 185
    throw new Meteor.Error(404, "Grain not found.");                                                                   // 186
  }                                                                                                                    // 187
                                                                                                                       //
  if (grain.userId === this.userId) {                                                                                  // 189
    this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: grain.identityId });              // 190
  }                                                                                                                    // 192
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: this.userId }));                        // 194
  var ownerIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));                  // 195
                                                                                                                       //
  var _this = this;                                                                                                    // 198
  var query = ApiTokens.find({                                                                                         // 199
    grainId: grainId,                                                                                                  // 200
    identityId: { $in: ownerIdentityIds },                                                                             // 201
    parentToken: { $exists: false },                                                                                   // 202
    "owner.user.identityId": { $in: identityIds },                                                                     // 203
    revoked: { $ne: true }                                                                                             // 204
  });                                                                                                                  // 199
  var handle = query.observe({                                                                                         // 206
    added: function added(apiToken) {                                                                                  // 207
      _this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: apiToken.owner.user.identityId });
    }                                                                                                                  // 210
  });                                                                                                                  // 206
                                                                                                                       //
  this.onStop(function () {                                                                                            // 213
    return handle.stop();                                                                                              // 213
  });                                                                                                                  // 213
});                                                                                                                    // 214
                                                                                                                       //
Meteor.publish("grainSize", function (grainId) {                                                                       // 216
  // Publish pseudo-collection containing the size of the grain opened in the given session.                           //
  check(grainId, String);                                                                                              // 218
                                                                                                                       //
  var grain = Grains.findOne(grainId);                                                                                 // 220
  if (!grain || grain.userId !== this.userId) {                                                                        // 221
    return [];                                                                                                         // 222
  }                                                                                                                    // 223
                                                                                                                       //
  var supervisor = globalBackend.cap().getGrain(this.userId, grainId).supervisor;                                      // 225
                                                                                                                       //
  var _this = this;                                                                                                    // 227
  var stopped = false;                                                                                                 // 228
  var promise = getGrainSize(supervisor);                                                                              // 229
                                                                                                                       //
  function getNext(oldSize) {                                                                                          // 231
    promise = getGrainSize(supervisor, oldSize);                                                                       // 232
    promise.then(function (size) {                                                                                     // 233
      if (!stopped) {                                                                                                  // 234
        if (size !== oldSize) {                                                                                        // 235
          // sometimes there are false alarms                                                                          //
          _this.changed("grainSizes", grainId, { size: size });                                                        // 236
        }                                                                                                              // 237
                                                                                                                       //
        getNext(size);                                                                                                 // 239
      }                                                                                                                // 240
    }, function (err) {                                                                                                // 241
                                                                                                                       //
      if (!stopped) {                                                                                                  // 243
        if (err.kjType === "disconnected") {                                                                           // 244
          _this.stop();                                                                                                // 245
        } else {                                                                                                       // 246
          _this.error(err);                                                                                            // 247
        }                                                                                                              // 248
      }                                                                                                                // 249
    });                                                                                                                // 250
  }                                                                                                                    // 251
                                                                                                                       //
  promise.then(function (size) {                                                                                       // 253
    if (!stopped) {                                                                                                    // 254
      _this.added("grainSizes", grainId, { size: size });                                                              // 255
      _this.ready();                                                                                                   // 256
      getNext(size);                                                                                                   // 257
    }                                                                                                                  // 258
  }, function (err) {                                                                                                  // 259
                                                                                                                       //
    if (!stopped) {                                                                                                    // 261
      if (err.kjType === "disconnected") {                                                                             // 262
        _this.stop();                                                                                                  // 263
      } else {                                                                                                         // 264
        _this.error(err);                                                                                              // 265
      }                                                                                                                // 266
    }                                                                                                                  // 267
  });                                                                                                                  // 268
                                                                                                                       //
  _this.onStop(function () {                                                                                           // 270
    stopped = true;                                                                                                    // 271
    promise.cancel();                                                                                                  // 272
  });                                                                                                                  // 273
});                                                                                                                    // 274
                                                                                                                       //
var GRAIN_DELETION_MS = 1000 * 60 * 60 * 24 * 30; // thirty days                                                       // 276
SandstormDb.periodicCleanup(86400000, function () {                                                                    // 277
  var trashExpiration = new Date(Date.now() - GRAIN_DELETION_MS);                                                      // 278
  globalDb.removeApiTokens({ trashed: { $lt: trashExpiration } });                                                     // 279
  globalDb.deleteGrains({ trashed: { $lt: trashExpiration } }, globalBackend, "grain");                                // 280
});                                                                                                                    // 281
                                                                                                                       //
Meteor.methods({                                                                                                       // 283
  moveGrainsToTrash: function moveGrainsToTrash(grainIds) {                                                            // 284
    check(grainIds, [String]);                                                                                         // 285
                                                                                                                       //
    if (this.userId) {                                                                                                 // 287
      Grains.update({ userId: { $eq: this.userId },                                                                    // 288
        _id: { $in: grainIds },                                                                                        // 289
        trashed: { $exists: false } }, { $set: { trashed: new Date() } }, { multi: true });                            // 290
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 294
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 296
        "owner.user.identityId": { $in: identityIds },                                                                 // 297
        trashed: { $exists: false } }, { $set: { "trashed": new Date() } }, { multi: true });                          // 298
    }                                                                                                                  // 301
  },                                                                                                                   // 302
                                                                                                                       //
  moveGrainsOutOfTrash: function moveGrainsOutOfTrash(grainIds) {                                                      // 304
    check(grainIds, [String]);                                                                                         // 305
                                                                                                                       //
    if (this.userId) {                                                                                                 // 307
      Grains.update({ userId: { $eq: this.userId },                                                                    // 308
        _id: { $in: grainIds },                                                                                        // 309
        trashed: { $exists: true } }, { $unset: { trashed: 1 } }, { multi: true });                                    // 310
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 314
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 316
        "owner.user.identityId": { $in: identityIds },                                                                 // 317
        "trashed": { $exists: true } }, { $unset: { "trashed": 1 } }, { multi: true });                                // 318
    }                                                                                                                  // 321
  },                                                                                                                   // 322
                                                                                                                       //
  deleteGrain: function deleteGrain(grainId) {                                                                         // 324
    check(grainId, String);                                                                                            // 325
                                                                                                                       //
    if (this.userId) {                                                                                                 // 327
      var query = {                                                                                                    // 328
        _id: grainId,                                                                                                  // 329
        userId: this.userId,                                                                                           // 330
        trashed: { $exists: true }                                                                                     // 331
      };                                                                                                               // 328
      var numDeleted = globalDb.deleteGrains(query, globalBackend, isDemoUser() ? "demoGrain" : "grain");              // 333
                                                                                                                       //
      // Usually we don't automatically remove user-owned tokens that have become invalid,                             //
      // because if we did their owner might become confused as to why they have mysteriously                          //
      // disappeared. In this particular case, however, for tokens held by the grain owner,                            //
      // there should be no confusion. Indeed, it would be more confusing *not* to remove these                        //
      // tokens, because then the grain could still show up in the trash bin as a "shared with me"                     //
      // grain after the owner clicks "delete permanently".                                                            //
      //                                                                                                               //
      // Note that these tokens may be visible to other accounts if there are identities shared                        //
      // between the accounts; by only removing 'trashed' tokens, we minimize confusion in that                        //
      // case too.                                                                                                     //
      if (numDeleted > 0) {                                                                                            // 346
        globalDb.removeApiTokens({                                                                                     // 347
          grainId: grainId,                                                                                            // 348
          "owner.user.identityId": { $in: SandstormDb.getUserIdentityIds(Meteor.user()) },                             // 349
          "trashed": { $exists: true }                                                                                 // 350
        });                                                                                                            // 347
      }                                                                                                                // 352
    }                                                                                                                  // 353
  },                                                                                                                   // 354
                                                                                                                       //
  forgetGrain: function forgetGrain(grainId, identityId) {                                                             // 356
    check(grainId, String);                                                                                            // 357
    check(identityId, String);                                                                                         // 358
                                                                                                                       //
    if (!this.userId) {                                                                                                // 360
      throw new Meteor.Error(403, "Must be logged in to forget a grain.");                                             // 361
    }                                                                                                                  // 362
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 364
      throw new Meteor.Error(403, "Current user does not have the identity " + identityId);                            // 365
    }                                                                                                                  // 366
                                                                                                                       //
    globalDb.removeApiTokens({ grainId: grainId,                                                                       // 368
      "owner.user.identityId": identityId,                                                                             // 369
      "trashed": { $exists: true }                                                                                     // 370
    });                                                                                                                // 368
  },                                                                                                                   // 372
                                                                                                                       //
  updateGrainPreferredIdentity: function updateGrainPreferredIdentity(grainId, identityId) {                           // 374
    check(grainId, String);                                                                                            // 375
    check(identityId, String);                                                                                         // 376
    if (!this.userId) {                                                                                                // 377
      throw new Meteor.Error(403, "Must be logged in.");                                                               // 378
    }                                                                                                                  // 379
                                                                                                                       //
    var grain = globalDb.getGrain(grainId) || {};                                                                      // 381
    if (!grain.userId === this.userId) {                                                                               // 382
      throw new Meteor.Error(403, "Grain not owned by current user.");                                                 // 383
    }                                                                                                                  // 384
                                                                                                                       //
    Grains.update({ _id: grainId }, { $set: { identityId: identityId } });                                             // 386
  },                                                                                                                   // 387
                                                                                                                       //
  updateGrainTitle: function updateGrainTitle(grainId, newTitle, identityId) {                                         // 389
    check(grainId, String);                                                                                            // 390
    check(newTitle, String);                                                                                           // 391
    check(identityId, String);                                                                                         // 392
    if (this.userId) {                                                                                                 // 393
      var grain = Grains.findOne(grainId);                                                                             // 394
      if (grain) {                                                                                                     // 395
        if (grain.userId === this.userId) {                                                                            // 396
          Grains.update({ _id: grainId, userId: this.userId }, { $set: { title: newTitle } });                         // 397
                                                                                                                       //
          // Denormalize new title out to all sharing tokens.                                                          //
          ApiTokens.update({ grainId: grainId, "owner.user": { $exists: true } }, { $set: { "owner.user.upstreamTitle": newTitle } }, { multi: true });
        } else {                                                                                                       // 403
          if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                    // 404
            throw new Meteor.Error(403, "Current user does not have identity " + identityId);                          // 405
          }                                                                                                            // 406
                                                                                                                       //
          var token = ApiTokens.findOne({                                                                              // 408
            grainId: grainId,                                                                                          // 409
            objectId: { $exists: false },                                                                              // 410
            "owner.user.identityId": identityId                                                                        // 411
          }, {                                                                                                         // 408
            sort: { created: 1 } });                                                                                   // 413
          // The oldest token is our source of truth for the name.                                                     //
          if (token && token.owner.user.title !== newTitle) {                                                          // 415
            if (token.owner.user.upstreamTitle === newTitle) {                                                         // 416
              // User renamed grain to match upstream title. Act like they never renamed it at                         //
              // all.                                                                                                  //
              ApiTokens.update({                                                                                       // 419
                grainId: grainId,                                                                                      // 420
                "owner.user.identityId": identityId                                                                    // 421
              }, {                                                                                                     // 419
                $set: { "owner.user.title": newTitle },                                                                // 423
                $unset: { "owner.user.upstreamTitle": 1, "owner.user.renamed": 1 }                                     // 424
              }, {                                                                                                     // 422
                multi: true                                                                                            // 426
              });                                                                                                      // 425
            } else {                                                                                                   // 428
              var modification = {                                                                                     // 429
                "owner.user.title": newTitle,                                                                          // 430
                "owner.user.renamed": true                                                                             // 431
              };                                                                                                       // 429
                                                                                                                       //
              if (!token.owner.user.upstreamTitle) {                                                                   // 434
                // If `upstreamTitle` isn't present then it is equal to the old title.                                 //
                modification["owner.user.upstreamTitle"] = token.owner.user.title;                                     // 436
              }                                                                                                        // 437
                                                                                                                       //
              ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: modification }, { multi: true });
            }                                                                                                          // 442
          }                                                                                                            // 443
        }                                                                                                              // 444
      }                                                                                                                // 445
    }                                                                                                                  // 446
  },                                                                                                                   // 447
                                                                                                                       //
  privatizeGrain: function privatizeGrain(grainId) {                                                                   // 449
    check(grainId, String);                                                                                            // 450
    if (this.userId) {                                                                                                 // 451
      Grains.update({ _id: grainId, userId: this.userId }, { $set: { "private": true } });                             // 452
    }                                                                                                                  // 453
  },                                                                                                                   // 454
                                                                                                                       //
  inviteUsersToGrain: function inviteUsersToGrain(origin, identityId, grainId, title, roleAssignment, contacts, message) {
    var _this2 = this;                                                                                                 // 457
                                                                                                                       //
    if (!this.isSimulation) {                                                                                          // 458
      var _ret = function () {                                                                                         // 458
        check(origin, String);                                                                                         // 459
        check(identityId, String);                                                                                     // 460
        check(grainId, String);                                                                                        // 461
        check(title, String);                                                                                          // 462
        check(roleAssignment, roleAssignmentPattern);                                                                  // 463
        check(contacts, [{                                                                                             // 464
          _id: String,                                                                                                 // 466
          isDefault: Match.Optional(Boolean),                                                                          // 467
          profile: Match.ObjectIncluding({                                                                             // 468
            service: String,                                                                                           // 469
            name: String,                                                                                              // 470
            intrinsicName: String                                                                                      // 471
          })                                                                                                           // 468
        }]);                                                                                                           // 465
        check(message, { text: String, html: String });                                                                // 475
        if (!_this2.userId) {                                                                                          // 476
          throw new Meteor.Error(403, "Must be logged in to share by email.");                                         // 477
        }                                                                                                              // 478
                                                                                                                       //
        if (!globalDb.userHasIdentity(_this2.userId, identityId)) {                                                    // 480
          throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                           // 481
        }                                                                                                              // 482
                                                                                                                       //
        if (contacts.length === 0) {                                                                                   // 484
          throw new Meteor.Error(400, "No contacts were provided.");                                                   // 485
        }                                                                                                              // 486
                                                                                                                       //
        if (globalDb.isDemoUser()) {                                                                                   // 488
          throw new Meteor.Error(403, "Demo users are not allowed to share by email.");                                // 489
        }                                                                                                              // 490
                                                                                                                       //
        var accountId = _this2.userId;                                                                                 // 492
        var outerResult = { successes: [], failures: [] };                                                             // 493
        var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                          // 494
        var replyTo = globalDb.getPrimaryEmail(accountId, identityId);                                                 // 495
        contacts.forEach(function (contact) {                                                                          // 496
          if (contact.isDefault && contact.profile.service === "email") {                                              // 497
            var emailAddress = contact.profile.intrinsicName;                                                          // 498
            var result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "email invitation for " + emailAddress, roleAssignment, { webkey: { forSharing: true } });
            var url = origin + "/shared/" + result.token;                                                              // 503
            var html = message.html + "<br><br>" + emailLinkWithInlineStyle(url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: If you forward this email to other people, they will be able to access " + "the share as well. To prevent this, remove the button before forwarding.</div>";
            try {                                                                                                      // 509
              globalDb.incrementDailySentMailCount(accountId);                                                         // 510
              SandstormEmail.send({                                                                                    // 511
                to: emailAddress,                                                                                      // 512
                from: fromEmail,                                                                                       // 513
                replyTo: replyTo,                                                                                      // 514
                subject: title + " - Invitation to collaborate",                                                       // 515
                text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + url + "\n\nNote: If you forward this email to other people, they will be able to " + "access the share as well. To prevent this, remove the link before forwarding.",
                html: html                                                                                             // 519
              });                                                                                                      // 511
            } catch (e) {                                                                                              // 521
              outerResult.failures.push({ contact: contact, error: e.toString() });                                    // 522
            }                                                                                                          // 523
          } else {                                                                                                     // 524
            var _result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "direct invitation to " + contact.profile.intrinsicName, roleAssignment, { user: { identityId: contact._id, title: title } });
            var _url = origin + "/shared/" + _result.token;                                                            // 529
            try {                                                                                                      // 530
              var identity = Meteor.users.findOne({ _id: contact._id });                                               // 531
              var email = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                     // 532
              if (email) {                                                                                             // 534
                var intrinsicName = contact.profile.intrinsicName;                                                     // 535
                var loginNote = void 0;                                                                                // 536
                if (contact.profile.service === "google") {                                                            // 537
                  loginNote = "Google account with address " + email.email;                                            // 538
                } else if (contact.profile.service === "github") {                                                     // 539
                  loginNote = "Github account with username " + intrinsicName;                                         // 540
                } else if (contact.profile.service === "email") {                                                      // 541
                  loginNote = "email address " + intrinsicName;                                                        // 542
                } else if (contact.profile.service === "ldap") {                                                       // 543
                  loginNote = "LDAP username " + intrinsicName;                                                        // 544
                } else if (contact.profile.service === "saml") {                                                       // 545
                  loginNote = "SAML ID " + intrinsicName;                                                              // 546
                } else {                                                                                               // 547
                  throw new Meteor.Error(500, "Unknown service to email share link.");                                 // 548
                }                                                                                                      // 549
                                                                                                                       //
                var _html = message.html + "<br><br>" + emailLinkWithInlineStyle(_url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: You will need to log in with your " + loginNote + " to access this grain.";
                globalDb.incrementDailySentMailCount(accountId);                                                       // 556
                SandstormEmail.send({                                                                                  // 557
                  to: email.email,                                                                                     // 558
                  from: fromEmail,                                                                                     // 559
                  replyTo: replyTo,                                                                                    // 560
                  subject: title + " - Invitation to collaborate",                                                     // 561
                  text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + _url + "\n\nNote: You will need to log in with your " + loginNote + " to access this grain.",
                  html: _html                                                                                          // 565
                });                                                                                                    // 557
              } else {                                                                                                 // 567
                outerResult.failures.push({ contact: contact, warning: "User does not have a " + "verified email, so notification of this share was not sent to them. Please " + "manually share " + _url + " with them." });
              }                                                                                                        // 571
            } catch (e) {                                                                                              // 572
              outerResult.failures.push({ contact: contact, error: e.toString(),                                       // 573
                warning: "Share succeeded, but there was an error emailing the user. Please " + "manually share " + _url + " with them." });
            }                                                                                                          // 576
          }                                                                                                            // 577
        });                                                                                                            // 578
                                                                                                                       //
        return {                                                                                                       // 580
          v: outerResult                                                                                               // 580
        };                                                                                                             // 580
      }();                                                                                                             // 458
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 458
    }                                                                                                                  // 581
  },                                                                                                                   // 582
                                                                                                                       //
  requestAccess: function requestAccess(origin, grainId, identityId) {                                                 // 584
    check(origin, String);                                                                                             // 585
    check(grainId, String);                                                                                            // 586
    check(identityId, String);                                                                                         // 587
    if (!this.isSimulation) {                                                                                          // 588
      if (!this.userId) {                                                                                              // 589
        throw new Meteor.Error(403, "Must be logged in to request access.");                                           // 590
      }                                                                                                                // 591
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 593
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 594
      }                                                                                                                // 595
                                                                                                                       //
      var grain = Grains.findOne(grainId);                                                                             // 597
      if (!grain) {                                                                                                    // 598
        throw new Meteor.Error(404, "No such grain");                                                                  // 599
      }                                                                                                                // 600
                                                                                                                       //
      var grainOwner = globalDb.getUser(grain.userId);                                                                 // 602
      var email = _.findWhere(SandstormDb.getUserEmails(grainOwner), { primary: true });                               // 603
      if (!email) {                                                                                                    // 604
        throw new Meteor.Error("no email", "Grain owner has no email address.");                                       // 605
      }                                                                                                                // 606
                                                                                                                       //
      var emailAddress = email.email;                                                                                  // 608
                                                                                                                       //
      var identity = globalDb.getIdentity(identityId);                                                                 // 610
      globalDb.addContact(grainOwner._id, identityId);                                                                 // 611
                                                                                                                       //
      var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                            // 613
      var replyTo = globalDb.getPrimaryEmail(Meteor.userId(), identityId);                                             // 614
                                                                                                                       //
      // TODO(soon): In the HTML version, we should display an identity card.                                          //
      var identityNote = "";                                                                                           // 617
      if (identity.profile.service === "google") {                                                                     // 618
        identityNote = " (" + identity.privateIntrinsicName + ")";                                                     // 619
      } else if (identity.profile.service === "github") {                                                              // 620
        identityNote = " (" + identity.profile.intrinsicName + " on GitHub)";                                          // 621
      } else if (identity.profile.service === "email") {                                                               // 622
        identityNote = " (" + identity.profile.intrinsicName + ")";                                                    // 623
      } else if (identity.profile.service === "ldap") {                                                                // 624
        identityNote = " (" + identity.profile.intrinsicName + " on LDAP)";                                            // 625
      } else if (identity.profile.service === "saml") {                                                                // 626
        identityNote = " (" + identity.profile.intrinsicName + " on SAML)";                                            // 627
      }                                                                                                                // 628
                                                                                                                       //
      var message = identity.profile.name + identityNote + " is requesting access to your grain: " + grain.title + ".";
                                                                                                                       //
      var url = origin + "/share/" + grainId + "/" + identityId;                                                       // 633
                                                                                                                       //
      var html = message + "<br><br>" + emailLinkWithInlineStyle(url, "Open Sharing Menu");                            // 635
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 638
      var ACCESS_REQUEST_LIMIT = 10;                                                                                   // 639
      var resetCount = true;                                                                                           // 640
      if (user.accessRequests) {                                                                                       // 641
        if (user.accessRequests.resetOn < new Date()) {                                                                // 642
          Meteor.users.update({ _id: user._id }, { $unset: { accessRequests: 1 } });                                   // 643
        } else if (user.accessRequests.count >= ACCESS_REQUEST_LIMIT) {                                                // 644
          throw new Meteor.Error(403, "For spam control reasons, you are not allowed to make " + "more than " + ACCESS_REQUEST_LIMIT + " access requests per day.");
        } else {                                                                                                       // 648
          resetCount = false;                                                                                          // 649
        }                                                                                                              // 650
      }                                                                                                                // 651
                                                                                                                       //
      var modifier = { $inc: { "accessRequests.count": 1 } };                                                          // 653
      if (resetCount) {                                                                                                // 654
        var tomorrow = new Date(Date.now() + 86400000);                                                                // 655
        modifier.$set = { "accessRequests.resetOn": tomorrow };                                                        // 656
      }                                                                                                                // 657
                                                                                                                       //
      Meteor.users.update({ _id: user._id }, modifier);                                                                // 659
                                                                                                                       //
      SandstormEmail.send({                                                                                            // 661
        to: emailAddress,                                                                                              // 662
        from: fromEmail,                                                                                               // 663
        replyTo: replyTo,                                                                                              // 664
        subject: grain.title + " - Request for access",                                                                // 665
        text: message + "\n\nFollow this link to share access:\n\n" + url,                                             // 666
        html: html                                                                                                     // 667
      });                                                                                                              // 661
    }                                                                                                                  // 669
  }                                                                                                                    // 670
});                                                                                                                    // 283
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"hack-session.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/hack-session.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var hashSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"hashSturdyRef":function(v){hashSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Http = Npm.require("http");                                                                                        // 18
var Https = Npm.require("https");                                                                                      // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Net = Npm.require("net");                                                                                          // 21
var Dgram = Npm.require("dgram");                                                                                      // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Capnp = Npm.require("capnp");                                                                                      // 24
                                                                                                                       // 25
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 27
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 28
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 29
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 30
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 31
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 32
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                               // 33
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 35
                                                                                                                       //
ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                            // 37
HOSTNAME = ROOT_URL.hostname;                                                                                          // 38
                                                                                                                       //
SessionContextImpl = function () {                                                                                     // 40
  function SessionContextImpl(grainId, sessionId, identityId, tabId) {                                                 // 41
    _classCallCheck(this, SessionContextImpl);                                                                         // 41
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 42
    this.sessionId = sessionId;                                                                                        // 43
    this.identityId = identityId;                                                                                      // 44
    this.tabId = tabId;                                                                                                // 45
  }                                                                                                                    // 46
                                                                                                                       //
  SessionContextImpl.prototype.claimRequest = function claimRequest(sturdyRef, requiredPermissions) {                  // 40
    var _this2 = this;                                                                                                 // 48
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 49
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 50
                                                                                                                       //
      var token = ApiTokens.findOne({                                                                                  // 52
        _id: hashedSturdyRef,                                                                                          // 53
        "owner.clientPowerboxRequest.grainId": _this2.grainId,                                                         // 54
        "owner.clientPowerboxRequest.sessionId": _this2.sessionId                                                      // 55
      });                                                                                                              // 52
                                                                                                                       //
      if (!token) {                                                                                                    // 58
        throw new Error("no such token");                                                                              // 59
      }                                                                                                                // 60
                                                                                                                       //
      // Honor `requiredPermissions`.                                                                                  //
      var requirements = [];                                                                                           // 63
      if (token.owner.clientPowerboxRequest.introducerIdentity) {                                                      // 64
        requirements.push({                                                                                            // 65
          permissionsHeld: {                                                                                           // 66
            permissions: requiredPermissions || [],                                                                    // 67
            identityId: token.owner.clientPowerboxRequest.introducerIdentity,                                          // 68
            grainId: _this2.grainId                                                                                    // 69
          }                                                                                                            // 66
        });                                                                                                            // 65
      }                                                                                                                // 72
                                                                                                                       //
      return restoreInternal(new Buffer(sturdyRef), { clientPowerboxRequest: Match.ObjectIncluding({ grainId: _this2.grainId }) }, requirements, token);
    });                                                                                                                // 78
  };                                                                                                                   // 79
                                                                                                                       //
  SessionContextImpl.prototype.offer = function offer(cap, requiredPermissions, descriptor, displayInfo) {             // 40
    var _this3 = this;                                                                                                 // 81
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 82
      if (!_this3.identityId) {                                                                                        // 83
        // TODO(soon): allow non logged in users?                                                                      //
        throw new Meteor.Error(400, "Only logged in users can offer capabilities.");                                   // 85
      }                                                                                                                // 86
                                                                                                                       //
      var castedCap = cap.castAs(SystemPersistent);                                                                    // 88
      var apiTokenOwner = { webkey: null };                                                                            // 89
      var isUiView = descriptor && descriptor.tags && descriptor.tags.length === 1 && descriptor.tags[0] && descriptor.tags[0].id && descriptor.tags[0].id === Grain.UiView.typeId;
      if (isUiView) {                                                                                                  // 93
        var tagValue = {};                                                                                             // 94
        if (descriptor.tags[0].value) {                                                                                // 95
          tagValue = Capnp.parse(Grain.UiView.PowerboxTag, descriptor.tags[0].value);                                  // 96
        }                                                                                                              // 97
                                                                                                                       //
        if (!tagValue.title) {                                                                                         // 99
          // TODO(someday): We should arguably throw here, but the collections app currently                           //
          //   fails to provide a title.                                                                               //
          tagValue.title = "offer()ed grain had no title";                                                             // 102
        }                                                                                                              // 103
                                                                                                                       //
        apiTokenOwner = {                                                                                              // 105
          user: {                                                                                                      // 106
            identityId: _this3.identityId,                                                                             // 107
            title: tagValue.title                                                                                      // 108
          }                                                                                                            // 106
        };                                                                                                             // 105
      }                                                                                                                // 111
                                                                                                                       //
      // TODO(soon): This will eventually use SystemPersistent.addRequirements when membranes                          //
      // are fully implemented for supervisors.                                                                        //
      var requirement = {                                                                                              // 115
        permissionsHeld: {                                                                                             // 116
          grainId: _this3.grainId,                                                                                     // 117
          identityId: _this3.identityId,                                                                               // 118
          permissions: requiredPermissions                                                                             // 119
        }                                                                                                              // 116
      };                                                                                                               // 115
                                                                                                                       //
      checkRequirements(globalDb, [requirement]);                                                                      // 123
                                                                                                                       //
      var save = castedCap.save(apiTokenOwner);                                                                        // 125
      var sturdyRef = waitPromise(save).sturdyRef;                                                                     // 126
      ApiTokens.update({ _id: hashSturdyRef(sturdyRef) }, { $push: { requirements: requirement } });                   // 127
                                                                                                                       //
      var powerboxView = void 0;                                                                                       // 129
      if (isUiView) {                                                                                                  // 130
        // Deduplicate.                                                                                                //
        var tokenId = hashSturdyRef(sturdyRef.toString());                                                             // 132
        var newApiToken = ApiTokens.findOne({ _id: tokenId });                                                         // 133
        var dupeQuery = _.pick(newApiToken, "grainId", "roleAssignment", "requirements", "parentToken", "identityId", "accountId");
        dupeQuery._id = { $ne: newApiToken._id };                                                                      // 136
        dupeQuery["owner.user.identityId"] = _this3.identityId;                                                        // 137
        dupeQuery.trashed = { $exists: false };                                                                        // 138
        dupeQuery.revoked = { $exists: false };                                                                        // 139
                                                                                                                       //
        var dupeToken = ApiTokens.findOne(dupeQuery);                                                                  // 141
        if (dupeToken) {                                                                                               // 142
          globalDb.removeApiTokens({ _id: tokenId });                                                                  // 143
          tokenId = dupeToken._id;                                                                                     // 144
        }                                                                                                              // 145
                                                                                                                       //
        powerboxView = { offer: { uiView: { tokenId: tokenId } } };                                                    // 147
      } else {                                                                                                         // 148
        powerboxView = {                                                                                               // 149
          offer: {                                                                                                     // 150
            url: ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef                          // 151
          }                                                                                                            // 150
        };                                                                                                             // 149
      }                                                                                                                // 154
                                                                                                                       //
      Sessions.update({ _id: _this3.sessionId }, {                                                                     // 156
        $set: {                                                                                                        // 158
          powerboxView: powerboxView                                                                                   // 159
        }                                                                                                              // 158
      });                                                                                                              // 157
    });                                                                                                                // 163
  };                                                                                                                   // 164
                                                                                                                       //
  SessionContextImpl.prototype.activity = function activity(event) {                                                   // 40
    var _this4 = this;                                                                                                 // 166
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 167
      logActivity(_this4.grainId, _this4.identityId, event);                                                           // 168
    });                                                                                                                // 169
  };                                                                                                                   // 170
                                                                                                                       //
  return SessionContextImpl;                                                                                           // 40
}();                                                                                                                   // 40
                                                                                                                       //
Meteor.methods({                                                                                                       // 173
  finishPowerboxRequest: function finishPowerboxRequest(sessionId, webkeyUrl, saveLabel, identityId, grainId) {        // 174
    check(sessionId, String);                                                                                          // 175
    check(webkeyUrl, String);                                                                                          // 176
    check(saveLabel, Match.OneOf(undefined, null, String));                                                            // 177
    check(identityId, String);                                                                                         // 178
    check(grainId, String);                                                                                            // 179
                                                                                                                       //
    var userId = Meteor.userId();                                                                                      // 181
    if (!userId || !globalDb.userHasIdentity(userId, identityId)) {                                                    // 182
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 183
    }                                                                                                                  // 184
                                                                                                                       //
    var parsedWebkey = Url.parse(webkeyUrl.trim());                                                                    // 186
    var hostId = matchWildcardHost(parsedWebkey.host);                                                                 // 187
    if (!hostId || !globalDb.isApiHostId(hostId)) {                                                                    // 188
      throw new Meteor.Error(500, "Hostname does not match this server. External webkeys are not " + "supported (yet)");
    }                                                                                                                  // 191
                                                                                                                       //
    var token = parsedWebkey.hash;                                                                                     // 193
    if (!token) {                                                                                                      // 194
      throw new Meteor.Error(400, "Invalid webkey. You must pass in the full webkey, " + "including domain name and hash fragment");
    }                                                                                                                  // 197
                                                                                                                       //
    token = token.slice(1);                                                                                            // 199
    if (globalDb.isTokenSpecificHostId(hostId) && hostId !== globalDb.apiHostIdForToken(token)) {                      // 200
      // Note: This case is not security-sensitive. The client could easily compute the correct                        //
      //   host ID for this token. But since they've passed one that doesn't match, we assume                          //
      //   something is wrong and stop here.                                                                           //
      throw new Meteor.Error(400, "Invalid webkey: token doesn't match hostname.");                                    // 204
    }                                                                                                                  // 205
                                                                                                                       //
    var cap = restoreInternal(new Buffer(token), Match.Optional({ webkey: Match.Optional(Match.Any) }), []).cap;       // 207
    var castedCap = cap.castAs(SystemPersistent);                                                                      // 209
    var owner = {                                                                                                      // 210
      clientPowerboxRequest: {                                                                                         // 211
        grainId: grainId,                                                                                              // 212
        introducerIdentity: identityId,                                                                                // 213
        sessionId: sessionId                                                                                           // 214
      }                                                                                                                // 211
    };                                                                                                                 // 210
    if (saveLabel) {                                                                                                   // 217
      grainOwner.saveLabel = {                                                                                         // 218
        defaultText: saveLabel                                                                                         // 219
      };                                                                                                               // 218
    }                                                                                                                  // 221
                                                                                                                       //
    var save = castedCap.save(owner);                                                                                  // 223
    var sturdyRef = waitPromise(save).sturdyRef;                                                                       // 224
    return sturdyRef.toString();                                                                                       // 225
  },                                                                                                                   // 226
  finishPowerboxOffer: function finishPowerboxOffer(sessionId) {                                                       // 228
    check(sessionId, String);                                                                                          // 229
                                                                                                                       //
    Sessions.update({ _id: sessionId }, { $unset: { powerboxView: null } });                                           // 231
  },                                                                                                                   // 232
  getViewInfoForApiToken: function getViewInfoForApiToken(apiTokenId) {                                                // 234
    check(apiTokenId, String);                                                                                         // 235
    var token = globalDb.collections.apiTokens.findOne(apiTokenId);                                                    // 236
    if (!token) {                                                                                                      // 237
      throw new Meteor.Error(400, "No such token.");                                                                   // 238
    }                                                                                                                  // 239
                                                                                                                       //
    var grain = globalDb.collections.grains.findOne(token.grainId);                                                    // 241
    if (!grain) {                                                                                                      // 242
      throw new Meteor.Error(500, "No grain found for token.");                                                        // 243
    }                                                                                                                  // 244
                                                                                                                       //
    return grain.cachedViewInfo;                                                                                       // 246
  }                                                                                                                    // 247
});                                                                                                                    // 173
                                                                                                                       //
HackSessionContextImpl = function (_SessionContextImpl) {                                                              // 250
  _inherits(HackSessionContextImpl, _SessionContextImpl);                                                              // 250
                                                                                                                       //
  function HackSessionContextImpl(grainId, sessionId, identityId, tabId) {                                             // 251
    _classCallCheck(this, HackSessionContextImpl);                                                                     // 251
                                                                                                                       //
    return _possibleConstructorReturn(this, _SessionContextImpl.call(this, grainId, sessionId, identityId, tabId));    // 251
  }                                                                                                                    // 253
                                                                                                                       //
  HackSessionContextImpl.prototype._getPublicId = function _getPublicId() {                                            // 250
    // Get the grain's public ID, assigning a new one if it doesn't yet have one.                                      //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    while (!this.publicId) {                                                                                           // 260
      // We haven't looked up the public ID yet.                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { publicId: 1 } });                                           // 262
      if (!grain) throw new Error("Grain does not exist.");                                                            // 263
                                                                                                                       //
      if (grain.publicId) {                                                                                            // 265
        this.publicId = grain.publicId;                                                                                // 266
      } else {                                                                                                         // 267
        // The grain doesn't have a public ID yet. Generate one.                                                       //
        var candidate = generateRandomHostname(20);                                                                    // 269
                                                                                                                       //
        if (Grains.findOne({ publicId: candidate })) {                                                                 // 271
          // This should never ever happen.                                                                            //
          console.error("CRITICAL PROBLEM: Public ID collision. " + "CSPRNG is bad or has insufficient entropy.");     // 273
          continue;                                                                                                    // 275
        }                                                                                                              // 276
                                                                                                                       //
        // Carefully perform an update that becomes a no-op if anyone else has assigned a public ID                    //
        // simultaneously.                                                                                             //
        if (Grains.update({ _id: this.grainId, publicId: { $exists: false } }, { $set: { publicId: candidate } }) > 0) {
          // We won the race.                                                                                          //
          this.publicId = candidate;                                                                                   // 283
        }                                                                                                              // 284
      }                                                                                                                // 285
    }                                                                                                                  // 286
                                                                                                                       //
    return this.publicId;                                                                                              // 288
  };                                                                                                                   // 289
                                                                                                                       //
  HackSessionContextImpl.prototype._getAddress = function _getAddress() {                                              // 250
    // Get the grain's outgoing e-mail address.                                                                        //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    return this._getPublicId() + "@" + HOSTNAME;                                                                       // 296
  };                                                                                                                   // 297
                                                                                                                       //
  HackSessionContextImpl.prototype._getUserAddress = function _getUserAddress() {                                      // 250
    // Get the user's e-mail address.                                                                                  //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    var grain = Grains.findOne(this.grainId, { fields: { identityId: 1 } });                                           // 304
                                                                                                                       //
    var identity = globalDb.getIdentity(grain.identityId);                                                             // 306
                                                                                                                       //
    var primaryEmail = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                        // 308
    var email = primaryEmail && primaryEmail.email || identity.unverifiedEmail;                                        // 309
                                                                                                                       //
    var result = {};                                                                                                   // 311
    if (email) {                                                                                                       // 312
      result.address = email;                                                                                          // 313
    }                                                                                                                  // 314
                                                                                                                       //
    if (identity.profile.name) {                                                                                       // 316
      result.name = identity.profile.name;                                                                             // 317
    }                                                                                                                  // 318
                                                                                                                       //
    return result;                                                                                                     // 320
  };                                                                                                                   // 321
                                                                                                                       //
  HackSessionContextImpl.prototype.send = function send(email) {                                                       // 250
    return hackSendEmail(this, email);                                                                                 // 324
  };                                                                                                                   // 325
                                                                                                                       //
  HackSessionContextImpl.prototype.getPublicId = function getPublicId() {                                              // 250
    return inMeteor(function () {                                                                                      // 328
      var result = {};                                                                                                 // 329
                                                                                                                       //
      result.publicId = this._getPublicId();                                                                           // 331
      result.hostname = HOSTNAME;                                                                                      // 332
      result.autoUrl = ROOT_URL.protocol + "//" + makeWildcardHost(result.publicId);                                   // 333
                                                                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { userId: 1 } });                                             // 335
      result.isDemoUser = Meteor.users.findOne(grain.userId).expires ? true : false;                                   // 336
                                                                                                                       //
      return result;                                                                                                   // 338
    }.bind(this));                                                                                                     // 339
  };                                                                                                                   // 340
                                                                                                                       //
  HackSessionContextImpl.prototype.httpGet = function httpGet(url) {                                                   // 250
    var _this = this;                                                                                                  // 343
    var session = _this;                                                                                               // 344
                                                                                                                       //
    return new Promise(function (resolve, reject) {                                                                    // 346
      var requestMethod = Http.request;                                                                                // 347
      if (url.indexOf("https://") === 0) {                                                                             // 348
        requestMethod = Https.request;                                                                                 // 349
      } else if (url.indexOf("http://") !== 0) {                                                                       // 350
        err = new Error("Protocol not recognized.");                                                                   // 351
        err.nature = "precondition";                                                                                   // 352
        reject(err);                                                                                                   // 353
      }                                                                                                                // 354
                                                                                                                       //
      req = requestMethod(url, function (resp) {                                                                       // 356
        var buffers = [];                                                                                              // 357
        var err = void 0;                                                                                              // 358
                                                                                                                       //
        switch (Math.floor(resp.statusCode / 100)) {                                                                   // 360
          case 2:                                                                                                      // 361
            // 2xx response -- OK.                                                                                     //
            resp.on("data", function (buf) {                                                                           // 362
              buffers.push(buf);                                                                                       // 363
            });                                                                                                        // 364
                                                                                                                       //
            resp.on("end", function () {                                                                               // 366
              resolve({                                                                                                // 367
                content: Buffer.concat(buffers),                                                                       // 368
                mimeType: resp.headers["content-type"] || null                                                         // 369
              });                                                                                                      // 367
            });                                                                                                        // 371
            break;                                                                                                     // 372
          case 3:                                                                                                      // 373
            // 3xx response -- redirect.                                                                               //
            resolve(session.httpGet(resp.headers.location));                                                           // 374
            break;                                                                                                     // 375
          case 4:                                                                                                      // 376
            // 4xx response -- client error.                                                                           //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 377
            err.nature = "precondition";                                                                               // 378
            reject(err);                                                                                               // 379
            break;                                                                                                     // 380
          case 5:                                                                                                      // 381
            // 5xx response -- internal server error.                                                                  //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 382
            err.nature = "localBug";                                                                                   // 383
            reject(err);                                                                                               // 384
            break;                                                                                                     // 385
          default:                                                                                                     // 386
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 387
            err.nature = "localBug";                                                                                   // 388
            reject(err);                                                                                               // 389
            break;                                                                                                     // 390
        }                                                                                                              // 360
      });                                                                                                              // 392
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 394
        e.nature = "networkFailure";                                                                                   // 395
        reject(e);                                                                                                     // 396
      });                                                                                                              // 397
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 399
        req.abort();                                                                                                   // 400
        err = new Error("Request timed out.");                                                                         // 401
        err.nature = "localBug";                                                                                       // 402
        err.durability = "overloaded";                                                                                 // 403
        reject(err);                                                                                                   // 404
      });                                                                                                              // 405
                                                                                                                       //
      req.end();                                                                                                       // 407
    });                                                                                                                // 408
  };                                                                                                                   // 409
                                                                                                                       //
  HackSessionContextImpl.prototype.getUserAddress = function getUserAddress() {                                        // 250
    return inMeteor(function () {                                                                                      // 412
      return this._getUserAddress();                                                                                   // 413
    }.bind(this));                                                                                                     // 414
  };                                                                                                                   // 415
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteGenerateApiToken = function obsoleteGenerateApiToken(petname, userInfo, expires) {
    throw new Error("generateApiToken() has been removed. Use offer templates instead.");                              // 418
  };                                                                                                                   // 419
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteListApiTokens = function obsoleteListApiTokens() {                          // 250
    throw new Error("listApiTokens() has been removed. Use offer templates instead.");                                 // 422
  };                                                                                                                   // 423
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteRevokeApiToken = function obsoleteRevokeApiToken(tokenId) {                 // 250
    throw new Error("revokeApiToken() has been removed. Use offer templates instead.");                                // 426
  };                                                                                                                   // 427
                                                                                                                       //
  HackSessionContextImpl.prototype.getUiViewForEndpoint = function getUiViewForEndpoint(url) {                         // 250
    var parsedUrl = Url.parse(url);                                                                                    // 430
                                                                                                                       //
    if (parsedUrl.hash) {                                                                                              // 432
      // Assume that anything with a fragment is a webkey                                                              //
      if (parsedUrl.pathname) {                                                                                        // 433
        throw new Error("Webkey urls cannot contain a path.");                                                         // 434
      }                                                                                                                // 435
                                                                                                                       //
      var token = parsedUrl.hash.slice(1); // Get rid of # which is always the first character                         // 437
      var hostId = matchWildcardHost(parsedUrl.host);                                                                  // 438
      if (hostId && globalDb.isApiHostId(hostId)) {                                                                    // 439
        // Connecting to a local capability.                                                                           //
        return getWrappedUiViewForToken(token);                                                                        // 441
      } else {                                                                                                         // 442
        // Connecting to a remote server with a bearer token.                                                          //
        // TODO(someday): Negotiate server-to-server Cap'n Proto connection.                                           //
        return { view: new ExternalUiView(url, this.grainId, token) };                                                 // 445
      }                                                                                                                // 446
    } else {                                                                                                           // 447
      return { view: new ExternalUiView(url, this.grainId) };                                                          // 448
    }                                                                                                                  // 449
  };                                                                                                                   // 450
                                                                                                                       //
  return HackSessionContextImpl;                                                                                       // 250
}(SessionContextImpl);                                                                                                 // 250
                                                                                                                       //
makeHackSessionContext = function makeHackSessionContext(grainId, sessionId, identityId, tabId) {                      // 453
  return new Capnp.Capability(new HackSessionContextImpl(grainId, sessionId, identityId, tabId), HackSessionContext);  // 454
};                                                                                                                     // 456
                                                                                                                       //
var HOSTNAME_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";                                                           // 458
                                                                                                                       //
generateRandomHostname = function generateRandomHostname(length) {                                                     // 460
  // Generate a random unique name suitable for use in a hostname.                                                     //
                                                                                                                       //
  var digits = [];                                                                                                     // 463
  for (var i = 0; i < length; i++) {                                                                                   // 464
    digits[i] = Random.choice(HOSTNAME_CHARS);                                                                         // 465
  }                                                                                                                    // 466
                                                                                                                       //
  return digits.join("");                                                                                              // 468
};                                                                                                                     // 469
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"identity.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/identity.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var IdentityRpc = Capnp.importSystem("sandstorm/identity-impl.capnp");                                                 // 18
                                                                                                                       // 19
                                                                                                                       //
var IdentityImpl = function (_PersistentImpl) {                                                                        //
  _inherits(IdentityImpl, _PersistentImpl);                                                                            //
                                                                                                                       //
  function IdentityImpl(db, saveTemplate, identityId) {                                                                // 22
    _classCallCheck(this, IdentityImpl);                                                                               // 22
                                                                                                                       //
    var _this = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                        // 22
                                                                                                                       //
    _this.identityId = identityId;                                                                                     // 24
    return _this;                                                                                                      // 22
  }                                                                                                                    // 25
                                                                                                                       //
  return IdentityImpl;                                                                                                 //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 26
                                                                                                                       //
makeIdentity = function makeIdentity(identityId, requriements) {                                                       // 28
  var saveTemplate = { frontendRef: { identity: identityId } };                                                        // 29
  return new Capnp.Capability(new IdentityImpl(globalDb, saveTemplate, identityId), IdentityRpc.PersistentIdentity);   // 30
};                                                                                                                     // 32
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 34
  frontendRefField: "identity",                                                                                        // 35
                                                                                                                       //
  restore: function restore(db, saveTemplate, identityId) {                                                            // 37
    return new Capnp.Capability(new IdentityImpl(db, saveTemplate, identityId), IdentityRpc.PersistentIdentity);       // 38
  }                                                                                                                    // 40
});                                                                                                                    // 34
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"install-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/install-server.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var localizedTextPattern = {                                                                                           // 19
  defaultText: String,                                                                                                 // 20
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 21
};                                                                                                                     // 19
                                                                                                                       //
var uploadTokens = {};                                                                                                 // 24
                                                                                                                       //
// Not all users are allowed to upload apps. We need to manually implement authorization                               //
// because Meteor.userId() is not available in server-side routes.                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 29
  cancelDownload: function (_cancelDownload) {                                                                         // 30
    function cancelDownload(_x) {                                                                                      // 30
      return _cancelDownload.apply(this, arguments);                                                                   // 30
    }                                                                                                                  // 30
                                                                                                                       //
    cancelDownload.toString = function () {                                                                            // 30
      return _cancelDownload.toString();                                                                               // 30
    };                                                                                                                 // 30
                                                                                                                       //
    return cancelDownload;                                                                                             // 30
  }(function (packageId) {                                                                                             // 30
    check(packageId, String);                                                                                          // 31
                                                                                                                       //
    // TODO(security):  Only let user cancel download if they initiated it.                                            //
    cancelDownload(packageId);                                                                                         // 34
  }),                                                                                                                  // 35
                                                                                                                       //
  newUploadToken: function newUploadToken() {                                                                          // 37
    if (!isSignedUp()) {                                                                                               // 38
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can upload apps.");                              // 39
    }                                                                                                                  // 40
                                                                                                                       //
    if (globalDb.isUninvitedFreeUser()) {                                                                              // 42
      throw new Meteor.Error(403, "Unauthorized", "Only paid users can upload apps.");                                 // 43
    }                                                                                                                  // 44
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 46
    uploadTokens[token] = setTimeout(function () {                                                                     // 47
      delete uploadTokens[token];                                                                                      // 48
    }, 20 * 60 * 1000);                                                                                                // 49
                                                                                                                       //
    return token;                                                                                                      // 51
  },                                                                                                                   // 52
                                                                                                                       //
  upgradeGrains: function upgradeGrains(appId, version, packageId) {                                                   // 54
    this.connection.sandstormDb.upgradeGrains(appId, version, packageId, globalBackend);                               // 55
  },                                                                                                                   // 56
                                                                                                                       //
  ensureInstalled: function ensureInstalled(packageId, url, isRetry) {                                                 // 58
    check(packageId, String);                                                                                          // 59
    check(url, Match.OneOf(String, undefined, null));                                                                  // 60
    check(isRetry, Boolean);                                                                                           // 61
                                                                                                                       //
    if (!packageId.match(/^[a-zA-Z0-9]*$/)) {                                                                          // 63
      throw new Meteor.Error(400, "The package ID contains illegal characters.");                                      // 64
    }                                                                                                                  // 65
                                                                                                                       //
    if (!this.userId) {                                                                                                // 67
      if (allowDemo && isSafeDemoAppUrl(url)) {                                                                        // 68
        // continue on                                                                                                 //
      } else {                                                                                                         // 70
          // jscs:ignore disallowEmptyBlocks                                                                           //
          throw new Meteor.Error(403, "You must be logged in to install packages.");                                   // 71
        }                                                                                                              // 72
    } else if (!isSignedUp() && !isDemoUser()) {                                                                       // 73
      throw new Meteor.Error(403, "This Sandstorm server requires you to get an invite before installing apps.");      // 74
    } else if (isUserOverQuota(Meteor.user())) {                                                                       // 76
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 77
    }                                                                                                                  // 79
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 81
                                                                                                                       //
    if (!pkg || pkg.status !== "ready") {                                                                              // 83
      if (!this.userId || isDemoUser() || globalDb.isUninvitedFreeUser()) {                                            // 84
        if (!isSafeDemoAppUrl(url)) {                                                                                  // 85
          // TODO(someday): Billing prompt on client side.                                                             //
          throw new Meteor.Error(403, "Sorry, demo and free users cannot upload custom apps; " + "they may only install apps from apps.sandstorm.io.");
        }                                                                                                              // 89
      }                                                                                                                // 90
    }                                                                                                                  // 91
                                                                                                                       //
    if (!pkg || isRetry) {                                                                                             // 93
      globalDb.startInstall(packageId, url, isRetry);                                                                  // 94
    }                                                                                                                  // 95
  }                                                                                                                    // 96
});                                                                                                                    // 29
                                                                                                                       //
Router.map(function () {                                                                                               // 99
  this.route("upload", {                                                                                               // 100
    where: "server",                                                                                                   // 101
    path: "/upload/:token",                                                                                            // 102
                                                                                                                       //
    action: function action() {                                                                                        // 104
      if (!this.params.token || !uploadTokens[this.params.token]) {                                                    // 105
        this.response.writeHead(403, {                                                                                 // 106
          "Content-Type": "text/plain"                                                                                 // 107
        });                                                                                                            // 106
        this.response.write("Invalid upload token.");                                                                  // 109
        this.response.end();                                                                                           // 110
      } else if (this.request.method === "POST") {                                                                     // 111
        try {                                                                                                          // 112
          var packageId = promiseToFuture(doClientUpload(this.request)).wait();                                        // 113
          this.response.writeHead(200, {                                                                               // 114
            "Content-Length": packageId.length,                                                                        // 115
            "Content-Type": "text/plain"                                                                               // 116
          });                                                                                                          // 114
          this.response.write(packageId);                                                                              // 118
          this.response.end();                                                                                         // 119
          clearTimeout(uploadTokens[this.params.token]);                                                               // 120
          delete uploadTokens[this.params.token];                                                                      // 121
        } catch (error) {                                                                                              // 122
          console.error(error.stack);                                                                                  // 123
          this.response.writeHead(500, {                                                                               // 124
            "Content-Type": "text/plain"                                                                               // 125
          });                                                                                                          // 124
          this.response.write("Unpacking SPK failed; is it valid?");                                                   // 127
          this.response.end();                                                                                         // 128
        };                                                                                                             // 129
      } else {                                                                                                         // 130
        this.response.writeHead(405, {                                                                                 // 131
          "Content-Type": "text/plain"                                                                                 // 132
        });                                                                                                            // 131
        this.response.write("You can only POST here.");                                                                // 134
        this.response.end();                                                                                           // 135
      }                                                                                                                // 136
    }                                                                                                                  // 137
  });                                                                                                                  // 100
});                                                                                                                    // 139
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"installer.js":["babel-runtime/helpers/classCallCheck","fs","path","crypto","child_process","http","https","url","request",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/installer.js                                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Path;module.import("path",{"default":function(v){Path=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var ChildProcess;module.import("child_process",{"default":function(v){ChildProcess=v}});var Http;module.import("http",{"default":function(v){Http=v}});var Https;module.import("https",{"default":function(v){Https=v}});var Url;module.import("url",{"default":function(v){Url=v}});var Request;module.import("request",{"default":function(v){Request=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
var Promise = Npm.require("es6-promise").Promise;                                                                      // 24
                                                                                                                       // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
                                                                                                                       //
var Manifest = Capnp.importSystem("sandstorm/package.capnp").Manifest;                                                 // 28
                                                                                                                       //
var installers = void 0; // set to {} on main replica                                                                  // 30
// To protect against race conditions, we require that each row in the Packages                                        //
// collection have at most one writer at a time, as tracked by this `installers`                                       //
// map. Each key is a package ID and each value is either an AppInstaller object                                       //
// or the string 'uninstalling', indicating that some fiber is working on                                              //
// uninstalling the package.                                                                                           //
                                                                                                                       //
var verifyIsMainReplica = function verifyIsMainReplica() {                                                             // 37
  if (Meteor.settings.replicaNumber) {                                                                                 // 38
    throw new Error("This can only be called on the main front-end replica.");                                         // 39
  }                                                                                                                    // 40
};                                                                                                                     // 41
                                                                                                                       //
var deletePackageInternal = function deletePackageInternal(pkg) {                                                      // 43
  verifyIsMainReplica();                                                                                               // 44
                                                                                                                       //
  var packageId = pkg._id;                                                                                             // 46
                                                                                                                       //
  if (packageId in installers) {                                                                                       // 48
    return;                                                                                                            // 49
  }                                                                                                                    // 50
                                                                                                                       //
  installers[packageId] = "uninstalling";                                                                              // 52
                                                                                                                       //
  try {                                                                                                                // 54
    var action = UserActions.findOne({ packageId: packageId });                                                        // 55
    var grain = Grains.findOne({ packageId: packageId });                                                              // 56
    var notificationQuery = {};                                                                                        // 57
    notificationQuery["appUpdates." + pkg.appId] = { $exists: true };                                                  // 58
    if (!grain && !action && !(pkg.isAutoUpdated && Notifications.findOne(notificationQuery))) {                       // 59
      Packages.update({                                                                                                // 60
        _id: packageId                                                                                                 // 61
      }, {                                                                                                             // 60
        $set: { status: "delete" },                                                                                    // 63
        $unset: { shouldCleanup: "" }                                                                                  // 64
      });                                                                                                              // 62
      waitPromise(globalBackend.cap().deletePackage(packageId));                                                       // 66
      Packages.remove(packageId);                                                                                      // 67
                                                                                                                       //
      // Clean up assets (icon, etc).                                                                                  //
      getAllManifestAssets(pkg.manifest).forEach(function (assetId) {                                                  // 70
        globalDb.unrefStaticAsset(assetId);                                                                            // 71
      });                                                                                                              // 72
    } else {                                                                                                           // 73
      Packages.update({ _id: packageId }, { $unset: { shouldCleanup: "" } });                                          // 74
    }                                                                                                                  // 75
                                                                                                                       //
    delete installers[packageId];                                                                                      // 77
  } catch (error) {                                                                                                    // 78
    delete installers[packageId];                                                                                      // 79
    throw error;                                                                                                       // 80
  }                                                                                                                    // 81
};                                                                                                                     // 82
                                                                                                                       //
var startInstallInternal = function startInstallInternal(pkg) {                                                        // 84
  verifyIsMainReplica();                                                                                               // 85
                                                                                                                       //
  if (pkg._id in installers) {                                                                                         // 87
    return;                                                                                                            // 88
  }                                                                                                                    // 89
                                                                                                                       //
  var installer = new AppInstaller(pkg._id, pkg.url, pkg.appId, pkg.isAutoUpdated);                                    // 91
  installers[pkg._id] = installer;                                                                                     // 92
  installer.start();                                                                                                   // 93
};                                                                                                                     // 94
                                                                                                                       //
cancelDownload = function cancelDownload(packageId) {                                                                  // 96
  Packages.remove({ _id: packageId, status: "download" });                                                             // 97
};                                                                                                                     // 98
                                                                                                                       //
var cancelDownloadInternal = function cancelDownloadInternal(pkg) {                                                    // 100
  verifyIsMainReplica();                                                                                               // 101
                                                                                                                       //
  var installer = installers[pkg._id];                                                                                 // 103
                                                                                                                       //
  // Don't do anything unless a download is in progress.                                                               //
  if (installer && installer.downloadRequest) {                                                                        // 106
    // OK, effect cancellation by faking an error.                                                                     //
    installer.wrapCallback(function () {                                                                               // 108
      throw new Error("Canceled");                                                                                     // 109
    })();                                                                                                              // 110
  }                                                                                                                    // 111
};                                                                                                                     // 112
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 114
  installers = {};                                                                                                     // 115
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 117
    // Restart any deletions that were killed while in-progress.                                                       //
    Packages.find({ status: "delete" }).forEach(deletePackageInternal);                                                // 119
                                                                                                                       //
    // Watch for new installation requests and fulfill them.                                                           //
    Packages.find({ status: { $in: ["download", "verify", "unpack", "analyze"] } }).observe({                          // 122
      added: startInstallInternal,                                                                                     // 123
      removed: cancelDownloadInternal                                                                                  // 124
    });                                                                                                                // 122
                                                                                                                       //
    // Watch for new cleanup requests and fulfill them.                                                                //
    Packages.find({ status: "ready", shouldCleanup: true }).observe({                                                  // 128
      added: deletePackageInternal                                                                                     // 129
    });                                                                                                                // 128
  });                                                                                                                  // 131
}                                                                                                                      // 132
                                                                                                                       //
doClientUpload = function doClientUpload(stream) {                                                                     // 134
  return new Promise(function (resolve, reject) {                                                                      // 135
    var id = Random.id();                                                                                              // 136
                                                                                                                       //
    var backendStream = globalBackend.cap().installPackage().stream;                                                   // 138
    var hasher = Crypto.createHash("sha256");                                                                          // 139
                                                                                                                       //
    stream.on("data", function (chunk) {                                                                               // 141
      try {                                                                                                            // 142
        hasher.update(chunk);                                                                                          // 143
        backendStream.write(chunk);                                                                                    // 144
      } catch (err) {                                                                                                  // 145
        reject(err);                                                                                                   // 146
      }                                                                                                                // 147
    });                                                                                                                // 148
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 150
      try {                                                                                                            // 151
        (function () {                                                                                                 // 151
          backendStream.done();                                                                                        // 152
          var packageId = hasher.digest("hex").slice(0, 32);                                                           // 153
          resolve(backendStream.saveAs(packageId).then(function () {                                                   // 154
            return packageId;                                                                                          // 155
          }));                                                                                                         // 156
          backendStream.close();                                                                                       // 157
        })();                                                                                                          // 151
      } catch (err) {                                                                                                  // 158
        reject(err);                                                                                                   // 159
      }                                                                                                                // 160
    });                                                                                                                // 161
                                                                                                                       //
    stream.on("error", function (err) {                                                                                // 163
      // TODO(soon):  This event does't seem to fire if the user leaves the page mid-upload.                           //
      try {                                                                                                            // 165
        backendStream.close();                                                                                         // 166
        reject(err);                                                                                                   // 167
      } catch (err2) {                                                                                                 // 168
        reject(err2);                                                                                                  // 169
      }                                                                                                                // 170
    });                                                                                                                // 171
  });                                                                                                                  // 172
};                                                                                                                     // 173
                                                                                                                       //
AppInstaller = function () {                                                                                           // 175
  function AppInstaller(packageId, url, appId, isAutoUpdated) {                                                        // 176
    _classCallCheck(this, AppInstaller);                                                                               // 176
                                                                                                                       //
    verifyIsMainReplica();                                                                                             // 177
                                                                                                                       //
    this.packageId = packageId;                                                                                        // 179
    this.url = url;                                                                                                    // 180
    this.failed = false;                                                                                               // 181
    this.appId = appId;                                                                                                // 182
    this.isAutoUpdated = isAutoUpdated;                                                                                // 183
                                                                                                                       //
    // Serializes database writes.                                                                                     //
    this.writeChain = Promise.resolve();                                                                               // 186
  }                                                                                                                    // 187
                                                                                                                       //
  AppInstaller.prototype.updateProgress = function updateProgress(status, progress, error, manifest) {                 // 175
    // TODO(security):  On error, we should actually delete the package from the database and only                     //
    //   display the error to whomever was watching at the time.  Otherwise it's easy to confuse                       //
    //   people by 'pre-failing' packages.  (Actually, perhaps if a user tries to download an                          //
    //   already-downloading package but specifies a different URL, we really should initiate an                       //
    //   entirely separate download...  but cancel it if the first download succeeds.)                                 //
                                                                                                                       //
    this.status = status;                                                                                              // 196
    this.progress = progress || -1;                                                                                    // 197
    this.error = error;                                                                                                // 198
    this.manifest = manifest || null;                                                                                  // 199
                                                                                                                       //
    var _this = this;                                                                                                  // 201
                                                                                                                       //
    // The callback passed to inMeteor() runs in a new fiber. We need to make sure database writes                     //
    // occur in exactly the order in which we generate them, so we use a promise chain to serialize                    //
    // them.                                                                                                           //
    this.writeChain = this.writeChain.then(function () {                                                               // 206
      return inMeteor(function () {                                                                                    // 207
        if (manifest) extractManifestAssets(manifest);                                                                 // 208
                                                                                                                       //
        Packages.update(_this.packageId, {                                                                             // 210
          $set: {                                                                                                      // 211
            status: _this.status,                                                                                      // 212
            progress: _this.progress,                                                                                  // 213
            error: _this.error ? _this.error.message : null,                                                           // 214
            manifest: _this.manifest,                                                                                  // 215
            appId: _this.appId,                                                                                        // 216
            authorPgpKeyFingerprint: _this.authorPgpKeyFingerprint                                                     // 217
          }                                                                                                            // 211
        });                                                                                                            // 210
                                                                                                                       //
        if (_this.authorPgpKeyFingerprint) {                                                                           // 221
          globalDb.updateKeybaseProfileAsync(_this.authorPgpKeyFingerprint);                                           // 222
        }                                                                                                              // 223
      })["catch"](function (err) {                                                                                     // 224
        console.error(err.stack);                                                                                      // 225
      });                                                                                                              // 226
    });                                                                                                                // 227
  };                                                                                                                   // 228
                                                                                                                       //
  AppInstaller.prototype.wrapCallback = function wrapCallback(method) {                                                // 175
    // Note that the function below must not be an arrow function, since arrow functions do not have                   //
    // access to the context's arguments array.                                                                        //
    var _this = this;                                                                                                  // 233
    return function () {                                                                                               // 234
      if (_this.failed) return;                                                                                        // 235
      try {                                                                                                            // 236
        return method.apply(_this, _.toArray(arguments));                                                              // 237
      } catch (err) {                                                                                                  // 238
        _this.failed = true;                                                                                           // 239
        _this.cleanup();                                                                                               // 240
        _this.updateProgress("failed", 0, err);                                                                        // 241
        _this.writeChain = _this.writeChain.then(function () {                                                         // 242
          delete installers[_this.packageId];                                                                          // 243
        });                                                                                                            // 244
        console.error("Failed to install app:", err.stack);                                                            // 245
      }                                                                                                                // 246
    };                                                                                                                 // 247
  };                                                                                                                   // 248
                                                                                                                       //
  AppInstaller.prototype.cleanup = function cleanup() {                                                                // 175
    if (this.uploadStream) {                                                                                           // 251
      try {                                                                                                            // 252
        this.uploadStream.close();                                                                                     // 253
      } catch (err) {}                                                                                                 // 254
                                                                                                                       //
      delete this.uploadStream;                                                                                        // 256
    }                                                                                                                  // 257
                                                                                                                       //
    if (this.downloadRequest) {                                                                                        // 259
      try {                                                                                                            // 260
        this.downloadRequest.abort();                                                                                  // 261
      } catch (err) {}                                                                                                 // 262
                                                                                                                       //
      delete this.downloadRequest;                                                                                     // 264
    }                                                                                                                  // 265
  };                                                                                                                   // 266
                                                                                                                       //
  AppInstaller.prototype.start = function start() {                                                                    // 175
    var _this2 = this;                                                                                                 // 268
                                                                                                                       //
    return this.wrapCallback(function () {                                                                             // 269
      _this2.cleanup();                                                                                                // 270
                                                                                                                       //
      globalBackend.cap().tryGetPackage(_this2.packageId).then(_this2.wrapCallback(function (info) {                   // 272
        if (info.appId) {                                                                                              // 273
          _this2.appId = info.appId;                                                                                   // 274
          _this2.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                               // 275
          _this2.done(info.manifest);                                                                                  // 276
        } else {                                                                                                       // 277
          _this2.doDownload();                                                                                         // 278
        }                                                                                                              // 279
      }), _this2.wrapCallback(function (err) {                                                                         // 280
        throw err;                                                                                                     // 281
      }));                                                                                                             // 282
    })();                                                                                                              // 283
  };                                                                                                                   // 284
                                                                                                                       //
  AppInstaller.prototype.doDownload = function doDownload() {                                                          // 175
    if (!this.url) {                                                                                                   // 287
      throw new Error("Unknown package ID, and no URL was provided.");                                                 // 288
    }                                                                                                                  // 289
                                                                                                                       //
    console.log("Downloading app:", this.url);                                                                         // 291
    this.updateProgress("download");                                                                                   // 292
                                                                                                                       //
    this.uploadStream = globalBackend.cap().installPackage().stream;                                                   // 294
    return this.doDownloadTo(this.uploadStream);                                                                       // 295
  };                                                                                                                   // 296
                                                                                                                       //
  AppInstaller.prototype.doDownloadTo = function doDownloadTo(out) {                                                   // 175
    var _this3 = this;                                                                                                 // 298
                                                                                                                       //
    var url = Url.parse(this.url);                                                                                     // 299
    var options = {                                                                                                    // 300
      hostname: url.hostname,                                                                                          // 301
      port: url.port,                                                                                                  // 302
      path: url.path                                                                                                   // 303
    };                                                                                                                 // 300
                                                                                                                       //
    var protocol = void 0;                                                                                             // 306
    if (url.protocol === "http:" || url.protocol === "https:") {                                                       // 307
      protocol = Request.defaults({                                                                                    // 308
        maxRedirects: 20,                                                                                              // 309
        // Since we will verify the download against a hash anyway, we don't need to verify the                        //
        // server's certificate. In fact, the only reason we support HTTPS at all here is because                      //
        // some servers refuse to serve over HTTP (which is, in general, a good thing). Skipping the                   //
        // certificate check here is helpful in that it means we don't have to worry about having a                    //
        // reasonable list of trusted CAs available to Sandstorm.                                                      //
        strictSSL: false                                                                                               // 315
      });                                                                                                              // 308
    } else {                                                                                                           // 317
      throw new Error("Protocol not supported: " + url.protocol);                                                      // 318
    }                                                                                                                  // 319
                                                                                                                       //
    // TODO(security):  It could arguably be a security problem that it's possible to probe the                        //
    //   server's local network (behind any firewalls) by presenting URLs here.                                        //
    var bytesExpected = undefined;                                                                                     // 323
    var bytesReceived = 0;                                                                                             // 324
    var hasher = Crypto.createHash("sha256");                                                                          // 325
    var done = false;                                                                                                  // 326
    var updateDownloadProgress = _.throttle(this.wrapCallback(function () {                                            // 327
      if (!done) {                                                                                                     // 328
        if (bytesExpected) {                                                                                           // 329
          _this3.updateProgress("download", bytesReceived / bytesExpected);                                            // 330
        } else {                                                                                                       // 331
          _this3.updateProgress("download", bytesReceived);                                                            // 332
        }                                                                                                              // 333
      }                                                                                                                // 334
    }), 500);                                                                                                          // 335
                                                                                                                       //
    var request = protocol.get(this.url);                                                                              // 337
                                                                                                                       //
    request.on("response", this.wrapCallback(function (response) {                                                     // 339
      if ("content-length" in response.headers) {                                                                      // 340
        bytesExpected = parseInt(response.headers["content-length"]);                                                  // 341
      }                                                                                                                // 342
    }));                                                                                                               // 343
                                                                                                                       //
    request.on("data", this.wrapCallback(function (chunk) {                                                            // 345
      hasher.update(chunk);                                                                                            // 346
      out.write(chunk);                                                                                                // 347
      bytesReceived += chunk.length;                                                                                   // 348
      updateDownloadProgress();                                                                                        // 349
    }));                                                                                                               // 350
                                                                                                                       //
    request.on("end", this.wrapCallback(function () {                                                                  // 352
      out.done();                                                                                                      // 353
                                                                                                                       //
      if (hasher.digest("hex").slice(0, 32) !== _this3.packageId) {                                                    // 355
        throw new Error("Package hash did not match.");                                                                // 356
      }                                                                                                                // 357
                                                                                                                       //
      done = true;                                                                                                     // 359
      delete _this3.downloadRequest;                                                                                   // 360
                                                                                                                       //
      _this3.updateProgress("unpack");                                                                                 // 362
      out.saveAs(_this3.packageId).then(_this3.wrapCallback(function (info) {                                          // 363
        _this3.appId = info.appId;                                                                                     // 364
        _this3.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                                 // 365
        _this3.done(info.manifest);                                                                                    // 366
      }), _this3.wrapCallback(function (err) {                                                                         // 367
        throw err;                                                                                                     // 368
      }));                                                                                                             // 369
    }));                                                                                                               // 370
                                                                                                                       //
    request.on("error", this.wrapCallback(function (err) {                                                             // 372
      throw err;                                                                                                       // 372
    }));                                                                                                               // 372
                                                                                                                       //
    this.downloadRequest = request;                                                                                    // 374
  };                                                                                                                   // 375
                                                                                                                       //
  AppInstaller.prototype.done = function done(manifest) {                                                              // 175
    console.log("App ready:", this.packageId);                                                                         // 378
    this.updateProgress("ready", 1, undefined, manifest);                                                              // 379
    var _this = this;                                                                                                  // 380
    _this.writeChain = _this.writeChain.then(function () {                                                             // 381
      return inMeteor(function () {                                                                                    // 382
        if (_this.isAutoUpdated) {                                                                                     // 383
          globalDb.sendAppUpdateNotifications(_this.appId, _this.packageId, manifest.appTitle && manifest.appTitle.defaultText, manifest.appVersion, manifest.appMarketingVersion && manifest.appMarketingVersion.defaultText);
        }                                                                                                              // 387
      });                                                                                                              // 388
    }).then(function () {                                                                                              // 389
      delete installers[_this.packageId];                                                                              // 390
    });                                                                                                                // 391
  };                                                                                                                   // 392
                                                                                                                       //
  return AppInstaller;                                                                                                 // 175
}();                                                                                                                   // 175
                                                                                                                       //
extractManifestAssets = function extractManifestAssets(manifest) {                                                     // 395
  var metadata = manifest.metadata;                                                                                    // 396
  if (!metadata) return;                                                                                               // 397
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 399
  if (icons) {                                                                                                         // 400
    var handleIcon = function handleIcon(icon) {                                                                       // 401
      if (icon.svg) {                                                                                                  // 402
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/svg+xml" }, icon.svg);                               // 403
        icon.format = "svg";                                                                                           // 404
        delete icon.svg;                                                                                               // 405
        return true;                                                                                                   // 406
      } else if (icon.png) {                                                                                           // 407
        // Use the 1x version for 'normal' DPI, unless 1x isn't provided, in which case use 2x.                        //
        var normalDpi = icon.png.dpi1x || icon.png.dpi2x;                                                              // 409
        if (!normalDpi) return false;                                                                                  // 410
        icon.format = "png";                                                                                           // 411
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/png" }, normalDpi);                                  // 412
                                                                                                                       //
        if (icon.png.dpi1x && icon.png.dpi2x) {                                                                        // 414
          // Icon specifies both resolutions, so also record a 2x DPI option.                                          //
          icon.assetId2xDpi = globalDb.addStaticAsset({ mimeType: "image/png" }, icon.png.dpi2x);                      // 416
        }                                                                                                              // 417
                                                                                                                       //
        delete icon.png;                                                                                               // 419
        return true;                                                                                                   // 420
      } else {                                                                                                         // 421
        // Unknown icon. Filter it.                                                                                    //
        return false;                                                                                                  // 423
      }                                                                                                                // 424
    };                                                                                                                 // 425
                                                                                                                       //
    if (icons.appGrid && !handleIcon(icons.appGrid)) delete icons.appGrid;                                             // 427
    if (icons.grain && !handleIcon(icons.grain)) delete icons.grain;                                                   // 428
                                                                                                                       //
    // We don't need the market icons.                                                                                 //
    if (icons.market) delete icons.market;                                                                             // 431
    if (icons.marketBig) delete icons.marketBig;                                                                       // 432
  }                                                                                                                    // 433
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 435
    if (text.defaultText) {                                                                                            // 436
      text.defaultTextAssetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, text.defaultText);                 // 437
      delete text.defaultText;                                                                                         // 438
    }                                                                                                                  // 439
                                                                                                                       //
    if (text.localizations) {                                                                                          // 441
      text.localizations.forEach(function (localization) {                                                             // 442
        if (localization.text) {                                                                                       // 443
          localization.assetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, localization.text);               // 444
          delete localization.text;                                                                                    // 446
        }                                                                                                              // 447
      });                                                                                                              // 448
    }                                                                                                                  // 449
  };                                                                                                                   // 450
                                                                                                                       //
  var license = metadata.license;                                                                                      // 452
  if (license) {                                                                                                       // 453
    if (license.proprietary) license.proprietary = handleLocalizedText(license.proprietary);                           // 454
    if (license.publicDomain) license.publicDomain = handleLocalizedText(license.proprietary);                         // 455
    if (license.notices) license.notices = handleLocalizedText(license.notices);                                       // 456
  }                                                                                                                    // 457
                                                                                                                       //
  var author = metadata.author;                                                                                        // 459
  if (author) {                                                                                                        // 460
    // We remove the PGP signature since it was already verified down to a key ID in the back-end.                     //
    if (author.pgpSignature) delete author.pgpSignature;                                                               // 462
  }                                                                                                                    // 463
                                                                                                                       //
  // Don't need the keyring either.                                                                                    //
  if (metadata.pgpKeyring) delete metadata.pgpKeyring;                                                                 // 466
                                                                                                                       //
  // Perhaps used by the 'about' page?                                                                                 //
  if (metadata.description) metadata.description = handleLocalizedText(metadata.description);                          // 469
                                                                                                                       //
  // Screenshots are for app marketing; we don't use them post-install.                                                //
  if (metadata.screenshots) delete metadata.screenshots;                                                               // 472
                                                                                                                       //
  // We might allow the user to view the changelog.                                                                    //
  if (metadata.changeLog) metadata.changeLog = handleLocalizedText(metadata.changeLog);                                // 475
};                                                                                                                     // 476
                                                                                                                       //
getAllManifestAssets = function getAllManifestAssets(manifest) {                                                       // 478
  // Returns a list of all asset IDs in the given manifest.                                                            //
                                                                                                                       //
  var metadata = manifest.metadata;                                                                                    // 481
  if (!metadata) return [];                                                                                            // 482
                                                                                                                       //
  var result = [];                                                                                                     // 484
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 486
  if (icons) {                                                                                                         // 487
    var handleIcon = function handleIcon(icon) {                                                                       // 488
      if (icon.assetId) {                                                                                              // 489
        result.push(icon.assetId);                                                                                     // 490
      }                                                                                                                // 491
    };                                                                                                                 // 492
                                                                                                                       //
    if (icons.appGrid) handleIcon(icons.appGrid);                                                                      // 494
    if (icons.grain) handleIcon(icons.grain);                                                                          // 495
  }                                                                                                                    // 496
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 498
    if (text.defaultTextAssetId) {                                                                                     // 499
      result.push(defaultTextAssetId);                                                                                 // 500
    }                                                                                                                  // 501
                                                                                                                       //
    if (text.localizations) {                                                                                          // 503
      text.localizations.forEach(function (localization) {                                                             // 504
        if (localization.assetId) {                                                                                    // 505
          result.push(localization.assetId);                                                                           // 506
        }                                                                                                              // 507
      });                                                                                                              // 508
    }                                                                                                                  // 509
  };                                                                                                                   // 510
                                                                                                                       //
  var license = metadata.license;                                                                                      // 512
  if (license) {                                                                                                       // 513
    if (license.proprietary) handleLocalizedText(license.proprietary);                                                 // 514
    if (license.publicDomain) handleLocalizedText(license.publicDomain);                                               // 515
    if (license.notices) handleLocalizedText(license.notices);                                                         // 516
  }                                                                                                                    // 517
                                                                                                                       //
  if (metadata.description) handleLocalizedText(metadata.description);                                                 // 519
  if (metadata.changeLog) handleLocalizedText(metadata.changeLog);                                                     // 520
                                                                                                                       //
  return result;                                                                                                       // 522
};                                                                                                                     // 523
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"notifications-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/notifications-server.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var SupervisorCapnp = Capnp.importSystem("sandstorm/supervisor.capnp");                                                // 18
var SystemPersistent = SupervisorCapnp.SystemPersistent;                                                               // 19
                                                                                                                       //
logActivity = function logActivity(grainId, identityId, event) {                                                       // 21
  check(grainId, String);                                                                                              // 22
  check(identityId, String);                                                                                           // 23
  // `event` is always an ActivityEvent parsed from Cap'n Proto buf that's too complicated to check                    //
  // here.                                                                                                             //
                                                                                                                       //
  // TODO(perf): A cached copy of the grain from when the session opened would be fine to use                          //
  //   here, rather than looking it up every time.                                                                     //
  grain = Grains.findOne(grainId);                                                                                     // 29
  if (!grain) {                                                                                                        // 30
    // Shouldn't be possible since activity events come from the grain.                                                //
    throw new Error("no such grain");                                                                                  // 32
  }                                                                                                                    // 33
                                                                                                                       //
  // Look up the event typedef.                                                                                        //
  var eventType = ((grain.cachedViewInfo || {}).eventTypes || [])[event.type];                                         // 36
  if (!eventType) {                                                                                                    // 37
    throw new Error("No such event type in app's ViewInfo: " + event.type);                                            // 38
  }                                                                                                                    // 39
                                                                                                                       //
  if (!eventType.suppressUnread) {                                                                                     // 41
    // Clear the "seenAllActivity" bit for all users except the acting user.                                           //
    // TODO(perf): Consider throttling? Or should that be the app's responsibility?                                    //
    if (identityId != grain.identityId) {                                                                              // 44
      Grains.update(grainId, { $unset: { ownerSeenAllActivity: true } });                                              // 45
    }                                                                                                                  // 46
                                                                                                                       //
    // Also clear on ApiTokens.                                                                                        //
    ApiTokens.update({                                                                                                 // 49
      "grainId": grainId,                                                                                              // 50
      "owner.user.seenAllActivity": true,                                                                              // 51
      "owner.user.identityId": { $ne: identityId }                                                                     // 52
    }, { $unset: { "owner.user.seenAllActivity": true } }, { multi: true });                                           // 49
  }                                                                                                                    // 54
                                                                                                                       //
  // Apply auto-subscriptions.                                                                                         //
  if (eventType.autoSubscribeToGrain) {                                                                                // 57
    globalDb.subscribeToActivity(identityId, grainId);                                                                 // 58
  }                                                                                                                    // 59
                                                                                                                       //
  if (event.thread && eventType.autoSubscribeToThread) {                                                               // 61
    globalDb.subscribeToActivity(identityId, grainId, event.thread.path || "");                                        // 62
  }                                                                                                                    // 63
                                                                                                                       //
  // Figure out whom we need to notify.                                                                                //
  var notifyMap = {};                                                                                                  // 66
  var addRecipient = function addRecipient(recipient) {                                                                // 67
    // Mutes take priority over subscriptions.                                                                         //
    if (recipient.mute) {                                                                                              // 69
      notifyMap[identityId] = false;                                                                                   // 70
    } else {                                                                                                           // 71
      if (!(recipient.identityId in notifyMap)) {                                                                      // 72
        notifyMap[recipient.identityId] = true;                                                                        // 73
      }                                                                                                                // 74
    }                                                                                                                  // 75
  };                                                                                                                   // 76
                                                                                                                       //
  // Don't notify self.                                                                                                //
  addRecipient({ identityId: identityId, mute: true });                                                                // 79
                                                                                                                       //
  // Notify subscribers, if desired.                                                                                   //
  if (eventType.notifySubscribers) {                                                                                   // 82
    // The grain owner is implicitly subscribed.                                                                       //
    addRecipient({ identityId: grain.identityId });                                                                    // 84
                                                                                                                       //
    // Add everyone subscribed to the grain.                                                                           //
    globalDb.getActivitySubscriptions(grainId).forEach(addRecipient);                                                  // 87
                                                                                                                       //
    if (event.thread) {                                                                                                // 89
      // Add everyone subscribed to the thread.                                                                        //
      globalDb.getActivitySubscriptions(grainId, event.thread.path || "").forEach(addRecipient);                       // 91
    }                                                                                                                  // 92
  }                                                                                                                    // 93
                                                                                                                       //
  // Add everyone who is mentioned.                                                                                    //
  if (event.users && event.users.length > 0) {                                                                         // 96
    (function () {                                                                                                     // 96
      var promises = [];                                                                                               // 97
      event.users.forEach(function (user) {                                                                            // 98
        if (user.identity && (user.mentioned || user.subscribed)) {                                                    // 99
          promises.push(unwrapFrontendCap(user.identity, "identity", function (targetId) {                             // 100
            addRecipient({ identityId: targetId });                                                                    // 101
          }));                                                                                                         // 102
        }                                                                                                              // 103
      });                                                                                                              // 104
      waitPromise(Promise.all(promises).then(function (junk) {                                                         // 105
        return undefined;                                                                                              // 105
      }));                                                                                                             // 105
    })();                                                                                                              // 96
  }                                                                                                                    // 106
                                                                                                                       //
  // Make a list of everyone to notify.                                                                                //
  var notify = [];                                                                                                     // 109
  for (var _identityId in notifyMap) {                                                                                 // 110
    if (notifyMap[_identityId]) {                                                                                      // 111
      notify.push(_identityId);                                                                                        // 112
    }                                                                                                                  // 113
  }                                                                                                                    // 114
                                                                                                                       //
  if (notify.length > 0) {                                                                                             // 116
    (function () {                                                                                                     // 116
      var notification = {                                                                                             // 117
        grainId: grainId,                                                                                              // 118
        path: event.path || ""                                                                                         // 119
      };                                                                                                               // 117
                                                                                                                       //
      // Fields we'll update even if the notification already exists.                                                  //
      var update = {                                                                                                   // 123
        isUnread: true,                                                                                                // 124
        timestamp: new Date()                                                                                          // 125
      };                                                                                                               // 123
                                                                                                                       //
      if (event.thread) {                                                                                              // 128
        notification.threadPath = event.thread.path || "";                                                             // 129
      }                                                                                                                // 130
                                                                                                                       //
      if (identityId) {                                                                                                // 132
        notification.initiatingIdentity = identityId;                                                                  // 133
      }                                                                                                                // 134
                                                                                                                       //
      notification.eventType = event.type;                                                                             // 136
      update.text = eventType.verbPhrase;                                                                              // 137
                                                                                                                       //
      notify.forEach(function (targetId) {                                                                             // 139
        // Notify all accounts connected with this identity.                                                           //
        Meteor.users.find({ $or: [{ "loginIdentities.id": targetId }, { "nonloginIdentities.id": targetId }] }).forEach(function (account) {
          Notifications.upsert(_.extend({ userId: account._id }, notification), {                                      // 145
            $set: update,                                                                                              // 146
            $inc: { count: 1 }                                                                                         // 147
          });                                                                                                          // 145
        });                                                                                                            // 149
      });                                                                                                              // 150
    })();                                                                                                              // 116
  }                                                                                                                    // 151
};                                                                                                                     // 152
                                                                                                                       //
Meteor.methods({                                                                                                       // 154
  testNotifications: function testNotifications() {                                                                    // 155
    // Deliver a test notification of each non-grain-initiated type to the user.                                       //
    if (!this.userId) return;                                                                                          // 157
                                                                                                                       //
    Notifications.insert({                                                                                             // 159
      admin: {                                                                                                         // 160
        action: "/admin/stats",                                                                                        // 161
        type: "reportStats"                                                                                            // 162
      },                                                                                                               // 160
      userId: this.userId,                                                                                             // 164
      text: { defaultText: "You can help Sandstorm by sending us some anonymous " + "usage stats. Click here for more info." },
      timestamp: new Date(),                                                                                           // 167
      isUnread: true                                                                                                   // 168
    });                                                                                                                // 159
                                                                                                                       //
    Notifications.insert({                                                                                             // 171
      userId: this.userId,                                                                                             // 172
      referral: true,                                                                                                  // 173
      timestamp: new Date(),                                                                                           // 174
      isUnread: true                                                                                                   // 175
    });                                                                                                                // 171
                                                                                                                       //
    if (global.BlackrockPayments) {                                                                                    // 178
      Notifications.insert({                                                                                           // 179
        userId: this.userId,                                                                                           // 180
        mailingListBonus: true,                                                                                        // 181
        timestamp: new Date(),                                                                                         // 182
        isUnread: true                                                                                                 // 183
      });                                                                                                              // 179
    }                                                                                                                  // 185
  }                                                                                                                    // 186
});                                                                                                                    // 154
                                                                                                                       //
Meteor.publish("notifications", function () {                                                                          // 189
  return Notifications.find({ userId: this.userId });                                                                  // 190
});                                                                                                                    // 191
                                                                                                                       //
Meteor.publish("notificationGrains", function (notificationIds) {                                                      // 193
  // Since publishes can't be reactive, we leave it to the client to subscribe to both                                 //
  // "notifications" and "notificationGrains" reactively.                                                              //
  check(notificationIds, [String]);                                                                                    // 196
  var notifications = Notifications.find({                                                                             // 197
    _id: { $in: notificationIds },                                                                                     // 198
    userId: this.userId                                                                                                // 199
  }, {                                                                                                                 // 197
    fields: { grainId: 1, initiatingIdentity: 1 }                                                                      // 201
  });                                                                                                                  // 200
                                                                                                                       //
  var grainIds = notifications.map(function (row) {                                                                    // 204
    return row.grainId;                                                                                                // 205
  }).filter(function (x) {                                                                                             // 206
    return x;                                                                                                          // 206
  });                                                                                                                  // 206
                                                                                                                       //
  var identities = notifications.map(function (row) {                                                                  // 208
    return row.initiatingIdentity;                                                                                     // 209
  }).filter(function (x) {                                                                                             // 210
    return x;                                                                                                          // 210
  });                                                                                                                  // 210
                                                                                                                       //
  return [Grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } }), Meteor.users.find({ _id: { $in: identities } }, { fields: { profile: 1 } })];
});                                                                                                                    // 216
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"pre-meteor.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/pre-meteor.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file implements logic that we place in front of our main Meteor application,                                   //
// including routing of requests to proxies and handling of static web publishing.                                     //
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 20
var Fs = Npm.require("fs");                                                                                            // 21
var Dns = Npm.require("dns");                                                                                          // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Future = Npm.require("fibers/future");                                                                             // 24
var Http = Npm.require("http");                                                                                        // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 27
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 29
var DDP_HOSTNAME = process.env.DDP_DEFAULT_CONNECTION_URL && Url.parse(process.env.DDP_DEFAULT_CONNECTION_URL).hostname;
var CACHE_TTL_SECONDS = 30; // 30 seconds.  Cache-Control expects units of seconds, not millis.                        // 32
var DNS_CACHE_TTL = CACHE_TTL_SECONDS * 1000; // DNS cache is in millis.                                               // 33
                                                                                                                       //
var webPublishingHandlers = {};                                                                                        // 35
// Maps grain public IDs to Connect handlers.                                                                          //
// TODO(perf): Garbage-collect this map?                                                                               //
                                                                                                                       //
var dnsCache = {};                                                                                                     // 39
// Unfortunately, node's DNS library doesn't cache results, so we do our own caching.                                  //
// Unfortunately, node's DNS library also dosen't give us TTLs. So, we'll cache for                                    //
// DNS_CACHE_TTL (a relatively small value) and rely on the upstream DNS server to implement                           //
// better caching.                                                                                                     //
                                                                                                                       //
function isSandstormShell(hostname) {                                                                                  // 45
  // Is this hostname mapped to the Sandstorm shell?                                                                   //
                                                                                                                       //
  return hostname === HOSTNAME || DDP_HOSTNAME && hostname === DDP_HOSTNAME;                                           // 48
}                                                                                                                      // 49
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      //
// uses. Fortunately, they let us extract it.                                                                          //
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 53
                                                                                                                       //
var mime = connect["static"].mime;                                                                                     // 55
                                                                                                                       //
function wwwHandlerForGrain(grainId) {                                                                                 // 57
  return function (request, response) {                                                                                // 58
    var path = request.url;                                                                                            // 59
                                                                                                                       //
    // If a directory, open "index.html".                                                                              //
    if (path.slice(-1) === "/") {                                                                                      // 62
      path = path + "index.html";                                                                                      // 63
    }                                                                                                                  // 64
                                                                                                                       //
    // Strip leading "/".                                                                                              //
    if (path[0] === "/") path = path.slice(1);                                                                         // 67
                                                                                                                       //
    // Strip query.                                                                                                    //
    path = path.split("?")[0];                                                                                         // 70
                                                                                                                       //
    var type = mime.lookup(path);                                                                                      // 72
    var charset = mime.charsets.lookup(type);                                                                          // 73
    if (charset) {                                                                                                     // 74
      type = type + "; charset=" + charset;                                                                            // 75
    } else if (type === "application/json") {                                                                          // 76
      // HACK: Apparently the MIME module does not assume UTF-8 for JSON. :(                                           //
      type = type + "; charset=utf-8";                                                                                 // 78
    }                                                                                                                  // 79
                                                                                                                       //
    // TODO(perf): Automatically gzip text content? Use Express's "compress" middleware for this?                      //
    //   Note that nginx will also auto-compress things...                                                             //
                                                                                                                       //
    response.setHeader("Content-Type", type);                                                                          // 84
    response.setHeader("Cache-Control", "public, max-age=" + CACHE_TTL_SECONDS);                                       // 85
                                                                                                                       //
    if (path === "apps/index.json" || path.match(/apps\/[a-z0-9]{52}[.]json/) || path === "experimental/index.json" || path.match(/experimental\/[a-z0-9]{52}[.]json/)) {
      // TODO(cleanup): Extra special terrible hack: The app index needs to serve these JSON files                     //
      //   cross-origin. We could almost just make all web sites allow cross-origin since generally                    //
      //   web publishing is meant to publish public content. There is one case where this is                          //
      //   problematic, though: sites behind a firewall. Those sites could potentially be read                         //
      //   by outside sites if CORS is enabled on them. Some day we should make it so apps can                         //
      //   explicitly opt-in to allowing cross-origin queries but that day is not today.                               //
      response.setHeader("Access-Control-Allow-Origin", "*");                                                          // 97
    }                                                                                                                  // 98
                                                                                                                       //
    var stream = new ResponseStream(response, 200, "OK");                                                              // 100
                                                                                                                       //
    // We hold our own capability to the stream becaues we don't want ResponseStream's close()                         //
    // logic to happen if the response has no data.                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): This is pretty ugly.                                                                             //
    var streamCap = new Capnp.Capability(stream, ByteStream);                                                          // 106
                                                                                                                       //
    globalBackend.useGrain(grainId, function (supervisor) {                                                            // 108
      return supervisor.getWwwFileHack(path, streamCap).then(function (result) {                                       // 109
        // jscs:disable disallowQuotedKeysInObjects                                                                    //
        var status = result.status;                                                                                    // 111
        if (status === "file") {                                                                                       // 112
          // Nothing to do.                                                                                            //
        } else if (status === "directory") {                                                                           // 114
            stream.sendingDirectResponse();                                                                            // 115
            response.writeHead(303, {                                                                                  // 116
              "Content-Type": "text/plain",                                                                            // 117
              "Location": "/" + path + "/",                                                                            // 118
              "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                  // 119
            });                                                                                                        // 116
            response.end("redirect: /" + path + "/");                                                                  // 121
          } else if (status === "notFound") {                                                                          // 122
            stream.sendingDirectResponse();                                                                            // 123
            response.writeHead(404, {                                                                                  // 124
              "Content-Type": "text/plain"                                                                             // 125
            });                                                                                                        // 124
            response.end("404 not found: /" + path);                                                                   // 127
          } else {                                                                                                     // 128
            console.error("didn't understand result of getWwwFileHack:", status);                                      // 129
            stream.sendingDirectResponse();                                                                            // 130
            response.writeHead(500, {                                                                                  // 131
              "Content-Type": "text/plain"                                                                             // 132
            });                                                                                                        // 131
            response.end("Internal server error");                                                                     // 134
          }                                                                                                            // 135
                                                                                                                       //
        streamCap.close();                                                                                             // 137
      });                                                                                                              // 138
    })["catch"](function (err) {                                                                                       // 139
      console.error(err.stack);                                                                                        // 140
      streamCap.close();                                                                                               // 141
    });                                                                                                                // 142
  };                                                                                                                   // 143
}                                                                                                                      // 144
                                                                                                                       //
function writeErrorResponse(res, err) {                                                                                // 146
  var status = 500;                                                                                                    // 147
  if (err instanceof Meteor.Error && typeof err.error === "number" && err.error >= 400 && err.error < 600) {           // 148
    status = err.error;                                                                                                // 150
  } else if (err.httpErrorCode) {                                                                                      // 151
    status = err.httpErrorCode;                                                                                        // 152
  }                                                                                                                    // 153
                                                                                                                       //
  // Log errors that are our fault, but not errors that are the client's fault.                                        //
  if (status >= 500) console.error(err.stack);                                                                         // 156
                                                                                                                       //
  res.writeHead(status, { "Content-Type": err.htmlMessage ? "text/html" : "text/plain" });                             // 158
  res.end(err.htmlMessage || err.message);                                                                             // 159
}                                                                                                                      // 160
                                                                                                                       //
var PNG_MAGIC = new Buffer([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A]);                                          // 162
var JPEG_MAGIC = new Buffer([0xFF, 0xD8, 0xFF]);                                                                       // 163
                                                                                                                       //
function checkMagic(buf, magic) {                                                                                      // 165
  if (buf.length < magic.length) return false;                                                                         // 166
                                                                                                                       //
  for (var i = 0; i < magic.length; i++) {                                                                             // 168
    if (buf[i] != magic[i]) return false;                                                                              // 169
  }                                                                                                                    // 170
                                                                                                                       //
  return true;                                                                                                         // 172
}                                                                                                                      // 173
                                                                                                                       //
function serveSelfTest(req, res) {                                                                                     // 175
  try {                                                                                                                // 176
    if (req.method === "GET" && req.url === "/") {                                                                     // 177
      var content = new Buffer("Self-test OK.");                                                                       // 179
                                                                                                                       //
      // Convert the ROOT_URL to something that is a valid origin.                                                     //
      var rootUrlAsOrigin = process.env.ROOT_URL;                                                                      // 182
      if (rootUrlAsOrigin.slice(-1) === "/") {                                                                         // 183
        rootUrlAsOrigin = rootUrlAsOrigin.slice(0, -1);                                                                // 184
      }                                                                                                                // 185
                                                                                                                       //
      res.writeHead(200, {                                                                                             // 187
        "Content-Type": "text/plain",                                                                                  // 188
        "Content-Length": content.length,                                                                              // 189
        "Access-Control-Allow-Origin": rootUrlAsOrigin                                                                 // 190
      });                                                                                                              // 187
      res.end(content);                                                                                                // 192
    } else {                                                                                                           // 193
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 194
      res.end("Bad request to self-test subdomain.");                                                                  // 195
      return;                                                                                                          // 196
    }                                                                                                                  // 197
  } catch (err) {                                                                                                      // 198
    console.log("WARNING: An error occurred while serving self-test; proceeding anyway:", err);                        // 199
  }                                                                                                                    // 200
}                                                                                                                      // 201
                                                                                                                       //
function serveStaticAsset(req, res, hostId) {                                                                          // 203
  inMeteor(function () {                                                                                               // 204
    if (req.method === "GET") {                                                                                        // 205
      var assetCspHeader = "default-src 'none'; style-src 'unsafe-inline'; sandbox";                                   // 206
      if (req.headers["if-none-match"] === "permanent") {                                                              // 207
        // Cache never invalidates since we use a new URL for every resource.                                          //
        res.writeHead(304, {                                                                                           // 209
          "Cache-Control": "public, max-age=31536000",                                                                 // 210
          "ETag": "permanent",                                                                                         // 211
                                                                                                                       //
          // To be safe, send these again, although it shouldn't be necessary.                                         //
          "Content-Security-Policy": assetCspHeader,                                                                   // 214
          "Access-Control-Allow-Origin": "*",                                                                          // 215
          "X-Content-Type-Options": "nosniff"                                                                          // 216
        });                                                                                                            // 209
        res.end();                                                                                                     // 218
        return;                                                                                                        // 219
      }                                                                                                                // 220
                                                                                                                       //
      var url = Url.parse(req.url, true);                                                                              // 222
      var pathname = url.pathname.slice(1);                                                                            // 223
      var asset = void 0;                                                                                              // 224
      if (pathname.startsWith("identicon/")) {                                                                         // 225
        var size = parseInt((url.query || {}).s);                                                                      // 226
        if (size <= 512) {                                                                                             // 227
          asset = new Identicon(pathname.slice("identicon/".length), size).asAsset();                                  // 228
        }                                                                                                              // 229
      } else if (pathname.indexOf("/") == -1) {                                                                        // 230
        asset = globalDb.getStaticAsset(pathname);                                                                     // 231
      }                                                                                                                // 232
                                                                                                                       //
      if (asset) {                                                                                                     // 234
        var headers = {                                                                                                // 235
          "Content-Type": asset.mimeType,                                                                              // 236
          "Content-Length": asset.content.length,                                                                      // 237
                                                                                                                       //
          // Assets can be cached forever because each one has a unique ID.                                            //
          "Cache-Control": "public, max-age=31536000",                                                                 // 240
                                                                                                                       //
          // Since different resources get different URLs, we can use a static etag.                                   //
          "ETag": "permanent",                                                                                         // 243
                                                                                                                       //
          // Set strict Content-Security-Policy to prevent static assets from executing any script                     //
          // or doing basically anything when browsed to directly. The static assets host is not                       //
          // intended to serve HTML. Mostly, it serves images and javascript -- note that setting                      //
          // the CSP header on Javascript files does not prevent other hosts from voluntarily                          //
          // specifying these scripts in <script> tags.                                                                //
          "Content-Security-Policy": assetCspHeader,                                                                   // 250
                                                                                                                       //
          // Allow any host to fetch these assets. This is safe since requests to this host are                        //
          // totally side-effect-free and the asset ID acts as a capability to prevent loading                         //
          // assets you're not supposed to know about.                                                                 //
          "Access-Control-Allow-Origin": "*",                                                                          // 255
                                                                                                                       //
          // Extra protection against content type trickery.                                                           //
          "X-Content-Type-Options": "nosniff"                                                                          // 258
        };                                                                                                             // 235
                                                                                                                       //
        if (asset.encoding) {                                                                                          // 261
          headers["Content-Encoding"] = asset.encoding;                                                                // 262
        }                                                                                                              // 263
                                                                                                                       //
        res.writeHead(200, headers);                                                                                   // 265
        res.end(asset.content);                                                                                        // 266
      } else {                                                                                                         // 267
        res.writeHead(404, { "Content-Type": "text/plain" });                                                          // 268
        res.end("not found");                                                                                          // 269
      }                                                                                                                // 270
    } else if (req.method === "POST") {                                                                                // 271
      var _ret = function () {                                                                                         // 271
        res.setHeader("Access-Control-Allow-Origin", "*");                                                             // 272
                                                                                                                       //
        var url = Url.parse(req.url);                                                                                  // 274
        var purpose = globalDb.fulfillAssetUpload(url.pathname.slice(1));                                              // 275
                                                                                                                       //
        // Sanity check the purpose of this upload token.                                                              //
        if (!purpose) {                                                                                                // 278
          res.writeHead(404, { "Content-Type": "text/plain" });                                                        // 279
          res.end("Upload token not found or expired.");                                                               // 280
          return {                                                                                                     // 281
            v: void 0                                                                                                  // 281
          };                                                                                                           // 281
        } else if (purpose.profilePicture) {                                                                           // 282
          var userId = purpose.profilePicture.userId;                                                                  // 283
          var identityId = purpose.profilePicture.identityId;                                                          // 284
          check(userId, String);                                                                                       // 285
          check(identityId, String);                                                                                   // 286
        } else if (purpose.loginLogo) {                                                                                // 287
          // no additional fields for loginLogo                                                                        //
        } else {                                                                                                       // 289
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 290
            res.end("Found invalid purpose for upload");                                                               // 291
            return {                                                                                                   // 292
              v: void 0                                                                                                // 292
            };                                                                                                         // 292
          }                                                                                                            // 293
                                                                                                                       //
        var buffers = [];                                                                                              // 295
        var totalSize = 0;                                                                                             // 296
        var done = new Future();                                                                                       // 297
        req.on("data", function (buf) {                                                                                // 298
          totalSize += buf.length;                                                                                     // 299
          if (totalSize <= 64 * 1024) {                                                                                // 300
            buffers.push(buf);                                                                                         // 301
          }                                                                                                            // 302
        });                                                                                                            // 303
        req.on("end", done["return"].bind(done));                                                                      // 304
        req.on("error", done["throw"].bind(done));                                                                     // 305
        done.wait();                                                                                                   // 306
                                                                                                                       //
        if (totalSize > 64 * 1024) {                                                                                   // 308
          // TODO(soon): Resize the image ourselves.                                                                   //
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 310
          res.end("Picture too large; please use an image under 64 KiB.");                                             // 311
          return {                                                                                                     // 312
            v: void 0                                                                                                  // 312
          };                                                                                                           // 312
        }                                                                                                              // 313
                                                                                                                       //
        var content = Buffer.concat(buffers);                                                                          // 315
        var type = void 0;                                                                                             // 316
        if (checkMagic(content, PNG_MAGIC)) {                                                                          // 317
          type = "image/png";                                                                                          // 318
        } else if (checkMagic(content, JPEG_MAGIC)) {                                                                  // 319
          type = "image/jpeg";                                                                                         // 320
        } else {                                                                                                       // 321
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 322
          res.end("Image must be PNG or JPEG.");                                                                       // 323
          return {                                                                                                     // 324
            v: void 0                                                                                                  // 324
          };                                                                                                           // 324
        }                                                                                                              // 325
                                                                                                                       //
        var assetId = globalDb.addStaticAsset({ mimeType: type }, content);                                            // 327
                                                                                                                       //
        if (purpose.profilePicture) {                                                                                  // 329
          var _identityId = purpose.profilePicture.identityId;                                                         // 330
          var old = Meteor.users.findAndModify({                                                                       // 331
            query: { _id: _identityId },                                                                               // 332
            update: { $set: { "profile.picture": assetId } },                                                          // 333
            fields: { "profile.picture": 1 }                                                                           // 334
          });                                                                                                          // 331
                                                                                                                       //
          if (old && old.profile && old.profile.picture) {                                                             // 337
            globalDb.unrefStaticAsset(old.profile.picture);                                                            // 338
          }                                                                                                            // 339
        } else if (purpose.loginLogo) {                                                                                // 340
          var _old = globalDb.collections.settings.findAndModify({                                                     // 341
            query: { _id: "whitelabelCustomLogoAssetId" },                                                             // 342
            update: {                                                                                                  // 343
              $setOnInsert: { _id: "whitelabelCustomLogoAssetId" },                                                    // 344
              $set: { value: assetId }                                                                                 // 345
            },                                                                                                         // 343
            upsert: true,                                                                                              // 347
            fields: { value: 1 }                                                                                       // 348
          });                                                                                                          // 341
                                                                                                                       //
          if (_old && _old.value) {                                                                                    // 351
            globalDb.unrefStaticAsset(_old.value);                                                                     // 352
          }                                                                                                            // 353
        }                                                                                                              // 354
                                                                                                                       //
        res.writeHead(204, {});                                                                                        // 356
        res.end();                                                                                                     // 357
      }();                                                                                                             // 271
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 271
    } else if (req.method === "OPTIONS") {                                                                             // 358
      var requestedHeaders = req.headers["access-control-request-headers"];                                            // 359
      if (requestedHeaders) {                                                                                          // 360
        res.setHeader("Access-Control-Allow-Headers", requestedHeaders);                                               // 361
      }                                                                                                                // 362
                                                                                                                       //
      res.writeHead(204, {                                                                                             // 364
        "Access-Control-Allow-Origin": "*",                                                                            // 365
        "Access-Control-Allow-Methods": "GET, HEAD, POST, OPTIONS",                                                    // 366
        "Access-Control-Max-Age": "3600"                                                                               // 367
      });                                                                                                              // 364
      res.end();                                                                                                       // 369
    } else {                                                                                                           // 370
      res.writeHead(405, "Method Not Allowed", {                                                                       // 371
        "Allow": "GET, POST, OPTIONS",                                                                                 // 372
        "Content-Type": "text/plain"                                                                                   // 373
      });                                                                                                              // 371
      res.end("405 Method Not Allowed: " + req.method);                                                                // 375
    }                                                                                                                  // 376
  })["catch"](function (err) {                                                                                         // 377
    writeErrorResponse(res, err);                                                                                      // 378
  });                                                                                                                  // 379
}                                                                                                                      // 380
                                                                                                                       //
var canonicalizeShellOrWildcardUrl = function canonicalizeShellOrWildcardUrl(hostname, url) {                          // 382
  // Start with ROOT_URL, apply host & path from inbound URL, then                                                     //
  // redirect.                                                                                                         //
  var targetUrl = Url.parse(process.env.ROOT_URL);                                                                     // 385
                                                                                                                       //
  // Retain the protocol & port from ROOT_URL but use the inbound                                                      //
  // hostname.                                                                                                         //
  targetUrl.host = hostname + ":" + targetUrl.port;                                                                    // 389
                                                                                                                       //
  // The following allows to avoid decoding + re-encoding query                                                        //
  // string parameters, if provided.                                                                                   //
  targetUrl = Url.resolve(Url.format(targetUrl), url);                                                                 // 393
  return targetUrl;                                                                                                    // 394
};                                                                                                                     // 395
                                                                                                                       //
var handleNonMeteorRequest = function handleNonMeteorRequest(req, res, next, redirectIfInWildcard) {                   // 397
  // if redirectIfInWildcard is true, and if the host is part of the wildcard host, then we will                       //
  // prefer to redirect to the canonical url for that request.  If false, we will respond to the                       //
  // request directly.                                                                                                 //
                                                                                                                       //
  var hostname = req.headers.host.split(":")[0];                                                                       // 402
                                                                                                                       //
  var publicIdPromise = void 0;                                                                                        // 404
  // See if the request was for a host in the wildcard.                                                                //
  var id = matchWildcardHost(req.headers.host);                                                                        // 406
  if (id) {                                                                                                            // 407
    // Match!                                                                                                          //
    if (redirectIfInWildcard) {                                                                                        // 409
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 410
      res.end();                                                                                                       // 411
      return;                                                                                                          // 412
    }                                                                                                                  // 413
                                                                                                                       //
    if (id === "static") {                                                                                             // 415
      // Static assets domain.                                                                                         //
      serveStaticAsset(req, res);                                                                                      // 417
      return;                                                                                                          // 418
    }                                                                                                                  // 419
                                                                                                                       //
    if (id.match(/^selftest-/)) {                                                                                      // 421
      // Self test domain pattern. Starts w/ hyphen to avoid ambiguity with grain session/static                       //
      // publishing wildcard hosts.                                                                                    //
      serveSelfTest(req, res);                                                                                         // 424
      return;                                                                                                          // 425
    }                                                                                                                  // 426
                                                                                                                       //
    // Try to route the request to a session.                                                                          //
    publicIdPromise = tryProxyRequest(id, req, res).then(function (handled) {                                          // 429
      if (handled) {                                                                                                   // 430
        return null;                                                                                                   // 431
      } else {                                                                                                         // 432
        return id;                                                                                                     // 433
      }                                                                                                                // 434
    });                                                                                                                // 435
  } else {                                                                                                             // 436
    // Not a wildcard host. Perhaps it is a custom host.                                                               //
    publicIdPromise = lookupPublicIdFromDns(hostname);                                                                 // 438
  }                                                                                                                    // 439
                                                                                                                       //
  publicIdPromise.then(function (publicId) {                                                                           // 441
    if (publicId) {                                                                                                    // 442
      return Promise.resolve(undefined).then(function () {                                                             // 443
        var handler = webPublishingHandlers[publicId];                                                                 // 444
        if (handler) {                                                                                                 // 445
          return handler;                                                                                              // 446
        } else {                                                                                                       // 447
          // We don't have a handler for this publicId, so look it up in the grain DB.                                 //
          return inMeteor(function () {                                                                                // 449
            var grain = Grains.findOne({ publicId: publicId }, { fields: { _id: 1 } });                                // 450
            if (!grain) {                                                                                              // 451
              throw new Meteor.Error(404, "No such grain for public ID: " + publicId);                                 // 452
            }                                                                                                          // 453
                                                                                                                       //
            var grainId = grain._id;                                                                                   // 455
            return webPublishingHandlers[publicId] = wwwHandlerForGrain(grainId);                                      // 456
          });                                                                                                          // 457
        }                                                                                                              // 458
      }).then(function (handler) {                                                                                     // 459
        handler(req, res);                                                                                             // 460
      });                                                                                                              // 461
    } else {                                                                                                           // 462
      // Already handled by tryProxyRequest above, no further action needed.                                           //
      return Promise.resolve(undefined);                                                                               // 464
    }                                                                                                                  // 465
  })["catch"](function (err) {                                                                                         // 466
    writeErrorResponse(res, err);                                                                                      // 467
  });                                                                                                                  // 468
};                                                                                                                     // 469
                                                                                                                       //
// This function serves responses on Sandstorm's main HTTP/HTTPS                                                       //
// port.                                                                                                               //
var handleNonMeteorRequestDirectly = function handleNonMeteorRequestDirectly(req, res, next) {                         // 473
  handleNonMeteorRequest(req, res, next, false);                                                                       // 474
};                                                                                                                     // 475
                                                                                                                       //
// "Alternate ports" are ports other than the main HTTP or HTTPS port.                                                 //
// They are handled as follows:                                                                                        //
//                                                                                                                     //
// * Requests to the shell & grains, we redirect to the main port.                                                     //
// * For requests to static publishing on hosts within the wildcard, we redirect to the main port.                     //
// * For static publishing glued in via DNS TXT record, we serve the request as-is.                                    //
//                                                                                                                     //
// Alternate ports are bound to FD #5 and higher.                                                                      //
var getNumberOfAlternatePorts = function getNumberOfAlternatePorts() {                                                 // 485
  var numPorts = process.env.PORT.split(",").length;                                                                   // 486
  var numAlternatePorts = numPorts - 1;                                                                                // 487
  return numAlternatePorts;                                                                                            // 488
};                                                                                                                     // 489
                                                                                                                       //
var handleNonMainPortRequest = function handleNonMainPortRequest(req, res, next) {                                     // 491
  try {                                                                                                                // 492
    if (!req.headers.host) {                                                                                           // 493
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 494
      res.end("Missing Host header");                                                                                  // 495
      return;                                                                                                          // 496
    }                                                                                                                  // 497
                                                                                                                       //
    // If this request is intended for the shell, redirect to the canonical shell URL.                                 //
    var hostname = req.headers.host.split(":")[0];                                                                     // 500
    if (isSandstormShell(hostname)) {                                                                                  // 501
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 502
      res.end();                                                                                                       // 503
      return;                                                                                                          // 504
    }                                                                                                                  // 505
                                                                                                                       //
    handleNonMeteorRequest(req, res, next, true);                                                                      // 507
  } catch (e) {                                                                                                        // 508
    // This should never be reached, because all the request handlers should be catching                               //
    // exceptions, but you can never be too careful in a top-level request handler.                                    //
    console.err("Unhandled exception in request handler:", e.stack);                                                   // 511
    res.writeHead(500, { "Content-Type": "text/plain" });                                                              // 512
    res.end("Unhandled exception: " + e.stack);                                                                        // 513
  }                                                                                                                    // 514
};                                                                                                                     // 515
                                                                                                                       //
var listenOnAlternatePorts = function listenOnAlternatePorts() {                                                       // 517
  for (var i = 0; i < getNumberOfAlternatePorts(); i++) {                                                              // 518
    // Call createServerForSandstorm() to skip our monkey patching.                                                    //
    var alternatePortServer = Http.createServerForSandstorm(handleNonMainPortRequest);                                 // 520
    alternatePortServer.listen({ fd: i + 5 });                                                                         // 521
  }                                                                                                                    // 522
};                                                                                                                     // 523
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 525
  var meteorRequestListeners = WebApp.httpServer.listeners("request");                                                 // 526
                                                                                                                       //
  // Construct the middleware chain for requests to non-DDP, non-shell hosts.                                          //
  var nonMeteorRequestHandler = connect();                                                                             // 529
  // BlackrockPayments is only defined in the Blackrock build of Sandstorm.                                            //
  if (global.BlackrockPayments) {                                                                                      // 531
    // Have to check with global, because it could be undefined.                                                       //
    nonMeteorRequestHandler.use(BlackrockPayments.makeConnectHandler(globalDb));                                       // 532
  }                                                                                                                    // 533
                                                                                                                       //
  nonMeteorRequestHandler.use(handleNonMeteorRequestDirectly);                                                         // 535
                                                                                                                       //
  WebApp.httpServer.removeAllListeners("request");                                                                     // 537
  WebApp.httpServer.on("request", function (req, res) {                                                                // 538
    try {                                                                                                              // 539
      if (!req.headers.host) {                                                                                         // 540
        res.writeHead(400, { "Content-Type": "text/plain" });                                                          // 541
        res.end("Missing Host header");                                                                                // 542
        return;                                                                                                        // 543
      }                                                                                                                // 544
                                                                                                                       //
      var hostname = req.headers.host.split(":")[0];                                                                   // 546
      if (isSandstormShell(hostname)) {                                                                                // 547
        // If destined for the DDP host or the main host, pass on to Meteor                                            //
        for (var i = 0; i < meteorRequestListeners.length; i++) {                                                      // 549
          meteorRequestListeners[i](req, res);                                                                         // 550
        }                                                                                                              // 551
      } else {                                                                                                         // 552
        // Otherwise, dispatch to our own middleware proxy chain.                                                      //
        nonMeteorRequestHandler(req, res);                                                                             // 554
        // Adjust timeouts on proxied requests to allow apps to long-poll if needed.                                   //
        WebApp._timeoutAdjustmentRequestCallback(req, res);                                                            // 556
      }                                                                                                                // 557
    } catch (e) {                                                                                                      // 558
      // This should never be reached, because all the request handlers should be catching                             //
      // exceptions, but you can never be too careful in a top-level request handler.                                  //
      console.err("Unhandled exception in request handler:", e.stack);                                                 // 561
      res.writeHead(500, { "Content-Type": "text/plain" });                                                            // 562
      res.end("Unhandled exception: " + e.stack);                                                                      // 563
    }                                                                                                                  // 564
  });                                                                                                                  // 565
                                                                                                                       //
  var meteorUpgradeListeners = WebApp.httpServer.listeners("upgrade");                                                 // 567
  WebApp.httpServer.removeAllListeners("upgrade");                                                                     // 568
                                                                                                                       //
  WebApp.httpServer.on("upgrade", function (req, socket, head) {                                                       // 570
    Promise.resolve(undefined).then(function () {                                                                      // 571
      if (!req.headers.host) {                                                                                         // 572
        throw new Meteor.Error(400, "Missing Host header");                                                            // 573
      } else if (isSandstormShell(req.headers.host.split(":")[0])) {                                                   // 574
        // Go on to Meteor.                                                                                            //
        for (var ii = 0; ii < meteorUpgradeListeners.length; ++ii) {                                                   // 576
          meteorUpgradeListeners[ii](req, socket, head);                                                               // 577
        }                                                                                                              // 578
                                                                                                                       //
        return true;                                                                                                   // 580
      } else {                                                                                                         // 581
        var id = matchWildcardHost(req.headers.host);                                                                  // 582
        if (id) {                                                                                                      // 583
          return tryProxyUpgrade(id, req, socket, head);                                                               // 584
        } else {                                                                                                       // 585
          return false;                                                                                                // 586
        }                                                                                                              // 587
      }                                                                                                                // 588
    }).then(function (handled) {                                                                                       // 589
      if (!handled) socket.destroy();                                                                                  // 590
    })["catch"](function (err) {                                                                                       // 591
      console.error("WebSocket event handler failed:", err.stack);                                                     // 592
      socket.destroy();                                                                                                // 593
    });                                                                                                                // 594
  });                                                                                                                  // 595
                                                                                                                       //
  listenOnAlternatePorts();                                                                                            // 597
});                                                                                                                    // 598
                                                                                                                       //
var errorTxtMapping = {};                                                                                              // 600
errorTxtMapping[Dns.NOTFOUND] = "<p>" + "If you were trying to configure static publishing for a blog or website, powered " + "by a Sandstorm app hosted at this server, you either have not added DNS TXT records " + "correctly, or the DNS cache has not updated yet (may take a while, like 5 minutes to one " + "hour).</p>";
errorTxtMapping[Dns.NODATA] = errorTxtMapping[Dns.NOTFOUND];                                                           // 606
errorTxtMapping[Dns.TIMEOUT] = "<p>" + "The DNS query has timed out, which may be a sign of poorly configured DNS on the server.</p>";
errorTxtMapping[Dns.CONNREFUSED] = "<p>" + "The DNS server refused the connection, which means either your DNS server is down/unreachable, " + "or the server has misconfigured their DNS.</p>";
                                                                                                                       //
function lookupPublicIdFromDns(hostname) {                                                                             // 613
  // Given a hostname, determine its public ID.                                                                        //
  // We look for a TXT record indicating the public ID. Unfortunately, according to spec, a single                     //
  // hostname cannot have both a CNAME and a TXT record, because a TXT lookup on a CNAME'd host                        //
  // should actually be redirected to the CNAME, just like an A lookup would be. In practice lots                      //
  // of DNS software actually allows TXT records on CNAMEs, and it seems to work, but some software                    //
  // does not allow it and it's explicitly disallowed by the spec. Therefore, we instead look for                      //
  // the TXT record on a subdomain.                                                                                    //
  //                                                                                                                   //
  // I also considered having the CNAME itself point to <publicId>.<hostname>, where                                   //
  // *.<hostname> is in turn a CNAME for the Sandstorm server. This approach seemed elegant at                         //
  // first, but has a number of problems, the biggest being that it breaks the ability to place a                      //
  // CDN like CloudFlare in front of the site.                                                                         //
                                                                                                                       //
  var cache = dnsCache[hostname];                                                                                      // 627
  if (cache && Date.now() < cache.expiration) {                                                                        // 628
    return Promise.resolve(cache.value);                                                                               // 629
  }                                                                                                                    // 630
                                                                                                                       //
  return new Promise(function (resolve, reject) {                                                                      // 632
    Dns.resolveTxt("sandstorm-www." + hostname, function (err, records) {                                              // 633
      if (err) {                                                                                                       // 634
        var errorMsg = errorTxtMapping[err.code] || "";                                                                // 635
        var error = new Error('Error looking up DNS TXT records for host "' + hostname + '": ' + err.message);         // 636
        error.htmlMessage = '<style type="text/css">h2, h3, p { max-width: 600px; }</style>' + "<h2>Sandstorm static publishing needs further configuration (or wrong URL)</h2>" + errorMsg + "<p>To visit this Sandstorm server's main interface, go to: <a href='" + process.env.ROOT_URL + "'>" + process.env.ROOT_URL + "</a></p>" + "<h3>DNS details</h3>" + '<p>Error looking up DNS TXT records for host "' + hostname + '": ' + err.message + "</p>" + "<p>If you have the <tt>dig</tt> tool, you can run this command to learn more:</p>" + "<p><tt>dig TXT sandstorm-www." + hostname + "</tt></p>" + "<h3>Changing the server URL, or troubleshooting OAuth login</h3>" + "<p>If you are the server admin and want to use this address as the main interface, " + "edit /opt/sandstorm/sandstorm.conf, modify the BASE_URL setting, and restart " + "Sandstorm.</p>" + "<p>If you got here after trying to log in via OAuth (e.g. through GitHub or Google), " + "the problem is probably that the OAuth callback URL was set wrong. You need to " + "update it through the respective login provider's management console. The " + "easiest way to do that is to run <tt>sudo sandstorm admin-token</tt>, then " + "reconfigure the OAuth provider.</p>";
        error.httpErrorCode = _.contains(["ENOTFOUND", "ENODATA"], err.code) ? 404 : 500;                              // 657
        reject(error);                                                                                                 // 658
      } else if (records.length !== 1) {                                                                               // 659
        reject(new Error('Host "sandstorm-www.' + hostname + '" must have exactly one TXT record.'));                  // 660
      } else {                                                                                                         // 661
        var result = records[0];                                                                                       // 662
        dnsCache[hostname] = { value: result, expiration: Date.now() + DNS_CACHE_TTL };                                // 663
        resolve(result);                                                                                               // 664
      }                                                                                                                // 665
    });                                                                                                                // 666
  });                                                                                                                  // 667
}                                                                                                                      // 668
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"proxy.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck","bignum",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/proxy.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
var Crypto = Npm.require("crypto");                                                                                    // 18
var ChildProcess = Npm.require("child_process");                                                                       // 19
var Fs = Npm.require("fs");                                                                                            // 20
var Path = Npm.require("path");                                                                                        // 21
var Future = Npm.require("fibers/future");                                                                             // 22
var Http = Npm.require("http");                                                                                        // 23
var Url = Npm.require("url");                                                                                          // 24
var Promise = Npm.require("es6-promise").Promise;                                                                      // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var Net = Npm.require("net");                                                                                          // 27
                                                                                                                       //
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 29
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 30
var WebSession = Capnp.importSystem("sandstorm/web-session.capnp").WebSession;                                         // 31
var HackSession = Capnp.importSystem("sandstorm/hack-session.capnp");                                                  // 32
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 33
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 34
                                                                                                                       //
var storeReferralProgramInfoApiTokenCreated = function storeReferralProgramInfoApiTokenCreated(db, accountId, identityId, apiTokenAccountId) {
  // From the Referral program's perspective, if Bob's Account has no referredByComplete, then we                      //
  // update Bob's Identity to say it's referredBy Alice's Account (which is apiTokenAccountId).                        //
  check(accountId, String);                                                                                            // 39
  check(identityId, String);                                                                                           // 40
  check(apiTokenAccountId, String);                                                                                    // 41
                                                                                                                       //
  // Bail out early if quota enforcement is disabled.                                                                  //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 44
    return;                                                                                                            // 45
  }                                                                                                                    // 46
                                                                                                                       //
  var aliceAccountId = apiTokenAccountId;                                                                              // 48
  var bobAccountId = accountId;                                                                                        // 49
  var bobIdentityId = identityId;                                                                                      // 50
                                                                                                                       //
  if (Meteor.users.find({                                                                                              // 52
    _id: bobAccountId,                                                                                                 // 53
    referredByComplete: { $exists: true }                                                                              // 54
  }).count() > 0) {                                                                                                    // 52
    return;                                                                                                            // 56
  }                                                                                                                    // 57
                                                                                                                       //
  // Only actually update Bob's Identity ID if there is no referredBy.                                                 //
  Meteor.users.update({ _id: bobIdentityId, referredBy: { $exists: false } }, { $set: { referredBy: aliceAccountId } });
};                                                                                                                     // 63
                                                                                                                       //
function referralProgramLogSharingTokenUse(db, bobAccountId) {                                                         // 65
  // Hooray! The sharing token is valid! Someone (let's call them Charlie) is going to get a UiView                    //
  // to this grain!  This means that the user who created this apiToken knows how to use the 'share                    //
  // access' interface. Let's call them Bob.                                                                           //
  //                                                                                                                   //
  // If Bob's Account.referredByComplete is not yet set, then look at Bob's Identities and take the                    //
  // first referredBy we find -- let's call that Alice.                                                                //
  //                                                                                                                   //
  // We copy Alice's account ID to Bob's Account.referredByComplete, and then update Alice's                           //
  // referredIdentityIds to point at Bob's Identity, and then remove the referredBy from Bob's                         //
  // Identity since it has become redundant.                                                                           //
  //                                                                                                                   //
  // Implementation note: this does mean that Alice can get referral credit for Bob by sharing a                       //
  // link with Bob, even if Bob already had an account.                                                                //
                                                                                                                       //
  // Bail out early if quota support is not enabled.                                                                   //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 81
    return;                                                                                                            // 82
  }                                                                                                                    // 83
                                                                                                                       //
  // Bail out if Bob has a referredByComplete.                                                                         //
  if (Meteor.users.find({ _id: bobAccountId, referredByComplete: { $exists: true } }).count() > 0) {                   // 86
    return;                                                                                                            // 87
  }                                                                                                                    // 88
                                                                                                                       //
  // Look for a referredBy on any of Bob's identities.                                                                 //
  var bobIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: bobAccountId }));                    // 91
  var bobIdentityWithReferredBy = Meteor.users.findOne({                                                               // 92
    _id: { $in: bobIdentityIds },                                                                                      // 93
    referredBy: { $exists: true }                                                                                      // 94
  });                                                                                                                  // 92
                                                                                                                       //
  if (!bobIdentityWithReferredBy) {                                                                                    // 97
    return;                                                                                                            // 98
  }                                                                                                                    // 99
                                                                                                                       //
  var aliceAccountId = bobIdentityWithReferredBy.referredBy;                                                           // 101
                                                                                                                       //
  // Store Bob's Account.referralCompletedBy.                                                                          //
  var now = new Date();                                                                                                // 104
  Meteor.users.update({                                                                                                // 105
    _id: bobAccountId,                                                                                                 // 106
    referredByComplete: { $exists: false }                                                                             // 107
  }, {                                                                                                                 // 105
    $set: {                                                                                                            // 109
      referredByComplete: bobIdentityWithReferredBy.referredBy,                                                        // 110
      referredCompleteDate: now                                                                                        // 111
    }                                                                                                                  // 109
  });                                                                                                                  // 108
                                                                                                                       //
  // Update Alice's Account.referredIdentityIds.                                                                       //
  Meteor.users.update({ _id: aliceAccountId }, {                                                                       // 116
    $push: { referredIdentityIds: bobIdentityWithReferredBy._id }                                                      // 117
  });                                                                                                                  // 116
                                                                                                                       //
  // Remove now-redundant Bob identity referredBy.                                                                     //
  Meteor.users.update({ _id: bobIdentityWithReferredBy._id }, {                                                        // 121
    $unset: { referredBy: true }                                                                                       // 122
  });                                                                                                                  // 121
}                                                                                                                      // 124
                                                                                                                       //
var HeaderWhitelist = function () {                                                                                    //
  function HeaderWhitelist(list) {                                                                                     // 127
    var _this2 = this;                                                                                                 // 127
                                                                                                                       //
    _classCallCheck(this, HeaderWhitelist);                                                                            // 127
                                                                                                                       //
    this._headers = {};                                                                                                // 128
    this._prefixes = [];                                                                                               // 129
                                                                                                                       //
    list.forEach(function (pattern) {                                                                                  // 131
      if (pattern.endsWith("*")) {                                                                                     // 132
        _this2._prefixes.push(pattern.slice(0, -1));                                                                   // 133
      } else {                                                                                                         // 134
        _this2._headers[pattern] = true;                                                                               // 135
      }                                                                                                                // 136
    });                                                                                                                // 137
  }                                                                                                                    // 138
                                                                                                                       //
  HeaderWhitelist.prototype.matches = function matches(header) {                                                       //
    header = header.toLowerCase();                                                                                     // 141
    if (this._headers[header]) return true;                                                                            // 142
                                                                                                                       //
    for (var i in this._prefixes) {                                                                                    // 144
      if (header.startsWith(this._prefixes[i])) {                                                                      // 145
        return true;                                                                                                   // 146
      }                                                                                                                // 147
    };                                                                                                                 // 148
                                                                                                                       //
    return false;                                                                                                      // 150
  };                                                                                                                   // 151
                                                                                                                       //
  return HeaderWhitelist;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
var REQUEST_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Context.headerWhitelist);                                // 154
var RESPONSE_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Response.headerWhitelist);                              // 155
                                                                                                                       //
// User-agent strings that should be allowed to use http basic authentication.                                         //
// These are regex matches, so ensure they are escaped properly with double                                            //
// backslashes. For security reasons, we MUST NOT whitelist any user-agents                                            //
// that may render html and execute embedded scripts.                                                                  //
BASIC_AUTH_USER_AGENTS = ["git\\/", "GitHub-Hookshot\\/", "mirall\\/", "Mozilla\\/5\\.0 \\([^\\\\]*\\) mirall\\/", "Mozilla\\/5\\.0 \\(iOS\\) ownCloud-iOS\\/", "Mozilla\\/5\\.0 \\(Android\\) ownCloud-android\\/", "litmus\\/"];
BASIC_AUTH_USER_AGENTS_REGEX = new RegExp("^(" + BASIC_AUTH_USER_AGENTS.join("|") + ")", "");                          // 170
                                                                                                                       //
var SESSION_PROXY_TIMEOUT = 60000;                                                                                     // 172
                                                                                                                       //
var sandstormCoreFactory = makeSandstormCoreFactory();                                                                 // 174
var backendAddress = "unix:" + (SANDSTORM_ALTHOME || "") + Backend.socketPath;                                         // 175
var sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 176
var sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 177
                                                                                                                       //
// TODO(cleanup): This initilization belongs with the rest of our package initialization in                            //
//   db-deprecated.js. We can't put it there now because we need to contruct sandstormCoreFactory first.               //
globalBackend = new SandstormBackend(globalDb, sandstormBackend);                                                      // 181
Meteor.onConnection(function (connection) {                                                                            // 182
  connection.sandstormBackend = globalBackend;                                                                         // 183
});                                                                                                                    // 184
                                                                                                                       //
// We've observed a problem in production where occasionally the front-end stops talking to the                        //
// back-end. It happens very rarely -- like once a month -- and we've been unable to reproduce it                      //
// in testing, making it very hard to debug. The problem appears both on Sandstorm and Blackrock.                      //
// Restarting the node process (and only the node process) always fixes the problem.                                   //
//                                                                                                                     //
// Here, I've added some code that attempts to detect the problem by doing a health check                              //
// periodically and then remaking the connection if it seems broken. We'll see if this helps!                          //
var backendHealthy = true;                                                                                             // 193
var disconnectCount = 0;                                                                                               // 194
Meteor.setInterval(function () {                                                                                       // 195
  if (!backendHealthy) {                                                                                               // 196
    if (disconnectCount++ > 2) process.abort();                                                                        // 197
    console.error("error: Backend hasn't responded in 30 seconds! Reconnecting.");                                     // 198
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(true);                                        // 199
    sandstormBackendConnection.close();                                                                                // 200
    sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 201
    sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 202
    globalBackend._backendCap = sandstormBackend;                                                                      // 203
  }                                                                                                                    // 204
                                                                                                                       //
  var debugLog = !backendHealthy;                                                                                      // 206
  backendHealthy = false;                                                                                              // 207
  var promise = sandstormBackend.ping().then(function () {                                                             // 208
    backendHealthy = true;                                                                                             // 209
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(false);                                       // 210
  }, function (err) {                                                                                                  // 211
    console.error("error: Backend ping threw error!", err.stack);                                                      // 212
    // The connection will be remade on the next interval. Note that we do NOT normally observe                        //
    // exceptions being thrown for this problem; we see the connection simply stop responding.                         //
    // So we don't expect this branch to execute in any case.                                                          //
  });                                                                                                                  // 216
                                                                                                                       //
  if (debugLog) {                                                                                                      // 218
    console.log("capnp.js: outer promise:", promise);                                                                  // 219
  }                                                                                                                    // 220
}, 30000);                                                                                                             // 221
                                                                                                                       //
// =======================================================================================                             //
// Meteor context <-> Async Node.js context adapters                                                                   //
// TODO(cleanup):  Move to a different file.                                                                           //
                                                                                                                       //
var inMeteorInternal = Meteor.bindEnvironment(function (callback) {                                                    // 227
  callback();                                                                                                          // 228
});                                                                                                                    // 229
                                                                                                                       //
inMeteor = function inMeteor(callback) {                                                                               // 231
  // Calls the callback in a Meteor context.  Returns a Promise for its result.                                        //
  return new Promise(function (resolve, reject) {                                                                      // 233
    inMeteorInternal(function () {                                                                                     // 234
      try {                                                                                                            // 235
        resolve(callback());                                                                                           // 236
      } catch (err) {                                                                                                  // 237
        reject(err);                                                                                                   // 238
      }                                                                                                                // 239
    });                                                                                                                // 240
  });                                                                                                                  // 241
};                                                                                                                     // 242
                                                                                                                       //
promiseToFuture = function promiseToFuture(promise) {                                                                  // 244
  var result = new Future();                                                                                           // 245
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                           // 246
  return result;                                                                                                       // 247
};                                                                                                                     // 248
                                                                                                                       //
waitPromise = function waitPromise(promise) {                                                                          // 250
  return promiseToFuture(promise).wait();                                                                              // 251
};                                                                                                                     // 252
                                                                                                                       //
// =======================================================================================                             //
// API for creating / starting grains from Meteor methods.                                                             //
                                                                                                                       //
var proxiesByHostId = {};                                                                                              // 257
                                                                                                                       //
Meteor.methods({                                                                                                       // 259
  newGrain: function newGrain(packageId, command, title, identityId) {                                                 // 260
    // Create and start a new grain.                                                                                   //
                                                                                                                       //
    check(packageId, String);                                                                                          // 263
    check(command, Object); // Manifest.Command from package.capnp.                                                    // 264
    check(title, String);                                                                                              // 265
    check(identityId, String);                                                                                         // 266
                                                                                                                       //
    if (!this.userId) {                                                                                                // 268
      throw new Meteor.Error(403, "Unauthorized", "Must be logged in to create grains.");                              // 269
    }                                                                                                                  // 270
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 272
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 273
    }                                                                                                                  // 274
                                                                                                                       //
    if (!isSignedUpOrDemo()) {                                                                                         // 276
      throw new Meteor.Error(403, "Unauthorized", "Only invited users or demo users can create grains.");              // 277
    }                                                                                                                  // 279
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 281
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 282
    }                                                                                                                  // 284
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 286
    var isDev = false;                                                                                                 // 287
    if (!pkg) {                                                                                                        // 288
      // Maybe they wanted a dev package.  Check there too.                                                            //
      pkg = DevPackages.findOne(packageId);                                                                            // 290
      isDev = true;                                                                                                    // 291
    }                                                                                                                  // 292
                                                                                                                       //
    if (!pkg) {                                                                                                        // 294
      throw new Meteor.Error(404, "Not Found", "No such package is installed.");                                       // 295
    }                                                                                                                  // 296
                                                                                                                       //
    var appId = pkg.appId;                                                                                             // 298
    var manifest = pkg.manifest;                                                                                       // 299
    var grainId = Random.id(22); // 128 bits of entropy                                                                // 300
    Grains.insert({                                                                                                    // 301
      _id: grainId,                                                                                                    // 302
      packageId: packageId,                                                                                            // 303
      appId: appId,                                                                                                    // 304
      appVersion: manifest.appVersion,                                                                                 // 305
      userId: this.userId,                                                                                             // 306
      identityId: identityId,                                                                                          // 307
      title: title,                                                                                                    // 308
      "private": true                                                                                                  // 309
    });                                                                                                                // 301
                                                                                                                       //
    globalBackend.startGrainInternal(packageId, grainId, this.userId, command, true, isDev);                           // 312
    globalBackend.updateLastActive(grainId, this.userId, identityId);                                                  // 313
    return grainId;                                                                                                    // 314
  },                                                                                                                   // 315
  openSession: function openSession(grainId, identityId, cachedSalt) {                                                 // 317
    // Open a new UI session on an existing grain.  Starts the grain if it is not already                              //
    // running.                                                                                                        //
                                                                                                                       //
    check(grainId, String);                                                                                            // 321
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 322
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 323
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 325
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 326
    }                                                                                                                  // 327
                                                                                                                       //
    var grain = Grains.findOne({ _id: grainId });                                                                      // 329
    if (!grain) {                                                                                                      // 330
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + grainId);                                          // 331
    } else if (grain.trashed) {                                                                                        // 332
      throw new Meteor.Error("grain-is-in-trash", "Grain is in trash", "Grain ID: " + grainId);                        // 333
    }                                                                                                                  // 334
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 336
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 337
    if (!SandstormPermissions.mayOpenGrain(db, { grain: { _id: grainId, identityId: identityId } })) {                 // 338
      throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                       // 340
    }                                                                                                                  // 341
                                                                                                                       //
    var opened = globalBackend.openSessionInternal(grainId, this.userId, identityId, null, null, cachedSalt);          // 343
    var result = opened.methodResult;                                                                                  // 345
    var proxy = new Proxy(grainId, this.userId, result.sessionId, result.hostId, result.tabId, identityId, false, opened.supervisor);
    proxiesByHostId[result.hostId] = proxy;                                                                            // 348
    return result;                                                                                                     // 349
  },                                                                                                                   // 350
  openSessionFromApiToken: function openSessionFromApiToken(params, identityId, cachedSalt) {                          // 352
    // Given an API token, either opens a new WebSession to the underlying grain or returns a                          //
    // path to which the client should redirect in order to open such a session.                                       //
                                                                                                                       //
    check(params, {                                                                                                    // 356
      token: String,                                                                                                   // 357
      incognito: Boolean                                                                                               // 358
    });                                                                                                                // 356
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 360
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 361
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 363
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 364
    }                                                                                                                  // 365
                                                                                                                       //
    if (!identityId && globalDb.getOrganizationDisallowGuests()) {                                                     // 367
      throw new Meteor.Error("guestDisallowed", "This Sandstorm server does not allow " + "guests or anonymous users");
    }                                                                                                                  // 370
                                                                                                                       //
    var token = params.token;                                                                                          // 372
    var incognito = params.incognito;                                                                                  // 373
    var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                      // 374
    var apiToken = ApiTokens.findOne(hashedToken);                                                                     // 375
    validateWebkey(apiToken);                                                                                          // 376
    var grain = Grains.findOne({ _id: apiToken.grainId });                                                             // 377
    if (!grain) {                                                                                                      // 378
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + apiToken.grainId);                                 // 379
    }                                                                                                                  // 380
                                                                                                                       //
    if (apiToken.accountId) {                                                                                          // 382
      referralProgramLogSharingTokenUse(globalDb, apiToken.accountId);                                                 // 383
    }                                                                                                                  // 384
                                                                                                                       //
    var title = void 0;                                                                                                // 386
    if (grain.userId === apiToken.accountId) {                                                                         // 387
      title = grain.title;                                                                                             // 388
    } else {                                                                                                           // 389
      var sharerToken = apiToken.identityId && ApiTokens.findOne({                                                     // 390
        grainId: apiToken.grainId,                                                                                     // 392
        "owner.user.identityId": apiToken.identityId                                                                   // 393
      }, {                                                                                                             // 391
        sort: {                                                                                                        // 395
          lastUsed: -1                                                                                                 // 396
        }                                                                                                              // 395
      });                                                                                                              // 394
      if (sharerToken) {                                                                                               // 399
        title = sharerToken.owner.user.title;                                                                          // 400
      } else {                                                                                                         // 401
        title = "shared grain";                                                                                        // 402
      }                                                                                                                // 403
    }                                                                                                                  // 404
                                                                                                                       //
    if (this.userId && !incognito) {                                                                                   // 406
      if (identityId != apiToken.identityId && identityId != grain.identityId && !ApiTokens.findOne({ "owner.user.identityId": identityId, parentToken: hashedToken })) {
        var owner = { user: { identityId: identityId, title: title } };                                                // 409
                                                                                                                       //
        // Create a new API token for the identity redeeming this token.                                               //
        var result = SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: token }, apiToken.grainId, apiToken.petname, { allAccess: null }, owner);
        globalDb.addContact(apiToken.accountId, identityId);                                                           // 414
                                                                                                                       //
        // If the parent API token is forSharing and it has an accountId, then the logged-in user (call                //
        // them Bob) is about to access a grain owned by someone (call them Alice) and save a reference                //
        // to it as a new ApiToken. (For share-by-link, this occurs when viewing the grain. For                        //
        // share-by-identity, this happens immediately.)                                                               //
        if (result.parentApiToken) {                                                                                   // 420
          var parentApiToken = result.parentApiToken;                                                                  // 421
          if (parentApiToken.forSharing && parentApiToken.accountId) {                                                 // 422
            storeReferralProgramInfoApiTokenCreated(globalDb, this.userId, owner.user.identityId, parentApiToken.accountId);
          }                                                                                                            // 425
        }                                                                                                              // 426
      }                                                                                                                // 427
                                                                                                                       //
      return { redirectToGrain: apiToken.grainId };                                                                    // 429
    } else {                                                                                                           // 430
      if (!SandstormPermissions.mayOpenGrain(globalDb, { token: apiToken })) {                                         // 431
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 432
      }                                                                                                                // 434
                                                                                                                       //
      var opened = globalBackend.openSessionInternal(apiToken.grainId, null, null, title, apiToken, cachedSalt);       // 436
                                                                                                                       //
      var _result = opened.methodResult;                                                                               // 439
      var proxy = new Proxy(apiToken.grainId, grain.userId, _result.sessionId, _result.hostId, _result.tabId, identityId, false, opened.supervisor);
      proxy.apiToken = apiToken;                                                                                       // 443
      proxiesByHostId[_result.hostId] = proxy;                                                                         // 444
      return _result;                                                                                                  // 445
    }                                                                                                                  // 446
  },                                                                                                                   // 447
  keepSessionAlive: function keepSessionAlive(sessionId) {                                                             // 449
    // TODO(security):  Prevent draining someone else's quota by holding open several grains shared                    //
    //   by them.                                                                                                      //
    check(sessionId, String);                                                                                          // 452
                                                                                                                       //
    var session = Sessions.findAndModify({                                                                             // 454
      query: { _id: sessionId },                                                                                       // 455
      update: { $set: { timestamp: new Date().getTime() } },                                                           // 456
      fields: { grainId: 1, identityId: 1, hostId: 1 }                                                                 // 457
    });                                                                                                                // 454
                                                                                                                       //
    if (session) {                                                                                                     // 460
      // Session still present in database, so send keep-alive to backend.                                             //
      try {                                                                                                            // 462
        var grainId = session.grainId;                                                                                 // 463
        var hostId = session.hostId;                                                                                   // 464
        var supervisor = proxiesByHostId[hostId] && proxiesByHostId[hostId].supervisor;                                // 465
        if (!supervisor) {                                                                                             // 466
          supervisor = globalBackend.continueGrain(grainId).supervisor;                                                // 467
        }                                                                                                              // 468
                                                                                                                       //
        waitPromise(supervisor.keepAlive());                                                                           // 470
        globalBackend.updateLastActive(grainId, this.userId, session.identityId);                                      // 471
      } catch (err) {                                                                                                  // 472
        // Ignore disconnects, which imply that the grain shut down already. It'll start back up on                    //
        // the next request, so whatever.                                                                              //
        if (err.kjType !== "disconnected") {                                                                           // 475
          throw err;                                                                                                   // 476
        }                                                                                                              // 477
      }                                                                                                                // 478
                                                                                                                       //
      return true;                                                                                                     // 480
    } else {                                                                                                           // 481
      return false;                                                                                                    // 482
    }                                                                                                                  // 483
  },                                                                                                                   // 484
  shutdownGrain: function shutdownGrain(grainId) {                                                                     // 486
    check(grainId, String);                                                                                            // 487
    var grain = Grains.findOne(grainId);                                                                               // 488
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 489
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 490
    }                                                                                                                  // 491
                                                                                                                       //
    waitPromise(globalBackend.shutdownGrain(grainId, grain.userId, true));                                             // 493
  }                                                                                                                    // 494
});                                                                                                                    // 259
                                                                                                                       //
var validateWebkey = function validateWebkey(apiToken, refreshedExpiration) {                                          // 497
  // Validates that `apiToken` is a valid UiView webkey, throwing an exception if it is not. If                        //
  // `refreshedExpiration` is set and if the token has an `expiresIfUnused` field, then the                            //
  // `expiresIfUnused` field is reset to `refreshedExpiration`.                                                        //
                                                                                                                       //
  if (!apiToken) {                                                                                                     // 502
    throw new Meteor.Error(403, "Invalid authorization token");                                                        // 503
  }                                                                                                                    // 504
                                                                                                                       //
  if (apiToken.revoked) {                                                                                              // 506
    throw new Meteor.Error(403, "Authorization token has been revoked");                                               // 507
  }                                                                                                                    // 508
                                                                                                                       //
  if (apiToken.owner && !("webkey" in apiToken.owner)) {                                                               // 510
    throw new Meteor.Error(403, "Unauthorized to open non-webkey token.");                                             // 511
  }                                                                                                                    // 512
                                                                                                                       //
  if (apiToken.expires && apiToken.expires.getTime() <= Date.now()) {                                                  // 514
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 515
  }                                                                                                                    // 516
                                                                                                                       //
  if (apiToken.expiresIfUnused) {                                                                                      // 518
    if (apiToken.expiresIfUnused.getTime() <= Date.now()) {                                                            // 519
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 520
    } else if (refreshedExpiration) {                                                                                  // 521
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: refreshedExpiration } });                              // 522
    } else {                                                                                                           // 523
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: null } });                                             // 525
    }                                                                                                                  // 526
  }                                                                                                                    // 527
                                                                                                                       //
  if (apiToken.objectId || apiToken.frontendRef) {                                                                     // 529
    throw new Meteor.Error(403, "ApiToken refers to a non-webview Capability.");                                       // 530
  }                                                                                                                    // 531
};                                                                                                                     // 532
                                                                                                                       //
// Used by shared/grain.js (which sounds like a broken dependency, since this code is only available                   //
// on the server)                                                                                                      //
getGrainSize = function getGrainSize(supervisor, oldSize) {                                                            // 536
  var promise = void 0;                                                                                                // 537
  if (oldSize === undefined) {                                                                                         // 538
    promise = supervisor.getGrainSize();                                                                               // 539
  } else {                                                                                                             // 540
    promise = supervisor.getGrainSizeWhenDifferent(oldSize);                                                           // 541
  }                                                                                                                    // 542
                                                                                                                       //
  var promise2 = promise.then(function (result) {                                                                      // 544
    return parseInt(result.size);                                                                                      // 544
  });                                                                                                                  // 544
  promise2.cancel = function () {                                                                                      // 545
    promise.cancel();                                                                                                  // 545
  };                                                                                                                   // 545
                                                                                                                       //
  return promise2;                                                                                                     // 547
};                                                                                                                     // 548
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 550
  var shutdownApp = function shutdownApp(appId) {                                                                      // 551
    Grains.find({ appId: appId }).forEach(function (grain) {                                                           // 552
      waitPromise(globalBackend.shutdownGrain(grain._id, grain.userId));                                               // 553
    });                                                                                                                // 554
  };                                                                                                                   // 555
                                                                                                                       //
  DevPackages.find().observe({                                                                                         // 557
    removed: function removed(devPackage) {                                                                            // 558
      shutdownApp(devPackage.appId);                                                                                   // 558
    },                                                                                                                 // 558
    changed: function changed(newDevPackage, oldDevPackage) {                                                          // 560
      shutdownApp(oldDevPackage.appId);                                                                                // 561
      if (oldDevPackage.appId !== newDevPackage.appId) {                                                               // 562
        shutdownApp(newDevPackage.appId);                                                                              // 563
      }                                                                                                                // 564
    },                                                                                                                 // 565
    added: function added(devPackage) {                                                                                // 567
      shutdownApp(devPackage.appId);                                                                                   // 567
    }                                                                                                                  // 567
  });                                                                                                                  // 557
                                                                                                                       //
  Sessions.find().observe({                                                                                            // 570
    removed: function removed(session) {                                                                               // 571
      var proxy = proxiesByHostId[session.hostId];                                                                     // 572
      delete proxiesByHostId[session.hostId];                                                                          // 573
      if (proxy) {                                                                                                     // 574
        proxy.close();                                                                                                 // 575
      }                                                                                                                // 576
    }                                                                                                                  // 577
  });                                                                                                                  // 570
});                                                                                                                    // 579
                                                                                                                       //
// Kill off sessions idle for >~3 minutes.                                                                             //
var TIMEOUT_MS = 180000;                                                                                               // 582
var gcSessions = function gcSessions() {                                                                               // 583
  var now = new Date().getTime();                                                                                      // 584
  Sessions.remove({ timestamp: { $lt: now - TIMEOUT_MS } });                                                           // 585
};                                                                                                                     // 586
                                                                                                                       //
SandstormDb.periodicCleanup(TIMEOUT_MS, gcSessions);                                                                   // 588
                                                                                                                       //
var getProxyForHostId = function getProxyForHostId(hostId, isAlreadyOpened) {                                          // 590
  // Get the Proxy corresponding to the given grain session host, possibly (re)creating it if it                       //
  // doesn't already exist. The first request on the session host will always create a new proxy.                      //
  // Later requests may create a proxy if they go to a different front-end replica or if the                           //
  // front-end was restarted.                                                                                          //
  check(hostId, String);                                                                                               // 595
                                                                                                                       //
  return Promise.resolve(undefined).then(function () {                                                                 // 597
    var proxy = proxiesByHostId[hostId];                                                                               // 598
    if (proxy) {                                                                                                       // 599
      return proxy;                                                                                                    // 600
    } else {                                                                                                           // 601
      // Set table entry to null for now so that we can detect if it is concurrently deleted.                          //
      proxiesByHostId[hostId] = null;                                                                                  // 603
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 605
        var session = Sessions.findOne({ hostId: hostId });                                                            // 606
        if (!session) {                                                                                                // 607
          if (isAlreadyOpened) {                                                                                       // 608
            var _ret = function () {                                                                                   // 608
              var observer = void 0;                                                                                   // 609
              return {                                                                                                 // 610
                v: new Promise(function (resolve, reject) {                                                            // 610
                  var task = Meteor.setTimeout(function () {                                                           // 611
                    reject(new Meteor.Error(504, "Requested session that no longer exists, and " + "timed out waiting for client to restore it. This can happen if you have " + "opened an app's content in a new window and then closed it in the " + "UI. If you see this error *inside* the Sandstorm UI, please report a " + "bug and describe the circumstances of the error."));
                  }, SESSION_PROXY_TIMEOUT);                                                                           // 617
                  observer = Sessions.find({ hostId: hostId }).observe({                                               // 618
                    added: function added() {                                                                          // 619
                      Meteor.clearTimeout(task);                                                                       // 620
                      resolve(getProxyForHostId(hostId, false));                                                       // 621
                    }                                                                                                  // 622
                  });                                                                                                  // 618
                }).then(function (v) {                                                                                 // 624
                  observer.stop();                                                                                     // 625
                  return v;                                                                                            // 626
                }, function (e) {                                                                                      // 627
                  observer.stop();                                                                                     // 628
                  throw e;                                                                                             // 629
                })                                                                                                     // 630
              };                                                                                                       // 610
            }();                                                                                                       // 608
                                                                                                                       //
            if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;               // 608
          } else {                                                                                                     // 631
            // Does not appear to be a valid session host.                                                             //
            return undefined;                                                                                          // 633
          }                                                                                                            // 634
        }                                                                                                              // 635
                                                                                                                       //
        var apiToken = void 0;                                                                                         // 637
        if (session.hashedToken) {                                                                                     // 638
          apiToken = ApiTokens.findOne({ _id: session.hashedToken });                                                  // 639
          // We don't have to fully validate the API token here because if it changed the session                      //
          // would have been deleted.                                                                                  //
          if (!apiToken) {                                                                                             // 642
            throw new Meteor.Error(410, "ApiToken has been deleted");                                                  // 643
          }                                                                                                            // 644
        }                                                                                                              // 645
                                                                                                                       //
        var grain = Grains.findOne(session.grainId);                                                                   // 647
        if (!grain) {                                                                                                  // 648
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 650
        }                                                                                                              // 651
                                                                                                                       //
        // Note that we don't need to call mayOpenGrain() because the existence of a session                           //
        // implies this check was already performed.                                                                   //
                                                                                                                       //
        var proxy = new Proxy(grain._id, grain.userId, session._id, hostId, session.tabId, session.identityId, false);
        if (apiToken) proxy.apiToken = apiToken;                                                                       // 658
                                                                                                                       //
        // Only add the proxy to the table if it was not concurrently deleted (which could happen                      //
        // e.g. if the user's access was revoked).                                                                     //
        if (hostId in proxiesByHostId) {                                                                               // 662
          proxiesByHostId[hostId] = proxy;                                                                             // 663
        } else {                                                                                                       // 664
          throw new Meteor.Error(403, "Session was concurrently closed.");                                             // 665
        }                                                                                                              // 666
                                                                                                                       //
        return proxy;                                                                                                  // 668
      });                                                                                                              // 669
    }                                                                                                                  // 670
  });                                                                                                                  // 671
};                                                                                                                     // 672
                                                                                                                       //
// =======================================================================================                             //
// API tokens                                                                                                          //
                                                                                                                       //
var ApiSessionProxies = function () {                                                                                  //
  // Class that caches proxies for requests that come in through HTTP API endpoints. Such                              //
  // requests are not associated with any entry in the `Sessions` collection, so we need                               //
  // some other means of detecting unused proxies and closing them. This class works by keeping                        //
  // the proxies in two buckets. When a proxy is used, it is put in the new bucket. Periodically,                      //
  // the old bucket is emptied and the contents of new bucket are moved to the old bucket.                             //
  //                                                                                                                   //
  // Each bucket is a two-level map, keyed by hashes of the tokens and their `ApiSession.Params`                       //
  // structs.                                                                                                          //
                                                                                                                       //
  function ApiSessionProxies(intervalMillis) {                                                                         // 687
    var _this3 = this;                                                                                                 // 687
                                                                                                                       //
    _classCallCheck(this, ApiSessionProxies);                                                                          // 687
                                                                                                                       //
    check(intervalMillis, Number);                                                                                     // 688
    this.newBucket = {};                                                                                               // 689
    this.oldBucket = {};                                                                                               // 690
    this.interval = Meteor.setInterval(function () {                                                                   // 691
      for (var oldHashedToken in _this3.oldBucket) {                                                                   // 692
        for (var oldHashedParams in _this3.oldBucket[oldHashedToken]) {                                                // 693
          var newProxy = _this3.newBucket[oldHashedToken] && _this3.newBucket[oldHashedToken][oldHashedParams];        // 694
          var oldProxy = _this3.oldBucket[oldHashedToken][oldHashedParams];                                            // 696
          if (oldProxy && !newProxy) {                                                                                 // 697
            if (Object.keys(oldProxy.websockets).length > 0) {                                                         // 698
              // A client has an open websocket. Keep the proxy around.                                                //
              _this3.put(oldHashedToken, oldHashedParams, oldProxy);                                                   // 700
            } else {                                                                                                   // 701
              // We can close this proxy and forget about it.                                                          //
              oldProxy.close();                                                                                        // 703
            }                                                                                                          // 704
          }                                                                                                            // 705
        }                                                                                                              // 706
      }                                                                                                                // 707
                                                                                                                       //
      _this3.oldBucket = _this3.newBucket;                                                                             // 709
      _this3.newBucket = {};                                                                                           // 710
    }, intervalMillis);                                                                                                // 711
  }                                                                                                                    // 712
                                                                                                                       //
  ApiSessionProxies.prototype.get = function get(hashedToken, hashedParams) {                                          //
    if (this.newBucket[hashedToken] && this.newBucket[hashedToken][hashedParams]) {                                    // 715
      return this.newBucket[hashedToken][hashedParams];                                                                // 716
    } else if (this.oldBucket[hashedToken] && this.oldBucket[hashedToken][hashedParams]) {                             // 717
      var proxy = this.oldBucket[hashedToken][hashedParams];                                                           // 718
      delete this.oldBucket[hashedToken][hashedParams];                                                                // 719
      this.put(hashedToken, hashedParams, proxy);                                                                      // 720
      return proxy;                                                                                                    // 721
    } else {                                                                                                           // 722
      return null;                                                                                                     // 723
    }                                                                                                                  // 724
  };                                                                                                                   // 725
                                                                                                                       //
  ApiSessionProxies.prototype.put = function put(hashedToken, hashedParams, proxy) {                                   //
    if (!this.newBucket[hashedToken]) {                                                                                // 728
      this.newBucket[hashedToken] = {};                                                                                // 729
    }                                                                                                                  // 730
                                                                                                                       //
    this.newBucket[hashedToken][hashedParams] = proxy;                                                                 // 732
  };                                                                                                                   // 733
                                                                                                                       //
  ApiSessionProxies.prototype.removeProxiesOfToken = function removeProxiesOfToken(hashedToken) {                      //
    if (hashedToken in this.oldBucket) {                                                                               // 736
      for (var hashedParams in this.oldBucket[hashedToken]) {                                                          // 737
        this.oldBucket[hashedToken][hashedParams].close();                                                             // 738
      }                                                                                                                // 739
                                                                                                                       //
      delete this.oldBucket[hashedToken];                                                                              // 741
    }                                                                                                                  // 742
                                                                                                                       //
    if (hashedToken in this.newBucket) {                                                                               // 744
      for (var _hashedParams in this.newBucket[hashedToken]) {                                                         // 745
        this.newBucket[hashedToken][_hashedParams].close();                                                            // 746
      }                                                                                                                // 747
                                                                                                                       //
      delete this.newBucket[hashedToken];                                                                              // 749
    }                                                                                                                  // 750
  };                                                                                                                   // 751
                                                                                                                       //
  return ApiSessionProxies;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var apiSessionProxies = new ApiSessionProxies(3 * 60 * 1000);                                                          // 754
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 756
  Grains.find().observe({                                                                                              // 757
    changed: function changed(newGrain, oldGrain) {                                                                    // 758
      if (oldGrain["private"] != newGrain["private"]) {                                                                // 759
        Sessions.remove({ grainId: oldGrain._id, identityId: { $ne: oldGrain.identityId } });                          // 760
        ApiTokens.find({ grainId: oldGrain._id }).forEach(function (apiToken) {                                        // 761
          apiSessionProxies.removeProxiesOfToken(apiToken._id);                                                        // 762
        });                                                                                                            // 763
      }                                                                                                                // 764
    }                                                                                                                  // 765
  });                                                                                                                  // 757
});                                                                                                                    // 767
                                                                                                                       //
function getApiSessionParams(request) {                                                                                // 769
  var params = {};                                                                                                     // 770
  if ("x-sandstorm-passthrough" in request.headers) {                                                                  // 771
    var optIns = request.headers["x-sandstorm-passthrough"].split(",").map(function (s) {                              // 772
      return s.trim();                                                                                                 // 774
    });                                                                                                                // 774
    // The only currently supported passthrough value is 'address', but others could be useful in                      //
    // the future.                                                                                                     //
                                                                                                                       //
    if (optIns.indexOf("address") !== -1) {                                                                            // 778
      // Sadly, we can't use request.socket.remoteFamily because it's not available in the                             //
      // (rather-old) version of node that comes in the Meteor bundle we're using. Hence this                          //
      // hackery.                                                                                                      //
      var addressToPass = request.socket.remoteAddress;                                                                // 782
      if (isRfc1918OrLocal(addressToPass) && "x-real-ip" in request.headers) {                                         // 783
        // Allow overriding the socket's remote address with X-Real-IP header if the request comes                     //
        // from either localhost or an RFC1918 address. These are not useful for geolocation anyway.                   //
        addressToPass = request.headers["x-real-ip"];                                                                  // 786
      }                                                                                                                // 787
                                                                                                                       //
      if (Net.isIPv4(addressToPass)) {                                                                                 // 789
        // Map IPv4 addresses in IPv6.                                                                                 //
        // This conveniently comes out to a 48-bit number, which is precisely representable in a                       //
        // double (which has 53 mantissa bits). Thus we can avoid using Bignum/strings, which we                       //
        // might otherwise need to precisely represent 64-bit fields.                                                  //
        var v4Int = 0xFFFF00000000 + addressToPass.split(".").map(function (x) {                                       // 794
          return parseInt(x, 10);                                                                                      // 795
        }).reduce(function (a, b) {                                                                                    // 795
          return 256 * a + b;                                                                                          // 796
        });                                                                                                            // 796
        params.remoteAddress = {                                                                                       // 797
          lower64: v4Int,                                                                                              // 798
          upper64: 0                                                                                                   // 799
        };                                                                                                             // 797
      } else if (Net.isIPv6(addressToPass)) {                                                                          // 801
        // TODO(test): Unit test this                                                                                  //
        // Parse a valid v6 address.                                                                                   //
        // Split into groups, then insert an appropriate number of 0's if :: was used.                                 //
        var groups = addressToPass.split(":");                                                                         // 805
                                                                                                                       //
        // Strip extra empty group in the case of a leading or trailing '::'.                                          //
        if (groups[0] === "") {                                                                                        // 808
          groups.shift();                                                                                              // 809
        }                                                                                                              // 810
                                                                                                                       //
        if (groups[groups.length - 1] === "") {                                                                        // 812
          groups.pop();                                                                                                // 813
        }                                                                                                              // 814
                                                                                                                       //
        var lastGroup = groups[groups.length - 1];                                                                     // 816
        // Handle IPv4-mapped IPv6 addresses.  These end in a dotted-quad IPv4 address, which we                       //
        // should expand into two groups of 4-character hex strings, like the rest of the address.                     //
        if (Net.isIPv4(lastGroup)) {                                                                                   // 819
          groups.pop();                                                                                                // 820
          var quad = lastGroup.split(".").map(function (x) {                                                           // 821
            return parseInt(x, 10);                                                                                    // 821
          });                                                                                                          // 821
          groups.push((quad[0] * 256 + quad[1]).toString(16));                                                         // 822
          groups.push((quad[2] * 256 + quad[3]).toString(16));                                                         // 823
        }                                                                                                              // 824
                                                                                                                       //
        var groupsToAdd = 8 - groups.length;                                                                           // 826
        var emptyGroupIndex = groups.indexOf("");                                                                      // 827
        var cleanGroups = void 0;                                                                                      // 828
        if (emptyGroupIndex !== -1) {                                                                                  // 829
          var head = groups.slice(0, emptyGroupIndex);                                                                 // 830
          // groupsToAdd + 1 because we sliced out the empty element                                                   //
          var mid = Array(groupsToAdd + 1);                                                                            // 832
          for (var i = 0; i < groupsToAdd + 1; i++) {                                                                  // 833
            mid[i] = "0";                                                                                              // 834
          }                                                                                                            // 835
                                                                                                                       //
          var tail = groups.slice(emptyGroupIndex + 1, groups.length);                                                 // 837
          cleanGroups = [].concat(head, mid, tail);                                                                    // 838
        } else {                                                                                                       // 839
          cleanGroups = groups;                                                                                        // 840
        }                                                                                                              // 841
                                                                                                                       //
        var ints = cleanGroups.map(function (x) {                                                                      // 843
          return parseInt(x, 16);                                                                                      // 843
        });                                                                                                            // 843
        // We use strings because we'd lose data from loss of precision casting the 64-bit uints                       //
        // into 53-bit-mantissa doubles.                                                                               //
        params.remoteAddress = {                                                                                       // 846
          upper64: quadToIntString(ints.slice(0, 4)),                                                                  // 847
          lower64: quadToIntString(ints.slice(4, 8))                                                                   // 848
        };                                                                                                             // 846
      }                                                                                                                // 850
    }                                                                                                                  // 851
  }                                                                                                                    // 852
                                                                                                                       //
  return Capnp.serialize(ApiSession.Params, params);                                                                   // 854
}                                                                                                                      // 855
                                                                                                                       //
// Used by server/drivers/external-ui/view.js                                                                          //
getProxyForApiToken = function getProxyForApiToken(token, request) {                                                   // 858
  check(token, String);                                                                                                // 859
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 860
  var tabId = Crypto.createHash("sha256").update("tab:").update(hashedToken).digest("hex").slice(0, 32);               // 861
  var serializedParams = getApiSessionParams(request);                                                                 // 863
  var hashedParams = Crypto.createHash("sha256").update(serializedParams).digest("base64");                            // 864
  return Promise.resolve(undefined).then(function () {                                                                 // 865
    var proxy = apiSessionProxies.get(hashedToken, hashedParams);                                                      // 866
    if (proxy) {                                                                                                       // 867
      if (proxy.expires && proxy.expires.getTime() <= Date.now()) {                                                    // 868
        throw new Meteor.Error(403, "Authorization token expired");                                                    // 869
      }                                                                                                                // 870
                                                                                                                       //
      return proxy;                                                                                                    // 872
    } else {                                                                                                           // 873
      return inMeteor(function () {                                                                                    // 874
        var tokenInfo = ApiTokens.findOne(hashedToken);                                                                // 875
        validateWebkey(tokenInfo);                                                                                     // 876
                                                                                                                       //
        var grain = Grains.findOne(tokenInfo.grainId);                                                                 // 878
        if (!grain) {                                                                                                  // 879
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 881
        }                                                                                                              // 882
                                                                                                                       //
        var proxy = void 0;                                                                                            // 884
        if (tokenInfo.userInfo) {                                                                                      // 885
          throw new Error("API tokens created with arbitrary userInfo no longer supported");                           // 886
        } else {                                                                                                       // 887
          var identityId = null;                                                                                       // 888
          if (tokenInfo.identityId && !tokenInfo.forSharing) {                                                         // 889
            identityId = tokenInfo.identityId;                                                                         // 890
          }                                                                                                            // 891
                                                                                                                       //
          proxy = new Proxy(tokenInfo.grainId, grain.userId, null, null, tabId, identityId, true);                     // 893
          proxy.apiToken = tokenInfo;                                                                                  // 894
          proxy.apiSessionParams = serializedParams;                                                                   // 895
        }                                                                                                              // 896
                                                                                                                       //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: tokenInfo })) {                                      // 898
          // Note that only public grains may be opened without a user ID.                                             //
          throw new Meteor.Error(403, "Unauthorized.");                                                                // 900
        }                                                                                                              // 901
                                                                                                                       //
        if (tokenInfo.expires) {                                                                                       // 903
          proxy.expires = tokenInfo.expires;                                                                           // 904
        }                                                                                                              // 905
                                                                                                                       //
        apiSessionProxies.put(hashedToken, hashedParams, proxy);                                                       // 907
                                                                                                                       //
        return proxy;                                                                                                  // 909
      });                                                                                                              // 910
    }                                                                                                                  // 911
  });                                                                                                                  // 912
};                                                                                                                     // 913
                                                                                                                       //
var apiUseBasicAuth = function apiUseBasicAuth(req, hostId) {                                                          // 915
  // If the request was to a token-specific host *and* the request has no Origin header (meaning                       //
  // it is not an XHR from a web site), then we permit the use of HTTP basic auth. The reason we                       //
  // prohibit XHRs is because we want to discourage people from using basic auth in a browser,                         //
  // because the browser will cache the credentials, which exposes the hostname to XSRF attack                         //
  // (which is mostly, but not completely, mitigated by the unguessable hostname). The reason we                       //
  // want to allow basic auth at all is because a lot of existing client apps support only basic                       //
  // auth. New clients and web-based clients should use `Authorization: bearer <token>` instead.                       //
  if (globalDb.isTokenSpecificHostId(hostId) && !req.headers.origin) {                                                 // 923
    return true;                                                                                                       // 924
  }                                                                                                                    // 925
                                                                                                                       //
  // Historically, all API tokens were served from the same host rather than have token-specific                       //
  // hosts. In this model, basic auth in browsers was far more dangerous since the hostname was                        //
  // not a secret -- in fact, even benign attempts to use two APIs on the same server from the same                    //
  // browser could interfere if using basic auth. Hence, basic auth was prohibited except when                         //
  // coming from certain whitelisted clients known not to be browsers, e.g. Mirall, the ownCloud                       //
  // client app.                                                                                                       //
  //                                                                                                                   //
  // Since many clients in the wild have already been configured to use the shared API host, we                        //
  // must continue to support them, so this logic remains.                                                             //
  var agent = req.headers["user-agent"];                                                                               // 936
  return agent.match(BASIC_AUTH_USER_AGENTS_REGEX);                                                                    // 937
};                                                                                                                     // 938
                                                                                                                       //
var apiTokenForRequest = function apiTokenForRequest(req, hostId) {                                                    // 940
  // Extract the API token from the request.                                                                           //
                                                                                                                       //
  var auth = req.headers.authorization;                                                                                // 943
  var token = void 0;                                                                                                  // 944
  if (auth && auth.slice(0, 7).toLowerCase() === "bearer ") {                                                          // 945
    token = auth.slice(7).trim();                                                                                      // 946
  } else if (auth && auth.slice(0, 6).toLowerCase() === "basic " && apiUseBasicAuth(req, hostId)) {                    // 947
    token = new Buffer(auth.slice(6).trim(), "base64").toString().split(":")[1];                                       // 949
  } else if (hostId !== "api" && req.url.startsWith("/.sandstorm-token/")) {                                           // 950
    // Disallow clients that use the old "api" hostId from using tokens in the path.                                   //
    // Allowing them would be a security problem in browsers that ignore CSP.                                          //
    var parts = req.url.slice(1).split("/"); // remove leading / and split                                             // 953
    if (parts.length < 2) {                                                                                            // 954
      token = undefined;                                                                                               // 955
    } else {                                                                                                           // 956
      token = parts[1];                                                                                                // 957
      req.url = "/" + parts.slice(2).join("/");                                                                        // 958
      // remove .sandstorm-api-token/$TOKEN from path                                                                  //
    }                                                                                                                  // 960
  } else {                                                                                                             // 961
      token = undefined;                                                                                               // 962
    }                                                                                                                  // 963
                                                                                                                       //
  if (token && hostId !== "api") {                                                                                     // 965
    // Verify that the token matches the specific host.                                                                //
    if (hostId !== globalDb.apiHostIdForToken(token)) {                                                                // 967
      token = undefined;                                                                                               // 968
    }                                                                                                                  // 969
  }                                                                                                                    // 970
                                                                                                                       //
  return token;                                                                                                        // 972
};                                                                                                                     // 973
                                                                                                                       //
// =======================================================================================                             //
// Routing to proxies.                                                                                                 //
//                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyUpgrade = function tryProxyUpgrade(hostId, req, socket, head) {                                                // 980
  // Attempt to handle a WebSocket upgrade by dispatching it to a grain. Returns a promise that                        //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  if (globalDb.isApiHostId(hostId)) {                                                                                  // 986
    var token = apiTokenForRequest(req, hostId);                                                                       // 987
    if (token) {                                                                                                       // 988
      return getProxyForApiToken(token, req).then(function (proxy) {                                                   // 989
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 992
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 994
        return true;                                                                                                   // 995
      });                                                                                                              // 996
    } else {                                                                                                           // 997
      return Promise.resolve(false);                                                                                   // 998
    }                                                                                                                  // 999
  } else {                                                                                                             // 1000
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1001
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1002
      if (proxy) {                                                                                                     // 1003
        // Cross-origin requests are not allowed on UI session hosts.                                                  //
        var origin = req.headers.origin;                                                                               // 1005
        if (origin !== PROTOCOL + "//" + req.headers.host) {                                                           // 1006
          throw new Meteor.Error(403, "Detected illegal cross-origin WebSocket from: " + origin);                      // 1007
        }                                                                                                              // 1008
                                                                                                                       //
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 1012
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 1014
        return true;                                                                                                   // 1015
      } else {                                                                                                         // 1016
        return false;                                                                                                  // 1017
      }                                                                                                                // 1018
    });                                                                                                                // 1019
  }                                                                                                                    // 1020
};                                                                                                                     // 1021
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyRequest = function tryProxyRequest(hostId, req, res) {                                                         // 1024
  // Attempt to handle an HTTP request by dispatching it to a grain. Returns a promise that                            //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  var hostIdHash = globalDb.isApiHostId(hostId);                                                                       // 1030
  if (hostIdHash) {                                                                                                    // 1031
    var _ret2 = function () {                                                                                          // 1031
      // This is a request for the API host.                                                                           //
                                                                                                                       //
      res.setHeader("Access-Control-Allow-Origin", "*");                                                               // 1034
                                                                                                                       //
      if (req.method === "OPTIONS") {                                                                                  // 1036
        // Reply to CORS preflight request.                                                                            //
                                                                                                                       //
        // All we want to do is permit APIs to be accessed from arbitrary origins. Since clients                       //
        // must send a valid Authorization header, and since cookies are not used for                                  //
        // authorization, this is perfectly safe. In a sane world, we would only need to send back                     //
        // 'Access-Control-Allow-Origin: *' and be done with it.                                                       //
        //                                                                                                             //
        // However, CORS demands that we explicitly whitelist individual methods and headers for                       //
        // use cross-origin, as if this is somehow useful for implementing any practical security                      //
        // policy (it isn't). To make matters worse, we are REQUIRED to enumerate each one                             //
        // individually. We cannot just write '*' for these lists. WTF, CORS?                                          //
        //                                                                                                             //
        // Luckily, the request tells us exactly what method and headers are being requested, so we                    //
        // only need to copy those over, rather than create an exhaustive list. But this is still                      //
        // overly complicated.                                                                                         //
                                                                                                                       //
        var accessControlHeaders = {                                                                                   // 1053
          "Access-Control-Allow-Methods": "GET, HEAD, POST, PUT, PATCH, DELETE",                                       // 1054
          "Access-Control-Max-Age": "3600"                                                                             // 1055
        };                                                                                                             // 1053
                                                                                                                       //
        // Copy all requested headers to the allowed headers list.                                                     //
        var requestedHeaders = req.headers["access-control-request-headers"];                                          // 1059
        if (requestedHeaders) {                                                                                        // 1060
          accessControlHeaders["Access-Control-Allow-Headers"] = requestedHeaders;                                     // 1061
        }                                                                                                              // 1062
                                                                                                                       //
        // Add the requested method to the allowed methods list, if it's not there already.                            //
        var requestedMethod = req.headers["access-control-request-method"];                                            // 1065
        if (requestedMethod && !_.contains(["GET", "HEAD", "POST", "PUT", "PATCH", "DELETE"], requestedMethod)) {      // 1066
          accessControlHeaders["Access-Control-Allow-Methods"] += ", " + requestedMethod;                              // 1068
        }                                                                                                              // 1069
                                                                                                                       //
        for (header in accessControlHeaders) {                                                                         // 1071
          res.setHeader(header, accessControlHeaders[header]);                                                         // 1072
        }                                                                                                              // 1073
      }                                                                                                                // 1074
                                                                                                                       //
      var errorHandler = function errorHandler(err) {                                                                  // 1076
        if (err instanceof Meteor.Error) {                                                                             // 1077
          console.log("error: " + err);                                                                                // 1078
          res.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                                      // 1079
        } else {                                                                                                       // 1080
          res.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                               // 1081
        }                                                                                                              // 1082
                                                                                                                       //
        res.end(err.stack);                                                                                            // 1084
      };                                                                                                               // 1085
                                                                                                                       //
      var token = apiTokenForRequest(req, hostId);                                                                     // 1087
      if (token && req.headers["x-sandstorm-token-keepalive"]) {                                                       // 1088
        inMeteor(function () {                                                                                         // 1089
          var keepaliveDuration = parseInt(req.headers["x-sandstorm-token-keepalive"]);                                // 1090
          check(keepaliveDuration, Match.Integer);                                                                     // 1091
          var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                // 1092
          validateWebkey(ApiTokens.findOne(hashedToken), new Date(Date.now() + keepaliveDuration));                    // 1093
        }).then(function () {                                                                                          // 1094
          res.writeHead(200, {});                                                                                      // 1095
          res.end();                                                                                                   // 1096
        }, errorHandler);                                                                                              // 1097
      } else if (token) {                                                                                              // 1098
        getProxyForApiToken(token, req).then(function (proxy) {                                                        // 1099
          proxy.requestHandler(req, res);                                                                              // 1100
        }, errorHandler);                                                                                              // 1101
      } else {                                                                                                         // 1102
        // No token. Look up static API host info.                                                                     //
        inMeteor(function () {                                                                                         // 1104
          var apiHost = globalDb.collections.apiHosts.findOne(hostIdHash);                                             // 1105
                                                                                                                       //
          if (req.method === "OPTIONS") {                                                                              // 1107
            // OPTIONS request with no authorization token.                                                            //
                                                                                                                       //
            var dav = ((apiHost || {}).options || {}).dav || [];                                                       // 1110
            if (dav.length > 0) {                                                                                      // 1111
              res.setHeader("DAV", dav.join(", "));                                                                    // 1112
              res.setHeader("Access-Control-Expose-Headers", "DAV");                                                   // 1113
            }                                                                                                          // 1114
                                                                                                                       //
            res.writeHead(200, {});                                                                                    // 1116
            res.end();                                                                                                 // 1117
          } else {                                                                                                     // 1118
            var resources = (apiHost || {}).resources || {};                                                           // 1119
            var path = SandstormDb.escapeMongoKey(req.url.split("?")[0]);                                              // 1120
            if (path in resources) {                                                                                   // 1121
              // Serve a static resource.                                                                              //
              var resource = resources[path];                                                                          // 1123
              console.log(path, resources, resource);                                                                  // 1124
              if (resource.language) res.setHeader("Content-Language", resource.language);                             // 1125
              if (resource.encoding) res.setHeader("Content-Encoding", resource.encoding);                             // 1126
              res.writeHead(200, {                                                                                     // 1127
                "Content-Type": resource.type                                                                          // 1128
              });                                                                                                      // 1127
              res.end(resource.body);                                                                                  // 1130
            } else {                                                                                                   // 1131
              if (apiUseBasicAuth(req, hostId)) {                                                                      // 1132
                res.writeHead(401, {                                                                                   // 1133
                  "Content-Type": "text/plain",                                                                        // 1134
                  "WWW-Authenticate": "Basic realm='Sandstorm API'"                                                    // 1135
                });                                                                                                    // 1133
              } else {                                                                                                 // 1137
                // TODO(someday): Display some sort of nifty API browser.                                              //
                res.writeHead(403, { "Content-Type": "text/plain" });                                                  // 1139
              }                                                                                                        // 1140
                                                                                                                       //
              res.end("Missing or invalid authorization header.\n\n" + "This address serves APIs, which allow external apps (such as a phone app) to\n" + "access data on your Sandstorm server. This address is not meant to be opened\n" + "in a regular browser.");
            }                                                                                                          // 1146
          }                                                                                                            // 1147
        }).then(function () {}, errorHandler);                                                                         // 1148
      }                                                                                                                // 1149
                                                                                                                       //
      return {                                                                                                         // 1151
        v: Promise.resolve(true)                                                                                       // 1151
      };                                                                                                               // 1151
    }();                                                                                                               // 1031
                                                                                                                       //
    if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                    // 1031
  } else {                                                                                                             // 1152
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1153
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1154
      if (proxy) {                                                                                                     // 1155
        proxy.requestHandler(req, res);                                                                                // 1156
        return true;                                                                                                   // 1157
      } else {                                                                                                         // 1158
        return false;                                                                                                  // 1159
      }                                                                                                                // 1160
    });                                                                                                                // 1161
  }                                                                                                                    // 1162
};                                                                                                                     // 1163
                                                                                                                       //
// =======================================================================================                             //
// Proxy class                                                                                                         //
//                                                                                                                     //
// Connects to a grain and exports it on a wildcard host.                                                              //
//                                                                                                                     //
                                                                                                                       //
var Proxy = function () {                                                                                              //
  function Proxy(grainId, ownerId, sessionId, hostId, tabId, identityId, isApi, supervisor) {                          // 1172
    var _this4 = this;                                                                                                 // 1172
                                                                                                                       //
    _classCallCheck(this, Proxy);                                                                                      // 1172
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 1173
    this.ownerId = ownerId;                                                                                            // 1174
    this.identityId = identityId;                                                                                      // 1175
    this.supervisor = supervisor; // note: optional parameter; we can reconnect                                        // 1176
    this.sessionId = sessionId;                                                                                        // 1177
    this.tabId = tabId;                                                                                                // 1178
    this.isApi = isApi;                                                                                                // 1179
    this.hasLoaded = false;                                                                                            // 1180
    this.websockets = {};                                                                                              // 1181
    this.websocketCounter = 0; // Used for generating unique socket IDs.                                               // 1182
    if (sessionId) {                                                                                                   // 1183
      if (!hostId) throw new Error("sessionId must come with hostId");                                                 // 1184
      if (isApi) throw new Error("API proxy shouldn't have sessionId");                                                // 1185
      this.hostId = hostId;                                                                                            // 1186
    } else {                                                                                                           // 1187
      if (!isApi) throw new Error("non-API proxy requires sessionId");                                                 // 1188
      if (hostId) throw new Error("API proxy sholudn't have hostId");                                                  // 1189
    }                                                                                                                  // 1190
                                                                                                                       //
    if (this.identityId) {                                                                                             // 1192
      var identity = globalDb.getIdentity(this.identityId);                                                            // 1193
      if (!identity) {                                                                                                 // 1194
        throw new Error("identity not found: " + this.identityId);                                                     // 1195
      }                                                                                                                // 1196
                                                                                                                       //
      // The identity cap becomes invalid if the user no longer has access to the grain.                               //
      var idCapRequirement = {                                                                                         // 1199
        permissionsHeld: { identityId: identity._id, grainId: this.grainId }                                           // 1200
      };                                                                                                               // 1199
                                                                                                                       //
      this.userInfo = {                                                                                                // 1203
        displayName: { defaultText: identity.profile.name },                                                           // 1204
        preferredHandle: identity.profile.handle,                                                                      // 1205
        identityId: new Buffer(identity._id, "hex"),                                                                   // 1206
        identity: makeIdentity(identity._id, [idCapRequirement])                                                       // 1207
      };                                                                                                               // 1203
      if (identity.profile.pictureUrl) {                                                                               // 1209
        this.userInfo.pictureUrl = identity.profile.pictureUrl;                                                        // 1210
      } else {                                                                                                         // 1211
        this.userInfo.pictureUrl = PROTOCOL + "//" + makeWildcardHost("static") + "/identicon/" + this.identityId.slice(0, 32) + "?s=128";
      }                                                                                                                // 1215
                                                                                                                       //
      if (identity.profile.pronoun) this.userInfo.pronouns = identity.profile.pronoun;                                 // 1217
    } else {                                                                                                           // 1218
      this.userInfo = {                                                                                                // 1219
        displayName: { defaultText: "Anonymous User" },                                                                // 1220
        preferredHandle: "anonymous"                                                                                   // 1221
      };                                                                                                               // 1219
    }                                                                                                                  // 1223
                                                                                                                       //
    this.requestHandler = function (request, response) {                                                               // 1225
      if (_this4.sessionId) {                                                                                          // 1226
        // Implement /_sandstorm-init for setting the session cookie.                                                  //
        var url = Url.parse(request.url, true);                                                                        // 1228
        if (url.pathname === "/_sandstorm-init" && url.query.sessionid === _this4.sessionId) {                         // 1229
          _this4.doSessionInit(request, response, url.query.path);                                                     // 1230
          return;                                                                                                      // 1231
        }                                                                                                              // 1232
      }                                                                                                                // 1233
                                                                                                                       //
      Promise.resolve(undefined).then(function () {                                                                    // 1235
        var contentLength = request.headers["content-length"];                                                         // 1236
        if ((request.method === "POST" || request.method === "PUT") && (contentLength === undefined || contentLength > 1024 * 1024)) {
          // The input is either very long, or we don't know how long it is, so use streaming mode.                    //
          return _this4.handleRequestStreaming(request, response, contentLength, 0);                                   // 1240
        } else {                                                                                                       // 1241
          return readAll(request).then(function (data) {                                                               // 1242
            return _this4.handleRequest(request, data, response, 0);                                                   // 1243
          });                                                                                                          // 1244
        }                                                                                                              // 1245
      })["catch"](function (err) {                                                                                     // 1246
        _this4.setHasLoaded();                                                                                         // 1247
                                                                                                                       //
        var body = err.stack;                                                                                          // 1249
        if (err.cppFile) {                                                                                             // 1250
          body += "\nC++ location:" + err.cppFile + ":" + (err.line || "??");                                          // 1251
        }                                                                                                              // 1252
                                                                                                                       //
        if (err.kjType) {                                                                                              // 1254
          body += "\ntype: " + err.kjType;                                                                             // 1255
        }                                                                                                              // 1256
                                                                                                                       //
        if (response.headersSent) {                                                                                    // 1258
          // Unfortunately, it's too late to tell the client what happened.                                            //
          console.error("HTTP request failed after response already sent:", body);                                     // 1260
          response.end();                                                                                              // 1261
        } else {                                                                                                       // 1262
          if (err instanceof Meteor.Error) {                                                                           // 1263
            response.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                               // 1264
          } else {                                                                                                     // 1265
            response.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                        // 1266
          }                                                                                                            // 1267
                                                                                                                       //
          response.end(body);                                                                                          // 1269
        }                                                                                                              // 1270
      });                                                                                                              // 1271
    };                                                                                                                 // 1272
                                                                                                                       //
    this.upgradeHandler = function (request, socket, head) {                                                           // 1274
      _this4.handleWebSocket(request, socket, head, 0)["catch"](function (err) {                                       // 1275
        console.error("WebSocket setup failed:", err.stack);                                                           // 1276
        // TODO(cleanup):  Manually send back a 500 response?                                                          //
        socket.destroy();                                                                                              // 1278
      });                                                                                                              // 1279
    };                                                                                                                 // 1280
  }                                                                                                                    // 1281
                                                                                                                       //
  Proxy.prototype.close = function close() {                                                                           //
    for (var socketIdx in this.websockets) {                                                                           // 1284
      this.websockets[socketIdx].destroy();                                                                            // 1285
    };                                                                                                                 // 1286
                                                                                                                       //
    this.websockets = {};                                                                                              // 1288
                                                                                                                       //
    if (this.session) {                                                                                                // 1290
      this.session.close();                                                                                            // 1291
      delete this.session;                                                                                             // 1292
    }                                                                                                                  // 1293
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1295
      this.uiView.close();                                                                                             // 1296
      delete this.uiView;                                                                                              // 1297
    }                                                                                                                  // 1298
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1300
      this.supervisor.close();                                                                                         // 1301
      delete this.supervisor;                                                                                          // 1302
    }                                                                                                                  // 1303
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1305
      this.permissionsObserver.stop();                                                                                 // 1306
      delete this.permissionsObserver;                                                                                 // 1307
    }                                                                                                                  // 1308
  };                                                                                                                   // 1309
                                                                                                                       //
  Proxy.prototype.getConnection = function getConnection() {                                                           //
    if (!this.supervisor) {                                                                                            // 1312
      this.supervisor = globalBackend.cap().getGrain(this.ownerId, this.grainId).supervisor;                           // 1313
      this.uiView = null;                                                                                              // 1314
    }                                                                                                                  // 1315
                                                                                                                       //
    if (!this.uiView) {                                                                                                // 1317
      this.uiView = this.supervisor.getMainView().view;                                                                // 1318
    }                                                                                                                  // 1319
  };                                                                                                                   // 1320
                                                                                                                       //
  Proxy.prototype._callNewWebSession = function _callNewWebSession(request, userInfo) {                                //
    var params = Capnp.serialize(WebSession.Params, {                                                                  // 1323
      basePath: PROTOCOL + "//" + request.headers.host,                                                                // 1324
      userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",                 // 1325
      acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
        return s.trim();                                                                                               // 1329
      }) : ["en-US", "en"]                                                                                             // 1329
    });                                                                                                                // 1323
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, new Buffer(this.tabId, "hex")).session;
  };                                                                                                                   // 1335
                                                                                                                       //
  Proxy.prototype._callNewApiSession = function _callNewApiSession(request, userInfo) {                                //
    var _this5 = this;                                                                                                 // 1337
                                                                                                                       //
    var serializedParams = this.apiSessionParams;                                                                      // 1338
    if (!serializedParams) {                                                                                           // 1339
      throw new Meteor.Error(500, "Should have already computed apiSessionParams.");                                   // 1340
    }                                                                                                                  // 1341
                                                                                                                       //
    // TODO(someday): We are currently falling back to WebSession if we get any kind of error upon                     //
    // calling newSession with an ApiSession._id.                                                                      //
    // Eventually we'll remove this logic once we're sure apps have updated.                                           //
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), ApiSession.typeId, serializedParams, new Buffer(this.tabId, "hex")).then(function (session) {
      return session.session;                                                                                          // 1350
    }, function (err) {                                                                                                // 1351
      return _this5._callNewWebSession(request, userInfo);                                                             // 1352
    });                                                                                                                // 1353
  };                                                                                                                   // 1354
                                                                                                                       //
  Proxy.prototype._callNewSession = function _callNewSession(request, viewInfo) {                                      //
    var _this6 = this;                                                                                                 // 1356
                                                                                                                       //
    var userInfo = _.clone(this.userInfo);                                                                             // 1357
    var promise = inMeteor(function () {                                                                               // 1358
      var vertex = void 0;                                                                                             // 1359
      if (_this6.apiToken) {                                                                                           // 1360
        vertex = { token: _this6.apiToken };                                                                           // 1361
      } else {                                                                                                         // 1362
        // (this.identityId might be null; this is fine)                                                               //
        vertex = { grain: { _id: _this6.grainId, identityId: _this6.identityId } };                                    // 1364
      }                                                                                                                // 1365
                                                                                                                       //
      var onInvalidated = function onInvalidated() {                                                                   // 1367
        Sessions.remove({ _id: _this6.sessionId });                                                                    // 1368
      };                                                                                                               // 1369
                                                                                                                       //
      if (!_this6.sessionId) {                                                                                         // 1371
        onInvalidated = function onInvalidated() {                                                                     // 1372
          apiSessionProxies.removeProxiesOfToken(_this6.apiToken._id);                                                 // 1373
        };                                                                                                             // 1374
      }                                                                                                                // 1375
                                                                                                                       //
      var permissions = SandstormPermissions.grainPermissions(globalDb, vertex, viewInfo, onInvalidated);              // 1377
                                                                                                                       //
      if (_this6.permissionsObserver) _this6.permissionsObserver.stop();                                               // 1380
      _this6.permissionsObserver = permissions.observeHandle;                                                          // 1381
                                                                                                                       //
      if (!permissions.permissions) {                                                                                  // 1383
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 1384
      }                                                                                                                // 1385
                                                                                                                       //
      Sessions.update({                                                                                                // 1387
        _id: _this6.sessionId                                                                                          // 1388
      }, {                                                                                                             // 1387
        $set: {                                                                                                        // 1390
          viewInfo: viewInfo,                                                                                          // 1391
          permissions: permissions.permissions                                                                         // 1392
        }                                                                                                              // 1390
      });                                                                                                              // 1389
                                                                                                                       //
      return permissions.permissions;                                                                                  // 1396
    });                                                                                                                // 1397
                                                                                                                       //
    return promise.then(function (permissions) {                                                                       // 1399
      userInfo.permissions = permissions;                                                                              // 1400
                                                                                                                       //
      var numBytes = Math.ceil(permissions.length / 8);                                                                // 1402
      var buf = new Buffer(numBytes);                                                                                  // 1403
      for (var ii = 0; ii < numBytes; ++ii) {                                                                          // 1404
        buf[ii] = 0;                                                                                                   // 1405
      }                                                                                                                // 1406
                                                                                                                       //
      for (var _ii = 0; _ii < permissions.length; ++_ii) {                                                             // 1408
        var byteNum = Math.floor(_ii / 8);                                                                             // 1409
        var bitNum = _ii % 8;                                                                                          // 1410
        if (permissions[_ii]) {                                                                                        // 1411
          buf[byteNum] = buf[byteNum] | 1 << bitNum;                                                                   // 1412
        }                                                                                                              // 1413
      }                                                                                                                // 1414
                                                                                                                       //
      userInfo.deprecatedPermissionsBlob = buf;                                                                        // 1416
                                                                                                                       //
      if (_this6.isApi) {                                                                                              // 1418
        return _this6._callNewApiSession(request, userInfo);                                                           // 1419
      } else {                                                                                                         // 1420
        return _this6._callNewWebSession(request, userInfo);                                                           // 1421
      }                                                                                                                // 1422
    });                                                                                                                // 1423
  };                                                                                                                   // 1424
                                                                                                                       //
  Proxy.prototype.getSession = function getSession(request) {                                                          //
    var _this7 = this;                                                                                                 // 1426
                                                                                                                       //
    if (!this.session) {                                                                                               // 1427
      this.getConnection(); // make sure we're connected                                                               // 1428
      var promise = this.uiView.getViewInfo().then(function (viewInfo) {                                               // 1429
        return inMeteor(function () {                                                                                  // 1430
          // For now, we don't allow grains to set `appTitle` or `grainIcon`.                                          //
          var cachedViewInfo = _.omit(viewInfo, "appTitle", "grainIcon");                                              // 1432
          Grains.update(_this7.grainId, { $set: { cachedViewInfo: cachedViewInfo } });                                 // 1433
        }).then(function () {                                                                                          // 1434
          return _this7._callNewSession(request, viewInfo);                                                            // 1435
        });                                                                                                            // 1436
      }, function (error) {                                                                                            // 1437
        if (error.kjType === "failed" || error.kjType === "unimplemented") {                                           // 1438
          // Method not implemented.                                                                                   //
          // TODO(apibump): Don't treat 'failed' as 'unimplemented'. Unfortunately, old apps built                     //
          //   with old versions of Cap'n Proto don't throw 'unimplemented' exceptions, so we have                     //
          //   to accept 'failed' here at least until the next API bump.                                               //
          return _this7._callNewSession(request, {});                                                                  // 1443
        } else {                                                                                                       // 1444
          return Promise.reject(error);                                                                                // 1445
        }                                                                                                              // 1446
      });                                                                                                              // 1447
      this.session = new Capnp.Capability(promise, WebSession);                                                        // 1448
    }                                                                                                                  // 1449
                                                                                                                       //
    return this.session;                                                                                               // 1451
  };                                                                                                                   // 1452
                                                                                                                       //
  Proxy.prototype.keepAlive = function keepAlive() {                                                                   //
    this.getConnection();                                                                                              // 1455
    return this.supervisor.keepAlive();                                                                                // 1456
  };                                                                                                                   // 1457
                                                                                                                       //
  Proxy.prototype.resetConnection = function resetConnection() {                                                       //
    if (this.session) {                                                                                                // 1460
      this.session.close();                                                                                            // 1461
      delete this.session;                                                                                             // 1462
    }                                                                                                                  // 1463
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1465
      this.uiView.close();                                                                                             // 1466
      delete this.uiView;                                                                                              // 1467
    }                                                                                                                  // 1468
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1470
      this.supervisor.close();                                                                                         // 1471
      delete this.supervisor;                                                                                          // 1472
    }                                                                                                                  // 1473
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1475
      this.permissionsObserver.stop();                                                                                 // 1476
      delete this.permissionsObserver;                                                                                 // 1477
    }                                                                                                                  // 1478
  };                                                                                                                   // 1479
                                                                                                                       //
  Proxy.prototype.maybeRetryAfterError = function maybeRetryAfterError(error, retryCount) {                            //
    var _this8 = this;                                                                                                 // 1481
                                                                                                                       //
    // If the error may be caused by the grain dying or a network failure, try to restart it,                          //
    // returning a promise that resolves once restarted. Otherwise, just rethrow the error.                            //
    // `retryCount` should be incremented for every successful retry as part of the same request;                      //
    // we only want to retry once.                                                                                     //
    if (SandstormBackend.shouldRestartGrain(error, retryCount)) {                                                      // 1486
      this.resetConnection();                                                                                          // 1487
      return inMeteor(function () {                                                                                    // 1488
        _this8.supervisor = globalBackend.continueGrain(_this8.grainId).supervisor;                                    // 1489
      });                                                                                                              // 1490
    } else {                                                                                                           // 1491
      throw error;                                                                                                     // 1492
    }                                                                                                                  // 1493
  };                                                                                                                   // 1494
                                                                                                                       //
  Proxy.prototype.doSessionInit = function doSessionInit(request, response, requestPath) {                             //
    // jscs:disable disallowQuotedKeysInObjects                                                                        //
    var path = requestPath || "/";                                                                                     // 1498
                                                                                                                       //
    // Check that the path is relative (ie. starts with a /).                                                          //
    // Also ensure that it doesn't start with 2 /, because that is interpreted as non-relative                         //
    if (path.lastIndexOf("/", 0) !== 0 || path.lastIndexOf("//", 0) === 0) {                                           // 1502
      response.writeHead(400, "Invalid path supplied", { "Content-Type": "text/plain" });                              // 1503
      response.end("Invalid path supplied.");                                                                          // 1504
      return;                                                                                                          // 1505
    }                                                                                                                  // 1506
                                                                                                                       //
    // Set the session ID.                                                                                             //
    response.setHeader("Set-Cookie", ["sandstorm-sid=", this.sessionId, "; Max-Age=31536000; HttpOnly"].join(""));     // 1509
                                                                                                                       //
    response.setHeader("Cache-Control", "no-cache, private");                                                          // 1511
                                                                                                                       //
    // Redirect to the app's root URL.                                                                                 //
    // Note:  All browsers support relative locations and the next update to HTTP/1.1 will officially                  //
    //   make them valid.  http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-26#page-67                       //
    response.writeHead(303, "See Other", { "Location": encodeURI(path) });                                             // 1516
    response.end();                                                                                                    // 1517
  };                                                                                                                   // 1518
                                                                                                                       //
  Proxy.prototype.makeContext = function makeContext(request, response, callback) {                                    //
    // Parses the cookies from the request, checks that the session ID is present and valid, then                      //
    // synchronously calls callback() passing it the request context object which contains the                         //
    // other cookies. Throws an exception if the session ID is missing or invalid. The callback                        //
    // must immediately use the context in an RPC. Once the callback returns, the context object                       //
    // will be torn down.                                                                                              //
    //                                                                                                                 //
    // `makeContext()` returns the result of `callback()`.                                                             //
                                                                                                                       //
    var context = {};                                                                                                  // 1529
                                                                                                                       //
    if (this.hostId) {                                                                                                 // 1531
      var parseResult = parseCookies(request);                                                                         // 1532
      if (!parseResult.sessionId || parseResult.sessionId !== this.sessionId) {                                        // 1533
        throw new Meteor.Error(403, "Unauthorized");                                                                   // 1534
      }                                                                                                                // 1535
                                                                                                                       //
      if (parseResult.cookies.length > 0) {                                                                            // 1537
        context.cookies = parseResult.cookies;                                                                         // 1538
      }                                                                                                                // 1539
    } else {                                                                                                           // 1540
      // jscs:disable disallowEmptyBlocks                                                                              //
      // This is an API request. Cookies are not supported.                                                            //
    }                                                                                                                  // 1543
                                                                                                                       //
    context.accept = parseAcceptHeader(request);                                                                       // 1545
                                                                                                                       //
    context.eTagPrecondition = parsePreconditionHeader(request);                                                       // 1547
                                                                                                                       //
    context.additionalHeaders = [];                                                                                    // 1549
    for (var headerName in request.headers) {                                                                          // 1550
      if (REQUEST_HEADER_WHITELIST.matches(headerName)) {                                                              // 1551
        context.additionalHeaders.push({                                                                               // 1552
          name: headerName,                                                                                            // 1553
          value: request.headers[headerName]                                                                           // 1554
        });                                                                                                            // 1552
      }                                                                                                                // 1556
    }                                                                                                                  // 1557
                                                                                                                       //
    if (response) {                                                                                                    // 1559
      var promise = new Promise(function (resolve, reject) {                                                           // 1560
        response.resolveResponseStream = resolve;                                                                      // 1561
        response.rejectResponseStream = reject;                                                                        // 1562
      });                                                                                                              // 1563
                                                                                                                       //
      context.responseStream = new Capnp.Capability(promise, ByteStream);                                              // 1565
                                                                                                                       //
      try {                                                                                                            // 1567
        return callback(context);                                                                                      // 1568
      } finally {                                                                                                      // 1569
        context.responseStream.close();                                                                                // 1570
      }                                                                                                                // 1571
    } else {                                                                                                           // 1572
      // WebSocket -- no response object.                                                                              //
      return callback(context);                                                                                        // 1574
    }                                                                                                                  // 1575
  };                                                                                                                   // 1576
                                                                                                                       //
  Proxy.prototype.translateResponse = function translateResponse(rpcResponse, response, request) {                     //
    if (this.hostId) {                                                                                                 // 1579
      if (rpcResponse.setCookies && rpcResponse.setCookies.length > 0) {                                               // 1580
        response.setHeader("Set-Cookie", rpcResponse.setCookies.map(makeSetCookieHeader));                             // 1581
      }                                                                                                                // 1582
                                                                                                                       //
      // TODO(security): Add a Content-Security-Policy header which:                                                   //
      // (1) Prevents the app from initiating HTTP requests to third parties.                                          //
      // (2) Prevents the app from navigating the parent frame.                                                        //
      // (3) Prevents the app from opening popups.                                                                     //
      // (4) Prohibits anyone other than the Sandstorm shell from framing the app (as a backup                         //
      //   defense vs. clickjacking, though unguessable hostnames already mostly prevent this).                        //
    } else {                                                                                                           // 1590
        // This is an API request. Cookies are not supported.                                                          //
                                                                                                                       //
        // We need to make sure caches know that different bearer tokens get totally different results.                //
        response.setHeader("Vary", "Authorization");                                                                   // 1594
                                                                                                                       //
        // APIs can be called from any origin. Because we ignore cookies, there is no security problem.                //
        response.setHeader("Access-Control-Allow-Origin", "*");                                                        // 1597
                                                                                                                       //
        // Add a Content-Security-Policy as a backup in case someone finds a way to load this resource                 //
        // in a browser context. This policy should thoroughly neuter it.                                              //
        response.setHeader("Content-Security-Policy", "default-src 'none'; sandbox");                                  // 1601
      }                                                                                                                // 1602
                                                                                                                       //
    if (rpcResponse.additionalHeaders && rpcResponse.additionalHeaders.length > 0) {                                   // 1604
      // Add any additional prefixed/whitelisted headers to the response.                                              //
      // We cannot trust that the headers in the RPC response are actually                                             //
      // allowed, so we check if they are prefixed or whitelisted.                                                     //
      rpcResponse.additionalHeaders.forEach(function (header) {                                                        // 1608
        if (RESPONSE_HEADER_WHITELIST.matches(header.name)) {                                                          // 1609
          // If header is prefixed with appHeaderPrefix,                                                               //
          // or if the header name is in whitelist, set it.                                                            //
          response.setHeader(header.name, header.value);                                                               // 1612
        }                                                                                                              // 1613
      });                                                                                                              // 1614
    }                                                                                                                  // 1615
                                                                                                                       //
    // On first response, update the session to have hasLoaded=true                                                    //
    this.setHasLoaded();                                                                                               // 1618
                                                                                                                       //
    // TODO(security): Set X-Content-Type-Options: nosniff?                                                            //
                                                                                                                       //
    if ("content" in rpcResponse) {                                                                                    // 1622
      var content = rpcResponse.content;                                                                               // 1623
      var code = successCodes[content.statusCode];                                                                     // 1624
      if (!code) {                                                                                                     // 1625
        throw new Error("Unknown status code: ", content.statusCode);                                                  // 1626
      }                                                                                                                // 1627
                                                                                                                       //
      if (content.mimeType) {                                                                                          // 1629
        response.setHeader("Content-Type", content.mimeType);                                                          // 1630
      }                                                                                                                // 1631
                                                                                                                       //
      if (content.encoding) {                                                                                          // 1633
        response.setHeader("Content-Encoding", content.encoding);                                                      // 1634
      }                                                                                                                // 1635
                                                                                                                       //
      if (content.language) {                                                                                          // 1637
        response.setHeader("Content-Language", content.language);                                                      // 1638
      }                                                                                                                // 1639
                                                                                                                       //
      if (content.eTag) {                                                                                              // 1641
        response.setHeader("ETag", composeETag(content.eTag));                                                         // 1642
      }                                                                                                                // 1643
                                                                                                                       //
      if ("disposition" in content && "download" in content.disposition) {                                             // 1645
        response.setHeader("Content-Disposition", 'attachment; filename="' + content.disposition.download.replace(/([\\"\n])/g, "\\$1") + '"');
      }                                                                                                                // 1648
                                                                                                                       //
      if ("stream" in content.body) {                                                                                  // 1650
        if (request.method === "HEAD") {                                                                               // 1651
          content.body.stream.close();                                                                                 // 1652
          response.rejectResponseStream(new Error("HEAD request; content doesn't matter."));                           // 1653
        } else {                                                                                                       // 1654
          var streamHandle = content.body.stream;                                                                      // 1655
          var responseStream = new Capnp.Capability(new ResponseStream(response, code.id, code.title, streamHandle), ByteStream);
          response.resolveResponseStream(responseStream);                                                              // 1659
          return { streamHandle: responseStream };                                                                     // 1660
        }                                                                                                              // 1661
      } else {                                                                                                         // 1662
        response.rejectResponseStream(new Error("Response content body was not a stream."));                           // 1663
                                                                                                                       //
        if ("bytes" in content.body) {                                                                                 // 1666
          response.setHeader("Content-Length", content.body.bytes.length);                                             // 1667
        } else {                                                                                                       // 1668
          throw new Error("Unknown content body type.");                                                               // 1669
        }                                                                                                              // 1670
      }                                                                                                                // 1671
                                                                                                                       //
      response.writeHead(code.id, code.title);                                                                         // 1673
                                                                                                                       //
      if ("bytes" in content.body && request.method !== "HEAD") {                                                      // 1675
        response.write(content.body.bytes);                                                                            // 1676
      }                                                                                                                // 1677
                                                                                                                       //
      response.end();                                                                                                  // 1679
    } else if ("noContent" in rpcResponse) {                                                                           // 1680
      var noContent = rpcResponse.noContent;                                                                           // 1681
      var noContentCode = noContentSuccessCodes[noContent.shouldResetForm * 1];                                        // 1682
      if (noContent.eTag) {                                                                                            // 1683
        response.setHeader("ETag", composeETag(noContent.eTag));                                                       // 1684
      }                                                                                                                // 1685
                                                                                                                       //
      response.writeHead(noContentCode.id, noContentCode.title);                                                       // 1687
      response.end();                                                                                                  // 1688
    } else if ("preconditionFailed" in rpcResponse) {                                                                  // 1689
      var preconditionFailed = rpcResponse.preconditionFailed;                                                         // 1690
      if (request.method === "GET" && "if-none-match" in request.headers) {                                            // 1691
        if (preconditionFailed.matchingETag) {                                                                         // 1692
          response.setHeader("ETag", composeETag(preconditionFailed.matchingETag));                                    // 1693
        }                                                                                                              // 1694
                                                                                                                       //
        response.writeHead(304, "Not Modified");                                                                       // 1696
      } else {                                                                                                         // 1697
        response.writeHead(412, "Precondition Failed");                                                                // 1698
      }                                                                                                                // 1699
                                                                                                                       //
      response.end();                                                                                                  // 1701
    } else if ("redirect" in rpcResponse) {                                                                            // 1702
      var redirect = rpcResponse.redirect;                                                                             // 1703
      var redirectCode = redirectCodes[redirect.switchToGet * 2 + redirect.isPermanent];                               // 1704
      response.writeHead(redirectCode.id, redirectCode.title, {                                                        // 1705
        "Location": redirect.location                                                                                  // 1706
      });                                                                                                              // 1705
      response.end();                                                                                                  // 1708
    } else if ("clientError" in rpcResponse) {                                                                         // 1709
      var clientError = rpcResponse.clientError;                                                                       // 1710
      var errorCode = errorCodes[clientError.statusCode];                                                              // 1711
      if (!errorCode) {                                                                                                // 1712
        throw new Error("Unknown status code: ", clientError.statusCode);                                              // 1713
      }                                                                                                                // 1714
                                                                                                                       //
      response.writeHead(errorCode.id, errorCode.title, {                                                              // 1716
        "Content-Type": "text/html"                                                                                    // 1717
      });                                                                                                              // 1716
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1720
        if (clientError.descriptionHtml) {                                                                             // 1721
          response.write(clientError.descriptionHtml);                                                                 // 1722
        } else {                                                                                                       // 1723
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>" + errorCode.id + ": " + errorCode.title + "</h1></body></html>");          // 1725
        }                                                                                                              // 1727
      }                                                                                                                // 1728
                                                                                                                       //
      response.end();                                                                                                  // 1730
    } else if ("serverError" in rpcResponse) {                                                                         // 1731
      response.writeHead(500, "Internal Server Error", {                                                               // 1732
        "Content-Type": "text/html"                                                                                    // 1733
      });                                                                                                              // 1732
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1736
        if (rpcResponse.serverError.descriptionHtml) {                                                                 // 1737
          response.write(rpcResponse.serverError.descriptionHtml);                                                     // 1738
        } else {                                                                                                       // 1739
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>500: Internal Server Error</h1></body></html>");                             // 1741
        }                                                                                                              // 1742
      }                                                                                                                // 1743
                                                                                                                       //
      response.end();                                                                                                  // 1745
    } else {                                                                                                           // 1746
      throw new Error("Unknown HTTP response type:\n" + JSON.stringify(rpcResponse));                                  // 1747
    }                                                                                                                  // 1748
                                                                                                                       //
    return {};                                                                                                         // 1750
  };                                                                                                                   // 1751
                                                                                                                       //
  Proxy.prototype.handleRequest = function handleRequest(request, data, response, retryCount) {                        //
    var _this9 = this;                                                                                                 // 1753
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 1754
      return _this9.makeContext(request, response, function (context) {                                                // 1755
        // jscs:disable requireDotNotation                                                                             //
        // Send the RPC.                                                                                               //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1758
        var session = _this9.getSession(request);                                                                      // 1759
                                                                                                                       //
        var requestContent = function requestContent() {                                                               // 1761
          return {                                                                                                     // 1762
            content: data,                                                                                             // 1763
            encoding: request.headers["content-encoding"],                                                             // 1764
            mimeType: request.headers["content-type"]                                                                  // 1765
          };                                                                                                           // 1762
        };                                                                                                             // 1767
                                                                                                                       //
        var xmlContent = function xmlContent() {                                                                       // 1769
          var type = request.headers["content-type"] || "application/xml;charset=utf-8";                               // 1770
          var match = type.match(/[^/]*\/xml(; *charset *= *([^ ;]*))?/);                                              // 1771
          if (!match) {                                                                                                // 1772
            response.writeHead(415, "Unsupported media type.", {                                                       // 1773
              "Content-Type": "text/plain"                                                                             // 1774
            });                                                                                                        // 1773
            response.end("expected XML request body");                                                                 // 1776
            throw new Error("expected XML request body");                                                              // 1777
          }                                                                                                            // 1778
                                                                                                                       //
          var charset = match[2] || "ISO-8859-1";                                                                      // 1780
                                                                                                                       //
          var encoding = request.headers["content-encoding"];                                                          // 1782
          if (encoding && encoding !== "identity") {                                                                   // 1783
            if (encoding !== "gzip") throw new Error("unknown Content-Encoding: " + encoding);                         // 1784
            data = gunzipSync(data);                                                                                   // 1785
          }                                                                                                            // 1786
                                                                                                                       //
          return data.toString(charset.toLowerCase() === "utf-8" ? "utf8" : "binary");                                 // 1788
        };                                                                                                             // 1789
                                                                                                                       //
        var propfindDepth = function propfindDepth() {                                                                 // 1791
          var depth = request.headers["depth"];                                                                        // 1792
          return depth === "0" ? "zero" : depth === "1" ? "one" : "infinity";                                          // 1793
        };                                                                                                             // 1796
                                                                                                                       //
        var shallow = function shallow() {                                                                             // 1798
          return request.headers["depth"] === "0";                                                                     // 1799
        };                                                                                                             // 1800
                                                                                                                       //
        var noOverwrite = function noOverwrite() {                                                                     // 1802
          return (request.headers["overwrite"] || "").toLowerCase() === "f";                                           // 1803
        };                                                                                                             // 1804
                                                                                                                       //
        var destination = function destination() {                                                                     // 1806
          var result = request.headers["destination"];                                                                 // 1807
          if (!result) throw new Error("missing destination");                                                         // 1808
          return Url.parse(result).path.slice(1); // remove leading '/'                                                // 1809
        };                                                                                                             // 1810
                                                                                                                       //
        if (request.method === "GET" || request.method === "HEAD") {                                                   // 1812
          return session.get(path, context, request.method === "HEAD");                                                // 1813
        } else if (request.method === "POST") {                                                                        // 1814
          return session.post(path, requestContent(), context);                                                        // 1815
        } else if (request.method === "PUT") {                                                                         // 1816
          return session.put(path, requestContent(), context);                                                         // 1817
        } else if (request.method === "PATCH") {                                                                       // 1818
          return session.patch(path, requestContent(), context);                                                       // 1819
        } else if (request.method === "DELETE") {                                                                      // 1820
          return session["delete"](path, context);                                                                     // 1821
        } else if (request.method === "PROPFIND") {                                                                    // 1822
          return session.propfind(path, xmlContent(), propfindDepth(), context);                                       // 1823
        } else if (request.method === "PROPPATCH") {                                                                   // 1824
          return session.proppatch(path, xmlContent(), context);                                                       // 1825
        } else if (request.method === "MKCOL") {                                                                       // 1826
          return session.mkcol(path, requestContent(), context);                                                       // 1827
        } else if (request.method === "COPY") {                                                                        // 1828
          return session.copy(path, destination(), noOverwrite(), shallow(), context);                                 // 1829
        } else if (request.method === "MOVE") {                                                                        // 1830
          return session.move(path, destination(), noOverwrite(), context);                                            // 1831
        } else if (request.method === "LOCK") {                                                                        // 1832
          return session.lock(path, xmlContent(), shallow(), context);                                                 // 1833
        } else if (request.method === "UNLOCK") {                                                                      // 1834
          return session.unlock(path, request.headers["lock-token"], context);                                         // 1835
        } else if (request.method === "ACL") {                                                                         // 1836
          return session.acl(path, xmlContent(), context);                                                             // 1837
        } else if (request.method === "REPORT") {                                                                      // 1838
          return session.report(path, requestContent(), context);                                                      // 1839
        } else if (request.method === "OPTIONS") {                                                                     // 1840
          return session.options(path, context).then(function (options) {                                              // 1841
            var dav = [];                                                                                              // 1842
            if (options.davClass1) dav.push("1");                                                                      // 1843
            if (options.davClass2) dav.push("2");                                                                      // 1844
            if (options.davClass3) dav.push("3");                                                                      // 1845
            if (options.davExtensions) {                                                                               // 1846
              options.davExtensions.forEach(function (token) {                                                         // 1847
                if (token.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+|<[\x21-\x7E]*>)$/)) {                                   // 1848
                  dav.push(token);                                                                                     // 1849
                }                                                                                                      // 1850
              });                                                                                                      // 1851
            }                                                                                                          // 1852
                                                                                                                       //
            if (dav.length > 0) {                                                                                      // 1854
              response.setHeader("DAV", dav.join(", "));                                                               // 1855
              response.setHeader("Access-Control-Expose-Headers", "DAV");                                              // 1856
            }                                                                                                          // 1857
                                                                                                                       //
            response.end();                                                                                            // 1859
            // Return no response; we already handled everything.                                                      //
          }, function (err) {                                                                                          // 1861
            if (err.kjType !== "unimplemented") throw err;                                                             // 1862
            response.end();                                                                                            // 1863
            // Return no response; we already handled everything.                                                      //
          });                                                                                                          // 1865
        } else {                                                                                                       // 1866
            throw new Error("Sandstorm only supports the following methods: GET, POST, PUT, PATCH, DELETE, HEAD, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK, ACL, REPORT, and OPTIONS.");
          }                                                                                                            // 1868
      });                                                                                                              // 1869
    }).then(function (rpcResponse) {                                                                                   // 1870
      if (rpcResponse !== undefined) {                                                                                 // 1871
        // Will be undefined for OPTIONS request.                                                                      //
        return _this9.translateResponse(rpcResponse, response, request);                                               // 1872
      }                                                                                                                // 1873
    })["catch"](function (error) {                                                                                     // 1874
      return _this9.maybeRetryAfterError(error, retryCount).then(function () {                                         // 1875
        return _this9.handleRequest(request, data, response, retryCount + 1);                                          // 1876
      });                                                                                                              // 1877
    });                                                                                                                // 1878
  };                                                                                                                   // 1879
                                                                                                                       //
  Proxy.prototype.handleRequestStreaming = function handleRequestStreaming(request, response, contentLength, retryCount) {
    var _this10 = this;                                                                                                // 1881
                                                                                                                       //
    return this.makeContext(request, response, function (context) {                                                    // 1882
      var path = request.url.slice(1); // remove leading '/'                                                           // 1883
      var session = _this10.getSession(request);                                                                       // 1884
                                                                                                                       //
      var mimeType = request.headers["content-type"] || "application/octet-stream";                                    // 1886
      var encoding = request.headers["content-encoding"];                                                              // 1887
                                                                                                                       //
      var requestStreamPromise = void 0;                                                                               // 1889
      if (request.method === "POST") {                                                                                 // 1890
        requestStreamPromise = session.postStreaming(path, mimeType, context, encoding);                               // 1891
      } else if (request.method === "PUT") {                                                                           // 1892
        requestStreamPromise = session.putStreaming(path, mimeType, context, encoding);                                // 1893
      } else {                                                                                                         // 1894
        throw new Error("Sandstorm only supports streaming POST and PUT requests.");                                   // 1895
      }                                                                                                                // 1896
                                                                                                                       //
      // TODO(perf): We ought to be pipelining the body, but we can't currently, because we have to                    //
      //   handle the case where the app doesn't actually support streaming. We could pipeline while                   //
      //   also buffering the data on the side in case we need it again later, but that's kind of                      //
      //   complicated. We should fix the whole protocol to make streaming the standard.                               //
      return requestStreamPromise.then(function (requestStreamResult) {                                                // 1902
        var requestStream = requestStreamResult.stream;                                                                // 1903
                                                                                                                       //
        // Initialized when getResponse() returns, if the response is streaming.                                       //
        var downloadStreamHandle = void 0;                                                                             // 1906
                                                                                                                       //
        // Initialized if an upload-stream method throws.                                                              //
        var uploadStreamError = void 0;                                                                                // 1909
                                                                                                                       //
        // We call `getResponse()` immediately so that the app can start streaming data down even                      //
        // while data is still being streamed up. This theoretically allows apps to perform                            //
        // bidirectional streaming, though probably very few actually do that.                                         //
        //                                                                                                             //
        // Note that we need to be able to cancel `responsePromise` below, so it's important that                      //
        // it is the raw Cap'n Proto promise. Hence `translateResponsePromise` is a separate                           //
        // variable.                                                                                                   //
        var responsePromise = requestStream.getResponse();                                                             // 1918
                                                                                                                       //
        var reportUploadStreamError = function reportUploadStreamError(err) {                                          // 1920
          // Called when an upload-stream method throws.                                                               //
                                                                                                                       //
          if (!uploadStreamError) {                                                                                    // 1923
            uploadStreamError = err;                                                                                   // 1924
                                                                                                                       //
            // If we're still waiting on any response stuff, cancel it.                                                //
            responsePromise.cancel();                                                                                  // 1927
            requestStream.close();                                                                                     // 1928
            if (downloadStreamHandle) {                                                                                // 1929
              downloadStreamHandle.close();                                                                            // 1930
            }                                                                                                          // 1931
          }                                                                                                            // 1932
        };                                                                                                             // 1933
                                                                                                                       //
        // If we have a Content-Length, pass it along to the app by calling `expectSize()`.                            //
        if (contentLength !== undefined) {                                                                             // 1936
          requestStream.expectSize(contentLength)["catch"](function (err) {                                            // 1937
            // expectSize() is allowed to be unimplemented.                                                            //
            if (err.kjType !== "unimplemented") {                                                                      // 1939
              reportUploadStreamError(err);                                                                            // 1940
            }                                                                                                          // 1941
          });                                                                                                          // 1942
        }                                                                                                              // 1943
                                                                                                                       //
        // Pipe the input stream to the app.                                                                           //
        var writesInFlight = 0;                                                                                        // 1946
        var readingPaused = false;                                                                                     // 1947
        request.on("data", function (buf) {                                                                            // 1948
          // TODO(someday): Coalesce small writes.                                                                     //
          if (!uploadStreamError) {                                                                                    // 1950
            requestStream.write(buf).then(function () {                                                                // 1951
              writesInFlight--;                                                                                        // 1952
              if (readingPaused) {                                                                                     // 1953
                request.resume();                                                                                      // 1954
                readingPaused = false;                                                                                 // 1955
              }                                                                                                        // 1956
            })["catch"](reportUploadStreamError);                                                                      // 1957
                                                                                                                       //
            if (writesInFlight++ > 16) {                                                                               // 1959
              request.pause();                                                                                         // 1960
              readingPaused = true;                                                                                    // 1961
            }                                                                                                          // 1962
          }                                                                                                            // 1963
        });                                                                                                            // 1964
                                                                                                                       //
        request.on("end", function () {                                                                                // 1966
          if (!uploadStreamError) requestStream.done()["catch"](reportUploadStreamError);                              // 1967
                                                                                                                       //
          // We're all done making calls to requestStream.                                                             //
          requestStream.close();                                                                                       // 1970
        });                                                                                                            // 1971
                                                                                                                       //
        request.on("close", function () {                                                                              // 1973
          reportUploadStreamError(new Error("HTTP connection unexpectedly closed during request."));                   // 1974
        });                                                                                                            // 1975
                                                                                                                       //
        request.on("error", function (err) {                                                                           // 1977
          reportUploadStreamError(err);                                                                                // 1978
        });                                                                                                            // 1979
                                                                                                                       //
        return responsePromise.then(function (rpcResponse) {                                                           // 1981
          // Stop here if the upload stream has already failed.                                                        //
          if (uploadStreamError) throw uploadStreamError;                                                              // 1983
          downloadStreamHandle = _this10.translateResponse(rpcResponse, response, request).streamHandle;               // 1984
        });                                                                                                            // 1985
      }, function (err) {                                                                                              // 1986
        if (err.kjType === "failed" && err.message.indexOf("not implemented") !== -1) {                                // 1987
          // Hack to work around old apps using an old version of Cap'n Proto, before the                              //
          // 'unimplemented' exception type was introduced. :(                                                         //
          // TODO(cleanup): When we transition to API version 2, we can move this into the                             //
          //   compatibility layer.                                                                                    //
          err.kjType = "unimplemented";                                                                                // 1992
        }                                                                                                              // 1993
                                                                                                                       //
        if (SandstormBackend.shouldRestartGrain(err, 0)) {                                                             // 1995
          // This is the kind of error that indicates we should retry. Note that we passed 0 for                       //
          // the retry count above because we were just checking if this is a retriable error (vs.                     //
          // possibly a method-not-implemented error); maybeRetryAfterError() will check again with                    //
          // the proper retry count.                                                                                   //
          return _this10.maybeRetryAfterError(err, retryCount).then(function () {                                      // 2000
            return _this10.handleRequestStreaming(request, response, contentLength, retryCount + 1);                   // 2001
          });                                                                                                          // 2002
        } else if (err.kjType === "unimplemented") {                                                                   // 2003
          // Streaming is not implemented. Fall back to non-streaming version.                                         //
          return readAll(request).then(function (data) {                                                               // 2005
            return _this10.handleRequest(request, data, response, 0);                                                  // 2006
          });                                                                                                          // 2007
        } else {                                                                                                       // 2008
          throw err;                                                                                                   // 2009
        }                                                                                                              // 2010
      });                                                                                                              // 2011
    });                                                                                                                // 2012
  };                                                                                                                   // 2013
                                                                                                                       //
  Proxy.prototype.handleWebSocket = function handleWebSocket(request, socket, head, retryCount) {                      //
    var _this11 = this;                                                                                                // 2015
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 2016
      return _this11.makeContext(request, undefined, function (context) {                                              // 2017
        var path = request.url.slice(1); // remove leading '/'                                                         // 2018
        var session = _this11.getSession(request);                                                                     // 2019
                                                                                                                       //
        if (!("sec-websocket-key" in request.headers)) {                                                               // 2021
          throw new Error("Missing Sec-WebSocket-Accept header.");                                                     // 2022
        }                                                                                                              // 2023
                                                                                                                       //
        var magic = request.headers["sec-websocket-key"] + "258EAFA5-E914-47DA-95CA-C5AB0DC85B11";                     // 2025
        var acceptKey = Crypto.createHash("sha1").update(magic).digest("base64");                                      // 2026
                                                                                                                       //
        var protocols = [];                                                                                            // 2028
        if ("sec-websocket-protocol" in request.headers) {                                                             // 2029
          protocols = request.headers["sec-websocket-protocol"].split(",").map(function (s) {                          // 2030
            return s.trim();                                                                                           // 2031
          });                                                                                                          // 2031
        }                                                                                                              // 2032
                                                                                                                       //
        var receiver = new WebSocketReceiver(socket);                                                                  // 2034
                                                                                                                       //
        var promise = session.openWebSocket(path, context, protocols, receiver);                                       // 2036
                                                                                                                       //
        if (head.length > 0) {                                                                                         // 2038
          promise.serverStream.sendBytes(head);                                                                        // 2039
        }                                                                                                              // 2040
                                                                                                                       //
        var socketIdx = _this11.websocketCounter.toString();                                                           // 2042
        _this11.websockets[socketIdx] = socket;                                                                        // 2043
        _this11.websocketCounter += 1;                                                                                 // 2044
        pumpWebSocket(socket, promise.serverStream, function () {                                                      // 2045
          delete _this11.websockets[socketIdx];                                                                        // 2045
        });                                                                                                            // 2045
                                                                                                                       //
        return promise.then(function (response) {                                                                      // 2047
          var headers = ["HTTP/1.1 101 Switching Protocols", "Upgrade: websocket", "Connection: Upgrade", "Sec-WebSocket-Accept: " + acceptKey];
          if (response.protocol && response.protocol.length > 0) {                                                     // 2054
            headers.push("Sec-WebSocket-Protocol: " + response.protocol.join(", "));                                   // 2055
          }                                                                                                            // 2056
                                                                                                                       //
          headers.push("");                                                                                            // 2058
          headers.push("");                                                                                            // 2059
                                                                                                                       //
          socket.write(headers.join("\r\n"));                                                                          // 2061
          receiver.go();                                                                                               // 2062
                                                                                                                       //
          // Note:  At this point errors are out of our hands.                                                         //
        });                                                                                                            // 2065
      });                                                                                                              // 2066
    })["catch"](function (error) {                                                                                     // 2067
      return _this11.maybeRetryAfterError(error, retryCount).then(function () {                                        // 2068
        return _this11.handleWebSocket(request, socket, head, retryCount + 1);                                         // 2069
      });                                                                                                              // 2070
    });                                                                                                                // 2071
  };                                                                                                                   // 2072
                                                                                                                       //
  Proxy.prototype.setHasLoaded = function setHasLoaded() {                                                             //
    var _this12 = this;                                                                                                // 2074
                                                                                                                       //
    if (!this.hasLoaded) {                                                                                             // 2075
      (function () {                                                                                                   // 2075
        _this12.hasLoaded = true;                                                                                      // 2076
        var sessionId = _this12.sessionId;                                                                             // 2077
        inMeteor(function () {                                                                                         // 2078
          Sessions.update({ _id: sessionId }, { $set: { hasLoaded: true } });                                          // 2079
        });                                                                                                            // 2080
      })();                                                                                                            // 2075
    }                                                                                                                  // 2081
  };                                                                                                                   // 2082
                                                                                                                       //
  return Proxy;                                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 2085
                                                                                                                       //
var isRfc1918OrLocal = function isRfc1918OrLocal(address) {                                                            // 2087
  if (Net.isIPv4(address)) {                                                                                           // 2088
    var quad = address.split(".").map(function (x) {                                                                   // 2089
      return parseInt(x, 10);                                                                                          // 2089
    });                                                                                                                // 2089
    return quad[0] === 127 || quad[0] === 10 || quad[0] === 192 && quad[1] === 168 || quad[0] === 172 && quad[1] >= 16 && quad[1] < 32;
  } else if (Net.isIPv6(address)) {                                                                                    // 2093
    // IPv6 specifies ::1 as localhost and fd:: as reserved for private networks                                       //
    return address === "::1" || address.lastIndexOf("fd", 0) === 0;                                                    // 2095
  } else {                                                                                                             // 2096
    // Ignore things that are neither IPv4 nor IPv6                                                                    //
    return false;                                                                                                      // 2098
  }                                                                                                                    // 2099
};                                                                                                                     // 2100
                                                                                                                       //
var quadToIntString = function quadToIntString(quad) {                                                                 // 2102
  var num = Bignum(quad[0]).shiftLeft(16).add(quad[1]).shiftLeft(16).add(quad[2]).shiftLeft(16).add(quad[3]);          // 2103
  return num.toString();                                                                                               // 2107
};                                                                                                                     // 2108
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Session cookie management                                                                                           //
                                                                                                                       //
var parseCookies = function parseCookies(request) {                                                                    // 2113
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["cookie"];                                                                              // 2115
                                                                                                                       //
  var result = { cookies: [] };                                                                                        // 2117
  if (header) {                                                                                                        // 2118
    var reqCookies = header.split(";");                                                                                // 2119
    for (var i in reqCookies) {                                                                                        // 2120
      var reqCookie = reqCookies[i];                                                                                   // 2121
      var equalsPos = reqCookie.indexOf("=");                                                                          // 2122
      var cookie = void 0;                                                                                             // 2123
      if (equalsPos === -1) {                                                                                          // 2124
        cookie = { key: reqCookie.trim(), value: "" };                                                                 // 2125
      } else {                                                                                                         // 2126
        cookie = { key: reqCookie.slice(0, equalsPos).trim(), value: reqCookie.slice(equalsPos + 1) };                 // 2127
      }                                                                                                                // 2128
                                                                                                                       //
      if (cookie.key === "sandstorm-sid") {                                                                            // 2130
        if (result.sessionId) {                                                                                        // 2131
          throw new Error("Multiple sandstorm session IDs?");                                                          // 2132
        }                                                                                                              // 2133
                                                                                                                       //
        result.sessionId = cookie.value;                                                                               // 2135
      } else {                                                                                                         // 2136
        result.cookies.push(cookie);                                                                                   // 2137
      }                                                                                                                // 2138
    }                                                                                                                  // 2139
  }                                                                                                                    // 2140
                                                                                                                       //
  return result;                                                                                                       // 2142
};                                                                                                                     // 2143
                                                                                                                       //
var parsePreconditionHeader = function parsePreconditionHeader(request) {                                              // 2145
  if (request.headers["if-match"]) {                                                                                   // 2146
    if (request.headers["if-match"].trim() === "*") {                                                                  // 2147
      return { exists: null };                                                                                         // 2148
    }                                                                                                                  // 2149
                                                                                                                       //
    var matches = parseETagList(request.headers["if-match"]);                                                          // 2151
    if (matches.length > 0) {                                                                                          // 2152
      return { matchesOneOf: matches };                                                                                // 2153
    }                                                                                                                  // 2154
  }                                                                                                                    // 2155
                                                                                                                       //
  if (request.headers["if-none-match"]) {                                                                              // 2157
    if (request.headers["if-none-match"].trim() === "*") {                                                             // 2158
      return { doesntExist: null };                                                                                    // 2159
    }                                                                                                                  // 2160
                                                                                                                       //
    var noneMatches = parseETagList(request.headers["if-none-match"]);                                                 // 2162
    if (noneMatches.length > 0) {                                                                                      // 2163
      return { matchesNoneOf: noneMatches };                                                                           // 2164
    }                                                                                                                  // 2165
  }                                                                                                                    // 2166
                                                                                                                       //
  return { none: null };                                                                                               // 2168
};                                                                                                                     // 2169
                                                                                                                       //
var parseETagList = function parseETagList(input) {                                                                    // 2171
  // An ETag is a quoted, \-escaped string, possibly prefixed with W/ (outside the quotes) to                          //
  // indicate that it is weak. We are parsing a list of comma-delimited etags.                                         //
                                                                                                                       //
  input = input.trim();                                                                                                // 2175
  var results = [];                                                                                                    // 2176
                                                                                                                       //
  while (input.length > 0) {                                                                                           // 2178
    var match = input.match(/^\s*(W\/)?"(([^"\\]|\\.)*)"\s*($|,)/);                                                    // 2179
    if (!match) throw new Meteor.Error(400, "invalid etag");                                                           // 2180
                                                                                                                       //
    input = input.slice(match[0].length).trim();                                                                       // 2182
    results.push({ weak: !!match[1], value: match[2].replace(/\\(.)/g, "$1") });                                       // 2183
  }                                                                                                                    // 2184
                                                                                                                       //
  return results;                                                                                                      // 2186
};                                                                                                                     // 2187
                                                                                                                       //
var composeETag = function composeETag(tag) {                                                                          // 2189
  var result = '"' + (tag.value || "").replace(/([\\"])/g, "\\$1") + '"';                                              // 2190
  if (tag.weak) result = "W/" + result;                                                                                // 2191
  return result;                                                                                                       // 2192
};                                                                                                                     // 2193
                                                                                                                       //
var parseAcceptHeader = function parseAcceptHeader(request) {                                                          // 2195
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["accept"];                                                                              // 2197
                                                                                                                       //
  var result = [];                                                                                                     // 2199
  if (header) {                                                                                                        // 2200
    var acceptList = header.split(",");                                                                                // 2201
    for (var i in acceptList) {                                                                                        // 2202
      var acceptStr = acceptList[i];                                                                                   // 2203
      var tokensList = acceptStr.split(";");                                                                           // 2204
                                                                                                                       //
      var temp = { mimeType: tokensList[0].trim() };                                                                   // 2206
                                                                                                                       //
      var tokensListRest = tokensList.slice(1);                                                                        // 2208
      for (var j in tokensListRest) {                                                                                  // 2209
        var token = tokensListRest[j];                                                                                 // 2210
        var equalsPos = token.indexOf("=");                                                                            // 2211
        if (equalsPos) {                                                                                               // 2212
          var key = token.slice(0, equalsPos).trim();                                                                  // 2213
          var value = token.slice(equalsPos + 1).trim();                                                               // 2214
                                                                                                                       //
          if (key === "q") {                                                                                           // 2216
            temp.qValue = +value;                                                                                      // 2217
          }                                                                                                            // 2218
        }                                                                                                              // 2219
      }                                                                                                                // 2220
                                                                                                                       //
      result.push(temp);                                                                                               // 2222
    }                                                                                                                  // 2223
  }                                                                                                                    // 2224
                                                                                                                       //
  return result;                                                                                                       // 2226
};                                                                                                                     // 2227
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Regular HTTP request handling                                                                                       //
                                                                                                                       //
var readAll = function readAll(stream) {                                                                               // 2232
  return new Promise(function (resolve, reject) {                                                                      // 2233
    var buffers = [];                                                                                                  // 2234
    stream.on("data", function (buf) {                                                                                 // 2235
      buffers.push(buf);                                                                                               // 2236
    });                                                                                                                // 2237
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 2239
      resolve(Buffer.concat(buffers));                                                                                 // 2240
    });                                                                                                                // 2241
                                                                                                                       //
    stream.on("error", reject);                                                                                        // 2243
  });                                                                                                                  // 2244
};                                                                                                                     // 2245
                                                                                                                       //
var makeSetCookieHeader = function makeSetCookieHeader(cookie) {                                                       // 2247
  var result = [cookie.name, "=", cookie.value];                                                                       // 2248
                                                                                                                       //
  if ("absolute" in cookie.expires) {                                                                                  // 2250
    result.push("; Expires=");                                                                                         // 2251
    result.push(new Date(cookie.expires.absolute * 1000).toUTCString());                                               // 2252
  } else if ("relative" in cookie.expires) {                                                                           // 2253
    result.push("; Max-Age=" + cookie.expires.relative);                                                               // 2254
  }                                                                                                                    // 2255
                                                                                                                       //
  if (cookie.path) {                                                                                                   // 2257
    result.push("; Path=" + cookie.path);                                                                              // 2258
  }                                                                                                                    // 2259
                                                                                                                       //
  if (cookie.httpOnly) {                                                                                               // 2261
    result.push("; HttpOnly");                                                                                         // 2262
  }                                                                                                                    // 2263
                                                                                                                       //
  return result.join("");                                                                                              // 2265
};                                                                                                                     // 2266
                                                                                                                       //
// TODO(cleanup):  Auto-generate based on annotations in web-session.capnp.                                            //
var successCodes = {                                                                                                   // 2269
  ok: { id: 200, title: "OK" },                                                                                        // 2270
  created: { id: 201, title: "Created" },                                                                              // 2271
  accepted: { id: 202, title: "Accepted" },                                                                            // 2272
  multiStatus: { id: 207, title: "Multi-Status" }                                                                      // 2273
};                                                                                                                     // 2269
var noContentSuccessCodes = [                                                                                          // 2275
// Indexed by shouldResetForm * 1                                                                                      //
{ id: 204, title: "No Content" }, { id: 205, title: "Reset Content" }];                                                // 2277
var redirectCodes = [                                                                                                  // 2280
// Indexed by switchToGet * 2 + isPermanent                                                                            //
{ id: 307, title: "Temporary Redirect" }, { id: 308, title: "Permanent Redirect" }, { id: 303, title: "See Other" }, { id: 301, title: "Moved Permanently" }];
var errorCodes = {                                                                                                     // 2287
  badRequest: { id: 400, title: "Bad Request" },                                                                       // 2288
  forbidden: { id: 403, title: "Forbidden" },                                                                          // 2289
  notFound: { id: 404, title: "Not Found" },                                                                           // 2290
  methodNotAllowed: { id: 405, title: "Method Not Allowed" },                                                          // 2291
  notAcceptable: { id: 406, title: "Not Acceptable" },                                                                 // 2292
  conflict: { id: 409, title: "Conflict" },                                                                            // 2293
  gone: { id: 410, title: "Gone" },                                                                                    // 2294
  requestEntityTooLarge: { id: 413, title: "Request Entity Too Large" },                                               // 2295
  requestUriTooLong: { id: 414, title: "Request-URI Too Long" },                                                       // 2296
  unsupportedMediaType: { id: 415, title: "Unsupported Media Type" },                                                  // 2297
  imATeapot: { id: 418, title: "I'm a teapot" },                                                                       // 2298
  unprocessableEntity: { id: 422, title: "Unprocessable Entity" }                                                      // 2299
};                                                                                                                     // 2287
                                                                                                                       //
ResponseStream = function () {                                                                                         // 2302
  // Note: This class is used in pre-meteor.js as well as in this file.                                                //
                                                                                                                       //
  function ResponseStream(response, httpCode, httpStatus, upstreamHandle) {                                            // 2305
    var _this13 = this;                                                                                                // 2305
                                                                                                                       //
    _classCallCheck(this, ResponseStream);                                                                             // 2305
                                                                                                                       //
    // This is stupidly complicated, because:                                                                          //
    // - New versions of sandstorm-http-bridge (and other well-behaved apps) wait on write()                           //
    //   completion for flow control, so we want write() to complete only when there is space                          //
    //   available for more writes.                                                                                    //
    // - Old versions of sandstorm-http-bridge would make a zillion simultaneous calls to write()                      //
    //   with all of the data they wanted to send without waiting for previous calls to complete.                      //
    //   While in-flight, these writes can consume a lot of RAM at multiple points in the system.                      //
    // - Old versions of sandstorm-http-bridge would print any thrown error to stderr and then                         //
    //   keep going. So if canceling a download early on causes all future write()s to fail, this                      //
    //   can lead to very excessive log spam.                                                                          //
    // - If a write() fails to complete (it returns a promise that never resolves), then later                         //
    //   upon garbage collection the RPC will actually throw an exception about a PromiseFulfiller                     //
    //   never having been fulfilled. Hence, if we simply stop responding to write()s after some                       //
    //   point, we again get log spam.                                                                                 //
    // - If the connection closes during a write, Node never calls the completion callback at all.                     //
    //   We have to listen for the "close" event.                                                                      //
                                                                                                                       //
    this.response = response;                                                                                          // 2323
    this.httpCode = httpCode;                                                                                          // 2324
    this.httpStatus = httpStatus;                                                                                      // 2325
    this.upstreamHandle = upstreamHandle;                                                                              // 2326
                                                                                                                       //
    this.started = false;                                                                                              // 2328
    this.ended = false;                                                                                                // 2329
    this.waiting = [];                                                                                                 // 2330
                                                                                                                       //
    response.on("drain", function () {                                                                                 // 2332
      _this13.waiting.forEach(function (f) {                                                                           // 2333
        return f();                                                                                                    // 2333
      });                                                                                                              // 2333
      _this13.waiting = [];                                                                                            // 2334
    });                                                                                                                // 2335
                                                                                                                       //
    response.on("close", function () {                                                                                 // 2337
      _this13.aborted = true;                                                                                          // 2338
                                                                                                                       //
      // Resolve all outstanding writes. This is OK even if they didn't actually go through because                    //
      // an incomplete download is the client's problem, not the server's. The important thing is                      //
      // to cancel the stream if it is still being generated; to that end, the next new write()                        //
      // call after this point will throw.                                                                             //
      _this13.waiting.forEach(function (f) {                                                                           // 2344
        return f();                                                                                                    // 2344
      });                                                                                                              // 2344
      _this13.waiting = [];                                                                                            // 2345
                                                                                                                       //
      _this13.close();                                                                                                 // 2347
    });                                                                                                                // 2348
  }                                                                                                                    // 2349
                                                                                                                       //
  ResponseStream.prototype.expectSize = function expectSize(size) {                                                    // 2302
    if (!this.started) {                                                                                               // 2352
      this.started = true;                                                                                             // 2353
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": size });                             // 2354
    }                                                                                                                  // 2355
  };                                                                                                                   // 2356
                                                                                                                       //
  ResponseStream.prototype.write = function write(data) {                                                              // 2302
    var _this14 = this;                                                                                                // 2358
                                                                                                                       //
    if (!this.started) {                                                                                               // 2359
      this.started = true;                                                                                             // 2360
      this.response.writeHead(this.httpCode, this.httpStatus);                                                         // 2361
    }                                                                                                                  // 2362
                                                                                                                       //
    if (this.aborted) {                                                                                                // 2364
      // Connection has been aborted.                                                                                  //
      if (this.alreadyThrew) {                                                                                         // 2366
        // We already threw an error from a previous write(). Do not throw more errors, because                        //
        // older versions of sandstorm-http-bridge do not stop on the first error and will print                       //
        // every error to the log, wasting space. Newer versions stop on the first failure.                            //
        return;                                                                                                        // 2370
      } else {                                                                                                         // 2371
        this.alreadyThrew = true;                                                                                      // 2372
        throw new Error("client disconnected");                                                                        // 2373
      }                                                                                                                // 2374
    } else {                                                                                                           // 2375
      if (this.response.write(data)) {                                                                                 // 2376
        // All written.                                                                                                //
        return;                                                                                                        // 2378
      } else {                                                                                                         // 2379
        // Write buffer is full. Don't complete until it has more space.                                               //
        return new Promise(function (resolve, reject) {                                                                // 2381
          _this14.waiting.push(resolve);                                                                               // 2382
        });                                                                                                            // 2383
      }                                                                                                                // 2384
    }                                                                                                                  // 2385
  };                                                                                                                   // 2386
                                                                                                                       //
  ResponseStream.prototype.done = function done() {                                                                    // 2302
    if (!this.started) {                                                                                               // 2389
      this.started = true;                                                                                             // 2390
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": 0 });                                // 2391
    }                                                                                                                  // 2392
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2394
      this.ended = true;                                                                                               // 2395
      this.response.end();                                                                                             // 2396
    }                                                                                                                  // 2397
                                                                                                                       //
    this.close();                                                                                                      // 2399
  };                                                                                                                   // 2400
                                                                                                                       //
  ResponseStream.prototype.close = function close() {                                                                  // 2302
    if (this.upstreamHandle) {                                                                                         // 2403
      this.upstreamHandle.close();                                                                                     // 2404
    }                                                                                                                  // 2405
                                                                                                                       //
    // If `this.done()` has not been called, we should report an error to the client. Unfortunately,                   //
    // the only case in which we can actually report the error is when we haven't done any writes                      //
    // yet. So we handle that case and ignore the error otherwise. Note that `!this.started`                           //
    // implies `!this.ended`.                                                                                          //
    if (!this.started) {                                                                                               // 2411
      this.started = true;                                                                                             // 2412
      this.response.writeHead(500, "done() never called on response stream", { "Content-Type": "text/plain" });        // 2413
    }                                                                                                                  // 2415
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2417
      this.ended = true;                                                                                               // 2418
      this.response.end();                                                                                             // 2419
    }                                                                                                                  // 2420
  };                                                                                                                   // 2421
                                                                                                                       //
  ResponseStream.prototype.sendingDirectResponse = function sendingDirectResponse() {                                  // 2302
    // For internal front-end use: Indicates that the caller is going to fill in the response                          //
    // instead. If a response has already been started, this throws an exception.                                      //
    //                                                                                                                 //
    // This is used in particular in pre-meteor.js, when dealing with static web publishing.                           //
                                                                                                                       //
    if (this.started) {                                                                                                // 2429
      throw new Error("can't sendDirectResponse() because response already started");                                  // 2430
      this.response.end();                                                                                             // 2431
    } else if (this.ended) {                                                                                           // 2432
      throw new Error("can't sendDirectResponse() because response already sent");                                     // 2433
    } else {                                                                                                           // 2434
      this.started = true;                                                                                             // 2435
      this.ended = true;                                                                                               // 2436
    }                                                                                                                  // 2437
  };                                                                                                                   // 2438
                                                                                                                       //
  return ResponseStream;                                                                                               // 2302
}();                                                                                                                   // 2302
                                                                                                                       //
// TODO(cleanup): Node 0.12 has a `gunzipSync` but 0.10 (which Meteor still uses) does not.                            //
var Zlib = Npm.require("zlib");                                                                                        // 2442
var gunzipSync = Meteor.wrapAsync(Zlib.gunzip, Zlib);                                                                  // 2443
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// WebSocket handling                                                                                                  //
                                                                                                                       //
WebSocketReceiver = function () {                                                                                      // 2448
  function WebSocketReceiver(socket) {                                                                                 // 2449
    _classCallCheck(this, WebSocketReceiver);                                                                          // 2449
                                                                                                                       //
    this.socket = socket;                                                                                              // 2450
    this.queue = [];                                                                                                   // 2451
  }                                                                                                                    // 2452
                                                                                                                       //
  WebSocketReceiver.prototype.go = function go() {                                                                     // 2448
    for (var i in this.queue) {                                                                                        // 2455
      this.socket.write(this.queue[i]);                                                                                // 2456
    }                                                                                                                  // 2457
                                                                                                                       //
    this.queue = null;                                                                                                 // 2459
  };                                                                                                                   // 2460
                                                                                                                       //
  WebSocketReceiver.prototype.sendBytes = function sendBytes(message) {                                                // 2448
    // TODO(someday):  Flow control of some sort?                                                                      //
    if (this.queue === null) {                                                                                         // 2464
      this.socket.write(message);                                                                                      // 2465
    } else {                                                                                                           // 2466
      this.queue.push(message);                                                                                        // 2467
    }                                                                                                                  // 2468
  };                                                                                                                   // 2469
                                                                                                                       //
  WebSocketReceiver.prototype.close = function close() {                                                               // 2448
    this.socket.end();                                                                                                 // 2472
  };                                                                                                                   // 2473
                                                                                                                       //
  return WebSocketReceiver;                                                                                            // 2448
}();                                                                                                                   // 2448
                                                                                                                       //
function pumpWebSocket(socket, rpcStream, destructor) {                                                                // 2476
  var writesInFlight = 0;                                                                                              // 2477
  var readingPaused = false;                                                                                           // 2478
  socket.on("data", function (chunk) {                                                                                 // 2479
    rpcStream.sendBytes(chunk).then(function () {                                                                      // 2480
      writesInFlight--;                                                                                                // 2481
      if (readingPaused) {                                                                                             // 2482
        socket.resume();                                                                                               // 2483
        readingPaused = false;                                                                                         // 2484
      }                                                                                                                // 2485
    })["catch"](function (err) {                                                                                       // 2486
      if (err.kjType !== "disconnected") {                                                                             // 2487
        console.error("WebSocket sendBytes failed: " + err.stack);                                                     // 2488
      }                                                                                                                // 2489
                                                                                                                       //
      socket.destroy();                                                                                                // 2491
    });                                                                                                                // 2492
                                                                                                                       //
    if (writesInFlight++ > 16) {                                                                                       // 2494
      socket.pause();                                                                                                  // 2495
      readingPaused = true;                                                                                            // 2496
    }                                                                                                                  // 2497
  });                                                                                                                  // 2498
                                                                                                                       //
  socket.on("end", function (chunk) {                                                                                  // 2500
    rpcStream.close();                                                                                                 // 2501
  });                                                                                                                  // 2502
                                                                                                                       //
  socket.on("close", function () {                                                                                     // 2504
    destructor();                                                                                                      // 2505
  });                                                                                                                  // 2506
};                                                                                                                     // 2507
                                                                                                                       //
// =======================================================================================                             //
// Debug log access                                                                                                    //
                                                                                                                       //
Meteor.publish("grainLog", function (grainId) {                                                                        // 2512
  var _this15 = this;                                                                                                  // 2512
                                                                                                                       //
  check(grainId, String);                                                                                              // 2513
  var id = 0;                                                                                                          // 2514
  var grain = Grains.findOne(grainId);                                                                                 // 2515
  if (!grain || !this.userId || grain.userId !== this.userId) {                                                        // 2516
    this.added("grainLog", id++, { text: "Only the grain owner can view the debug log." });                            // 2517
    this.ready();                                                                                                      // 2518
    return;                                                                                                            // 2519
  }                                                                                                                    // 2520
                                                                                                                       //
  var connected = false;                                                                                               // 2522
  var _this = this;                                                                                                    // 2523
                                                                                                                       //
  var receiver = {                                                                                                     // 2525
    write: function write(data) {                                                                                      // 2526
      connected = true;                                                                                                // 2527
      _this.added("grainLog", id++, { text: data.toString("utf8") });                                                  // 2528
    },                                                                                                                 // 2529
    close: function close() {                                                                                          // 2531
      if (connected) {                                                                                                 // 2532
        _this.added("grainLog", id++, {                                                                                // 2533
          text: "*** lost connection to grain (probably because it shut down) ***"                                     // 2534
        });                                                                                                            // 2533
      }                                                                                                                // 2536
    }                                                                                                                  // 2537
  };                                                                                                                   // 2525
                                                                                                                       //
  try {                                                                                                                // 2540
    (function () {                                                                                                     // 2540
      var handle = waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                 // 2541
        return supervisor.watchLog(8192, receiver);                                                                    // 2542
      })).handle;                                                                                                      // 2543
      connected = true;                                                                                                // 2544
      _this15.onStop(function () {                                                                                     // 2545
        handle.close();                                                                                                // 2546
      });                                                                                                              // 2547
    })();                                                                                                              // 2540
  } catch (err) {                                                                                                      // 2548
    if (!connected) {                                                                                                  // 2549
      this.added("grainLog", id++, {                                                                                   // 2550
        text: "*** couldn't connect to grain (" + err + ") ***"                                                        // 2551
      });                                                                                                              // 2550
    }                                                                                                                  // 2553
  }                                                                                                                    // 2554
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 2557
});                                                                                                                    // 2558
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"sandcats.js":["node-forge",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/sandcats.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var pki,asn1;module.import("node-forge",{"pki":function(v){pki=v},"asn1":function(v){asn1=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Sandcats = {};                                                                                                         // 17
                                                                                                                       //
                                                                                                                       // 19
var querystring = Npm.require("querystring");                                                                          // 20
var https = Npm.require("https");                                                                                      // 21
var fs = Npm.require("fs");                                                                                            // 22
var dgram = Npm.require("dgram");                                                                                      // 23
var Url = Npm.require("url");                                                                                          // 24
                                                                                                                       //
var SANDCATS_HOSTNAME = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].sandcatsHostname;    // 26
var SANDCATS_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandcats";                                                     // 28
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 30
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 31
var SANDCATS_NAME = void 0; // Look at `startup` below to see where this is set                                        // 32
                                                                                                                       //
var updateSandcatsIp = function updateSandcatsIp() {                                                                   // 34
  var responseCallback = function responseCallback(res) {                                                              // 35
    if (res.statusCode === 200) {                                                                                      // 36
      console.log("Successfully updated sandcats IP");                                                                 // 37
    } else {                                                                                                           // 38
      console.error("Failed to update sandcats IP:", res.headers);                                                     // 39
    }                                                                                                                  // 40
  };                                                                                                                   // 41
                                                                                                                       //
  var errorCallback = function errorCallback(err) {                                                                    // 43
    console.error("Couldn't send update sandcats hostname", err);                                                      // 44
  };                                                                                                                   // 45
                                                                                                                       //
  performSandcatsRequest("/update", SANDCATS_HOSTNAME, { rawHostname: SANDCATS_NAME }, errorCallback, responseCallback);
};                                                                                                                     // 49
                                                                                                                       //
var pingUdp = function pingUdp() {                                                                                     // 51
  var socket = dgram.createSocket("udp4");                                                                             // 52
  var secret = Random.secret(16);                                                                                      // 53
                                                                                                                       //
  message = new Buffer(SANDCATS_NAME + " " + secret);                                                                  // 55
  socket.on("message", function (buf) {                                                                                // 56
    if (buf.toString() === secret) {                                                                                   // 57
      updateSandcatsIp();                                                                                              // 58
    } else {                                                                                                           // 59
      console.error("Received unexpected response in UDP sandcats ping:", buf.toString());                             // 60
    }                                                                                                                  // 61
  });                                                                                                                  // 62
                                                                                                                       //
  socket.send(message, 0, message.length, 8080, SANDCATS_HOSTNAME, function (err) {                                    // 64
    if (err) {                                                                                                         // 65
      console.error("Couldn't send UDP sandcats ping", err);                                                           // 66
    }                                                                                                                  // 67
  });                                                                                                                  // 68
                                                                                                                       //
  Meteor.setTimeout(function () {                                                                                      // 70
    socket.close();                                                                                                    // 71
  }, 10 * 1000);                                                                                                       // 72
};                                                                                                                     // 73
                                                                                                                       //
var performSandcatsRequest = function performSandcatsRequest(path, hostname, postData, errorCallback, responseCallback) {
  var options = {                                                                                                      // 76
    hostname: hostname,                                                                                                // 77
    path: path,                                                                                                        // 78
    method: "POST",                                                                                                    // 79
    agent: false,                                                                                                      // 80
    key: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa"),                                                                 // 81
    cert: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa.pub"),                                                            // 82
    headers: {                                                                                                         // 83
      "X-Sand": "cats",                                                                                                // 84
      "Content-Type": "application/x-www-form-urlencoded"                                                              // 85
    }                                                                                                                  // 83
  };                                                                                                                   // 76
                                                                                                                       //
  if (postData.certificateSigningRequest) {                                                                            // 89
    console.log("Submitting certificate request for host", postData.rawHostname, "where the request has length", postData.certificateSigningRequest.length);
  }                                                                                                                    // 93
                                                                                                                       //
  var newPostData = querystring.stringify(postData);                                                                   // 95
  if (SANDCATS_HOSTNAME === "sandcats-dev.sandstorm.io" && !process.env.NODE_TLS_REJECT_UNAUTHORIZED) {                // 96
    console.log("You are using the Sandcats dev server but have full HTTPS " + "certificate checking enabled. Probably you will get an HTTPS " + "error. Proceeding anyway.");
  }                                                                                                                    // 101
                                                                                                                       //
  var req = https.request(options, responseCallback);                                                                  // 103
  req.write(newPostData);                                                                                              // 104
  req.end();                                                                                                           // 105
                                                                                                                       //
  if (errorCallback) {                                                                                                 // 107
    req.on("error", errorCallback);                                                                                    // 108
  }                                                                                                                    // 109
                                                                                                                       //
  return req;                                                                                                          // 111
};                                                                                                                     // 112
                                                                                                                       //
var generateKeyAndCsr = function generateKeyAndCsr(commonName) {                                                       // 114
  check(commonName, String);                                                                                           // 115
                                                                                                                       //
  // Generate key pair. Using Meteor.wrapAsync because forge supports                                                  //
  // a synchronous as well as an asynchronous API, and the synchronous                                                 //
  // one blocks for a while.                                                                                           //
  var wrappedGenerateKeyPair = Meteor.wrapAsync(pki.rsa.generateKeyPair);                                              // 120
                                                                                                                       //
  // I could pick an `e`[xponent] value for the resulting RSA key, but                                                 //
  // I will refrain.                                                                                                   //
  var keys = wrappedGenerateKeyPair({ bits: 2048 });                                                                   // 124
                                                                                                                       //
  // Create a certificate request (CSR).                                                                               //
  var csr = pki.createCertificationRequest();                                                                          // 127
  csr.publicKey = keys.publicKey;                                                                                      // 128
  csr.setSubject([{                                                                                                    // 129
    name: "commonName",                                                                                                // 131
    value: commonName,                                                                                                 // 132
    valueTagClass: asn1.Type.UTF8                                                                                      // 133
  }]);                                                                                                                 // 130
  // We specify UTF8 to encode a UTF8String (rather than the default of PRINTABLESTRING) in the                        //
  // commonName so that GlobalSign does not report a warning, and also because that happens to                         //
  // be what openssl(1) does when asked to create a CSR.                                                               //
  csr.sign(keys.privateKey);                                                                                           // 139
  console.log("generateKeyAndCsr created new key & certificate request for", commonName);                              // 140
  return {                                                                                                             // 141
    privateKeyAsPem: pki.privateKeyToPem(keys.privateKey),                                                             // 142
    csrAsPem: pki.certificationRequestToPem(csr)                                                                       // 143
  };                                                                                                                   // 141
};                                                                                                                     // 145
                                                                                                                       //
Sandcats.storeNewKeyAndCsr = function (hostname, basePath) {                                                           // 147
  // We use the current JS time (like UNIX timestamp but in                                                            //
  // milliseconds) as the key number. Note that the keyNumber is                                                       //
  // intended to be an opaque identifier; the only important thing is                                                  //
  // that it increases numerically over time. We use the current time                                                  //
  // just as a simplistic way to pick a filename that probably no one                                                  //
  // else has created yet.                                                                                             //
  var keyNumber = new Date().getTime();                                                                                // 154
  var keyFilename = basePath + "/" + keyNumber;                                                                        // 155
  var csrFilename = keyFilename + ".csr";                                                                              // 156
  var responseFilename = keyFilename + ".response-json";                                                               // 157
  var withWildcard = "*." + hostname;                                                                                  // 158
  var keyAndCsr = generateKeyAndCsr(withWildcard);                                                                     // 159
  fs.writeFileSync(keyFilename, keyAndCsr.privateKeyAsPem, { mode: 0400 });                                            // 160
  fs.writeFileSync(csrFilename, keyAndCsr.csrAsPem);                                                                   // 162
  console.log("storeNewKeyAndCsr successfully saved key and certificate request to", keyFilename, "and", csrFilename, "respectively of length", keyAndCsr.privateKeyAsPem.length, "and", keyAndCsr.csrAsPem.length);
  return {                                                                                                             // 167
    csrFilename: csrFilename,                                                                                          // 168
    keyFilename: keyFilename,                                                                                          // 169
    responseFilename: responseFilename                                                                                 // 170
  };                                                                                                                   // 167
};                                                                                                                     // 172
                                                                                                                       //
Sandcats.renewHttpsCertificateIfNeeded = function () {                                                                 // 174
  var renewHttpsCertificate = function renewHttpsCertificate() {                                                       // 175
    var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                           // 176
    var basePath = "/var/sandcats/https/" + hostname;                                                                  // 177
    var filenames = Sandcats.storeNewKeyAndCsr(hostname, basePath);                                                    // 178
                                                                                                                       //
    var errorCallback = function errorCallback(err) {                                                                  // 180
      console.error("Error while renewing HTTPS certificate (will continue to retry)", err);                           // 181
    };                                                                                                                 // 182
                                                                                                                       //
    var responseCallback = function responseCallback(res) {                                                            // 184
      if (res.statusCode == 200) {                                                                                     // 185
        (function () {                                                                                                 // 185
          // Save the response, chunk by chunk, then store it on disk                                                  //
          // for later use.                                                                                            //
          var responseBody = "";                                                                                       // 188
          res.on("data", function (chunk) {                                                                            // 189
            responseBody += chunk;                                                                                     // 190
          });                                                                                                          // 191
                                                                                                                       //
          res.on("end", function () {                                                                                  // 193
            // For sanity, make sure it parses as JSON, since we're                                                    //
            // going to need it to do that.                                                                            //
            try {                                                                                                      // 196
              JSON.parse(responseBody);                                                                                // 197
            } catch (e) {                                                                                              // 198
              console.error("JSON parse error receiving new HTTPS certificate. Discarding:", responseBody, "due to exception:", e);
              // Overwrite the responseBody with the empty JSON object                                                 //
              // and continue with the process of saving it to disk.                                                   //
              responseBody = "{}";                                                                                     // 205
            }                                                                                                          // 206
                                                                                                                       //
            try {                                                                                                      // 208
              fs.writeFileSync(filenames.responseFilename, responseBody, "utf-8");                                     // 209
            } catch (err) {                                                                                            // 210
              return console.error("Failure while saveing new HTTPS certificate to", filenames.responseFilename, "will continue to retry. Exception was:", err);
            }                                                                                                          // 215
                                                                                                                       //
            // Tell Sandcats that now is a good time to update its info                                                //
            // about which keys are available.                                                                         //
            if (!global.sandcats) {                                                                                    // 219
              console.error("When getting new certificate, could not find callback to request re-keying! Certs will probably become invalid soon.");
            } else {                                                                                                   // 221
              // Call the sandcats rekeying function.                                                                  //
              global.sandcats.rekey();                                                                                 // 223
              // That's that.                                                                                          //
              console.log("Successfully renewed HTTPS certificate into", filenames.responseFilename);                  // 225
            }                                                                                                          // 227
          });                                                                                                          // 228
        })();                                                                                                          // 185
      } else {                                                                                                         // 229
        console.log("Received HTTP error while renewing certificate (will keep retrying)", res.statusCode);            // 230
        res.on("data", function (chunk) {                                                                              // 232
          console.log("Error response contained information", chunk.toString("utf-8"));                                // 233
        });                                                                                                            // 234
      }                                                                                                                // 235
    };                                                                                                                 // 236
                                                                                                                       //
    var wrappedReadFile = Meteor.wrapAsync(fs.readFile);                                                               // 238
                                                                                                                       //
    performSandcatsRequest("/getcertificate", SANDCATS_HOSTNAME, {                                                     // 240
      rawHostname: SANDCATS_NAME,                                                                                      // 241
      certificateSigningRequest: wrappedReadFile(filenames.csrFilename, "utf-8")                                       // 242
    }, errorCallback, responseCallback);                                                                               // 240
  };                                                                                                                   // 244
                                                                                                                       //
  if (global.sandcats.shouldGetAnotherCertificate()) {                                                                 // 246
    console.log("renewHttpsCertificateIfNeeded: Happily choosing to renew certificate.");                              // 247
    return renewHttpsCertificate();                                                                                    // 248
  }                                                                                                                    // 249
};                                                                                                                     // 250
                                                                                                                       //
Sandcats.initializeSandcats = function () {                                                                            // 252
  var i = HOSTNAME.lastIndexOf(SANDCATS_HOSTNAME);                                                                     // 253
  if (i < 0) {                                                                                                         // 254
    console.error("SANDCATS_BASE_DOMAIN is configured but your HOSTNAME doesn't appear to contain it:", SANDCATS_HOSTNAME, HOSTNAME);
  } else {                                                                                                             // 257
    var oneMinute = 60 * 1000;                                                                                         // 258
    var oneHour = 60 * oneMinute;                                                                                      // 259
    var randomIntervalZeroToOneHour = Math.random() * oneHour;                                                         // 260
    // All Sandcats installs need dyndns updating.                                                                     //
    SANDCATS_NAME = HOSTNAME.slice(0, i - 1);                                                                          // 262
    Meteor.setInterval(pingUdp, oneMinute);                                                                            // 263
    // If process.env.HTTPS_PORT is set, we need to auto-refresh our HTTPS certificate.                                //
    if (process.env.HTTPS_PORT) {                                                                                      // 265
      // Always do a HTTPS certificate update check on Sandstorm start.                                                //
      Sandcats.renewHttpsCertificateIfNeeded();                                                                        // 267
                                                                                                                       //
      // After that's done, schedule it for every approx 1-2 hours in                                                  //
      // the future.                                                                                                   //
      Meteor.setInterval(Sandcats.renewHttpsCertificateIfNeeded, oneHour + randomIntervalZeroToOneHour);               // 271
    }                                                                                                                  // 273
  }                                                                                                                    // 274
};                                                                                                                     // 275
                                                                                                                       //
if (SANDCATS_HOSTNAME) {                                                                                               // 277
  Meteor.startup(Sandcats.initializeSandcats);                                                                         // 278
};                                                                                                                     // 279
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"shell-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/shell-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Set up browser policy.                                                                                              //
//                                                                                                                     //
// Note that by default (when the browser-policy package is added), Content-Security-Policy will                       //
// already be set to same-origin-only for everything except XHR and WebSocket. Eval is disabled,                       //
// but inline script are enabled.                                                                                      //
//                                                                                                                     //
// TODO(security): Consider disallowing inline scripts. Currently this forces Meteor to do an                          //
//   extra round trip on startup to fetch server settings. That seems like something that could                        //
//   be fixed in Meteor (e.g. embed the settings as JSON text rather than script). Startup time                        //
//   is incredibly important, and Meteor's templating system (which we use to render all our                           //
//   HTML) already does a good job of protecting us from script injection, so right now I think                        //
//   we should favor avoiding the round trip.                                                                          //
//                                                                                                                     //
// TODO(someday): Detect when an app tries to navigate off-site using CSP's violation reporting                        //
//   feature. Ask the user whether they want to open the link in a new tab. This is an annoying                        //
//   prompt, but if we just open the tab directly then apps can trivially leak by opening tabs                         //
//   with encoded URLs to an evil server. Although, this attack would be very detectable to the                        //
//   user, so maybe it's not a big deal...                                                                             //
                                                                                                                       //
BrowserPolicy.framing.disallow(); // Disallow framing of the UI.                                                       // 36
BrowserPolicy.content.allowFrameOrigin(getWildcardOrigin());                                                           // 37
                                                                                                                       //
// Allow anything to be loaded from the static asset host.                                                             //
var Url = Npm.require("url");                                                                                          // 40
var staticAssetHost = Url.parse(process.env.ROOT_URL).protocol + "//" + globalDb.makeWildcardHost("static");           // 41
BrowserPolicy.content.allowImageOrigin(staticAssetHost);                                                               // 43
BrowserPolicy.content.allowScriptOrigin(staticAssetHost);                                                              // 44
BrowserPolicy.content.allowFontOrigin(staticAssetHost);                                                                // 45
BrowserPolicy.content.allowConnectOrigin(staticAssetHost);                                                             // 46
                                                                                                                       //
Meteor.publish("grainsMenu", function () {                                                                             // 48
  var _this = this;                                                                                                    // 48
                                                                                                                       //
  if (this.userId) {                                                                                                   // 49
    if (Meteor.settings["public"].quotaEnabled) {                                                                      // 50
      (function () {                                                                                                   // 50
        // Hack: Fire off an asynchronous update to the user's storage usage whenever they open the                    //
        //   front page.                                                                                               //
        // TODO(someday): Implement the ability to reactively subscribe to storage usage from the                      //
        //   back-end?                                                                                                 //
        var userId = _this.userId;                                                                                     // 55
        globalBackend.cap().getUserStorageUsage(userId).then(function (results) {                                      // 56
          inMeteor(function () {                                                                                       // 57
            Meteor.users.update(userId, { $set: { storageUsage: parseInt(results.size) } });                           // 58
          });                                                                                                          // 59
        })["catch"](function (err) {                                                                                   // 60
          if (err.kjType !== "unimplemented") {                                                                        // 61
            console.error(err.stack);                                                                                  // 62
          }                                                                                                            // 63
        });                                                                                                            // 64
      })();                                                                                                            // 50
    }                                                                                                                  // 65
                                                                                                                       //
    var identityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                   // 67
    return [UserActions.find({ userId: this.userId }), Grains.find({ userId: this.userId }), ApiTokens.find({ "owner.user.identityId": { $in: identityIds } })];
  } else {                                                                                                             // 73
    return [];                                                                                                         // 74
  }                                                                                                                    // 75
});                                                                                                                    // 76
                                                                                                                       //
Meteor.publish("sessions", function (sessionId) {                                                                      // 78
  // sessionId itself should be secret enough, but they are also not meant to be shared, so as                         //
  // a backup we only publish the session to its owner. Note that `userId` can be null if the                          //
  // user is not logged in or is using incognito mode.                                                                 //
  check(sessionId, String);                                                                                            // 82
  return Sessions.find({ _id: sessionId, $or: [{ userId: this.userId }, { userId: null }] });                          // 83
});                                                                                                                    // 84
                                                                                                                       //
Meteor.publish("devPackages", function () {                                                                            // 86
  return DevPackages.find();                                                                                           // 87
});                                                                                                                    // 88
                                                                                                                       //
Meteor.publish("hasUsers", function () {                                                                               // 90
  var _this2 = this;                                                                                                   // 90
                                                                                                                       //
  // Publish pseudo-collection which tells the client if there are any users at all.                                   //
  //                                                                                                                   //
  // TODO(cleanup):  This seems overcomplicated.  Does Meteor have a better way?                                       //
  var cursor = Meteor.users.find();                                                                                    // 94
  if (cursor.count() > 0) {                                                                                            // 95
    this.added("hasUsers", "hasUsers", { hasUsers: true });                                                            // 96
  } else {                                                                                                             // 97
    (function () {                                                                                                     // 97
      var handle = cursor.observeChanges({                                                                             // 98
        added: function added(id) {                                                                                    // 99
          _this2.added("hasUsers", "hasUsers", { hasUsers: true });                                                    // 100
          handle.stop();                                                                                               // 101
          handle = null;                                                                                               // 102
        }                                                                                                              // 103
      });                                                                                                              // 98
      _this2.onStop(function () {                                                                                      // 105
        if (handle) handle.stop();                                                                                     // 106
      });                                                                                                              // 107
    })();                                                                                                              // 97
  }                                                                                                                    // 108
                                                                                                                       //
  this.ready();                                                                                                        // 110
});                                                                                                                    // 111
                                                                                                                       //
Meteor.publish("referralInfoPseudo", function () {                                                                     // 113
  var _this3 = this;                                                                                                   // 113
                                                                                                                       //
  // This publishes a pseudo-collection called referralInfo whose documents have the following                         //
  // form:                                                                                                             //
  //                                                                                                                   //
  // - id: (String) same as the User._id of an identity this user has referred                                         //
  // - name: (String) the profile.name from that identity                                                              //
  // - completed: (Boolean) if this referral is complete                                                               //
                                                                                                                       //
  //  If the user is not logged in, then we have no referralInfo.                                                      //
  if (!this.userId) {                                                                                                  // 122
    return [];                                                                                                         // 123
  }                                                                                                                    // 124
                                                                                                                       //
  // Implementation note:                                                                                              //
  //                                                                                                                   //
  // This pseudo-collection is populated very differently for (1) the completed: false case versus                     //
  // the (2) completed: true case.                                                                                     //
                                                                                                                       //
  // Case 1. Publish information about not-yet-complete referrals.                                                     //
  var notCompletedReferralIdentitiesCursor = Meteor.users.find({                                                       // 132
    referredBy: this.userId,                                                                                           // 133
    "profile.name": { $exists: true }                                                                                  // 134
  }, {                                                                                                                 // 132
    fields: {                                                                                                          // 136
      _id: 1,                                                                                                          // 137
      referredBy: 1,                                                                                                   // 138
      "profile.name": 1                                                                                                // 139
    }                                                                                                                  // 136
  });                                                                                                                  // 135
  var notCompletedReferralIdentitiesHandle = notCompletedReferralIdentitiesCursor.observeChanges({                     // 142
    // The added function gets called with the id of Bob when Alice refers Bob.                                        //
    added: function added(id, fields) {                                                                                // 144
      _this3.added("referralInfo", id, { name: fields.profile.name, completed: false });                               // 145
    },                                                                                                                 // 146
    // The removed function gets called when Bob is no longer an uncompleted referral.  Note that                      //
    // this will get more complicated once we support sending completed referrals to the client.                       //
    removed: function removed(id) {                                                                                    // 149
      _this3.removed("referralInfo", id);                                                                              // 150
    },                                                                                                                 // 151
    // The modified function gets called when Bob's profile.name changed.                                              //
    modified: function modified(id, fields) {                                                                          // 153
      _this3.modified("referralInfo", id, { name: fields.profile.name, completed: false });                            // 154
    }                                                                                                                  // 155
  });                                                                                                                  // 142
                                                                                                                       //
  // Case 2. Handle completed referrals.                                                                               //
  //                                                                                                                   //
  // - Do a query for the current list of completed identities.                                                        //
  //                                                                                                                   //
  // - Every time we see a new such identity, we create a query that watches that one identity in                      //
  //   case its profile.name changes.                                                                                  //
  //                                                                                                                   //
  // - Also watch the first query, since the list of completed identities might change.                                //
  var handleForProfileNameByIdentityId = {};                                                                           // 166
  var stopWatchingAllIdentities = function stopWatchingAllIdentities() {                                               // 167
    Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                      // 168
      stopWatchingIdentity(identityId);                                                                                // 169
    });                                                                                                                // 170
  };                                                                                                                   // 171
                                                                                                                       //
  var stopWatchingIdentity = function stopWatchingIdentity(identityId) {                                               // 173
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 174
    if (handleForProfileName) {                                                                                        // 175
      _this3.removed("referralInfo", identityId);                                                                      // 176
      handleForProfileName.stop();                                                                                     // 177
      // delete is safe because we iterate across `Object.keys()` which returns a copy.                                //
      delete handleForProfileNameByIdentityId[identityId];                                                             // 179
    }                                                                                                                  // 180
  };                                                                                                                   // 181
                                                                                                                       //
  var watchIdentityAndPublishReferralSuccess = function watchIdentityAndPublishReferralSuccess(identityId) {           // 183
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 184
    if (handleForProfileName) {                                                                                        // 185
      return;                                                                                                          // 186
    }                                                                                                                  // 187
                                                                                                                       //
    handleForProfileName = Meteor.users.find({                                                                         // 189
      _id: identityId                                                                                                  // 190
    }, {                                                                                                               // 189
      fields: {                                                                                                        // 192
        "profile.name": 1                                                                                              // 193
      }                                                                                                                // 192
    }).observeChanges({                                                                                                // 191
      added: function added(id, fields) {                                                                              // 196
        _this3.added("referralInfo", id, { name: fields.profile.name, completed: true });                              // 197
      },                                                                                                               // 198
                                                                                                                       //
      changed: function changed(id, fields) {                                                                          // 200
        _this3.changed("referralInfo", id, { name: fields.profile.name, completed: true });                            // 201
      },                                                                                                               // 202
                                                                                                                       //
      removed: function removed(id) {                                                                                  // 204
        stopWatchingIdentity(id);                                                                                      // 205
      }                                                                                                                // 206
    });                                                                                                                // 195
                                                                                                                       //
    handleForProfileNameByIdentityId[identityId] = handleForProfileName;                                               // 209
  };                                                                                                                   // 210
                                                                                                                       //
  var completedIdentityIdsHandle = Meteor.users.find({                                                                 // 212
    _id: this.userId,                                                                                                  // 213
    referredIdentityIds: { $exists: true }                                                                             // 214
  }, {                                                                                                                 // 212
    fields: {                                                                                                          // 216
      referredIdentityIds: true                                                                                        // 217
    }                                                                                                                  // 216
  }).observeChanges({                                                                                                  // 215
    // `added` gets called when a user gets their first completed referral.                                            //
    added: function added(id, fields) {                                                                                // 221
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 222
        // Unconditionally mark these as successful referrals and start watching.                                      //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 224
      }                                                                                                                // 226
    },                                                                                                                 // 227
    // `changed` gets called when a user adds/removes referredIdentityIds, usually when a                              //
    // referral becomes complete.                                                                                      //
    changed: function changed(id, fields) {                                                                            // 230
      // Two major tasks.                                                                                              //
      //                                                                                                               //
      // 1. Look for identityIds to unsubscribe from & send removed notices to the client.                             //
      //                                                                                                               //
      // 2. Look for identityIds to subscribe to.                                                                      //
                                                                                                                       //
      // Task 1. Unsubscribe where needed.                                                                             //
      var referredIdentityIdsAsObject = {};                                                                            // 238
      fields.referredIdentityIds.forEach(function (i) {                                                                // 239
        referredIdentityIdsAsObject[i] = true;                                                                         // 239
      });                                                                                                              // 239
                                                                                                                       //
      Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                    // 241
        // If the handle doesn't show up in the new list of referredIdentityIds, then remove                           //
        // info from the client & stop it on the server & make it null.                                                //
        var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                       // 244
        if (referredIdentityIdsAsObject.hasOwnProperty(identityId)) {                                                  // 245
          stopWatchingIdentity(identityId);                                                                            // 246
        }                                                                                                              // 247
      });                                                                                                              // 248
                                                                                                                       //
      // Task 2. Subscribe where needed.                                                                               //
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 251
        // The watch... function will avoid double-creating subscriptions, so this is safe.                            //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 253
      }                                                                                                                // 254
    },                                                                                                                 // 255
    // `removed` gets called when a User suddenly has no referredIdentityIds.                                          //
    removed: function removed() {                                                                                      // 257
      // Remove all data from client; stop all handles.                                                                //
      stopWatchingAllIdentities();                                                                                     // 259
    }                                                                                                                  // 260
  });                                                                                                                  // 219
                                                                                                                       //
  // With cases 1 and 2 handled, register a cleanup function, then declare victory.                                    //
  this.onStop(function () {                                                                                            // 264
    stopWatchingAllIdentities();                                                                                       // 265
    notCompletedReferralIdentitiesHandle.stop();                                                                       // 266
    completedIdentityIdsHandle.stop();                                                                                 // 267
  });                                                                                                                  // 268
                                                                                                                       //
  this.ready();                                                                                                        // 270
});                                                                                                                    // 271
                                                                                                                       //
Meteor.publish("backers", function () {                                                                                // 273
  var _this4 = this;                                                                                                   // 273
                                                                                                                       //
  var backers = Assets.getText("backers.txt");                                                                         // 274
  var anonCount = 0;                                                                                                   // 275
  var counter = 0;                                                                                                     // 276
                                                                                                                       //
  backers.split("\n").forEach(function (name) {                                                                        // 278
    name = name.trim();                                                                                                // 279
    if (name === "") {                                                                                                 // 280
      ++anonCount;                                                                                                     // 281
    } else {                                                                                                           // 282
      _this4.added("backers", counter++, { name: name });                                                              // 283
    }                                                                                                                  // 284
  });                                                                                                                  // 285
                                                                                                                       //
  // Text file ends in \n but that shouldn't count.                                                                    //
  --anonCount;                                                                                                         // 288
                                                                                                                       //
  this.added("backers", "anonymous", { count: anonCount - 1 });                                                        // 290
                                                                                                                       //
  this.ready();                                                                                                        // 292
});                                                                                                                    // 293
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"signup-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/signup-server.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file covers creation and consumption of invite keys (i.e. to invite people to become                           //
// users of the Sandstorm server).                                                                                     //
                                                                                                                       //
Meteor.publish("signupKey", function (key) {                                                                           // 20
  check(key, String);                                                                                                  // 21
  return SignupKeys.find(key);                                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  useSignupKey: function useSignupKey(key) {                                                                           // 26
    check(key, String);                                                                                                // 27
                                                                                                                       //
    if (!this.userId) {                                                                                                // 29
      throw new Meteor.Error(403, "Must be signed in.");                                                               // 30
    }                                                                                                                  // 31
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 33
    if (user.signupKey) {                                                                                              // 34
      // Don't waste it.                                                                                               //
      return;                                                                                                          // 36
    }                                                                                                                  // 37
                                                                                                                       //
    if (isDemoUser()) {                                                                                                // 39
      throw new Meteor.Error(403, "Demo users cannot accept invite keys. Please sign in as a real user.");             // 40
    }                                                                                                                  // 42
                                                                                                                       //
    if (!user.loginIdentities) {                                                                                       // 44
      // Don't consume signup key as identity user.                                                                    //
      return;                                                                                                          // 46
    }                                                                                                                  // 47
                                                                                                                       //
    var keyInfo = SignupKeys.findOne(key);                                                                             // 49
    if (!keyInfo || keyInfo.used) {                                                                                    // 50
      throw new Meteor.Error(403, "Invalid key or already used.");                                                     // 51
    }                                                                                                                  // 52
                                                                                                                       //
    if (isSignedUp() && user.payments && user.payments.id) {                                                           // 54
      // This user is already signed up with a payment account. Possibly, they signed up before                        //
      // using their invite, and then went back and clicked on the invite. As a result they                            //
      // probably now have two payment accounts. Mark this invite as used but also add a special                       //
      // flag so we can find it later and cancel the dupe payment account. Record who tried to                         //
      // use it so that we can transfer credits over if needed.                                                        //
      SignupKeys.update(key, { $set: { used: true, rejectedBy: this.userId } });                                       // 60
      return;                                                                                                          // 61
    }                                                                                                                  // 62
                                                                                                                       //
    var userFields = {                                                                                                 // 64
      signupKey: key,                                                                                                  // 65
      signupNote: keyInfo.note                                                                                         // 66
    };                                                                                                                 // 64
    if (keyInfo.email) {                                                                                               // 68
      userFields.signupEmail = keyInfo.email;                                                                          // 69
    }                                                                                                                  // 70
                                                                                                                       //
    if ("quota" in keyInfo) {                                                                                          // 72
      userFields.quota = keyInfo.quota;                                                                                // 73
    }                                                                                                                  // 74
                                                                                                                       //
    if (keyInfo.plan) {                                                                                                // 76
      userFields.plan = keyInfo.plan;                                                                                  // 77
    }                                                                                                                  // 78
                                                                                                                       //
    if (keyInfo.payments) {                                                                                            // 80
      userFields["payments.id"] = keyInfo.payments.id;                                                                 // 81
    }                                                                                                                  // 82
                                                                                                                       //
    Meteor.users.update(this.userId, { $set: userFields });                                                            // 84
    SignupKeys.update(key, { $set: { used: true } });                                                                  // 85
  }                                                                                                                    // 86
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"startup.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/startup.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file is for various startup code that doesn't fit neatly anywhere else                                         //
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 19
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 21
  var baseUrlRow = Misc.findOne({ _id: "BASE_URL" });                                                                  // 22
                                                                                                                       //
  if (!baseUrlRow) {                                                                                                   // 24
    // Fill data with current value in the case this is a first run                                                    //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 26
    Misc.insert(baseUrlRow);                                                                                           // 27
  } else if (baseUrlRow.value !== ROOT_URL) {                                                                          // 28
    console.log("resetting oauth");                                                                                    // 29
    Settings.find({ _id: { $in: ["google", "github"] } }).forEach(function (setting) {                                 // 30
      if (!!setting.value) {                                                                                           // 31
        Settings.update({ _id: setting._id }, { $set: { value: false,                                                  // 32
            automaticallyReset: { baseUrlChangedFrom: baseUrlRow.value } } });                                         // 34
      }                                                                                                                // 35
    });                                                                                                                // 36
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 37
    Misc.update({ _id: "BASE_URL" }, { $set: { value: ROOT_URL } });                                                   // 38
  }                                                                                                                    // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"stats-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/stats-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var DAY_MS = 24 * 60 * 60 * 1000;                                                                                      // 19
                                                                                                                       //
if (Mongo.Collection.prototype.aggregate) {                                                                            // 21
  throw new Error("Looks like Meteor wrapped the Collection.aggregate() call. Make sure it " + "works then delete our own wrapper.");
}                                                                                                                      // 24
                                                                                                                       //
Mongo.Collection.prototype.aggregate = function () {                                                                   // 26
  // Meteor doesn't wrapp Mongo's aggregate() method.                                                                  //
  var raw = this.rawCollection();                                                                                      // 28
  return Meteor.wrapAsync(raw.aggregate, raw).apply(raw, arguments);                                                   // 29
};                                                                                                                     // 30
                                                                                                                       //
computeStats = function computeStats(since) {                                                                          // 32
  // We'll need this for a variety of queries.                                                                         //
  var timeConstraint = { $gt: since };                                                                                 // 34
                                                                                                                       //
  // This calculates the number of user accounts that have been used                                                   //
  // during the requested time period.                                                                                 //
  var currentlyActiveUsersCount = Meteor.users.find({                                                                  // 38
    expires: { $exists: false },                                                                                       // 39
    loginIdentities: { $exists: true },                                                                                // 40
    lastActive: timeConstraint                                                                                         // 41
  }).count();                                                                                                          // 38
                                                                                                                       //
  // This calculates the number of grains that have been used during                                                   //
  // the requested time period.                                                                                        //
  var activeGrainsCount = Grains.find({ lastUsed: timeConstraint }).count();                                           // 46
                                                                                                                       //
  // If Meteor.settings.allowDemoAccounts is true, DeleteStats                                                         //
  // contains records of type `user` and `appDemoUser`, indicating                                                     //
  // the number of those types of accounts that were created and                                                       //
  // then auto-expired through the demo mode's auto-account-expiry.                                                    //
  var deletedDemoUsersCount = DeleteStats.find({ type: "demoUser", lastActive: timeConstraint }).count();              // 52
  var deletedAppDemoUsersCount = DeleteStats.find({ type: "appDemoUser", lastActive: timeConstraint }).count();        // 54
                                                                                                                       //
  // Similarly, if the demo is enabled, we auto-delete grains; we store that                                           //
  // fact in DeleteStats with type: "grain".                                                                           //
  var deletedGrainsCount = DeleteStats.find({ type: "grain", lastActive: timeConstraint }).count();                    // 59
                                                                                                                       //
  var apps = Grains.aggregate([{ $match: { lastUsed: timeConstraint } }, {                                             // 62
    $group: {                                                                                                          // 65
      _id: "$appId",                                                                                                   // 66
      grains: { $sum: 1 },                                                                                             // 67
      userIds: { $addToSet: "$userId" }                                                                                // 68
    }                                                                                                                  // 65
  }, {                                                                                                                 // 64
    $project: {                                                                                                        // 72
      grains: 1,                                                                                                       // 73
      owners: { $size: "$userIds" }                                                                                    // 74
    }                                                                                                                  // 72
  }]);                                                                                                                 // 71
  apps = _.indexBy(apps, "_id");                                                                                       // 78
                                                                                                                       //
  for (var appId in apps) {                                                                                            // 80
    // We need to count ApiTokens, which don't have appId denormalized into them. We therefore                         //
    // have to fetch a list of grainIds first.                                                                         //
    // TODO(perf): If stats are getting slow, denormalize appId into ApiTokens. Note that it is                        //
    //   already denormalized for the specific case of apps that don't have icons, but the data                        //
    //   for that use case is NOT safe to use here because it's intended that we might allow an                        //
    //   app to mimic another app's icon by spoofing that app ID. In other words, the existing                         //
    //   denormalization of appId should be considered "app ID for identicon purposes only". We'll                     //
    //   need to add a new denormalization for stats purposes -- and make sure that it is not                          //
    //   revealed to the user.                                                                                         //
    var app = apps[appId];                                                                                             // 90
    delete app._id;                                                                                                    // 91
    var grains = Grains.find({                                                                                         // 92
      lastUsed: timeConstraint,                                                                                        // 93
      appId: appId                                                                                                     // 94
    }, {                                                                                                               // 92
      fields: { _id: 1 }                                                                                               // 96
    }).fetch();                                                                                                        // 95
    var grainIds = _.pluck(grains, "_id");                                                                             // 98
                                                                                                                       //
    var counts = ApiTokens.aggregate([{                                                                                // 100
      $match: {                                                                                                        // 102
        "owner.user": { $exists: true },                                                                               // 103
        lastUsed: timeConstraint,                                                                                      // 104
        grainId: { $in: grainIds }                                                                                     // 105
      }                                                                                                                // 102
    }, { $group: { _id: "$owner.user.identityId" } }, {                                                                // 101
      $group: {                                                                                                        // 110
        _id: "count",                                                                                                  // 111
        count: { $sum: 1 }                                                                                             // 112
      }                                                                                                                // 110
    }]);                                                                                                               // 109
                                                                                                                       //
    if (counts.length > 0) {                                                                                           // 117
      if (counts.length !== 1) {                                                                                       // 118
        console.error("error: sharedUsers aggregation returned multiple rows");                                        // 119
      }                                                                                                                // 120
                                                                                                                       //
      app.sharedUsers = counts[0].count;                                                                               // 122
    }                                                                                                                  // 123
  }                                                                                                                    // 124
                                                                                                                       //
  // Count per-app appdemo users and deleted grains.                                                                   //
  DeleteStats.aggregate([{                                                                                             // 127
    $match: {                                                                                                          // 129
      lastActive: timeConstraint,                                                                                      // 130
      appId: { $exists: true }                                                                                         // 131
    }                                                                                                                  // 129
  }, {                                                                                                                 // 128
    $group: {                                                                                                          // 135
      _id: {                                                                                                           // 136
        appId: "$appId",                                                                                               // 137
        type: "$type"                                                                                                  // 138
      },                                                                                                               // 136
      count: { $sum: 1 }                                                                                               // 140
    }                                                                                                                  // 135
  }]).forEach(function (deletion) {                                                                                    // 134
    var app = apps[deletion._id.appId];                                                                                // 144
    if (!app) {                                                                                                        // 145
      app = apps[deletion.appId] = {};                                                                                 // 146
    }                                                                                                                  // 147
                                                                                                                       //
    if (deletion._id.type === "appDemoUser") {                                                                         // 149
      app.appDemoUsers = deletion.count;                                                                               // 150
    } else if (deletion._id.type === "grain") {                                                                        // 151
      app.deleted = deletion.count;                                                                                    // 152
    } else if (deletion._id.type === "demoGrain") {                                                                    // 153
      app.demoed = deletion.count;                                                                                     // 154
    }                                                                                                                  // 155
  });                                                                                                                  // 156
                                                                                                                       //
  return {                                                                                                             // 158
    activeUsers: currentlyActiveUsersCount,                                                                            // 159
    demoUsers: deletedDemoUsersCount,                                                                                  // 160
    appDemoUsers: deletedAppDemoUsersCount,                                                                            // 161
    activeGrains: activeGrainsCount + deletedGrainsCount,                                                              // 162
    apps: apps                                                                                                         // 163
  };                                                                                                                   // 158
};                                                                                                                     // 165
                                                                                                                       //
function recordStats() {                                                                                               // 167
  var now = new Date();                                                                                                // 168
                                                                                                                       //
  var planStats = _.countBy(Meteor.users.find({ expires: { $exists: false }, "payments.id": { $exists: true } }, { fields: { plan: 1 } }).fetch(), "plan");
                                                                                                                       //
  var record = {                                                                                                       // 176
    timestamp: now,                                                                                                    // 177
    daily: computeStats(new Date(now.getTime() - DAY_MS)),                                                             // 178
    weekly: computeStats(new Date(now.getTime() - 7 * DAY_MS)),                                                        // 179
    monthly: computeStats(new Date(now.getTime() - 30 * DAY_MS)),                                                      // 180
    forever: computeStats(new Date(0)),                                                                                // 181
    plans: planStats                                                                                                   // 182
  };                                                                                                                   // 176
  record.computeTime = Date.now() - now;                                                                               // 184
                                                                                                                       //
  ActivityStats.insert(record);                                                                                        // 186
  var age = ActivityStats.find().count();                                                                              // 187
  if (age > 3) {                                                                                                       // 188
    var reportSetting = Settings.findOne({ _id: "reportStats" });                                                      // 189
    if (!reportSetting) {                                                                                              // 190
      // Setting not set yet, send out notifications and set it to false                                               //
      globalDb.sendAdminNotification("You can help Sandstorm by sending us some anonymous " + "usage stats. Click here for more info.", "/admin/stats");
      Settings.insert({ _id: "reportStats", value: "unset" });                                                         // 194
    } else if (reportSetting.value === true) {                                                                         // 195
      // The stats page which the user agreed we can send actually displays the whole history                          //
      // of the server, but we're only sending stats from the last day. Let's also throw in the                        //
      // length of said history. This is still strictly less information than what the user said                       //
      // we're allowed to send.                                                                                        //
      record.serverAge = age;                                                                                          // 200
                                                                                                                       //
      HTTP.post("https://alpha-api.sandstorm.io/data", {                                                               // 202
        data: record,                                                                                                  // 203
        headers: {                                                                                                     // 204
          Authorization: "Bearer aT-mGyNwsgwZBbZvd5FWr0Ma79O9IehI4NiEO94y_oR",                                         // 205
          "Content-Type": "application/json"                                                                           // 206
        }                                                                                                              // 204
      });                                                                                                              // 202
    }                                                                                                                  // 209
  }                                                                                                                    // 210
}                                                                                                                      // 211
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 213
  // Wait until 10:00 UTC (2:00 PST / 5:00 EST), then start recording stats every 24 hours.                            //
  // (Only on the first replica to avoid conflicts.)                                                                   //
  Meteor.setTimeout(function () {                                                                                      // 216
    Meteor.setInterval(function () {                                                                                   // 217
      recordStats();                                                                                                   // 218
    }, DAY_MS);                                                                                                        // 219
                                                                                                                       //
    recordStats();                                                                                                     // 221
  }, DAY_MS - (Date.now() - 10 * 60 * 60 * 1000) % DAY_MS);                                                            // 222
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 224
    if (StatsTokens.find().count() === 0) {                                                                            // 225
      StatsTokens.remove({});                                                                                          // 226
      StatsTokens.insert({ _id: Random.id(22) });                                                                      // 227
    }                                                                                                                  // 228
  });                                                                                                                  // 229
}                                                                                                                      // 230
                                                                                                                       //
Meteor.methods({                                                                                                       // 232
  regenerateStatsToken: function regenerateStatsToken() {                                                              // 233
    if (!isAdmin()) {                                                                                                  // 234
      throw new Meteor.Error(403, "Unauthorized", "User must be admin");                                               // 235
    }                                                                                                                  // 236
                                                                                                                       //
    StatsTokens.remove({});                                                                                            // 238
    var token = StatsTokens.insert({ _id: Random.id(22) });                                                            // 239
    return token._id;                                                                                                  // 240
  }                                                                                                                    // 241
});                                                                                                                    // 232
                                                                                                                       //
Router.map(function () {                                                                                               // 244
  this.route("fetchStats", {                                                                                           // 245
    where: "server",                                                                                                   // 246
    path: "/fetchStats/:tokenId",                                                                                      // 247
    action: function action() {                                                                                        // 248
      var token = StatsTokens.findOne({ _id: this.params.tokenId });                                                   // 249
                                                                                                                       //
      if (!token) {                                                                                                    // 251
        this.response.writeHead(404, {                                                                                 // 252
          "Content-Type": "text/plain"                                                                                 // 253
        });                                                                                                            // 252
        this.response.write("Token not found");                                                                        // 255
        return this.response.end();                                                                                    // 256
      }                                                                                                                // 257
                                                                                                                       //
      try {                                                                                                            // 259
        var stats = ActivityStats.find().fetch();                                                                      // 260
        var statsString = JSON.stringify(stats);                                                                       // 261
                                                                                                                       //
        this.response.writeHead(200, {                                                                                 // 263
          "Content-Type": "application/json"                                                                           // 264
        });                                                                                                            // 263
        this.response.write(statsString);                                                                              // 266
      } catch (error) {                                                                                                // 267
        console.error(error.stack);                                                                                    // 268
        this.response.writeHead(500, {                                                                                 // 269
          "Content-Type": "text/plain"                                                                                 // 270
        });                                                                                                            // 269
        this.response.write(error.stack);                                                                              // 272
      }                                                                                                                // 273
                                                                                                                       //
      return this.response.end();                                                                                      // 275
    }                                                                                                                  // 276
  });                                                                                                                  // 245
});                                                                                                                    // 278
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"imports":{"server":{"auth.js":["meteor/meteor","meteor/check","crypto","fs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/auth.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({checkAuth:function(){return checkAuth},clearAdminToken:function(){return clearAdminToken},tokenIsValid:function(){return tokenIsValid},tokenIsSetupSession:function(){return tokenIsSetupSession}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
// TODO(cleanup): globalDb is still an unbound global, but extracting it is Hard.                                      //
                                                                                                                       //
var ADMIN_TOKEN_EXPIRATION_TIME = 15 * 60 * 1000;                                                                      // 7
var SANDSTORM_ADMIN_TOKEN = SANDSTORM_VARDIR + "/adminToken";                                                          // 8
                                                                                                                       //
function clearAdminToken(token) {                                                                                      // 10
  if (tokenIsSetupSession(token)) {                                                                                    // 11
    var hash = Crypto.createHash("sha256").update(token).digest("base64");                                             // 12
    globalDb.collections.setupSession.remove({                                                                         // 13
      _id: "current-session",                                                                                          // 14
      hashedSessionId: hash                                                                                            // 15
    });                                                                                                                // 13
  }                                                                                                                    // 17
                                                                                                                       //
  if (tokenIsValid(token)) {                                                                                           // 19
    Fs.unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                              // 20
    console.log("Admin token deleted.");                                                                               // 21
  }                                                                                                                    // 22
}                                                                                                                      // 23
                                                                                                                       //
function tokenIsValid(token) {                                                                                         // 25
  if (token && Fs.existsSync(SANDSTORM_ADMIN_TOKEN)) {                                                                 // 26
    var stats = Fs.statSync(SANDSTORM_ADMIN_TOKEN);                                                                    // 27
    var expireTime = new Date(Date.now() - ADMIN_TOKEN_EXPIRATION_TIME);                                               // 28
    if (stats.mtime < expireTime) {                                                                                    // 29
      return false;                                                                                                    // 30
    } else {                                                                                                           // 31
      return Fs.readFileSync(SANDSTORM_ADMIN_TOKEN, { encoding: "utf8" }) === token;                                   // 32
    }                                                                                                                  // 33
  } else {                                                                                                             // 34
    return false;                                                                                                      // 35
  }                                                                                                                    // 36
}                                                                                                                      // 37
                                                                                                                       //
function tokenIsSetupSession(token) {                                                                                  // 39
  if (token) {                                                                                                         // 40
    var setupSession = globalDb.collections.setupSession.findOne({ _id: "current-session" });                          // 41
    if (setupSession) {                                                                                                // 42
      var hash = Crypto.createHash("sha256").update(token).digest("base64");                                           // 43
      var now = new Date();                                                                                            // 44
      var sessionLifetime = 24 * 60 * 60 * 1000; // length of setup session validity, in milliseconds: 1 day           // 45
      if (setupSession.hashedSessionId === hash && now - setupSession.creationDate < sessionLifetime) {                // 46
        return true;                                                                                                   // 47
      }                                                                                                                // 48
    }                                                                                                                  // 49
  }                                                                                                                    // 50
                                                                                                                       //
  return false;                                                                                                        // 52
}                                                                                                                      // 53
                                                                                                                       //
function checkAuth(token) {                                                                                            // 55
  check(token, Match.OneOf(undefined, null, String));                                                                  // 56
  if (!isAdmin() && !tokenIsValid(token) && !tokenIsSetupSession(token)) {                                             // 57
    throw new Meteor.Error(403, "User must be admin or provide a valid token");                                        // 58
  }                                                                                                                    // 59
}                                                                                                                      // 60
                                                                                                                       //
                                                                                                                       // 62
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"frontend-ref.js":["babel-runtime/helpers/classCallCheck","./persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/frontend-ref.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({FrontendRefRegistry:function(){return FrontendRefRegistry}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var checkRequirements;module.import("./persistent.js",{"checkRequirements":function(v){checkRequirements=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var FrontendRefRegistry = function () {                                                                                //
  function FrontendRefRegistry() {                                                                                     // 20
    _classCallCheck(this, FrontendRefRegistry);                                                                        // 20
                                                                                                                       //
    this._frontendRefHandlers = {};                                                                                    // 21
    this._typeIdHandlers = {};                                                                                         // 22
  }                                                                                                                    // 23
                                                                                                                       //
  FrontendRefRegistry.prototype.create = function create(db, frontendRef, requirements) {                              //
    // Construct a fresh capability based on a `frontendRef` value.                                                    //
                                                                                                                       //
    checkRequirements(requirements);                                                                                   // 28
                                                                                                                       //
    var saveTemplate = { frontendRef: frontendRef };                                                                   // 30
    if (requirements) {                                                                                                // 31
      saveTemplate.requirements = requirements;                                                                        // 32
    }                                                                                                                  // 33
                                                                                                                       //
    return this.restore(db, saveTemplate, frontendRef);                                                                // 35
  };                                                                                                                   // 36
                                                                                                                       //
  FrontendRefRegistry.prototype.restore = function restore(db, saveTemplate, frontendRef) {                            //
    // Restores a frontendRef capability using the appropriate registered handler.                                     //
                                                                                                                       //
    var keys = Object.keys(frontendRef);                                                                               // 41
    if (keys.length != 1) {                                                                                            // 42
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 43
    }                                                                                                                  // 44
                                                                                                                       //
    var key = keys[0];                                                                                                 // 46
    var handler = this._frontendRefHandlers[key];                                                                      // 47
    if (!handler) {                                                                                                    // 48
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 49
    }                                                                                                                  // 50
                                                                                                                       //
    return handler.restore(db, saveTemplate, frontendRef[key]);                                                        // 52
  };                                                                                                                   // 53
                                                                                                                       //
  FrontendRefRegistry.prototype.query = function query(db, userAccountId, tag) {                                       //
    // Performs a powerbox query using the appropriate registered handler.                                             //
                                                                                                                       //
    var handler = this._typeIdHandlers[tag.id];                                                                        // 58
    if (handler) {                                                                                                     // 59
      return handler.query(db, userAccountId, tag.value);                                                              // 60
    } else {                                                                                                           // 61
      return []; // no matches                                                                                         // 62
    }                                                                                                                  // 63
  };                                                                                                                   // 64
                                                                                                                       //
  FrontendRefRegistry.prototype.validate = function validate(db, session, mutableFrontendRef) {                        //
    // Validates a powerbox request on the given `session` (a record from the Sessions table)                          //
    // requesting the creation of the given frontendRef type. `mutableFrontendRef` is expected to                      //
    // come directly from the client; calling validate() verifies that it has a valid type, and                        //
    // may modify the value to add bits that need to be generated server-side. `validate()` also                       //
    // returns an array of MembraneRequirements that shall apply to the capability. These                              //
    // requirements will not yet have been checked, so the caller should check them before                             //
    // proceeding.                                                                                                     //
                                                                                                                       //
    var keys = Object.keys(mutableFrontendRef);                                                                        // 75
    if (keys.length != 1) {                                                                                            // 76
      throw new Error("invalid frontendRef: " + JSON.stringify(mutableFrontendRef));                                   // 77
    }                                                                                                                  // 78
                                                                                                                       //
    var key = keys[0];                                                                                                 // 80
    var handler = this._frontendRefHandlers[key];                                                                      // 81
    if (!handler) {                                                                                                    // 82
      throw new Error("invalid frontendRef: " + JSON.stringify(mutableFrontendRef));                                   // 83
    }                                                                                                                  // 84
                                                                                                                       //
    if (!handler.validate) {                                                                                           // 86
      throw new Error("frontendRef type cannot be created via powerbox: " + JSON.stringify(mutableFrontendRef));       // 87
    }                                                                                                                  // 89
                                                                                                                       //
    return handler.validate(db, session, mutableFrontendRef[key]);                                                     // 91
  };                                                                                                                   // 92
                                                                                                                       //
  FrontendRefRegistry.prototype.register = function register(object) {                                                 //
    // Register callbacks related to a particular frontendRef type. The object has the fields:                         //
    //   `frontendRefField`: Name of the field of `ApiTokens.frontendRef` that is filled in for                        //
    //       this type. Only needed if `create` and/or `validate` handlers are defined.                                //
    //   `typeId`: Type ID of powerbox tags handled by the `query` callback. Stringified decimal                       //
    //       64-bit integer. Only needed if `query` is defined.                                                        //
    //   `restore`: Callback to construct a capability of this type when restoring a saved                             //
    //       capability. Has signature `(db, saveTemplate, value) -> capability`, where:                               //
    //     `value`: The value of the single field of `ApiTokens.frontendRef` for this capability.                      //
    //     `saveTemplate`: The token template to pass to the PersistentImpl constructor.                               //
    //     `capability` (returned): A Cap'n Proto capability implementing SystemPersistent along                       //
    //         with whatever other interfaces are appropriate for the ref type.                                        //
    //   `validate`: Callback to validate a powerbox request for a new capability of this type.                        //
    //       Has signature `(db, session, mutableValue) -> {descriptor, requirements}`, where:                         //
    //     `mutableValue` is the value of the single field of `frontendRef` for this capability.                       //
    //         If this is an object value, the callback may optionally modify it, e.g. adding                          //
    //         additional fields that need to be generated server-side. The callback *must*, at                        //
    //         the very least, type-check this value. It should throw an exception if the vaule is                     //
    //         not valid.                                                                                              //
    //     `session` is the record from the Sessions table of the UI session where the powerbox                        //
    //         request occurred.                                                                                       //
    //     `descriptor` (returned) is the JSON-encoded PowerboxDescriptor for the capability. Note                     //
    //         that if the descriptor contains any `tag.value`s, they of course need to be                             //
    //         presented as capnp-encoded Buffers.                                                                     //
    //     `requirements` (returned) is an array of MembraneRequirements which should apply to the                     //
    //         new capability. Note that these requirements will be checked immediately and the                        //
    //         powerbox request will fail if they aren't met.                                                          //
    //    `query`: Callback to populate options for a powerbox request for this type ID. Has                           //
    //        signature `(db, userAccountId, tagValue) -> options`, where:                                             //
    //      `tagValue`: A Buffer of the Cap'n-Proto-encoded `PowerboxDescriptor.Tag.value`.                            //
    //      `options` (returned): An array of objects representing the options that should be                          //
    //          offered to the user for this query. See the `powerboxOptions` Meteor publish in                        //
    //          powerbox-server.js for a full description of the fields of each option.                                //
                                                                                                                       //
    if (object.frontendRefField) {                                                                                     // 128
      if (object.frontendRefField in this._frontendRefHandlers) {                                                      // 129
        throw new Error("frontendRef handler already registered: " + object.frontendRefField);                         // 130
      }                                                                                                                // 131
                                                                                                                       //
      this._frontendRefHandlers[object.frontendRefField] = object;                                                     // 133
    }                                                                                                                  // 134
                                                                                                                       //
    if (object.typeId) {                                                                                               // 136
      if (object.typeId in this._typeIdHandlers) {                                                                     // 137
        throw new Error("typeId handler already registered: " + object.typeId);                                        // 138
      }                                                                                                                // 139
                                                                                                                       //
      this._typeIdHandlers[object.typeId] = object;                                                                    // 141
    }                                                                                                                  // 142
  };                                                                                                                   // 143
                                                                                                                       //
  return FrontendRefRegistry;                                                                                          //
}();                                                                                                                   //
                                                                                                                       //
                                                                                                                       // 146
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"persistent.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/persistent.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({PersistentImpl:function(){return PersistentImpl},hashSturdyRef:function(){return hashSturdyRef},generateSturdyRef:function(){return generateSturdyRef},checkRequirements:function(){return checkRequirements}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
var privateDb = Symbol("PersistentImpl.db");                                                                           // 19
var privateTemplate = Symbol("PersistentImpl.template");                                                               // 20
var privateIsSaved = Symbol("PersistentImpl.isSaved");                                                                 // 21
                                                                                                                       //
var PersistentImpl = function () {                                                                                     //
  function PersistentImpl(db, saveTemplate) {                                                                          // 24
    _classCallCheck(this, PersistentImpl);                                                                             // 24
                                                                                                                       //
    this[privateDb] = db;                                                                                              // 25
    this[privateTemplate] = saveTemplate;                                                                              // 26
                                                                                                                       //
    // TODO(someday): This may or may not be quite right in cases where we're saving a root token                      //
    //   by copy. Is the copy the "same" capability or not? Today, isSaved() is only used by                           //
    //   wakelock notification handles which are not issued through the powerbox, therefore do not                     //
    //   go through claimRequest(), therefore are not saved by copy, so the point is moot.                             //
    this[privateIsSaved] = !!saveTemplate.parentToken;                                                                 // 32
  }                                                                                                                    // 33
                                                                                                                       //
  PersistentImpl.prototype.isSaved = function isSaved() {                                                              //
    // Can be called by subclasses to ask whether or not a record currently exists in the ApiTokens                    //
    // table representing this capability.                                                                             //
                                                                                                                       //
    return this[privateIsSaved];                                                                                       // 39
  };                                                                                                                   // 40
                                                                                                                       //
  PersistentImpl.prototype.save = function save(params) {                                                              //
    var _this = this;                                                                                                  // 42
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 43
      if (!params.sealFor) {                                                                                           // 44
        throw new Error("must specify 'sealFor'");                                                                     // 45
      }                                                                                                                // 46
                                                                                                                       //
      var db = _this[privateDb];                                                                                       // 48
                                                                                                                       //
      var newToken = _.clone(_this[privateTemplate]);                                                                  // 50
      newToken.owner = params.sealFor;                                                                                 // 51
      if (newToken.owner.user) {                                                                                       // 52
        if (!newToken.identityId) {                                                                                    // 53
          throw new Error("can't save non-UiView with user as owner");                                                 // 54
        }                                                                                                              // 55
                                                                                                                       //
        // Only "identityId" and "title" are allowed to be passed to save().                                           //
        var userOwner = _.pick(newToken.owner.user, "identityId", "title");                                            // 58
                                                                                                                       //
        // Fill in denormalizedGrainMetadata and upstreamTitle ourselves.                                              //
        userOwner.denormalizedGrainMetadata = db.getDenormalizedGrainInfo(newToken.grainId);                           // 61
                                                                                                                       //
        var grain = db.getGrain(newToken.grainId);                                                                     // 63
        if (grain && grain.title !== userOwner.title) {                                                                // 64
          userOwner.upstreamTitle = grain.title;                                                                       // 65
        }                                                                                                              // 66
                                                                                                                       //
        newToken.owner.user = userOwner;                                                                               // 68
      }                                                                                                                // 69
                                                                                                                       //
      var sturdyRef = generateSturdyRef();                                                                             // 71
      newToken._id = hashSturdyRef(sturdyRef);                                                                         // 72
                                                                                                                       //
      newToken.created = new Date();                                                                                   // 74
                                                                                                                       //
      db.collections.apiTokens.insert(newToken);                                                                       // 76
      _this[privateIsSaved] = true;                                                                                    // 77
      return { sturdyRef: new Buffer(sturdyRef) };                                                                     // 78
    });                                                                                                                // 79
  };                                                                                                                   // 80
                                                                                                                       //
  // TODO(someday): Implement SystemPersistent.addRequirements().                                                      //
                                                                                                                       //
                                                                                                                       //
  return PersistentImpl;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
function hashSturdyRef(sturdyRef) {                                                                                    // 85
  return Crypto.createHash("sha256").update(sturdyRef).digest("base64");                                               // 86
};                                                                                                                     // 87
                                                                                                                       //
function generateSturdyRef() {                                                                                         // 89
  return Random.secret();                                                                                              // 90
}                                                                                                                      // 91
                                                                                                                       //
function checkRequirements(db, requirements) {                                                                         // 93
  // Checks if the given list of MembraneRequirements are all satisfied, returning true if so and                      //
  // false otherwise.                                                                                                  //
                                                                                                                       //
  // TODO(cleanup): SandstormPermissions has a different way of checking the same requirements.                        //
  //   Reuse?                                                                                                          //
                                                                                                                       //
  // TODO(security): Eventually we want checkRequirements(), when it passes, to produce an observer                    //
  //   that can be used to receive a notification when the requirements may no longer be satisfied,                    //
  //   in order to revoke the live object. See RequirementObserver in supervisor.capnp.                                //
                                                                                                                       //
  if (!requirements) {                                                                                                 // 104
    return true;                                                                                                       // 105
  }                                                                                                                    // 106
                                                                                                                       //
  requirements.forEach(function (requirement) {                                                                        // 108
    if (requirement.tokenValid) {                                                                                      // 109
      var token = db.collections.apiTokens.findOne({ _id: requirement.tokenValid, revoked: { $ne: true } }, { fields: { requirements: 1 } });
      if (!token) {                                                                                                    // 113
        throw new Meteor.Error(403, "Capability revoked because the link through which it was introduced has been " + "revoked or deleted.");
      }                                                                                                                // 117
                                                                                                                       //
      checkRequirements(db, token.requirements);                                                                       // 119
                                                                                                                       //
      if (token.parentToken) {                                                                                         // 121
        checkRequirements(db, [{ tokenValid: token.parentToken }]);                                                    // 122
      }                                                                                                                // 123
    } else if (requirement.permissionsHeld) {                                                                          // 124
      var p = requirement.permissionsHeld;                                                                             // 125
      var viewInfo = db.collections.grains.findOne(p.grainId, { fields: { cachedViewInfo: 1 } }).cachedViewInfo;       // 126
      var currentPermissions = SandstormPermissions.grainPermissions(db, { grain: { _id: p.grainId, identityId: p.identityId } }, viewInfo || {}).permissions;
      if (!currentPermissions) {                                                                                       // 130
        throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
      }                                                                                                                // 134
                                                                                                                       //
      var requiredPermissions = p.permissions || [];                                                                   // 136
      for (var ii = 0; ii < requiredPermissions.length; ++ii) {                                                        // 137
        if (requiredPermissions[ii] && !currentPermissions[ii]) {                                                      // 138
          throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
        }                                                                                                              // 142
      }                                                                                                                // 143
    } else if (requirement.userIsAdmin) {                                                                              // 144
      if (!db.isAdminById(requirement.userIsAdmin)) {                                                                  // 145
        throw new Meteor.Error(403, "Capability revoked because the user who created it has lost their admin " + "rights.");
      }                                                                                                                // 149
    } else {                                                                                                           // 150
      throw new Meteor.Error(403, "Unknown requirement type.");                                                        // 151
    }                                                                                                                  // 152
  });                                                                                                                  // 153
};                                                                                                                     // 154
                                                                                                                       //
                                                                                                                       // 156
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"db-deprecated.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/db-deprecated.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file imports symbols from the sandstorm-db package. New code should use SandstormDb                            //
// directly.                                                                                                           //
                                                                                                                       //
// TODO(cleanup): Over time, eliminate the use of each of these assignments by using `globalDb`                        //
//   directly. For collections, prefer to update SandstormDb to provide methods for querying the                       //
//   collection rather than use `globalDb.collections` directly. When code is moved into packages,                     //
//   the `globalDb` global should NOT go with it; the package should expect a SandstormDb to be                        //
//   passed in, thus allowing mocking the database for unit tests.                                                     //
                                                                                                                       //
globalDb = new SandstormDb();                                                                                          // 26
                                                                                                                       //
Packages = globalDb.collections.packages;                                                                              // 28
DevPackages = globalDb.collections.devPackages;                                                                        // 29
UserActions = globalDb.collections.userActions;                                                                        // 30
Grains = globalDb.collections.grains;                                                                                  // 31
Contacts = globalDb.collections.contacts;                                                                              // 32
Sessions = globalDb.collections.sessions;                                                                              // 33
SignupKeys = globalDb.collections.signupKeys;                                                                          // 34
ActivityStats = globalDb.collections.activityStats;                                                                    // 35
DeleteStats = globalDb.collections.deleteStats;                                                                        // 36
FileTokens = globalDb.collections.fileTokens;                                                                          // 37
ApiTokens = globalDb.collections.apiTokens;                                                                            // 38
Notifications = globalDb.collections.notifications;                                                                    // 39
StatsTokens = globalDb.collections.statsTokens;                                                                        // 40
Misc = globalDb.collections.misc;                                                                                      // 41
Settings = globalDb.collections.settings;                                                                              // 42
                                                                                                                       //
currentUserGrains = globalDb.currentUserGrains.bind(globalDb);                                                         // 44
isDemoUser = globalDb.isDemoUser.bind(globalDb);                                                                       // 45
isSignedUp = globalDb.isSignedUp.bind(globalDb);                                                                       // 46
isSignedUpOrDemo = globalDb.isSignedUpOrDemo.bind(globalDb);                                                           // 47
isUserOverQuota = globalDb.isUserOverQuota.bind(globalDb);                                                             // 48
isUserExcessivelyOverQuota = globalDb.isUserExcessivelyOverQuota.bind(globalDb);                                       // 49
isAdmin = globalDb.isAdmin.bind(globalDb);                                                                             // 50
isAdminById = globalDb.isAdminById.bind(globalDb);                                                                     // 51
findAdminUserForToken = globalDb.findAdminUserForToken.bind(globalDb);                                                 // 52
matchWildcardHost = globalDb.matchWildcardHost.bind(globalDb);                                                         // 53
makeWildcardHost = globalDb.makeWildcardHost.bind(globalDb);                                                           // 54
allowDevAccounts = globalDb.allowDevAccounts.bind(globalDb);                                                           // 55
roleAssignmentPattern = globalDb.roleAssignmentPattern;                                                                // 56
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"demo.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/demo.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({allowDemo:function(){return allowDemo}});// Sandstorm - Personal Cloud Sandbox                          //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var allowDemo = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDemoAccounts;           // 17
                                                                                                                       //
                                                                                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"shared":{"admin.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/admin.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
function serviceEnabled(name) {                                                                                        // 17
  var setting = Settings.findOne({ _id: name });                                                                       // 18
  return setting && !!setting.value;                                                                                   // 19
}                                                                                                                      // 20
                                                                                                                       //
Accounts.identityServices.github = {                                                                                   // 22
  isEnabled: function isEnabled() {                                                                                    // 23
    return serviceEnabled("github");                                                                                   // 24
  },                                                                                                                   // 25
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 27
    return identity.services.github.username;                                                                          // 28
  },                                                                                                                   // 29
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 31
    Meteor.loginWithGithub();                                                                                          // 32
    return { oneClick: true };                                                                                         // 33
  },                                                                                                                   // 34
                                                                                                                       //
  loginTemplate: {                                                                                                     // 36
    name: "oauthLoginButton",                                                                                          // 37
    priority: 1,                                                                                                       // 38
    data: {                                                                                                            // 39
      method: "loginWithGithub",                                                                                       // 40
      name: "github",                                                                                                  // 41
      displayName: "GitHub",                                                                                           // 42
      linkingNewIdentity: false                                                                                        // 43
    }                                                                                                                  // 39
  }                                                                                                                    // 36
};                                                                                                                     // 22
                                                                                                                       //
Accounts.identityServices.google = {                                                                                   // 48
  isEnabled: function isEnabled() {                                                                                    // 49
    return serviceEnabled("google");                                                                                   // 50
  },                                                                                                                   // 51
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 53
    return identity.services.google.email;                                                                             // 54
  },                                                                                                                   // 55
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 57
    Meteor.loginWithGoogle({ loginHint: loginId });                                                                    // 58
    return { oneClick: true };                                                                                         // 59
  },                                                                                                                   // 60
                                                                                                                       //
  loginTemplate: {                                                                                                     // 62
    name: "oauthLoginButton",                                                                                          // 63
    priority: 2,                                                                                                       // 64
    data: {                                                                                                            // 65
      method: "loginWithGoogle",                                                                                       // 66
      name: "google",                                                                                                  // 67
      displayName: "Google",                                                                                           // 68
      linkingNewIdentity: false                                                                                        // 69
    }                                                                                                                  // 65
  }                                                                                                                    // 62
};                                                                                                                     // 48
                                                                                                                       //
Accounts.identityServices.email = {                                                                                    // 74
  isEnabled: function isEnabled() {                                                                                    // 75
    return serviceEnabled("emailToken");                                                                               // 76
  },                                                                                                                   // 77
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 79
    return identity.services.email.email;                                                                              // 80
  },                                                                                                                   // 81
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 83
    return { form: true };                                                                                             // 84
  },                                                                                                                   // 85
                                                                                                                       //
  loginTemplate: {                                                                                                     // 87
    name: "emailLoginForm",                                                                                            // 88
    priority: 10                                                                                                       // 89
  }                                                                                                                    // 87
};                                                                                                                     // 74
                                                                                                                       //
Accounts.identityServices.ldap = {                                                                                     // 93
  isEnabled: function isEnabled() {                                                                                    // 94
    return serviceEnabled("ldap") && globalDb.isFeatureKeyValid();                                                     // 95
  },                                                                                                                   // 96
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 98
    return identity.services.ldap.username;                                                                            // 99
  },                                                                                                                   // 100
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 102
    return { form: true };                                                                                             // 103
  },                                                                                                                   // 104
                                                                                                                       //
  loginTemplate: {                                                                                                     // 106
    name: "ldapLoginForm",                                                                                             // 107
    priority: 21 }                                                                                                     // 108
};                                                                                                                     // 93
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.saml = {                                                                                     // 112
  isEnabled: function isEnabled() {                                                                                    // 113
    return serviceEnabled("saml") && globalDb.isFeatureKeyValid();                                                     // 114
  },                                                                                                                   // 115
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 117
    return identity.services.saml.id;                                                                                  // 118
  },                                                                                                                   // 119
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 121
    Meteor.loginWithSaml();                                                                                            // 122
    return { oneClick: true };                                                                                         // 123
  },                                                                                                                   // 124
                                                                                                                       //
  loginTemplate: {                                                                                                     // 126
    name: "samlLoginForm",                                                                                             // 127
    priority: 20 }                                                                                                     // 128
};                                                                                                                     // 112
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.demo = {                                                                                     // 132
  isEnabled: function isEnabled() {                                                                                    // 133
    return false; // You can never authenticate as a demo user.                                                        // 134
  },                                                                                                                   // 135
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 137
    return identity._id;                                                                                               // 138
  },                                                                                                                   // 139
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 141
    return { demoCannotLogin: true };                                                                                  // 142
  },                                                                                                                   // 143
                                                                                                                       //
  loginTemplate: {}                                                                                                    // 145
};                                                                                                                     // 132
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/dev-accounts.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Accounts.identityServices.dev = {                                                                                      // 17
  isEnabled: function isEnabled() {                                                                                    // 18
    return globalDb.allowDevAccounts();                                                                                // 19
  },                                                                                                                   // 20
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 22
    return identity.services.dev.name;                                                                                 // 23
  },                                                                                                                   // 24
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 26
    loginDevAccount(loginId);                                                                                          // 27
    return { oneClick: true };                                                                                         // 28
  },                                                                                                                   // 29
                                                                                                                       //
  loginTemplate: {                                                                                                     // 31
    name: "devLoginForm",                                                                                              // 32
    priority: -10 }                                                                                                    // 33
};                                                                                                                     // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"grain-shared.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/grain-shared.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.methods({                                                                                                       // 17
  // Methods defined in this file have meaningful latency compensation (client-side prediction)                        //
  // potential.                                                                                                        //
  //                                                                                                                   //
  // Methods for which latency compensation makes no sense are defined in grain-server.js.                             //
                                                                                                                       //
  markActivityReadByOwner: function markActivityReadByOwner(grainId) {                                                 // 23
    check(grainId, String);                                                                                            // 24
    check(this.userId, String);                                                                                        // 25
                                                                                                                       //
    Grains.update({ _id: grainId, userId: this.userId }, { $set: { "ownerSeenAllActivity": true } });                  // 27
  },                                                                                                                   // 29
                                                                                                                       //
  markActivityRead: function markActivityRead(grainId, identityId) {                                                   // 31
    check(grainId, String);                                                                                            // 32
    check(identityId, String);                                                                                         // 33
                                                                                                                       //
    if (!this.userId || !globalDb.userHasIdentity(this.userId, identityId)) {                                          // 35
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 36
    }                                                                                                                  // 37
                                                                                                                       //
    ApiTokens.update({ "grainId": grainId, "owner.user.identityId": identityId }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
  }                                                                                                                    // 41
});                                                                                                                    // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"install.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/install.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
isSafeDemoAppUrl = function isSafeDemoAppUrl(url) {                                                                    // 17
    // For demo accounts, we allow using a bare hash with no URL (which will never upload a new app)                   //
    // and we allow specifying a sandstorm.io URL.                                                                     //
    return !url || url.lastIndexOf("http://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://alpha-j7uny7u376jnimcsx34c.sandstorm.io/", 0) === 0 || url.lastIndexOf("https://app-index.sandstorm.io/", 0) === 0;
};                                                                                                                     // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"testing.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/testing.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 17
                                                                                                                       //
// jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                                 //
if (isTesting) {                                                                                                       // 21
  if (Meteor.isServer) {                                                                                               // 22
    (function () {                                                                                                     // 22
      var clearUser = function clearUser(id) {                                                                         // 22
        UserActions.remove({ userId: id });                                                                            // 24
        globalDb.removeApiTokens({ userId: id });                                                                      // 25
        Grains.find({ userId: id }).forEach(function (grain) {                                                         // 26
          globalBackend.deleteGrain(grain._id);                                                                        // 27
        });                                                                                                            // 28
                                                                                                                       //
        Grains.remove({ userId: id });                                                                                 // 30
        Meteor.users.remove({ _id: id });                                                                              // 31
      };                                                                                                               // 32
                                                                                                                       //
      Meteor.methods({                                                                                                 // 34
        createMockGithubUser: function createMockGithubUser() {                                                        // 35
          Meteor.users.update({ _id: "Py8fwsaryQNGBuiXb" }, { $set: { createdAt: new Date("2014-08-11T21:44:04.147Z"), isAdmin: true, lastActive: new Date("2014-08-19T09:58:39.676Z"), profile: { name: "Github User" }, services: { github: { accessToken: "sometoken", id: 1595880, username: "testuser" }, resume: { loginTokens: [{ when: new Date("2099-08-13T05:16:02.356Z"), hashedToken: "GriUSDp+uN/K4HptwSl1wsdWfHEpS8c9KjjdqwKNo0k=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 39
                                                                                                                       //
        clearMockGithubUser: function clearMockGithubUser() {                                                          // 41
          clearUser("Py8fwsaryQNGBuiXb");                                                                              // 42
        },                                                                                                             // 43
                                                                                                                       //
        createMockGoogleUser: function createMockGoogleUser() {                                                        // 45
          Meteor.users.update({ _id: "6WJcRo2gg2Ysuxsok" }, { $set: { createdAt: new Date("2014-08-21T07:52:55.581Z"), profile: { name: "Google User" }, services: { google: { accessToken: "sometoken", expiresAt: 4562182723000, id: "116893057283177439912", verified_email: true, name: "Google User", given_name: "Google", family_name: "User", picture: "https://lh3.googleusercontent.com/-XdUIqdMkCWA/AAAAAAAAAAI/AAAAAAAAAAA/4252rscbv5M/photo.jpg", locale: "en", gender: "male" }, resume: { loginTokens: [{ when: new Date("2099-08-21T07:52:55.592Z"), hashedToken: "cbJGxLGKW3f0j7Ehit77hdK58W7xuPjzZhGHgKhyddo=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 49
                                                                                                                       //
        clearMockGoogleUser: function clearMockGoogleUser() {                                                          // 51
          clearUser("6WJcRo2gg2Ysuxsok");                                                                              // 52
        },                                                                                                             // 53
                                                                                                                       //
        fetchAppIndexTest: function fetchAppIndexTest() {                                                              // 55
          SandstormAutoupdateApps.updateAppIndex(this.connection.sandstormDb);                                         // 56
        }                                                                                                              // 57
      });                                                                                                              // 34
    })();                                                                                                              // 22
  }                                                                                                                    // 59
                                                                                                                       //
  mockLoginGithub = function mockLoginGithub() {                                                                       // 61
    Meteor.call("createMockGithubUser", function (err) {                                                               // 62
      if (err) {                                                                                                       // 63
        console.log(err);                                                                                              // 64
      }                                                                                                                // 65
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "F0S6luPxIJV--y_GAkBKOMuWMYnnqgG3UMv9M-DIs2f");                 // 67
      window.localStorage.setItem("Meteor.loginTokenExpires", "Mon Nov 10 2099 21:16:02 GMT-0800 (PST)");              // 68
      window.localStorage.setItem("Meteor.userId", "Py8fwsaryQNGBuiXb");                                               // 69
      window.location.reload();                                                                                        // 70
    });                                                                                                                // 71
  };                                                                                                                   // 72
                                                                                                                       //
  clearMockGithubUser = function clearMockGithubUser() {                                                               // 74
    Meteor.call("clearMockGithubUser", function (err) {                                                                // 75
      if (err) {                                                                                                       // 76
        console.log(err);                                                                                              // 77
      }                                                                                                                // 78
    });                                                                                                                // 79
  };                                                                                                                   // 80
                                                                                                                       //
  mockLoginGoogle = function mockLoginGoogle() {                                                                       // 82
    Meteor.call("createMockGoogleUser", function (err) {                                                               // 83
      if (err) {                                                                                                       // 84
        console.log(err);                                                                                              // 85
      }                                                                                                                // 86
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "P3ffUfVJtptyVX2IPUfNDZY0F3b-GIZ-WQf7w3GdL21");                 // 88
      window.localStorage.setItem("Meteor.loginTokenExpires", "Tue Nov 18 2099 23:52:55 GMT-0800 (PST)");              // 89
      window.localStorage.setItem("Meteor.userId", "6WJcRo2gg2Ysuxsok");                                               // 90
      window.location.reload();                                                                                        // 91
    });                                                                                                                // 92
  };                                                                                                                   // 93
                                                                                                                       //
  clearMockGoogleUser = function clearMockGoogleUser() {                                                               // 95
    Meteor.call("clearMockGoogleUser", function (err) {                                                                // 96
      if (err) {                                                                                                       // 97
        console.log(err);                                                                                              // 98
      }                                                                                                                // 99
    });                                                                                                                // 100
  };                                                                                                                   // 101
}                                                                                                                      // 102
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}},{"extensions":[".js",".json"]});
require("./server/lib/constants.js");
require("./server/accounts/accounts-ui-methods.js");
require("./server/accounts/accounts-ui-server.js");
require("./server/admin/admin-alert-server.js");
require("./server/admin/admin-user-invite.js");
require("./server/admin/network-capabilities-server.js");
require("./server/admin/personalization-server.js");
require("./server/admin/system-status-server.js");
require("./server/drivers/external-ui-view.js");
require("./server/drivers/ip.js");
require("./server/drivers/mail.js");
require("./server/00-startup.js");
require("./server/admin-server.js");
require("./server/backup.js");
require("./server/core.js");
require("./server/demo-server.js");
require("./server/desktop-notifications-server.js");
require("./server/dev-accounts-server.js");
require("./server/feature-key.js");
require("./server/grain-server.js");
require("./server/hack-session.js");
require("./server/identity.js");
require("./server/install-server.js");
require("./server/installer.js");
require("./server/notifications-server.js");
require("./server/pre-meteor.js");
require("./server/proxy.js");
require("./server/sandcats.js");
require("./server/shell-server.js");
require("./server/signup-server.js");
require("./server/startup.js");
require("./server/stats-server.js");
require("./shared/admin.js");
require("./shared/dev-accounts.js");
require("./shared/grain-shared.js");
require("./shared/install.js");
require("./shared/testing.js");
//# sourceMappingURL=app.js.map
